#ifndef DBCRS_H
#define DBCRS_H

#include <stdio.h>
#include "../SRC/alias.h"

class csec
/**
   Cross-section class

   Created by Tomas Koudelka, koudelka@cml.fsv.cvut.cz
*/
{
  public :
   crsectype type;
   long nprop;   ///< number of indeces
   char **prop;  ///< array of strings with cross-section properties (cross-section indeces)
   long *propu;  ///< array indicators of indeces which are used
   long *ridx;   ///< array with renumbered used indeces
   long npropu;  ///< counter used indeces this cross-section type

   csec(void);
   ~csec(void);

   /// reading cross-section
   long read(FILE *in);
};

class dbcrs
/**
   Cross-section database class

   Created by Tomas Koudelka, koudelka@cml.fsv.cvut.cz
*/
{
  public :
   long numt; ///< number of cross-section entries
   csec *crs; ///< array with cross-sections

   dbcrs(void);
   ~dbcrs(void);

   /// searching cross-section with given type and index
   long search_crs(crsectype ce, long ci);
};

#endif
