#ifndef DBMAT_H
#define DBMAT_H

#include <stdio.h>
#include "../SRC/alias.h"

class matr
/**
   Material class

   Created by Tomas Koudelka, koudelka@cml.fsv.cvut.cz
*/
{
  public :
   mattype type; ///< material type number
   long nprop;   ///< number of indeces
   char **prop;  ///< array of strings with material properties (material indeces)
   long *propu;  ///< array indicators of indeces which are used
   long *ridx;   ///< array with renumbered used indeces
   long npropu;  ///< counter used indeces this material type

   matr(void);
   ~matr(void);
   long read(FILE *in);
};

class dbmat
/**
   Material database class

   Created by Tomas Koudelka, koudelka@cml.fsv.cvut.cz
*/
{
  public :
   long numt;    ///< number of material entries
   matr *mat;    ///< array with materials

   dbmat(void);
   ~dbmat(void);
   long search_mat(mattype ce, long ci);
};

#endif
