#ifndef CREEPEFFYM_H
#define CREEPEFFYM_H

#include <stdio.h>
#include "alias.h"
struct matrix;
struct vector;

/**
  This class defines material model for simple creep modelling
  which uses effective Young modulus approach. The model is
  reasonable only with elasttime material model.
  
  Order of internal variables in the other array :
  -----------------------------------------------
  0-ncompstr : computed "irreversible creep strains"
*/
class creep_effym
{
 public:
  creep_effym (void);
  ~creep_effym (void);
  void matstiff (matrix &d,long ipp,long im,long ido);
  void nlstresses (long ipp, long im, long ido);
  void updateval (long ipp, long im, long ido);
  void giveirrstrains (long ipp, long im, long ido, vector &epscr);
  double give_actual_ft (long ipp, long im, long ido);
};

#endif
