#include "crsec2dbar.h"
#include "global.h"
#include "stochdriver.h"

crsec2dbar::crsec2dbar (void)
{
  a=0.0;  rho=0.0;
}
crsec2dbar::~crsec2dbar (void)
{
  
}

void crsec2dbar::read (XFILE *in)
{
  switch (Mp->tprob){
  case linear_statics:{
    xfscanf (in,"%lf",&a);
    break;
  }
  case eigen_dynamics:{
    xfscanf (in,"%lf %lf",&a,&rho);
    break;
  }
  case forced_dynamics:{
    xfscanf (in,"%lf %lf",&a,&rho);
    break;
  }
  case mat_nonlinear_statics:{
    xfscanf (in,"%lf",&a);
    break;
  }
  case mech_timedependent_prob:{
    xfscanf (in,"%lf",&a);
    break;
  }
  case growing_mech_structure:{
    xfscanf (in,"%lf",&a);
    break;
  }
  case lin_floating_subdomain:{
    xfscanf (in,"%lf",&a);
    break;
  }
  case nonlin_floating_subdomain:{
    xfscanf (in,"%lf",&a);
    break;
  }
  case load_balancing:{
    xfscanf (in,"%lf",&a);
    break;
  }
  default:{
    fprintf (stderr,"\n\n unknown problem type is required in function");
    fprintf (stderr,"\n read (file %s, line %d).\n",__FILE__,__LINE__);
  }
  }
}

void crsec2dbar::changeparam (atsel &atcs,vector &val)
{
  long i;
  
  for (i=0;i<atcs.num;i++){
    switch (atcs.atrib[i]){
    case 0:{
      a=val[i];
      break;
    }
    case 1:{
      rho=val[i];
      break;
    }
    default:{
      fprintf (stderr,"\n\n wrong number of atribute in function changeparam (file %s, line %d).\n",__FILE__,__LINE__);
    }
    }
  }
}
