#ifndef DLOADN_H
#define DLOADN_H

#include <stdio.h>
#include "iotools.h"
#include "genfile.h"

/**
  This class defines dynamical nodal load or the load which is the function of time or displacement.
  The load may be described with constant values, expression defined by the string or set of strings and
  finally it may be described with table.
*/
class dloadn
{
 public:
  dloadn();
  ~dloadn();
  long read(XFILE *in);
  double getval(double t, long id);
  long read_prop(FILE *in, long ndofn, long lc);
  long print_prop(FILE *out, long ndofn);

  ///  type of time function
  generalfunct tfunc;
  ///  number of loaded node
  long idn;
  /// number of directions
  long ndir;
  /// number of expression sets
  long neqs;
  /// load case number
  long nlc;
  ///  components of load or limits of intervals for set of parsers
  double *f;

  ///  array with the strings containing expressions
  char  **func;
  ///  parser binary trees with expressions
  Equation **eq;
  ///  array with pointers to the expression variables
  variable **var;

  ///  function defined by table
  tablefunct *tabf;

};

#endif
