#ifndef LOADCASE_H
#define LOADCASE_H

#include "iotools.h"
class loadn;
class loadel;
struct ivector;

/**
   class loadcase defines load cases in static problems
   
   JK
*/

class loadcase
{
 public:
  loadcase (void);
  ~loadcase (void);
  void read (XFILE *in);
  void assemble (long lcid,double *rhs,double *flv, double scale);
  void compute_reactions (long lcid);
  void tempercontrib (long lcid,double *rhs,double scale);
  
  ///  number of loaded nodes
  long nln;
  ///  number of loaded elements
  long nle;
  ///  number of prescribed displacements
  long npd;
  ///  number of prescribed temperature changes
  long npt;
  
  ///  presence of temperature changes
  long tempchang;

  //  loaded nodes
  loadn *lon;
  //  loaded elements
  loadel *loe;
  //  prescribed displacements
  double *pd;
  //  prescribed temperature changes
  double *pt;
  
  //double *rhstemp;
};

#endif
