#include "strretalg.h"
#include "alias.h"
#include "global.h"

strretalg::strretalg ()
{
  zero=0.0;
  ni=0;
  err=0.0;
}

strretalg::~strretalg ()
{
}

void strretalg::read (XFILE *in)
{
  //  type of stress return algorithm
  xfscanf (in,"%m", &stressretalgtype_kwdset,(int*)&tsra);
  
  switch (tsra){
  case nostressretalg:{
    if (Mespr==1)
      fprintf (stdout,"\n\n no stress return algorithm is required (file %s, line %d).\n",__FILE__,__LINE__);
    break;
  }
  case cp:{
    xfscanf (in,"%ld %lf",&ni,&err);
    break;
  }
  case gsra:{
    xfscanf (in,"%ld %lf",&ni,&err);
    break;
  }
  default:{
    fprintf (stderr,"\n\n unknown stress return algorithm is required in function read (file %s, line %d).\n",__FILE__,__LINE__);
  }
  }
  
}

stressretalgtype strretalg::give_tsra ()
{
  return tsra;
}

long strretalg::give_ni ()
{
  return ni;
}

double strretalg::give_err ()
{
  return err;
}
