#ifndef STRRETALG_H
#define STRRETALG_H

#include "iotools.h"
#include "alias.h"

/**
   class defines type of stress return algorithm
   it contains all necessary informations about selected algorithm
   
   JK
*/

class strretalg
{
 public:
  strretalg ();
  ~strretalg ();
  void read (XFILE *in);
  stressretalgtype give_tsra ();
  long give_ni ();
  double give_err ();
  
  ///  type of stress return algorithm
  stressretalgtype tsra;
  ///  computer zero
  double zero;
  ///  maximum number of iterations
  long ni;
  ///  required accuracy
  double err;

};

#endif
