#ifndef SVISPL_H
#define SVISPL_H

#include "iotools.h"
struct vector;
struct matrix;

/**
   structure of the array eqother:
   stress increments, viscoplastic (irreversible) strain increments,
   previous total strains,

*/
class svisplas
{
 public:
  svisplas (void);
  ~svisplas (void);
  void read (XFILE *in);
  double gfun (double f);
  double dergfun (double f);
  void nlstresses (long ipp,long ido);
  void nlstressesincr (long ipp,long ido);
  void matstiff (matrix &d,long ipp,long ido);
  
  void give_interparam (long ipp,long ido,vector &q);
  void store_interparam (long ipp,long ido,vector &q);

  void givestressincr (long ipp,long ido,vector &sig);
  void storestressincr (long ipp,long ido,vector &sig);
    
  //  viscosity
  double eta;
};

#endif
