#ifndef VISPLAST_H
#define VISPLAST_H

#include <stdio.h>
#include "alias.h"
struct matrix;
struct vector;

/**
   artificial material model for combination of viscous and plastic material models
   viscous material is the first one while plastic material is the second one
   
   remark: in time dependent problems the array stress contains increments
   of stress, not stress; stress components are located in the array eqother!
   
   structure of eqother array of a visco-plastic material:
   total stress components, previous total strains, increments of irreversible strains,
   consistency parameter, hardening parameters
   
   direct access from viscous material: total stress components, previous total strains,
   direct access from plastic material: increments of irreversible strains, consistency parameter,
                                        hardening parameters
   
   25.6.2004,
*/
class visplast
{
 public:
  visplast (void);
  ~visplast (void);
  void matstiff (matrix &d,long ipp,long im,long ido);
  void nlstresses (long ipp,long im,long ido);
  
};

#endif
