#include <stdlib.h>  
#include <stdio.h>


#include <math.h>


#include "normmat.h"


#include "mechmat.h"


#include "intpoints.h"


#include "global.h"


#include "matrix.h"








normmat::normmat (void)
{
  tcn=NULL;
  
  zero=1.0e-10;

  iter=1;

  tcn = new double [4];
  ki = new double [4];
  a1sp = new double [4];
  b1sp = new double [4];
  allocm (2,2,kn);
  allocm (4,4,kp);
  allocv (2,fkn);
  allocv (4,fkp);
  m = new double [4];
  mp = new double [4];
  mpp = new double [4];
  tcv = new double [4];
  tcn = new double [4];
  epscsp = new double [4];
  epss1sp = new double [4];			
  a1sp = new double [4];
  a2spp = new double [4];
  a2sp = new double [4];
  b1sp = new double [4];
  b2spp = new double [4];
  b2sp = new double [4];
  mr = new double [4];
  epscr = new double [4];
  epss1r = new double [4];
  epss1spp = new double [4];
  xr = new double [4];
  xsp = new double [4];
  ir1 = new double [4];
  ims1 = new double [4];
  ims2 = new double [4];
  ir2 = new double [4];
  ir3 = new double [4];
  ims3 = new double [4];
  ic1 = new double [4];
  ic2 = new double [4];
  icp = new double [4];
  c1 = new double [4];
  c2 = new double [4];
  c1p = new double [4];
  c2p = new double [4];
  kih = new double [4];
  kid = new double [4];
  ki = new double [4];

}





normmat::~normmat (void)


{


  delete [] tcn;


}





void normmat::read (XFILE *in)
{
  xfscanf (in,"%le %le %le %le %le %le  %le  %le %le %le %le %le %le %le %le",
	  &fck,&fy,&ft,&epsc1,&epscm,&epss1lim,&ash,&asd,&ch,&cd,&e0c,&h,&b,&fp,&fn);
  
  
  compute_fc ();
  compute_ecnom ();
  compute_epsuk ();
  compute_e0cn ();
  compute_k ();
  compute_a ();
  compute_d ();
  
}







//pevnost betonu v tlaku uvazovana pro vypocet


void normmat::compute_fc ()
{
  fc=-8000.0 + fck;
}





 //modul pruznosti betonu v tlaku prislusny 0,6 fc v kPa


void normmat::compute_ecnom ()
{
  ecnom = (1.6321156877891085*fc)/epsc1;
}





  //pretvoreni oceli pro stanoveni modulu pruznosti e0cn


void normmat::compute_epsuk ()
{
  epsuk = 0.05;
}


 


//modul pruznosti odpovidajici zplastizovani oceli v kPa
void normmat::compute_e0cn ()
{
  e0cn = (ft - fy)/(-(fy/e0c) + epsuk);
}


 


//soucinitel pro definovani pracovniho diagramu betonu
void normmat::compute_k ()
{
   k = (11*ecnom*epsc1)/(10.*fc);
}


 


//plocha prurezu


void normmat::compute_a ()
{
  a = b*h;
}


 


//ucinna vyska prurezu


void normmat::compute_d ()
{
  d = h - cd;
}





  
//svisla koncova sila ve stycniku i


void normmat::compute_z1 (long ipp,double lp)
{
  /*
	double wi,wfi,wj,wfj;

	wi = Mm->ip[ipp].strain[1]; 
	wfi = Mm->ip[ipp].strain[2];
	wj = Mm->ip[ipp].strain[4]; 
	wfj = Mm->ip[ipp].strain[5];

	z1 = ecnom*b*(h^3)/12.*((12.*wi)/pow(lp,3)- 
      (12.*wj)/pow(lp,3) - (6.*wfi)/pow(lp,2) - 
      (6.*wfj)/pow(lp,2))-(fp*lp)/2.;
      */
	
  z1 = Mm->ip[ipp].stress[1];
	//z1 = 0.;
} 


  
//momentova koncova sila ve stycniku i


void normmat::compute_z2 (long ipp,double lp)
{
/*
	double wi,wfi,wj,wfj;

	wi = Mm->ip[ipp].strain[1]; 
	wfi = Mm->ip[ipp].strain[2];
	wj = Mm->ip[ipp].strain[4]; 
	wfj = Mm->ip[ipp].strain[5];

	z2 = ecnom*b*(h^3)/12.*((-6.*wi)/pow(lp,2)+ 
      (6.*wj)/pow(lp,2) + (4.*wfi)/lp + 
      (2.*wfj)/lp)+(fp*pow(lp,2))/12.;
*/
	
  z2 = Mm->ip[ipp].stress[2];
	//z2=1000.;
} 





  
//vodorovna koncova sila ve stycniku i


void normmat::compute_z3p (long ipp,double lp)
{
	

	z3p = Mm->ip[ipp].stress[0];

	
} 






//vodorovna koncova sila ve stycniku i


void normmat::compute_z3 ()
{
	
/*
	double ui,uj;

	ui = Mm->ip[ipp].strain[0]; 
	uj = Mm->ip[ipp].strain[3]; 
	
	z3 = ecnom*a*(ui/lp - 
		uj/lp)+(fn*lp)/2.;
*/

	

  if (z3p <= 0.0)
    
    { z3 = 0.1; }
  
  else
    
    { z3 = z3p; }
  
  //z3 = Mm->ip[ipp].stress[0];
  //z3=2000;
} 





  
//vyztuz pro tahovou oblast od ucinku ohyboveho momentu as1


double normmat::compute_as1 (double lp)
{
  if (-(fp*pow(lp,2))/8. - (lp*z1)/2. - z2 <= 0){
    as1=asd;
  }
  else {
    as1=ash;
  }
  return as1;
}
 


//vyztuz pro tlakovou oblast od ucinku ohyboveho momentu as2


double normmat::compute_as2 (double lp)
{
  if (-(fp*pow(lp,2))/8. - (lp*z1)/2. - z2 <= 0){
   as2=ash;
 }
  else {
    as2=asd;
  }
  
  return as2;
}





 


//ohybovy moment na dannem elementu v polovine intervalu


void normmat::compute_m (double lp)
{

  m[0]=-(fp*pow(lp, 2))/128. - (lp*z1)/8. - z2;


  m[1]=(-9*fp*pow(lp, 2))/128. - (3*lp*z1)/8. - z2;


  m[2]=(-25*fp*pow(lp, 2))/128. - (5*lp*z1)/8. - z2;


  m[3]=(-49*fp*pow(lp, 2))/128. - (7*lp*z1)/8. - z2;


   


 }


 


//absolutni hodnota ohyboveho momentu na dannem elementu v polovine intervalu


void normmat::compute_mpp (double lp)
{
	if(m[0]==0.0){mpp[0]= 0.01;}
	else {mpp[0]= fabs(-(fp*pow(lp, 2))/128. - (lp*z1)/8. - z2);}

	if(m[1]==0.0){mpp[1]= 0.01;}
	else {mpp[1]= fabs((-9*fp*pow(lp, 2))/128. - (3*lp*z1)/8. - z2);}

	if(m[2]==0.0){mpp[2]= 0.01;}
	else {mpp[2]= fabs((-25*fp*pow(lp, 2))/128. - (5*lp*z1)/8. - z2);}

	if(m[3]==0.0){mpp[3]= 0.01;}
	else {mpp[3]= fabs((-49*fp*pow(lp, 2))/128. - (7*lp*z1)/8. - z2);}

  
}


 


//normalova sila na dannem elementu v polovine intervalu


double normmat::compute_n0 (double lp)


{


  double n0;


  


  


  if (-z3 + fn*lp/2 <= -0.1 ){


    n0=-z3 + fn*lp/2;}


  


  else{


    n0=-0.1;


  }


  


  return n0;


}






 
//pocet iteraci


long normmat::compute_iter ()


{


  long iter;	


  


  //iter = je rovna cislu iterace, ktera prave probiha pro danny zatezovaci stav, nulta iterace bude prvni vypocet, ktery bude stanoven linearne;


  iter = 1;


  return iter;


}






 
//funkce ktera rusi vliv betonove casti prurezu


void normmat::compute_tcv ()
{	
  long i;

  for (i=0;i<4;i++){
    
    
    //tcn[i]=Mm->ip.other[];
    
    
  }
  
  
  
  
  
  //compute_tcni (ipp,lp,tcn);


  


  //tcn = je funkce, ktera bude prenesena z predchoziho iterace a je rovna fci tcn, pro nultou iteraci je rovna (0,0,0,0);


  


  /*


  tcv[0]=tcn[0];


  tcv[1]=tcn[1];


  tcv[2]=tcn[2];


  tcv[3]=tcn[3];


  */





  tcv[0]=0.0;


  tcv[1]=0.0;


  tcv[2]=0.0;


  tcv[3]=0.0;


  


}


 


//VLIV NORMALOVE SILY


 


//pretvoreni od ucinku normalove sily


double normmat::compute_epsn ()


{


	double epsn;





	epsn =(-2*a*fc*epsc1 + 3*a*fc*k*epsc1 + as1*e0c*k*pow(epsc1, 2) + 


      as2*e0c*k*pow(epsc1, 2) - 


      sqrt(pow(epsc1, 


              2)*(-8*a*fc*(-1 + k)*k*n0 + 


                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 2))))/(4.*a*


      fc*(-1 + k));





	return epsn;


}


 


//maximalni tlakova normalova sila, kterou lze zatizit prurez


double normmat::compute_nmax ()


{	


	double nmax;





	nmax =as1*e0c*epsc1 + 


  as2*e0c*epsc1 + (a*fc*(-2*(-1 + k)*epsc1 + (-2 + 3*k)*epsc1))/(k*epsc1);





  return nmax;


}


 


//prvni clen pro linearizaci


double normmat::compute_an1 ()


{	


	double an1;





	an1 = sqrt(pow(epsc1, 


            2)*(-8*a*fc*(-1 + k)*k*n0 + 


              pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 2)))/(k*


          pow(epsc1, 2));





  return an1;


}


 


//druhy clen pro linearizaci


double normmat::compute_an2 ()


{	


	double an2;





	an2 = n0 + (sqrt(pow(epsc1, 


                2)*(-8*a*fc*(-1 + k)*k*n0 + 


                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                      2)))*(epsc1*(a*fc*(2 - 3*k) - (as1 + as2)*e0c*k*epsc1) +


               sqrt(pow(epsc1, 


                      2)*(-8*a*fc*(-1 + k)*k*n0 + 


                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                            2)))))/(4.*a*fc*(-1 + k)*k*pow(epsc1, 2));





  return an2;


}


 


//prace na betonove casti prurezu pro prubeh normalove sily (-z3 + fn x) pres element delky lp 


double normmat::compute_in1 (double lp)


{


	double in1;	


	


	


  if (fn == 0. && z3>= 0.0){





    in1=1/(32.*pow(a, 2)*pow(fc, 2)*pow(-1 + k, 2)*k*pow(epsc1, 2))*(lp*


      pow(a*fc*(-2 + 3*k)*epsc1 + (as1 + as2)*e0c*k*pow(epsc1, 2) - 


          sqrt(pow(epsc1, 


                  2)*(8*a*fc*(-1 + k)*k*z3 + 


                    pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 2))), 


        2)*(a*fc*(-2 + 3*k)*epsc1 - (as1 + as2)*e0c*k*pow(epsc1, 2) + 


          sqrt(pow(epsc1, 


                  2)*(8*a*fc*(-1 + k)*k*z3 + 


                    pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 2)))));





  }


  else if (fn != 0. && z3>= 0.0){





    in1=-(1/(960.*pow(a, 3)*pow(fc, 3)*fn*pow(-1 + k, 3)*


            pow(k, 2)))*(-pow(a, 4)*pow(fc, 4)*


        pow(2 - 3*k, 


          4)*(sqrt(pow(epsc1, 


                    2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 2))) - 


            sqrt(pow(epsc1, 


                    2)*(8*a*fc*(-1 + k)*k*z3 + 


                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                          2)))) + 


      9*pow(as1 + as2, 4)*pow(e0c, 4)*pow(k, 4)*


        pow(epsc1, 


          4)*(sqrt(pow(epsc1, 


                    2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 2))) - 


            sqrt(pow(epsc1, 


                    2)*(8*a*fc*(-1 + k)*k*z3 + 


                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                          2)))) + 


      2*pow(a, 3)*pow(fc, 3)*


        k*(-2 + 3*k)*(-60*pow(fn, 2)*pow(-1 + k, 2)*k*pow(lp, 2)*


              epsc1 + (-2 + 3*k)*(2*(-1 + k)*z3 + 


                  3*(as1 + as2)*e0c*(-2 + 3*k)*


                    epsc1)*(sqrt(pow(epsc1, 


                            2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                              pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1,


                                   2))) - 


                    sqrt(pow(epsc1, 


                            2)*(8*a*fc*(-1 + k)*k*z3 + 


                              pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1,


                                   2))))\


+2*fn*(-1 + k)*


              lp*(30*pow(k, 2)*epsc1*(2*z3 + 3*(as1 + as2)*e0c*epsc1) + 


                  2*sqrt(pow(epsc1, 


                          2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                            pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                                2))) - 


                  3*k*(20*z3*epsc1 + 20*as1*e0c*pow(epsc1, 2) + 


                        20*as2*e0c*pow(epsc1, 2) + 


                        sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2)))))) + 


      2*a*pow(as1 + as2, 2)*pow(e0c, 2)*fc*pow(k, 3)*


        pow(epsc1, 


          2)*(as1*e0c*


              epsc1*(60*fn*(-1 + k)*k*lp*epsc1 + 


                  13*(-2 + 


                        3*k)*(sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                        sqrt(pow(epsc1, 


                                2)*(8*a*fc*(-1 + k)*k*z3 + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))))) + 


            as2*e0c*epsc1*(60*fn*(-1 + k)*k*lp*epsc1 + 


                  13*(-2 + 


                        3*k)*(sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                        sqrt(pow(epsc1, 


                                2)*(8*a*fc*(-1 + k)*k*z3 + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))))) - 


            42*(-1 + 


                  k)*(fn*lp*


                    sqrt(pow(epsc1, 


                          2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                            pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                                2))) + 


                  z3*(-sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) + 


                        sqrt(pow(epsc1, 


                                2)*(8*a*fc*(-1 + k)*k*z3 + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2)))))) + 


      8*pow(a, 2)*pow(fc, 2)*


        pow(k, 


          2)*(3*pow(as1, 2)*pow(e0c, 2)*(-2 + 3*k)*


              pow(epsc1, 


                2)*(10*fn*(-1 + k)*k*lp*


                    epsc1 + (-2 + 


                        3*k)*(sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                        sqrt(pow(epsc1, 


                                2)*(8*a*fc*(-1 + k)*k*z3 + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))))) + 


            3*pow(as2, 2)*pow(e0c, 2)*(-2 + 3*k)*


              pow(epsc1, 


                2)*(10*fn*(-1 + k)*k*lp*


                    epsc1 + (-2 + 


                        3*k)*(sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                        sqrt(pow(epsc1, 


                                2)*(8*a*fc*(-1 + k)*k*z3 + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))))) - 


            as2*e0c*(-1 + k)*


              epsc1*(45*pow(fn, 2)*(-1 + k)*k*pow(lp, 2)*epsc1 + 


                  fn*lp*(90*k*z3*epsc1 - 90*pow(k, 2)*z3*epsc1 - 


                        22*sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) + 


                        33*k*sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2)))) - 


                  11*(-2 + 3*k)*


                    z3*(sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                        sqrt(pow(epsc1, 


                                2)*(8*a*fc*(-1 + k)*k*z3 + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))))) + 


            12*pow(-1 + k, 


                2)*(pow(fn, 2)*pow(lp, 2)*


                    sqrt(pow(epsc1, 


                          2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                            pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                                2))) - 


                  2*fn*lp*z3*


                    sqrt(pow(epsc1, 


                          2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                            pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                                2))) + 


                  pow(z3, 


                      2)*(sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                        sqrt(pow(epsc1, 


                                2)*(8*a*fc*(-1 + k)*k*z3 + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))))) + 


            as1*e0c*epsc1*(-45*pow(fn, 2)*pow(-1 + k, 2)*k*pow(lp, 2)*


                    epsc1 + (-2 + 3*k)*(11*(-1 + k)*z3 + 


                        6*as2*e0c*(-2 + 3*k)*


                          epsc1)*(sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                        sqrt(pow(epsc1, 


                                2)*(8*a*fc*(-1 + k)*k*z3 + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2)))) + 


                  fn*(-1 + k)*


                    lp*(90*pow(k, 2)*epsc1*(z3 + 2*as2*e0c*epsc1) + 


                        22*sqrt(pow(epsc1, 


                                2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                  pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                        3*k*(30*z3*epsc1 + 40*as2*e0c*pow(epsc1, 2) + 


                              11*sqrt(pow(epsc1, 


                                      2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))))))));





  }





  else{





    in1=0.;





  }


  return in1;


 }


  


//prace na ocelove casti prurezu pro prubeh normalove sily (-z3 + fn x) pres element delky lp 


double normmat::compute_in2 (double lp)


{


	double in2;	


	


	


  if (fn == 0. && z3>= 0.0){





    in2=1/(16.*pow(a, 2)*pow(fc, 2)*pow(-1 + k, 2))*((as1 + as2)*e0c*lp*


      pow(a*fc*(-2 + 3*k)*epsc1 + (as1 + as2)*e0c*k*pow(epsc1, 2) - 


          sqrt(pow(epsc1, 


                  2)*(8*a*fc*(-1 + k)*k*z3 + 


                    pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 2))), 2));





  }


  else if (fn != 0. && z3>= 0.0){





    in2=1/(96.*pow(a, 3)*pow(fc, 3)*fn*pow(-1 + k, 3)*k)*((as1 + as2)*e0c*


      epsc1*(pow(as1 + as2, 3)*pow(e0c, 3)*pow(k, 3)*


            pow(epsc1, 


              3)*(sqrt(pow(epsc1, 


                        2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                          pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                              2))) - 


                sqrt(pow(epsc1, 


                        2)*(8*a*fc*(-1 + k)*k*z3 + 


                          pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                              2)))) + 


          pow(a, 3)*pow(fc, 3)*


            pow(2 - 3*k, 


              2)*(12*fn*(-1 + k)*k*lp*


                  epsc1 + (-2 + 


                      3*k)*(sqrt(pow(epsc1, 


                              2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                      sqrt(pow(epsc1, 


                              2)*(8*a*fc*(-1 + k)*k*z3 + 


                                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))))) + 


          pow(a, 2)*pow(fc, 2)*


            k*(-24*pow(fn, 2)*pow(-1 + k, 2)*k*pow(lp, 2)*


                  epsc1 + (-2 + 3*k)*(8*(-1 + k)*z3 + 


                      3*(as1 + as2)*e0c*(-2 + 3*k)*


                        epsc1)*(sqrt(pow(epsc1, 


                              2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                      sqrt(pow(epsc1, 


                              2)*(8*a*fc*(-1 + k)*k*z3 + 


                                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2)))) + 


                8*fn*(-1 + k)*


                  lp*(3*pow(k, 2)*epsc1*(2*z3 + 3*(as1 + as2)*e0c*epsc1) + 


                      2*sqrt(pow(epsc1, 


                              2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                      3*k*(2*z3*epsc1 + 2*as1*e0c*pow(epsc1, 2) + 


                            2*as2*e0c*pow(epsc1, 2) + 


                            sqrt(pow(epsc1, 


                                    2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2)))))) + 


          a*(as1 + as2)*e0c*fc*pow(k, 2)*


            epsc1*(3*as1*e0c*


                  epsc1*(4*fn*(-1 + k)*k*lp*


                        epsc1 + (-2 + 


                            3*k)*(sqrt(pow(epsc1, 


                                    2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2))) - 


                            sqrt(pow(epsc1, 


                                    2)*(8*a*fc*(-1 + k)*k*z3 + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2))))) + 


                3*as2*e0c*


                  epsc1*(4*fn*(-1 + k)*k*lp*


                        epsc1 + (-2 + 


                            3*k)*(sqrt(pow(epsc1, 


                                    2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2))) - 


                            sqrt(pow(epsc1, 


                                    2)*(8*a*fc*(-1 + k)*k*z3 + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2))))) - 


                8*(-1 + 


                      k)*(fn*lp*


                        sqrt(pow(epsc1, 


                              2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) + 


                      z3*(-sqrt(pow(epsc1, 


                                    2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2))) + 


                            sqrt(pow(epsc1, 


                                    2)*(8*a*fc*(-1 + k)*k*z3 + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2))))))));





  }





  else{





    in2=0.;





  }


  return in2;


 }


  


//celkova prace na prurezu pro prubeh normalove sily (-z3 + fn x) pres element delky lp 


double normmat::compute_kinh ()


{


	double kinh;





	kinh = in1 + in2;


	


  return kinh;


 }


 


//pomocna prace na prurezu pro prubeh normalove sily (-z3 + fn x) pres element delky lp 


double normmat::compute_kind (double lp)


{





  double kind;


  


  


  if (fn == 0. && z3>= 0.0 ){


    





    kind=1.0/(16.*pow(a, 2)*an1*pow(fc, 2)*pow(-1 + k, 2))*(as1*e0c*lp*(a*fc*(-2 + 3*k)*epsc1 +


									(as1 + as2)*e0c*k*pow(epsc1, 2) - sqrt(pow(epsc1,2)*(8*a*fc*(-1 + k)*k*z3 + 


															     pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1,2))))*(an1*(as1 + as2)*e0c*k*pow(epsc1, 2) + 


																						  a*fc*(4*an2*(-1 + k) + an1*(-2 + 3*k)*epsc1) - an1*sqrt(pow(epsc1,2)*(8*a*fc*(-1 + k)*k*z3 + 


																															pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 2)))));








  }


  else if (fn != 0. && z3>= 0.0){


    





    kind=1/(96.*pow(a, 3)*an1*pow(fc, 3)*fn*pow(-1 + k, 3)*k)*(as1*


      e0c*(an1*pow(as1 + as2, 3)*pow(e0c, 3)*pow(k, 3)*


            pow(epsc1, 


              4)*(sqrt(pow(epsc1, 


                        2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                          pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                              2))) - 


                sqrt(pow(epsc1, 


                        2)*(8*a*fc*(-1 + k)*k*z3 + 


                          pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*epsc1, 


                              2)))) + 


          pow(a, 3)*


            pow(fc, 


              3)*(-2 + 3*k)*(2*an2*(-1 + k) + 


                an1*(-2 + 3*k)*epsc1)*(12*fn*(-1 + k)*k*lp*


                  epsc1 + (-2 + 


                      3*k)*(sqrt(pow(epsc1, 


                              2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                      sqrt(pow(epsc1, 


                              2)*(8*a*fc*(-1 + k)*k*z3 + 


                                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))))) + 


          a*(as1 + as2)*e0c*fc*pow(k, 2)*


            pow(epsc1, 


              2)*(2*an2*(as1 + as2)*


                  e0c*(-1 + 


                      k)*(sqrt(pow(epsc1, 


                              2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2))) - 


                      sqrt(pow(epsc1, 


                              2)*(8*a*fc*(-1 + k)*k*z3 + 


                                pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*k*


                                        epsc1, 2)))) + 


                an1*(3*as1*e0c*


                        epsc1*(4*fn*(-1 + k)*k*lp*


                              epsc1 + (-2 + 


                                  3*k)*(sqrt(pow(epsc1, 


                                        2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))) - 


                                  sqrt(pow(epsc1, 


                                        2)*(8*a*fc*(-1 + k)*k*z3 + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))))) + 


                      3*as2*e0c*


                        epsc1*(4*fn*(-1 + k)*k*lp*


                              epsc1 + (-2 + 


                                  3*k)*(sqrt(pow(epsc1, 


                                        2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))) - 


                                  sqrt(pow(epsc1, 


                                        2)*(8*a*fc*(-1 + k)*k*z3 + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))))) - 


                      8*(-1 + k)*(fn*lp*


                            sqrt(pow(epsc1, 


                                    2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2)))


+z3*(-sqrt(pow(epsc1, 


                                        2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))) + 


                                sqrt(pow(epsc1, 


                                        2)*(8*a*fc*(-1 + k)*k*z3 + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))))))) + 


          pow(a, 2)*pow(fc, 2)*


            k*(an1*epsc1*(-24*pow(fn, 2)*pow(-1 + k, 2)*k*pow(lp, 2)*


                        epsc1 + (-2 + 3*k)*(8*(-1 + k)*z3 + 


                            3*(as1 + as2)*e0c*(-2 + 3*k)*


                              epsc1)*(sqrt(pow(epsc1, 


                                    2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2))) - 


                            sqrt(pow(epsc1, 


                                    2)*(8*a*fc*(-1 + k)*k*z3 + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2)))) + 


                      8*fn*(-1 + k)*


                        lp*(3*pow(k, 2)*


                              epsc1*(2*z3 + 3*(as1 + as2)*e0c*epsc1) + 


                            2*sqrt(pow(epsc1, 


                                    2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2))) - 


                            3*k*(2*z3*epsc1 + 2*as1*e0c*pow(epsc1, 2) + 


                                  2*as2*e0c*pow(epsc1, 2) + 


                                  sqrt(pow(epsc1, 


                                        2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2)))))) + 


                4*an2*(-1 + 


                      k)*(as1*e0c*


                        epsc1*(6*fn*(-1 + k)*k*lp*


                              epsc1 + (-2 + 


                                  3*k)*(sqrt(pow(epsc1, 


                                        2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))) - 


                                  sqrt(pow(epsc1, 


                                        2)*(8*a*fc*(-1 + k)*k*z3 + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))))) + 


                      as2*e0c*


                        epsc1*(6*fn*(-1 + k)*k*lp*


                              epsc1 + (-2 + 


                                  3*k)*(sqrt(pow(epsc1, 


                                        2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))) - 


                                  sqrt(pow(epsc1, 


                                        2)*(8*a*fc*(-1 + k)*k*z3 + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))))) - 


                      4*(-1 + k)*(fn*lp*


                            sqrt(pow(epsc1, 


                                    2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                      pow(a*fc*(-2 + 3*k) + (as1 + as2)*e0c*


                                        k*epsc1, 2)))


+z3*(-sqrt(pow(epsc1, 


                                        2)*(-8*a*fc*(-1 + k)*k*(fn*lp - z3) + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


                                        e0c*k*epsc1, 2))) + 


                                sqrt(pow(epsc1, 


                                        2)*(8*a*fc*(-1 + k)*k*z3 + 


                                        pow(a*fc*(-2 + 3*k) + (as1 + as2)*


					    e0c*k*epsc1, 2)))))))));


					    





  }





  else{





    kind=1.0;





  }


  return kind;





}


 


//pomer prace vnitrnich sil a pomocne prace vnitrnich sil na dannem elementu od ucinku normalove sily


double normmat::compute_kin ()


{


	double kin;





	kin = kinh/kind;


	


  return kin;


 }


  


//TLACENA VYZTUZ + NORMALOVA SILA + x = h


 


//pretvoreni betonu, kdy tlacena plocha x=h


double normmat::compute_epschr1 ()


{	


  double epsc,disk,pom,epschr1;	


  


  disk =pow(6*b*fc*pow(h, 2)*epsc1 - 9*b*fc*pow(h, 2)*k*epsc1 + 


        6*as2*ch*e0c*k*pow(epsc1, 2) + 6*as1*d*e0c*k*pow(epsc1, 2) - 


        6*as1*e0c*h*k*pow(epsc1, 2) - 6*as2*e0c*h*k*pow(epsc1, 2) - 


        8*b*fc*pow(h, 2)*epsn + 8*b*fc*pow(h, 2)*k*epsn, 2) - 


  4*b*fc*pow(h, 


      2)*(-4 + 4*k)*(6*h*k*n0*pow(epsc1, 2) + 6*b*fc*pow(h, 2)*epsc1*epsn - 


        9*b*fc*pow(h, 2)*k*epsc1*epsn + 6*as2*ch*e0c*k*pow(epsc1, 2)*epsn + 


        6*as1*d*e0c*k*pow(epsc1, 2)*epsn - 6*as1*e0c*h*k*pow(epsc1, 2)*epsn - 


        6*as2*e0c*h*k*pow(epsc1, 2)*epsn - 4*b*fc*pow(h, 2)*pow(epsn, 2) + 


        4*b*fc*pow(h, 2)*k*pow(epsn, 2));





  if (disk >= 0.0 ){





    epsc=1/(2.*b*fc*pow(h, 2)*(-4 + 4*k))*(-6*b*fc*pow(h, 2)*epsc1 + 


      9*b*fc*pow(h, 2)*k*epsc1 - 6*as2*ch*e0c*k*pow(epsc1, 2) - 


      6*as1*d*e0c*k*pow(epsc1, 2) + 6*as1*e0c*h*k*pow(epsc1, 2) + 


      6*as2*e0c*h*k*pow(epsc1, 2) + 8*b*fc*pow(h, 2)*epsn - 


      8*b*fc*pow(h, 2)*k*epsn - 


      sqrt(pow(6*b*fc*pow(h, 2)*epsc1 - 9*b*fc*pow(h, 2)*k*epsc1 + 


                  6*as2*ch*e0c*k*pow(epsc1, 2) + 


                  6*as1*d*e0c*k*pow(epsc1, 2) - 6*as1*e0c*h*k*pow(epsc1, 2) - 


                  6*as2*e0c*h*k*pow(epsc1, 2) - 8*b*fc*pow(h, 2)*epsn + 


                  8*b*fc*pow(h, 2)*k*epsn, 2) - 


            4*b*fc*pow(h, 


                2)*(-4 + 4*k)*(6*h*k*n0*pow(epsc1, 2) + 


                  6*b*fc*pow(h, 2)*epsc1*epsn - 


                  9*b*fc*pow(h, 2)*k*epsc1*epsn + 


                  6*as2*ch*e0c*k*pow(epsc1, 2)*epsn + 


                  6*as1*d*e0c*k*pow(epsc1, 2)*epsn - 


                  6*as1*e0c*h*k*pow(epsc1, 2)*epsn - 


                  6*as2*e0c*h*k*pow(epsc1, 2)*epsn - 


                  4*b*fc*pow(h, 2)*pow(epsn, 2) + 


                  4*b*fc*pow(h, 2)*k*pow(epsn, 2))));





  }


  else{


    epsc=-1.0;


  }


   pom =(-(fy/e0c) - epsn)-((-ch + h)*epsc)/h;


   


   if (pom >= 0.0 ){


    epschr1=-1.0;


  }


  else{


    epschr1=epsc;


  }


  return epschr1;


}


 


//hodnota ohyboveho momentu, kdy tlacena plocha x=h a nedochazi k teceni oceli As1 a As2


double normmat::compute_mhr1 ()


{


  double mhr1;	


  


  if(epschr1 < 0 && epschr1 != -1)


    { 


    mhr1 = 0.08333333333333333*(6*as1*


        e0c*(-2*cd + h)*(epsn + 


            1/(6.*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2))*(6*as2*ch*e0c*k*


                    epschr1*pow(epsc1, 2) + 


                  3*d*k*pow(epsc1, 


                      2)*(n0 + as1*e0c*(epschr1 - epsn) - 


                        as2*e0c*(epschr1 + epsn)) + 


                  sqrt(3.)*


                    sqrt(k*pow(epsc1, 


                          2)*(3*k*pow(epsc1, 2)*


                              pow(-2*as2*ch*e0c*epschr1 + 


                                  d*(-n0 + 


                                        e0c*(as1*(-epschr1 + epsn) + 


                                        as2*(epschr1 + epsn))), 2) - 


                            2*(as2*ch + as1*d)*


                              e0c*(b*pow(d, 2)*fc*


                                    pow(epschr1 + epsn, 


                                      2)*(4*(-1 + k)*epschr1 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                  6*k*epschr1*


                                    pow(epsc1, 


                                      2)*(as2*ch*e0c*epschr1 + 


                                        d*(n0 - 


                                        e0c*(as1*epsn + 


                                        as2*(epschr1 + epsn))))))))) - 


      6*as2*e0c*(-2*ch + h)*(epschr1 - (ch*epschr1)/d + 


            epsn + (ch*(6*as2*ch*e0c*k*epschr1*pow(epsc1, 2) + 


                      3*d*k*pow(epsc1, 


                          2)*(n0 + as1*e0c*(epschr1 - epsn) - 


                            as2*e0c*(epschr1 + epsn)) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*e0c*epschr1 + 


                                      d*(-n0 + 


                                        e0c*(as1*(-epschr1 + epsn) + 


                                        as2*(epschr1 + epsn))), 2) - 


                                2*(as2*ch + as1*d)*


                                  e0c*(b*pow(d, 2)*fc*


                                        pow(epschr1 + epsn, 


                                        2)*(4*(-1 + k)*epschr1 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                      6*k*epschr1*


                                        pow(epsc1, 


                                        2)*(as2*ch*e0c*epschr1 + 


                                        d*(n0 - e0c*(as1*epsn + 


                                        as2*(epschr1 + epsn)))))))))/(6.*


                  d*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2))) - (b*d*fc*


            pow(epschr1 + epsn, 


              2)*(2*d*(epschr1 + 


                      epsn)*((-1 + k)*epschr1 + (2 - 3*k)*epsc1 + (-1 + k)*


                        epsn) - 


                h*(4*(-1 + k)*epschr1 + (6 - 9*k)*epsc1 + 


                      4*(-1 + k)*


                        epsn)*(epschr1 - (6*as2*ch*e0c*k*epschr1*


                              pow(epsc1, 2) + 


                            3*d*k*pow(epsc1, 


                                2)*(n0 + as1*e0c*(epschr1 - epsn) - 


                                  as2*e0c*(epschr1 + epsn)) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(-2*as2*ch*e0c*epschr1 + 


                                        d*(-n0 + e0c*(as1*(-epschr1 + epsn) + 


                                        as2*(epschr1 + epsn))), 2) - 


                                      2*(as2*ch + as1*d)*


                                        e0c*(b*pow(d, 2)*fc*


                                        pow(epschr1 + epsn, 


                                        2)*(4*(-1 + k)*epschr1 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                        6*k*epschr1*


                                        pow(epsc1, 


                                        2)*(as2*ch*e0c*epschr1 + 


                                        d*(n0 - e0c*(as1*epsn + 


                                        as2*(epschr1 + epsn))))))))/(6.*(as2*


                                  ch + as1*d)*e0c*k*pow(epsc1, 2)))))/(k*


            pow(epsc1, 2)*


            pow(epschr1 - 


                1/(6.*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2))*(6*as2*ch*e0c*k*


                        epschr1*pow(epsc1, 2) + 


                      3*d*k*pow(epsc1, 


                          2)*(n0 + as1*e0c*(epschr1 - epsn) - 


                            as2*e0c*(epschr1 + epsn)) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*e0c*epschr1 + 


                                      d*(-n0 + 


                                        e0c*(as1*(-epschr1 + epsn) + 


                                        as2*(epschr1 + epsn))), 2) - 


                                2*(as2*ch + as1*d)*


                                  e0c*(b*pow(d, 2)*fc*


                                        pow(epschr1 + epsn, 


                                        2)*(4*(-1 + k)*epschr1 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                      6*k*epschr1*


                                        pow(epsc1, 


                                        2)*(as2*ch*e0c*epschr1 + 


                                        d*(n0 - e0c*(as1*epsn + 


                                        as2*(epschr1 + epsn)))))))), 2))) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





  }


  else{


    mhr1=1000000000.0;


	 }


  return mhr1;


  }


  


 //TLACENA VYZTUZ + NORMALOVA SILA + TECENI V As1 + x < h


  


 //pretvoreni betonu, kdy dochazi k teceni vyztuze As1, ale netece As2 a ani nedochazi k drceni betonu


double normmat::compute_epschr2 ()


{


  double disk1,epsct,disk2,epschr2;





  disk1 =e0c*(3*e0c*


        pow(k*pow(epsc1, 


                2)*(-2*as2*ch*fy - as1*d*fy + as2*d*fy + d*n0 + 


                  2*as2*(ch - d)*e0c*epsn) + 


            b*pow(d, 2)*


              fc*(-2*(-1 + k)*pow(epsc1, 2) + (2 - 3*k)*epsc1*epsn + 


                  2*(-1 + k)*pow(epsn, 2)), 


          2) - (2*as2*(-ch + d)*e0c*k*pow(epsc1, 2) - 


            b*pow(d, 2)*fc*((-2 + k)*epsc1 + 4*(-1 + k)*epsn))*(-6*as2*k*


              pow(epsc1, 2)*(fy - e0c*epsn)*(ch*fy + (-ch + d)*e0c*epsn) + 


            d*(6*fy*k*n0*pow(epsc1, 2) - 


                  6*as1*fy*k*pow(epsc1, 2)*(fy - e0c*epsn) + 


                  e0c*(-6*k*n0*pow(epsc1, 2)*epsn + 


                        b*d*fc*(-4*(-1 + k)*pow(epsc1, 3) + 


                              3*(-2 + 3*k)*epsc1*pow(epsn, 2) - 


                              4*(-1 + k)*pow(epsn, 3))))));


  


  if (mhr1 == 1000000000.0 || disk1 < 0.0){





    epsct=-1.0;





  }





  else {





    epsct=(-3*e0c*k*pow(epsc1,2) * (-2*as2*ch*fy - as1*d*fy + as2*d*fy + d*n0 + 2*as2*(ch - d)*e0c*epsn) + 


	   3*b*pow(d, 2)*e0c*fc*(2*(-1 + k)*pow(epsc1, 2) + (-2 + 3*k)*epsc1*epsn - 2*(-1 + k)*pow(epsn, 2)) + 


	   sqrt(3.)*sqrt(e0c*(3*e0c*pow(k*pow(epsc1,2)*(-2*as2*ch*fy - as1*d*fy + as2*d*fy + d*n0 + 


                              2*as2*(ch - d)*e0c*epsn) + 


                        b*pow(d, 2)*


                          fc*(-2*(-1 + k)*pow(epsc1, 2) + (2 - 3*k)*epsc1*


                                epsn + 2*(-1 + k)*pow(epsn, 2)), 


                      2) - (2*as2*(-ch + d)*e0c*k*pow(epsc1, 2) - 


                        b*pow(d, 2)*


                          fc*((-2 + k)*epsc1 + 4*(-1 + k)*epsn))*(-6*as2*k*


                          pow(epsc1, 


                            2)*(fy - e0c*epsn)*(ch*fy + (-ch + d)*e0c*epsn) + 


                        d*(6*fy*k*n0*pow(epsc1, 2) - 


                              6*as1*fy*k*pow(epsc1, 2)*(fy - e0c*epsn) + 


                              e0c*(-6*k*n0*pow(epsc1, 2)*epsn + 


                                    b*d*fc*(-4*(-1 + k)*pow(epsc1, 3) + 


                                        3*(-2 + 3*k)*epsc1*pow(epsn, 2) - 


					    4*(-1 + k)*pow(epsn, 3))))))))/


      (3.*e0c*(2*as2*(ch - d)*e0c*k*pow(epsc1, 2) + b*pow(d, 2)*fc*((-2 + k)*epsc1 + 4*(-1 + k)*epsn)));





  }





  disk2 =e0c*(3*e0c*


        pow(as2*k*


              pow(epsc1, 2)*(-2*ch*fy + d*fy + 2*ch*e0c*epsn - 2*d*e0c*epsn) +


             d*(-(as1*fy*k*pow(epsc1, 2)) + 


                  2*b*d*fc*(pow(epsct, 2) + (epsc1 - epsn)*epsn) + 


                  k*(n0*pow(epsc1, 2) + 


                        b*d*fc*(-2*pow(epsct, 2) - 3*epsc1*epsn + 


                              2*pow(epsn, 2)))), 


          2) - (2*as2*(-ch + d)*e0c*k*pow(epsc1, 2) + 


            b*pow(d, 2)*


              fc*((-2 + 3*k)*epsc1 - 4*(-1 + k)*(epsct + epsn)))*(-6*as2*k*


              pow(epsc1, 2)*(fy - e0c*epsn)*(ch*fy + (-ch + d)*e0c*epsn) + 


            d*(6*fy*k*n0*pow(epsc1, 2) - 


                  6*as1*fy*k*pow(epsc1, 2)*(fy - e0c*epsn) + 


                  e0c*(-6*k*n0*pow(epsc1, 2)*epsn + 


                        b*d*fc*(-4*(-1 + k)*pow(epsct, 3) + 


                              3*(-2 + 3*k)*epsc1*pow(epsn, 2) - 


                              4*(-1 + k)*pow(epsn, 3))))));





  if (mhr1 == 1000000000.0 || disk2 < 0.0 || epsct == -1.0){





	  epschr2=-1.0;


  }


  else{





    epschr2=(-3*as2*e0c*k*


          pow(epsc1, 2)*(-2*ch*fy + d*fy + 2*ch*e0c*epsn - 2*d*e0c*epsn) + 


        3*d*e0c*(k*(as1*fy - n0)*pow(epsc1, 2) - 2*b*d*fc*pow(epsct, 2) + 


              2*b*d*fc*k*pow(epsct, 2) + b*d*fc*(-2 + 3*k)*epsc1*epsn - 


              2*b*d*fc*(-1 + k)*pow(epsn, 2)) + 


        sqrt(3.)*sqrt(e0c*(3*e0c*


                    pow(as2*k*


                          pow(epsc1, 


                            2)*(-2*ch*fy + d*fy + 2*ch*e0c*epsn - 


                              2*d*e0c*epsn) + 


                        d*(-as1*fy*k*pow(epsc1, 2) + 


                              2*b*d*fc*(pow(epsct, 2) + (epsc1 - epsn)*epsn) +


                               k*(n0*pow(epsc1, 2) + 


                                    b*d*fc*(-2*pow(epsct, 2) - 3*epsc1*epsn + 


                                        2*pow(epsn, 2)))), 


                      2) - (2*as2*(-ch + d)*e0c*k*pow(epsc1, 2) + 


                        b*pow(d, 2)*


                          fc*((-2 + 3*k)*epsc1 - 


                              4*(-1 + k)*(epsct + epsn)))*(-6*as2*k*


                          pow(epsc1, 


                            2)*(fy - e0c*epsn)*(ch*fy + (-ch + d)*e0c*epsn) + 


                        d*(6*fy*k*n0*pow(epsc1, 2) - 


                              6*as1*fy*k*pow(epsc1, 2)*(fy - e0c*epsn) + 


                              e0c*(-6*k*n0*pow(epsc1, 2)*epsn + 


                                    b*d*fc*(-4*(-1 + k)*pow(epsct, 3) + 


                                        3*(-2 + 3*k)*epsc1*pow(epsn, 2) - 


                                        4*(-1 + k)*pow(epsn, 3))))))))/(3.*


        e0c*(2*as2*(ch - d)*e0c*k*pow(epsc1, 2) + 


	     b*pow(d, 2)*fc*((2 - 3*k)*epsc1 + 4*(-1 + k)*(epsct + epsn))));


  }


  return epschr2;


}


 


 


 //hodnota ohyboveho momentu, kdy dochazi k teceni vyztuze As1, ale netece As2 a ani nedochazi k drceni betonu 


double normmat::compute_mhr2 ()


{


	double mhr2;	


	


	if (epschr2 < 0.0 && epschr2!=-1.0){





    mhr2=0.08333333333333333*(6*as1*


        e0c*(-2*cd + h)*(epsn + 


            1/(6.*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2))*(6*as2*ch*e0c*k*


                    epschr2*pow(epsc1, 2) + 


                  3*d*k*pow(epsc1, 


                      2)*(n0 + as1*e0c*(epschr2 - epsn) - 


                        as2*e0c*(epschr2 + epsn)) + 


                  sqrt(3.)*


                    sqrt(k*pow(epsc1, 


                          2)*(3*k*pow(epsc1, 2)*


                              pow(-2*as2*ch*e0c*epschr2 + 


                                  d*(-n0 + 


                                        e0c*(as1*(-epschr2 + epsn) + 


                                        as2*(epschr2 + epsn))), 2) - 


                            2*(as2*ch + as1*d)*


                              e0c*(b*pow(d, 2)*fc*


                                    pow(epschr2 + epsn, 


                                      2)*(4*(-1 + k)*epschr2 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                  6*k*epschr2*


                                    pow(epsc1, 


                                      2)*(as2*ch*e0c*epschr2 + 


                                        d*(n0 - 


                                        e0c*(as1*epsn + 


                                        as2*(epschr2 + epsn))))))))) - 


      6*as2*e0c*(-2*ch + h)*(epschr2 - (ch*epschr2)/d + 


            epsn + (ch*(6*as2*ch*e0c*k*epschr2*pow(epsc1, 2) + 


                      3*d*k*pow(epsc1, 


                          2)*(n0 + as1*e0c*(epschr2 - epsn) - 


                            as2*e0c*(epschr2 + epsn)) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*e0c*epschr2 + 


                                      d*(-n0 + 


                                        e0c*(as1*(-epschr2 + epsn) + 


                                        as2*(epschr2 + epsn))), 2) - 


                                2*(as2*ch + as1*d)*


                                  e0c*(b*pow(d, 2)*fc*


                                        pow(epschr2 + epsn, 


                                        2)*(4*(-1 + k)*epschr2 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                      6*k*epschr2*


                                        pow(epsc1, 


                                        2)*(as2*ch*e0c*epschr2 + 


                                        d*(n0 - e0c*(as1*epsn + 


                                        as2*(epschr2 + epsn)))))))))/(6.*


                  d*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2))) - (b*d*fc*


            pow(epschr2 + epsn, 


              2)*(2*d*(epschr2 + 


                      epsn)*((-1 + k)*epschr2 + (2 - 3*k)*epsc1 + (-1 + k)*


                        epsn) - 


                h*(4*(-1 + k)*epschr2 + (6 - 9*k)*epsc1 + 


                      4*(-1 + k)*


                        epsn)*(epschr2 - (6*as2*ch*e0c*k*epschr2*


                              pow(epsc1, 2) + 


                            3*d*k*pow(epsc1, 


                                2)*(n0 + as1*e0c*(epschr2 - epsn) - 


                                  as2*e0c*(epschr2 + epsn)) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(-2*as2*ch*e0c*epschr2 + 


                                        d*(-n0 + e0c*(as1*(-epschr2 + epsn) + 


                                        as2*(epschr2 + epsn))), 2) - 


                                      2*(as2*ch + as1*d)*


                                        e0c*(b*pow(d, 2)*fc*


                                        pow(epschr2 + epsn, 


                                        2)*(4*(-1 + k)*epschr2 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                        6*k*epschr2*


                                        pow(epsc1, 


                                        2)*(as2*ch*e0c*epschr2 + 


                                        d*(n0 - e0c*(as1*epsn + 


                                        as2*(epschr2 + epsn))))))))/(6.*(as2*


                                  ch + as1*d)*e0c*k*pow(epsc1, 2)))))/(k*


            pow(epsc1, 2)*


            pow(epschr2 - 


                1/(6.*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2))*(6*as2*ch*e0c*k*


                        epschr2*pow(epsc1, 2) + 


                      3*d*k*pow(epsc1, 


                          2)*(n0 + as1*e0c*(epschr2 - epsn) - 


                            as2*e0c*(epschr2 + epsn)) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*e0c*epschr2 + 


                                      d*(-n0 + 


                                        e0c*(as1*(-epschr2 + epsn) + 


                                        as2*(epschr2 + epsn))), 2) - 


                                2*(as2*ch + as1*d)*


                                  e0c*(b*pow(d, 2)*fc*


                                        pow(epschr2 + epsn, 


                                        2)*(4*(-1 + k)*epschr2 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                      6*k*epschr2*


                                        pow(epsc1, 


                                        2)*(as2*ch*e0c*epschr2 + 


                                        d*(n0 - e0c*(as1*epsn + 


                                        as2*(epschr2 + epsn)))))))), 2))) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





  }





  else{





    mhr2=1000000000.0;





  }


  return mhr2;


 }





 


 //TLACENA VYZTUZ + NORMALOVA SILA + TECENI V As2 + x < h





//pretvoreni betonu, kdy dochazi k teceni vyztuze As2, ale netece As1 a ani nedochazi k drceni betonu, x < h


double normmat::compute_epschr3 ()


{


  double ac1,ac2,ac3,epschr3;





  ac1 =((12*sqrt(3.)*e0c*((-8*b*(as2*ch + as1*d)*e0c*fc*(epsc1 - epsn)*


                        pow(epsc1 + 2*epsn, 2) + 


                      k*(12*pow(n0, 2)*pow(epsc1, 2) - 


                            12*(as1 + as2)*e0c*n0*


                              pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                            e0c*(3*pow(as2, 2)*e0c*pow(epsc1, 2) + 


                                  2*as2*(3*as1*e0c*pow(epsc1, 2) + 


                                        b*ch*fc*(7*epsc1 - 4*epsn)) + 


                                  as1*(3*as1*e0c*pow(epsc1, 2) + 


                                        2*b*d*fc*(7*epsc1 - 4*epsn)))*


                              pow(epsc1 + 2*epsn, 2)))*(pow(as2, 2)*e0c*k*


                        pow(epsc1, 2) + 


                      2*as2*(as1*e0c*k*pow(epsc1, 2) + 


                            b*ch*fc*(k*epsc1 + 4*epsn - 4*k*epsn)) + 


                      as1*(as1*e0c*k*pow(epsc1, 2) + 


                            2*b*d*fc*(k*epsc1 + 4*epsn - 4*k*epsn))) - 


                3*e0c*pow(pow(as2, 2)*e0c*k*pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                      as1*(2*b*d*


                              fc*(epsc1 + 2*epsn)*((-1 + 2*k)*epsc1 - 


                                  2*(-1 + k)*epsn) + 


                            k*pow(epsc1, 


                                2)*(-2*n0 + as1*e0c*(epsc1 + 2*epsn))) + 


                      2*as2*(b*ch*


                              fc*(epsc1 + 2*epsn)*((-1 + 2*k)*epsc1 - 


                                  2*(-1 + k)*epsn) + 


                            k*pow(epsc1, 2)*(-n0 + as1*e0c*(epsc1 + 2*epsn))),


                     2))*sqrt(k*


                pow(epsc1, 


                  2)*(3*k*pow(epsc1, 2)*


                      pow(as2*ch*e0c*


                            epsc1 + (d*(2*n0 + 


                                    e0c*(as1*(epsc1 - 2*epsn) - 


                                        as2*(epsc1 + 2*epsn))))/2., 2) - 


                    2*(as2*ch + as1*d)*


                      e0c*(-(b*pow(d, 2)*fc*


                                  pow(epsc1 + 2*epsn, 


                                    2)*((-4 + 7*k)*epsc1 - 4*(-1 + k)*epsn))/


                            4. + 3*k*


                            pow(epsc1, 


                              3)*((as2*ch*e0c*epsc1)/2. + 


                                d*(n0 - (e0c*(as2*epsc1 + 2*as1*epsn + 


                                        2*as2*epsn))/2.))))))/((as2*ch + 


                as1*d)*k*


            pow(-8*b*(as2*ch + as1*d)*e0c*fc*(epsc1 - epsn)*


                  pow(epsc1 + 2*epsn, 2) + 


                k*(12*pow(n0, 2)*pow(epsc1, 2) - 


                      12*(as1 + as2)*e0c*n0*pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                      e0c*(3*pow(as2, 2)*e0c*pow(epsc1, 2) + 


                            2*as2*(3*as1*e0c*pow(epsc1, 2) + 


                                  b*ch*fc*(7*epsc1 - 4*epsn)) + 


                            as1*(3*as1*e0c*pow(epsc1, 2) + 


                                  2*b*d*fc*(7*epsc1 - 4*epsn)))*


                        pow(epsc1 + 2*epsn, 2)), 2)) - 


      4*epsc1*((6*(-ch + d)*e0c)/


              ch + (3*e0c*(2*as2*ch*k*pow(epsc1, 2) + (as1 - as2)*d*k*


                        pow(epsc1, 


                          2) + (2*


                            sqrt(3.)*(pow(as2, 2)*e0c*k*


                                  pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                                as1*(2*b*d*


                                        fc*(epsc1 + 


                                        2*epsn)*((-1 + 2*k)*epsc1 - 


                                        2*(-1 + k)*epsn) + 


                                      k*pow(epsc1, 


                                        2)*(-2*n0 + 


                                        as1*e0c*(epsc1 + 2*epsn))) + 


                                2*as2*(b*ch*


                                        fc*(epsc1 + 


                                        2*epsn)*((-1 + 2*k)*epsc1 - 


                                        2*(-1 + k)*epsn) + 


                                      k*pow(epsc1, 


                                        2)*(-n0 + as1*e0c*(epsc1 + 2*epsn))))*


                            sqrt(k*


                                pow(epsc1, 


                                  2)*(3*k*pow(epsc1, 2)*


                                      pow(as2*ch*e0c*


                                        epsc1 + (d*(2*n0 + 


                                        e0c*(as1*(epsc1 - 2*epsn) - 


                                        as2*(epsc1 + 2*epsn))))/2., 2) - 


                                    2*(as2*ch + as1*d)*


                                      e0c*(-(b*pow(d, 2)*fc*


                                        pow(epsc1 + 2*epsn, 


                                        2)*((-4 + 7*k)*epsc1 - 


                                        4*(-1 + k)*epsn))/4. + 


                                        3*k*pow(epsc1, 


                                        3)*((as2*ch*e0c*epsc1)/2. + 


                                        d*(n0 - (e0c*(as2*epsc1 + 


                                        2*as1*epsn + 2*as2*epsn))/


                                        2.))))))/(-8*b*(as2*ch + as1*d)*e0c*


                              fc*(epsc1 - epsn)*pow(epsc1 + 2*epsn, 2) + 


                            k*(12*pow(n0, 2)*pow(epsc1, 2) - 


                                  12*(as1 + as2)*e0c*n0*


                                    pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                                  e0c*(3*pow(as2, 2)*e0c*pow(epsc1, 2) + 


                                        2*as2*(3*as1*e0c*pow(epsc1, 2) + 


                                        b*ch*fc*(7*epsc1 - 4*epsn)) + 


                                        as1*(3*as1*e0c*pow(epsc1, 2) + 


                                        2*b*d*fc*(7*epsc1 - 4*epsn)))*


                                    pow(epsc1 + 2*epsn, 2)))))/((as2*ch + 


                      as1*d)*k*pow(epsc1, 2))) + (4*(3*as2*ch*d*k*


                  pow(epsc1, 2)*(4*fy + e0c*(epsc1 + 2*epsn)) + 


                3*as1*d*k*


                  pow(epsc1, 


                    2)*(-(ch*e0c*(epsc1 + 2*epsn)) + 


                      2*d*(2*fy + e0c*epsc1 + 2*e0c*epsn)) + 


                2*ch*(3*d*k*n0*pow(epsc1, 2) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(as2*ch*e0c*


                                        epsc1 + (d*(2*n0 + 


                                        e0c*(as1*(epsc1 - 2*epsn) - 


                                        as2*(epsc1 + 2*epsn))))/2., 2) - 


                                2*(as2*ch + as1*d)*


                                  e0c*(-(b*pow(d, 2)*fc*


                                        pow(epsc1 + 2*epsn, 


                                        2)*(-4*epsc1 + 7*k*epsc1 + 4*epsn - 


                                        4*k*epsn))/4. + 


                                      3*k*pow(epsc1, 


                                        3)*((as2*ch*e0c*epsc1)/2. + 


                                        d*(n0 - (e0c*(as2*epsc1 + 


                                        2*as1*epsn + 2*as2*epsn))/


                                        2.))))))))/(ch*(as2*ch + as1*d)*k*


            pow(epsc1, 2)))/(48.*e0c);





	ac2 =(-2 + (2*d)/


        ch - (2*sqrt(3.)*((-8*b*(as2*ch + as1*d)*e0c*fc*(epsc1 - epsn)*


                        pow(epsc1 + 2*epsn, 2) + 


                      k*(12*pow(n0, 2)*pow(epsc1, 2) - 


                            12*(as1 + as2)*e0c*n0*


                              pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                            e0c*(3*pow(as2, 2)*e0c*pow(epsc1, 2) + 


                                  2*as2*(3*as1*e0c*pow(epsc1, 2) + 


                                        b*ch*fc*(7*epsc1 - 4*epsn)) + 


                                  as1*(3*as1*e0c*pow(epsc1, 2) + 


                                        2*b*d*fc*(7*epsc1 - 4*epsn)))*


                              pow(epsc1 + 2*epsn, 2)))*(pow(as2, 2)*e0c*k*


                        pow(epsc1, 2) + 


                      2*as2*(as1*e0c*k*pow(epsc1, 2) + 


                            b*ch*fc*(k*epsc1 + 4*epsn - 4*k*epsn)) + 


                      as1*(as1*e0c*k*pow(epsc1, 2) + 


                            2*b*d*fc*(k*epsc1 + 4*epsn - 4*k*epsn))) - 


                3*e0c*pow(pow(as2, 2)*e0c*k*pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                      as1*(2*b*d*


                              fc*(epsc1 + 2*epsn)*((-1 + 2*k)*epsc1 - 


                                  2*(-1 + k)*epsn) + 


                            k*pow(epsc1, 


                                2)*(-2*n0 + as1*e0c*(epsc1 + 2*epsn))) + 


                      2*as2*(b*ch*


                              fc*(epsc1 + 2*epsn)*((-1 + 2*k)*epsc1 - 


                                  2*(-1 + k)*epsn) + 


                            k*pow(epsc1, 2)*(-n0 + as1*e0c*(epsc1 + 2*epsn))),


                     2))*sqrt(k*


                pow(epsc1, 


                  2)*(3*k*pow(epsc1, 2)*


                      pow(as2*ch*e0c*


                            epsc1 + (d*(2*n0 + 


                                    e0c*(as1*(epsc1 - 2*epsn) - 


                                        as2*(epsc1 + 2*epsn))))/2., 2) - 


                    2*(as2*ch + as1*d)*


                      e0c*(-(b*pow(d, 2)*fc*


                                  pow(epsc1 + 2*epsn, 


                                    2)*((-4 + 7*k)*epsc1 - 4*(-1 + k)*epsn))/


                            4. + 3*k*


                            pow(epsc1, 


                              3)*((as2*ch*e0c*epsc1)/2. + 


                                d*(n0 - (e0c*(as2*epsc1 + 2*as1*epsn + 


                                        2*as2*epsn))/2.))))))/((as2*ch + 


                as1*d)*k*epsc1*


            pow(-8*b*(as2*ch + as1*d)*e0c*fc*(epsc1 - epsn)*


                  pow(epsc1 + 2*epsn, 2) + 


                k*(12*pow(n0, 2)*pow(epsc1, 2) - 


                      12*(as1 + as2)*e0c*n0*pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                      e0c*(3*pow(as2, 2)*e0c*pow(epsc1, 2) + 


                            2*as2*(3*as1*e0c*pow(epsc1, 2) + 


                                  b*ch*fc*(7*epsc1 - 4*epsn)) + 


                            as1*(3*as1*e0c*pow(epsc1, 2) + 


                                  2*b*d*fc*(7*epsc1 - 4*epsn)))*


                        pow(epsc1 + 2*epsn, 2)), 2)) + (2*as2*ch*k*


              pow(epsc1, 2) + (as1 - as2)*d*k*


              pow(epsc1, 


                2) + (2*


                  sqrt(3.)*(pow(as2, 2)*e0c*k*pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                      as1*(2*b*d*


                              fc*(epsc1 + 2*epsn)*((-1 + 2*k)*epsc1 - 


                                  2*(-1 + k)*epsn) + 


                            k*pow(epsc1, 


                                2)*(-2*n0 + as1*e0c*(epsc1 + 2*epsn))) + 


                      2*as2*(b*ch*


                              fc*(epsc1 + 2*epsn)*((-1 + 2*k)*epsc1 - 


                                  2*(-1 + k)*epsn) + 


                            k*pow(epsc1, 


                                2)*(-n0 + as1*e0c*(epsc1 + 2*epsn))))*


                  sqrt(k*pow(epsc1, 


                        2)*(3*k*pow(epsc1, 2)*


                            pow(as2*ch*e0c*


                                  epsc1 + (d*(2*n0 + 


                                        e0c*(as1*(epsc1 - 2*epsn) - 


                                        as2*(epsc1 + 2*epsn))))/2., 2) - 


                          2*(as2*ch + as1*d)*


                            e0c*(-(b*pow(d, 2)*fc*


                                        pow(epsc1 + 2*epsn, 


                                        2)*((-4 + 7*k)*epsc1 - 


                                        4*(-1 + k)*epsn))/4. + 


                                3*k*pow(epsc1, 


                                    3)*((as2*ch*e0c*epsc1)/2. + 


                                      d*(n0 - (e0c*(as2*epsc1 + 2*as1*epsn + 


                                        2*as2*epsn))/2.))))))/(-8*


                    b*(as2*ch + as1*d)*e0c*fc*(epsc1 - epsn)*


                    pow(epsc1 + 2*epsn, 2) + 


                  k*(12*pow(n0, 2)*pow(epsc1, 2) - 


                        12*(as1 + as2)*e0c*n0*pow(epsc1, 2)*(epsc1 + 2*epsn) +


                         e0c*(3*pow(as2, 2)*e0c*pow(epsc1, 2) + 


                              2*as2*(3*as1*e0c*pow(epsc1, 2) + 


                                    b*ch*fc*(7*epsc1 - 4*epsn)) + 


                              as1*(3*as1*e0c*pow(epsc1, 2) + 


                                    2*b*d*fc*(7*epsc1 - 4*epsn)))*


                          pow(epsc1 + 2*epsn, 2))))/((as2*ch + as1*d)*k*


            pow(epsc1, 2)))/2.;





	ac3 =(sqrt(3.)*((-8*b*(as2*ch + as1*d)*e0c*fc*(epsc1 - epsn)*


                  pow(epsc1 + 2*epsn, 2) + 


                k*(12*pow(n0, 2)*pow(epsc1, 2) - 


                      12*(as1 + as2)*e0c*n0*pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                      e0c*(3*pow(as2, 2)*e0c*pow(epsc1, 2) + 


                            2*as2*(3*as1*e0c*pow(epsc1, 2) + 


                                  b*ch*fc*(7*epsc1 - 4*epsn)) + 


                            as1*(3*as1*e0c*pow(epsc1, 2) + 


                                  2*b*d*fc*(7*epsc1 - 4*epsn)))*


                        pow(epsc1 + 2*epsn, 2)))*(pow(as2, 2)*e0c*k*


                  pow(epsc1, 2) + 


                2*as2*(as1*e0c*k*pow(epsc1, 2) + 


                      b*ch*fc*(k*epsc1 + 4*epsn - 4*k*epsn)) + 


                as1*(as1*e0c*k*pow(epsc1, 2) + 


                      2*b*d*fc*(k*epsc1 + 4*epsn - 4*k*epsn))) - 


          3*e0c*pow(pow(as2, 2)*e0c*k*pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                as1*(2*b*d*


                        fc*(epsc1 + 2*epsn)*((-1 + 2*k)*epsc1 - 


                            2*(-1 + k)*epsn) + 


                      k*pow(epsc1, 2)*(-2*n0 + as1*e0c*(epsc1 + 2*epsn))) + 


                2*as2*(b*ch*


                        fc*(epsc1 + 2*epsn)*((-1 + 2*k)*epsc1 - 


                            2*(-1 + k)*epsn) + 


                      k*pow(epsc1, 2)*(-n0 + as1*e0c*(epsc1 + 2*epsn))), 2))*


      sqrt(k*pow(epsc1, 


            2)*(3*k*pow(epsc1, 2)*


                pow(as2*ch*e0c*


                      epsc1 + (d*(2*n0 + 


                              e0c*(as1*(epsc1 - 2*epsn) - 


                                    as2*(epsc1 + 2*epsn))))/2., 2) - 


              2*(as2*ch + as1*d)*


                e0c*(-(b*pow(d, 2)*fc*


                            pow(epsc1 + 2*epsn, 


                              2)*((-4 + 7*k)*epsc1 - 4*(-1 + k)*epsn))/4. + 


                    3*k*pow(epsc1, 


                        3)*((as2*ch*e0c*epsc1)/2. + 


                          d*(n0 - (e0c*(as2*epsc1 + 2*as1*epsn + 2*as2*epsn))/


                                  2.))))))/((as2*ch + as1*d)*k*pow(epsc1, 2)*


      pow(-8*b*(as2*ch + as1*d)*e0c*fc*(epsc1 - epsn)*pow(epsc1 + 2*epsn, 2) +


           k*(12*pow(n0, 2)*pow(epsc1, 2) - 


                12*(as1 + as2)*e0c*n0*pow(epsc1, 2)*(epsc1 + 2*epsn) + 


                e0c*(3*pow(as2, 2)*e0c*pow(epsc1, 2) + 


                      2*as2*(3*as1*e0c*pow(epsc1, 2) + 


                            b*ch*fc*(7*epsc1 - 4*epsn)) + 


                      as1*(3*as1*e0c*pow(epsc1, 2) + 


                            2*b*d*fc*(7*epsc1 - 4*epsn)))*


                  pow(epsc1 + 2*epsn, 2)), 2));





	epschr3 =(-ac2 + sqrt(pow(ac2, 2) - 4*ac1*ac3))/(2.*ac3);





	return epschr3;


}


 


//hodnota ohyboveho momentu, kdy dochazi k teceni vyztuze As2, ale netece As1 a ani nedochazi k drceni betonu, x < h


double normmat::compute_mhr3 ()


{


	double mhr3;	


	


	mhr3 =(6*as1*e0c*(-2*cd + 


            h)*(epsn + (6*as2*ch*e0c*k*epschr3*pow(epsc1, 2) + 


                  3*d*k*pow(epsc1, 


                      2)*(n0 + as1*e0c*(epschr3 - epsn) - 


                        as2*e0c*(epschr3 + epsn)) + 


                  sqrt(3.)*


                    sqrt(k*pow(epsc1, 


                          2)*(3*k*pow(epsc1, 2)*


                              pow(-2*as2*ch*e0c*epschr3 + 


                                  d*(-n0 + 


                                        e0c*(as1*(-epschr3 + epsn) + 


                                        as2*(epschr3 + epsn))), 2) - 


                            2*(as2*ch + as1*d)*


                              e0c*(b*pow(d, 2)*fc*


                                    pow(epschr3 + epsn, 


                                      2)*(4*(-1 + k)*epschr3 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                  6*k*epschr3*


                                    pow(epsc1, 


                                      2)*(as2*ch*e0c*epschr3 + 


                                        d*(n0 - 


                                        e0c*(as1*epsn + 


                                        as2*(epschr3 + epsn))))))))/(6.*(as2*


                        ch + as1*d)*e0c*k*pow(epsc1, 2))) - 


      6*as2*e0c*(-2*ch + h)*(epschr3 - (ch*epschr3)/d + 


            epsn + (ch*(6*as2*ch*e0c*k*epschr3*pow(epsc1, 2) + 


                      3*d*k*pow(epsc1, 


                          2)*(n0 + as1*e0c*(epschr3 - epsn) - 


                            as2*e0c*(epschr3 + epsn)) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*e0c*epschr3 + 


                                      d*(-n0 + 


                                        e0c*(as1*(-epschr3 + epsn) + 


                                        as2*(epschr3 + epsn))), 2) - 


                                2*(as2*ch + as1*d)*


                                  e0c*(b*pow(d, 2)*fc*


                                        pow(epschr3 + epsn, 


                                        2)*(4*(-1 + k)*epschr3 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                      6*k*epschr3*


                                        pow(epsc1, 


                                        2)*(as2*ch*e0c*epschr3 + 


                                        d*(n0 - e0c*(as1*epsn + 


                                        as2*(epschr3 + epsn)))))))))/(6.*


                  d*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2))) - (b*d*fc*


            pow(epschr3 + epsn, 


              2)*(2*d*(epschr3 + 


                      epsn)*((-1 + k)*epschr3 + (2 - 3*k)*epsc1 + (-1 + k)*


                        epsn) - 


                h*(4*(-1 + k)*epschr3 + (6 - 9*k)*epsc1 + 


                      4*(-1 + k)*


                        epsn)*(epschr3 - (6*as2*ch*e0c*k*epschr3*


                              pow(epsc1, 2) + 


                            3*d*k*pow(epsc1, 


                                2)*(n0 + as1*e0c*(epschr3 - epsn) - 


                                  as2*e0c*(epschr3 + epsn)) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(-2*as2*ch*e0c*epschr3 + 


                                        d*(-n0 + e0c*(as1*(-epschr3 + epsn) + 


                                        as2*(epschr3 + epsn))), 2) - 


                                      2*(as2*ch + as1*d)*


                                        e0c*(b*pow(d, 2)*fc*


                                        pow(epschr3 + epsn, 


                                        2)*(4*(-1 + k)*epschr3 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                        6*k*epschr3*


                                        pow(epsc1, 


                                        2)*(as2*ch*e0c*epschr3 + 


                                        d*(n0 - e0c*(as1*epsn + 


                                        as2*(epschr3 + epsn))))))))/(6.*(as2*


                                  ch + as1*d)*e0c*k*pow(epsc1, 2)))))/(k*


            pow(epsc1, 2)*


            pow(epschr3 - (6*as2*ch*e0c*k*epschr3*pow(epsc1, 2) + 


                      3*d*k*pow(epsc1, 


                          2)*(n0 + as1*e0c*(epschr3 - epsn) - 


                            as2*e0c*(epschr3 + epsn)) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*e0c*epschr3 + 


                                      d*(-n0 + 


                                        e0c*(as1*(-epschr3 + epsn) + 


                                        as2*(epschr3 + epsn))), 2) - 


                                2*(as2*ch + as1*d)*


                                  e0c*(b*pow(d, 2)*fc*


                                        pow(epschr3 + epsn, 


                                        2)*(4*(-1 + k)*epschr3 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                      6*k*epschr3*


                                        pow(epsc1, 


                                        2)*(as2*ch*e0c*epschr3 + 


                                        d*(n0 - e0c*(as1*epsn + 


                                        as2*(epschr3 + epsn))))))))/(6.*(as2*


                            ch + as1*d)*e0c*k*pow(epsc1, 2)), 2)))/12. + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mhr3;


}


  


//TLACENA VYZTUZ + NORMALOVA SILA + TECENI V As2 + x > h


 


//pretvoreni betonu, kdy dochazi k teceni vyztuze As2, ale netece As1 a ani nedochazi k drceni betonu, x > h


double normmat::compute_epschr4 ()


{


  double ac1,ac2,ac3,epschr4;





  ac1 =(-(ch*e0c*epsc1)/2. + d*(fy + (e0c*epsc1)/2. + e0c*epsn))/(ch*


        e0c) + (sqrt(3.)*b*fc*h*(-1 + k)*


          pow(epsc1, 


            4)*(pow(b, 2)*pow(fc, 2)*pow(h, 4)*pow(2 - 3*k, 2) + 


              4*pow(e0c, 


                  2)*(pow(as2, 2)*(3*pow(ch, 2) - 3*ch*h + pow(h, 2)) + 


                    pow(as1, 2)*(3*pow(d, 2) - 3*d*h + pow(h, 2)) + 


                    as1*as2*(6*ch*d - 3*ch*h - 3*d*h + 2*pow(h, 2)))*


                pow(k, 2)*pow(epsc1, 2) - 


              2*b*fc*pow(h, 3)*


                k*(4*(-1 + k)*n0 - (as1 + as2)*e0c*(-2 + 3*k)*epsc1))*


          sqrt(pow(d, 


                2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                    pow(epsc1, 4) + 


                  pow(b, 2)*pow(fc, 2)*


                    pow(h, 4)*((-4 + 7*k)*epsc1 - 


                        4*(-1 + k)*epsn)*((-4 + 5*k)*epsc1 + 


                        4*(-1 + k)*epsn) + 


                  4*b*fc*pow(h, 2)*k*


                    pow(epsc1, 


                      2)*(3*(as2*ch + as1*d)*


                          e0c*(k*(epsc1 - 4*epsn) + 4*epsn) + 


                        8*h*(-1 + 


                              k)*(-n0 + (as1 + as2)*


                                e0c*(epsc1/2. + epsn))))))/


      pow(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*pow(epsc1, 4) + 


        pow(b, 2)*pow(fc, 2)*


          pow(h, 4)*((16 - 48*k + 35*pow(k, 2))*pow(epsc1, 2) + 


              8*(-1 + k)*k*epsc1*epsn - 16*pow(-1 + k, 2)*pow(epsn, 2)) + 


        4*b*fc*pow(h, 2)*k*


          pow(epsc1, 


            2)*(3*(as2*ch + as1*d)*e0c*(k*(epsc1 - 4*epsn) + 4*epsn) - 


              4*h*(-1 + k)*(2*n0 - (as1 + as2)*e0c*(epsc1 + 2*epsn))), 


      2) + (6*as2*ch*d*e0c*k*pow(epsc1, 2) + 


        6*as1*pow(d, 2)*e0c*k*pow(epsc1, 2) + 


        b*fc*pow(h, 


            2)*(4*h*(-1 + k)*epsc1 + 3*d*(k*epsc1 + 4*epsn - 4*k*epsn)) - 


        sqrt(3.)*sqrt(pow(d, 


                2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                    pow(epsc1, 4) + 


                  pow(b, 2)*pow(fc, 2)*


                    pow(h, 4)*((-4 + 5*k)*epsc1 + 


                        4*(-1 + k)*epsn)*(-4*epsc1 + 7*k*epsc1 + 4*epsn - 


                        4*k*epsn) + 


                  4*b*fc*pow(h, 2)*k*


                    pow(epsc1, 


                      2)*(3*(as2*ch + as1*d)*


                          e0c*(k*epsc1 + 4*epsn - 4*k*epsn) + 


                        8*h*(-1 + 


                              k)*(-n0 + (as1 + as2)*


                                e0c*(epsc1/2. + epsn))))))/(8.*b*fc*


        pow(h, 3)*(-1 + k)) - (epsc1*(-1 + 


            d/ch - (3*d - 


                  2*h + (sqrt(3.)*(2*


                              e0c*(-3*as2*ch - 3*as1*d + 2*as1*h + 2*as2*h)*k*


                              pow(epsc1, 2) + 


                            b*fc*pow(h, 2)*(k*(epsc1 - 4*epsn) + 4*epsn))*


                        sqrt(pow(d, 


                              2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*


                                  pow(k, 2)*pow(epsc1, 4) + 


                                pow(b, 2)*pow(fc, 2)*


                                  pow(h, 


                                    4)*((-4 + 7*k)*epsc1 - 


                                      4*(-1 + k)*epsn)*((-4 + 5*k)*epsc1 + 


                                      4*(-1 + k)*epsn) + 


                                4*b*fc*pow(h, 2)*k*


                                  pow(epsc1, 


                                    2)*(3*(as2*ch + as1*d)*


                                        e0c*(k*(epsc1 - 4*epsn) + 4*epsn) + 


                                      8*h*(-1 + 


                                        k)*(-n0 + (as1 + as2)*


                                        e0c*(epsc1/2. + epsn))))))/(12*


                          pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                          pow(epsc1, 4) + 


                        pow(b, 2)*pow(fc, 2)*


                          pow(h, 


                            4)*((16 - 48*k + 35*pow(k, 2))*pow(epsc1, 2) + 


                              8*(-1 + k)*k*epsc1*epsn - 


                              16*pow(-1 + k, 2)*pow(epsn, 2)) + 


                        4*b*fc*pow(h, 2)*k*


                          pow(epsc1, 


                            2)*(3*(as2*ch + as1*d)*


                                e0c*(k*(epsc1 - 4*epsn) + 4*epsn) - 


                              4*h*(-1 + 


                                    k)*(2*n0 - (as1 + as2)*


                                      e0c*(epsc1 + 2*epsn)))))/(2.*h)))/2.;





	ac2 =-1 + d/ch - (4*sqrt(3.)*b*fc*h*(-1 + k)*


          pow(epsc1, 


            3)*(pow(b, 2)*pow(fc, 2)*pow(h, 4)*pow(2 - 3*k, 2) + 


              4*pow(e0c, 


                  2)*(pow(as2, 2)*(3*pow(ch, 2) - 3*ch*h + pow(h, 2)) + 


                    pow(as1, 2)*(3*pow(d, 2) - 3*d*h + pow(h, 2)) + 


                    as1*as2*(6*ch*d - 3*ch*h - 3*d*h + 2*pow(h, 2)))*


                pow(k, 2)*pow(epsc1, 2) - 


              2*b*fc*pow(h, 3)*


                k*(4*(-1 + k)*n0 - (as1 + as2)*e0c*(-2 + 3*k)*epsc1))*


          sqrt(pow(d, 


                2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                    pow(epsc1, 4) + 


                  pow(b, 2)*pow(fc, 2)*


                    pow(h, 4)*((-4 + 7*k)*epsc1 - 


                        4*(-1 + k)*epsn)*((-4 + 5*k)*epsc1 + 


                        4*(-1 + k)*epsn) + 


                  4*b*fc*pow(h, 2)*k*


                    pow(epsc1, 


                      2)*(3*(as2*ch + as1*d)*


                          e0c*(k*(epsc1 - 4*epsn) + 4*epsn) + 


                        8*h*(-1 + 


                              k)*(-n0 + (as1 + as2)*


                                e0c*(epsc1/2. + epsn))))))/


      pow(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*pow(epsc1, 4) + 


        pow(b, 2)*pow(fc, 2)*


          pow(h, 4)*((16 - 48*k + 35*pow(k, 2))*pow(epsc1, 2) + 


              8*(-1 + k)*k*epsc1*epsn - 16*pow(-1 + k, 2)*pow(epsn, 2)) + 


        4*b*fc*pow(h, 2)*k*


          pow(epsc1, 


            2)*(3*(as2*ch + as1*d)*e0c*(k*(epsc1 - 4*epsn) + 4*epsn) - 


              4*h*(-1 + k)*(2*n0 - (as1 + as2)*e0c*(epsc1 + 2*epsn))), 


      2) - (3*d - 


        2*h + (sqrt(3.)*(2*e0c*(-3*as2*ch - 3*as1*d + 2*as1*h + 2*as2*h)*k*


                    pow(epsc1, 2) + 


                  b*fc*pow(h, 2)*(k*(epsc1 - 4*epsn) + 4*epsn))*


              sqrt(pow(d, 


                    2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                        pow(epsc1, 4) + 


                      pow(b, 2)*pow(fc, 2)*


                        pow(h, 


                          4)*((-4 + 7*k)*epsc1 - 


                            4*(-1 + k)*epsn)*((-4 + 5*k)*epsc1 + 


                            4*(-1 + k)*epsn) + 


                      4*b*fc*pow(h, 2)*k*


                        pow(epsc1, 


                          2)*(3*(as2*ch + as1*d)*


                              e0c*(k*(epsc1 - 4*epsn) + 4*epsn) + 


                            8*h*(-1 + 


                                  k)*(-n0 + (as1 + as2)*


                                    e0c*(epsc1/2. + epsn))))))/(12*


                pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*pow(epsc1, 4) + 


              pow(b, 2)*pow(fc, 2)*


                pow(h, 4)*((16 - 48*k + 35*pow(k, 2))*pow(epsc1, 2) + 


                    8*(-1 + k)*k*epsc1*epsn - 


                    16*pow(-1 + k, 2)*pow(epsn, 2)) + 


              4*b*fc*pow(h, 2)*k*


                pow(epsc1, 


                  2)*(3*(as2*ch + as1*d)*e0c*(k*(epsc1 - 4*epsn) + 4*epsn) - 


                    4*h*(-1 + 


                          k)*(2*n0 - (as1 + as2)*e0c*(epsc1 + 2*epsn)))))/(2.*


        h);





	ac3 =(4*sqrt(3.)*b*fc*h*(-1 + k)*


        pow(epsc1, 


          2)*(pow(b, 2)*pow(fc, 2)*pow(h, 4)*pow(2 - 3*k, 2) + 


            4*pow(e0c, 


                2)*(pow(as2, 2)*(3*pow(ch, 2) - 3*ch*h + pow(h, 2)) + 


                  pow(as1, 2)*(3*pow(d, 2) - 3*d*h + pow(h, 2)) + 


                  as1*as2*(6*ch*d - 3*ch*h - 3*d*h + 2*pow(h, 2)))*pow(k, 2)*


              pow(epsc1, 2) - 


            2*b*fc*pow(h, 3)*


              k*(4*(-1 + k)*n0 - (as1 + as2)*e0c*(-2 + 3*k)*epsc1))*


        sqrt(pow(d, 


              2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                  pow(epsc1, 4) + 


                pow(b, 2)*pow(fc, 2)*


                  pow(h, 4)*((-4 + 7*k)*epsc1 - 


                      4*(-1 + k)*epsn)*((-4 + 5*k)*epsc1 + 4*(-1 + k)*epsn) + 


                4*b*fc*pow(h, 2)*k*


                  pow(epsc1, 


                    2)*(3*(as2*ch + as1*d)*


                        e0c*(k*(epsc1 - 4*epsn) + 4*epsn) + 


                      8*h*(-1 + 


                            k)*(-n0 + (as1 + as2)*e0c*(epsc1/2. + epsn))))))/


    pow(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*pow(epsc1, 4) + 


      pow(b, 2)*pow(fc, 2)*


        pow(h, 4)*((16 - 48*k + 35*pow(k, 2))*pow(epsc1, 2) + 


            8*(-1 + k)*k*epsc1*epsn - 16*pow(-1 + k, 2)*pow(epsn, 2)) + 


      4*b*fc*pow(h, 2)*k*


        pow(epsc1, 


          2)*(3*(as2*ch + as1*d)*e0c*(k*(epsc1 - 4*epsn) + 4*epsn) - 


            4*h*(-1 + k)*(2*n0 - (as1 + as2)*e0c*(epsc1 + 2*epsn))), 2);





	epschr4 =(-ac2 + sqrt(pow(ac2, 2) - 4*ac1*ac3))/(2.*ac3);





	return epschr4;


}


 


//maximalni pretvoreni betonu od ucinku ohyboveho momentu 


double normmat::compute_epscmax1 ()


{


	double epscmax1;





    epscmax1 = epscm - epsn;





	return epscmax1;


}


 


//pretvoreni betonu, kdy uz tece vyztuz As2, netece As1 a ani nedochazi k drceni betonu, ale dochazi ke zmene tlacene plochy x = h 


double normmat::compute_epschr4b ()


{


  double disk,epschr4b;





  disk =(pow(e0c, 2)*


      pow(6*b*fc*pow(h, 2)*epsc1 - 9*b*fc*pow(h, 2)*k*epsc1 + 


          6*as1*d*e0c*k*pow(epsc1, 2) + 6*as2*ch*e0cn*k*pow(epsc1, 2) - 


          6*as1*e0c*h*k*pow(epsc1, 2) - 6*as2*e0cn*h*k*pow(epsc1, 2) - 


          8*b*fc*pow(h, 2)*epsn + 8*b*fc*pow(h, 2)*k*epsn, 2) - 


    4*b*e0c*fc*


      pow(h, 2)*(-4 + 4*k)*(6*as2*e0c*fy*h*k*pow(epsc1, 2) - 


          6*as2*e0cn*fy*h*k*pow(epsc1, 2) + 6*e0c*h*k*n0*pow(epsc1, 2) + 


          6*b*e0c*fc*pow(h, 2)*epsc1*epsn - 


          9*b*e0c*fc*pow(h, 2)*k*epsc1*epsn + 


          6*as1*d*pow(e0c, 2)*k*pow(epsc1, 2)*epsn + 


          6*as2*ch*e0c*e0cn*k*pow(epsc1, 2)*epsn - 


          6*as1*pow(e0c, 2)*h*k*pow(epsc1, 2)*epsn - 


          6*as2*e0c*e0cn*h*k*pow(epsc1, 2)*epsn - 


          4*b*e0c*fc*pow(h, 2)*pow(epsn, 2) + 


			    4*b*e0c*fc*pow(h, 2)*k*pow(epsn, 2)));





  if (disk < 0.0){





    epschr4b=-1.0;





  }


  else{





    epschr4b=1/(2.*b*e0c*fc*


          pow(h, 2)*(-4 + 4*k))*(-e0c*(6*b*fc*pow(h, 2)*epsc1 - 


              9*b*fc*pow(h, 2)*k*epsc1 + 6*as1*d*e0c*k*pow(epsc1, 2) + 


              6*as2*ch*e0cn*k*pow(epsc1, 2) - 6*as1*e0c*h*k*pow(epsc1, 2) - 


              6*as2*e0cn*h*k*pow(epsc1, 2) - 8*b*fc*pow(h, 2)*epsn + 


              8*b*fc*pow(h, 2)*k*epsn) - 


        sqrt(pow(e0c, 2)*


                pow(6*b*fc*pow(h, 2)*epsc1 - 9*b*fc*pow(h, 2)*k*epsc1 + 


                    6*as1*d*e0c*k*pow(epsc1, 2) + 


                    6*as2*ch*e0cn*k*pow(epsc1, 2) - 


                    6*as1*e0c*h*k*pow(epsc1, 2) - 


                    6*as2*e0cn*h*k*pow(epsc1, 2) - 8*b*fc*pow(h, 2)*epsn + 


                    8*b*fc*pow(h, 2)*k*epsn, 2) - 


              4*b*e0c*fc*


                pow(h, 2)*(-4 + 4*k)*(6*as2*e0c*fy*h*k*pow(epsc1, 2) - 


                    6*as2*e0cn*fy*h*k*pow(epsc1, 2) + 


                    6*e0c*h*k*n0*pow(epsc1, 2) + 


                    6*b*e0c*fc*pow(h, 2)*epsc1*epsn - 


                    9*b*e0c*fc*pow(h, 2)*k*epsc1*epsn + 


                    6*as1*d*pow(e0c, 2)*k*pow(epsc1, 2)*epsn + 


                    6*as2*ch*e0c*e0cn*k*pow(epsc1, 2)*epsn - 


                    6*as1*pow(e0c, 2)*h*k*pow(epsc1, 2)*epsn - 


                    6*as2*e0c*e0cn*h*k*pow(epsc1, 2)*epsn - 


                    4*b*e0c*fc*pow(h, 2)*pow(epsn, 2) + 


				      4*b*e0c*fc*pow(h, 2)*k*pow(epsn, 2))));





  }


  return epschr4b;


}


 


//pomocne pretvoreni betonu


double normmat::compute_epschrk1a ()


{


  double epschrk1a;





  if ((epscmax1-epschr4b) < 0.0){





    epschrk1a=epschr4b;





  }


  else{





    epschrk1a=epscmax1;





  }


  return epschrk1a;


 }


 


//hodnota ohyboveho momentu, kdy dochazi k teceni vyztuze As2, ale netece As1 a ani nedochazi k drceni betonu, x > h


double normmat::compute_mhr4 ()


{


	double mhr4;	


	


	mhr4 =((12*b*d*fc*pow(h, 2)*epschr4 - 12*b*d*fc*pow(h, 2)*k*epschr4 - 


            6*b*d*fc*pow(h, 2)*epsc1 + 9*b*d*fc*pow(h, 2)*k*epsc1 + 


            6*as2*ch*d*e0c*k*pow(epsc1, 2) + 


            6*as1*pow(d, 2)*e0c*k*pow(epsc1, 2) + 12*b*d*fc*pow(h, 2)*epsn - 


            12*b*d*fc*pow(h, 2)*k*epsn - 


            sqrt(3.)*sqrt(pow(d, 


                    2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                        pow(epsc1, 4) - 


                      pow(b, 2)*pow(fc, 2)*


                        pow(h, 


                          4)*(4*(-1 + k)*epschr4 + (6 - 9*k)*epsc1 + 


                            4*(-1 + k)*epsn)*(4*(-1 + k)*epschr4 + (-2 + 3*k)*


                              epsc1 + 4*(-1 + k)*epsn) + 


                      4*b*fc*pow(h, 2)*k*


                        pow(epsc1, 


                          2)*(3*(as2*ch + as1*d)*


                              e0c*(-4*(-1 + k)*epschr4 + (-2 + 3*k)*epsc1 - 


                                  4*(-1 + k)*epsn) + 


                            8*h*(-1 + 


                                  k)*(-n0 + (as1 + as2)*


                                    e0c*(epschr4 + epsn))))))*(4*b*d*fc*


              pow(h, 2)*epschr4 - 4*b*d*fc*pow(h, 2)*k*epschr4 - 


            2*b*d*fc*pow(h, 2)*epsc1 + 3*b*d*fc*pow(h, 2)*k*epsc1 - 


            6*as2*ch*d*e0c*k*pow(epsc1, 2) - 


            6*as1*pow(d, 2)*e0c*k*pow(epsc1, 2) + 4*b*d*fc*pow(h, 2)*epsn - 


            4*b*d*fc*pow(h, 2)*k*epsn + 


            sqrt(3.)*sqrt(pow(d, 


                    2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                        pow(epsc1, 4) - 


                      pow(b, 2)*pow(fc, 2)*


                        pow(h, 


                          4)*(4*(-1 + k)*epschr4 + (6 - 9*k)*epsc1 + 


                            4*(-1 + k)*epsn)*(4*(-1 + k)*epschr4 + (-2 + 3*k)*


                              epsc1 + 4*(-1 + k)*epsn) + 


                      4*b*fc*pow(h, 2)*k*


                        pow(epsc1, 


                          2)*(3*(as2*ch + as1*d)*


                              e0c*(-4*(-1 + k)*epschr4 + (-2 + 3*k)*epsc1 - 


                                  4*(-1 + k)*epsn) + 


                            8*h*(-1 + 


                                  k)*(-n0 + (as1 + as2)*


                                    e0c*(epschr4 + epsn)))))))/(384.*b*


        pow(d, 2)*fc*pow(h, 2)*(-1 + k)*k*pow(epsc1, 2)) + (as1*


        e0c*(-2*cd + 


            h)*(epsn + (6*d*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2) + 


                  b*fc*pow(h, 


                      2)*(8*h*(-1 + k)*epschr4 - 


                        3*d*(4*(-1 + k)*epschr4 + (2 - 3*k)*epsc1 + 


                              4*(-1 + k)*epsn)) - 


                  sqrt(3.)*


                    sqrt(pow(d, 


                          2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                              pow(epsc1, 4) - 


                            pow(b, 2)*pow(fc, 2)*


                              pow(h, 


                                4)*(4*(-1 + k)*epschr4 + (6 - 9*k)*epsc1 + 


                                  4*(-1 + k)*epsn)*(4*(-1 + k)*


                                    epschr4 + (-2 + 3*k)*epsc1 + 


                                  4*(-1 + k)*epsn) + 


                            4*b*fc*pow(h, 2)*k*


                              pow(epsc1, 


                                2)*(3*(as2*ch + as1*d)*


                                    e0c*(-4*(-1 + k)*epschr4 + (-2 + 3*k)*


                                        epsc1 - 4*(-1 + k)*epsn) + 


                                  8*h*(-1 + 


                                        k)*(-n0 + (as1 + as2)*


                                        e0c*(epschr4 + epsn))))))/(8.*b*fc*


                  pow(h, 3)*(-1 + k))))/


    2. - (as2*


        e0c*(-2*ch + h)*(epschr4 - (ch*epschr4)/d + 


            epsn + (ch*(6*d*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2) + 


                      b*fc*pow(h, 


                          2)*(8*h*(-1 + k)*epschr4 - 


                            3*d*(4*(-1 + k)*epschr4 + (2 - 3*k)*epsc1 + 


                                  4*(-1 + k)*epsn)) - 


                      sqrt(3.)*


                        sqrt(pow(d, 


                              2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*


                                  pow(k, 2)*pow(epsc1, 4) - 


                                pow(b, 2)*pow(fc, 2)*


                                  pow(h, 


                                    4)*(4*(-1 + k)*epschr4 + (6 - 9*k)*


                                        epsc1 + 


                                      4*(-1 + k)*epsn)*(4*(-1 + k)*


                                        epschr4 + (-2 + 3*k)*epsc1 + 


                                      4*(-1 + k)*epsn) + 


                                4*b*fc*pow(h, 2)*k*


                                  pow(epsc1, 


                                    2)*(3*(as2*ch + as1*d)*


                                        e0c*(-4*(-1 + k)*epschr4 + (-2 + 3*k)*


                                        epsc1 - 4*(-1 + k)*epsn) + 


                                      8*h*(-1 + 


                                        k)*(-n0 + (as1 + as2)*


                                        e0c*(epschr4 + epsn)))))))/(8.*b*d*fc*


                  pow(h, 3)*(-1 + k))))/2. + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mhr4;


}


 


//hodnota ohyboveho momentu, kdy uz tece vyztuz As2, netece As1 a ani nedochazi k drceni betonu, ale dochazi ke zmene tlacene plochy x = h


double normmat::compute_mhr4b ()





{


	double mhr4b;	


	


	


  if (epschr4b < 0.0 && epschr4b!=-1.0){





    mhr4b=1/(384.*b*pow(d, 2)*pow(e0c, 2)*fc*pow(h, 2)*(-1 + k)*k*


          pow(epsc1, 2))*((-6*b*d*e0c*fc*pow(h, 2)*epsc1 + 


            9*b*d*e0c*fc*pow(h, 2)*k*epsc1 + 


            6*as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) + 


            6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


            12*b*d*e0c*fc*pow(h, 2)*epschr4b - 


            12*b*d*e0c*fc*pow(h, 2)*k*epschr4b + 


            12*b*d*e0c*fc*pow(h, 2)*epsn - 12*b*d*e0c*fc*pow(h, 2)*k*epsn - 


            sqrt(e0c*(e0c*


                        pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                            b*fc*pow(h, 


                                2)*(8*h*(-1 + k)*epschr4b - 


                                  3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epschr4b + 


                                        4*(-1 + k)*epsn)), 2) + 


                      16*b*fc*


                        pow(h, 


                          3)*(-1 + 


                            k)*(b*e0c*fc*


                              h*(-4*pow(h, 2)*(-1 + k)*pow(epschr4b, 2) - 


                                  6*pow(d, 


                                      2)*(epschr4b + epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epschr4b + 


                                        2*(-1 + k)*epsn) + 


                                  3*d*h*


                                    epschr4b*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epschr4b + 


                                        4*(-1 + k)*epsn)) + 


                            6*d*k*pow(epsc1, 


                                2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                  as2*(-ch*e0c*e0cn*epschr4b + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epschr4b + 


                                        epsn)))))))))*(-2*b*d*e0c*fc*


              pow(h, 2)*epsc1 + 3*b*d*e0c*fc*pow(h, 2)*k*epsc1 - 


            6*as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) - 


            6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


            4*b*d*e0c*fc*pow(h, 2)*epschr4b - 


            4*b*d*e0c*fc*pow(h, 2)*k*epschr4b + 4*b*d*e0c*fc*pow(h, 2)*epsn - 


            4*b*d*e0c*fc*pow(h, 2)*k*epsn + 


            sqrt(e0c*(e0c*


                        pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                            b*fc*pow(h, 


                                2)*(8*h*(-1 + k)*epschr4b - 


                                  3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epschr4b + 


                                        4*(-1 + k)*epsn)), 2) + 


                      16*b*fc*


                        pow(h, 


                          3)*(-1 + 


                            k)*(b*e0c*fc*


                              h*(-4*pow(h, 2)*(-1 + k)*pow(epschr4b, 2) - 


                                  6*pow(d, 


                                      2)*(epschr4b + epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epschr4b + 


                                        2*(-1 + k)*epsn) + 


                                  3*d*h*


                                    epschr4b*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epschr4b + 


                                        4*(-1 + k)*epsn)) + 


                            6*d*k*pow(epsc1, 


                                2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                  as2*(-ch*e0c*e0cn*epschr4b + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epschr4b + 


                                        epsn)))))))))) + 


  0.5*as1*e0c*(-2*cd + h)*(epsn + 


        1/(8.*b*e0c*fc*pow(h, 3)*(-1 + k))*(6*d*e0c*(as1*d*e0c + as2*ch*e0cn)*


                k*pow(epsc1, 2) + 


              b*e0c*fc*


                pow(h, 2)*(8*h*(-1 + k)*epschr4b - 


                    3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epschr4b + 


                          4*(-1 + k)*epsn)) - 


              sqrt(e0c*(e0c*


                          pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                              b*fc*pow(h, 


                                  2)*(8*h*(-1 + k)*epschr4b - 


                                    3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epschr4b + 


                                        4*(-1 + k)*epsn)), 2) + 


                        16*b*fc*


                          pow(h, 


                            3)*(-1 + 


                              k)*(b*e0c*fc*


                                h*(-4*pow(h, 2)*(-1 + k)*pow(epschr4b, 2) - 


                                    6*pow(d, 


                                        2)*(epschr4b + 


                                        epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epschr4b + 


                                        2*(-1 + k)*epsn) + 


                                    3*d*h*


                                      epschr4b*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epschr4b + 


                                        4*(-1 + k)*epsn)) + 


                              6*d*k*pow(epsc1, 


                                  2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                    as2*(-ch*e0c*e0cn*epschr4b + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epschr4b + 


                                        epsn)))))))))) + 


  0.5*as2*(-2*ch + h)*(fy - 


        e0cn*(fy/e0c + epschr4b - (ch*epschr4b)/d + epsn + 


              1/(8.*b*d*e0c*fc*


                      pow(h, 3)*(-1 + k))*(ch*(6*d*


                          e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                        b*e0c*fc*


                          pow(h, 


                            2)*(8*h*(-1 + k)*epschr4b - 


                              3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epschr4b + 


                                    4*(-1 + k)*epsn)) - 


                        sqrt(e0c*(e0c*


                                    pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                        pow(epsc1, 2) + 


                                        b*fc*


                                        pow(h, 


                                        2)*(8*h*(-1 + k)*epschr4b - 


                                        3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epschr4b + 


                                        4*(-1 + k)*epsn)), 2) + 


                                  16*b*fc*


                                    pow(h, 


                                      3)*(-1 + 


                                        k)*(b*e0c*fc*


                                        h*(-4*pow(h, 2)*(-1 + k)*


                                        pow(epschr4b, 2) - 


                                        6*pow(d, 2)*(epschr4b + 


                                        epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epschr4b + 


                                        2*(-1 + k)*epsn) + 


                                        3*d*h*epschr4b*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epschr4b + 


                                        4*(-1 + k)*epsn)) + 


                                        6*d*k*


                                        pow(epsc1, 


                                        2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                        as2*(-ch*e0c*e0cn*epschr4b + 


                                        d*(e0cn*fy + e0c*(-fy + 


                                        e0cn*(epschr4b + epsn)))))))))))) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





  }


  else{


    mhr4b=1000000000.0;


  }


  return mhr4b;


}


  


//pretvoreni betonu, ktere odpovida max. dosazenemu ohybovemu momentu, kdy uz tece vyztuz As2, netece As1 a dochazi k drceni betonu, x > h   poyor ynamenko


double normmat::compute_epscmax1p ()


{


	double disk,epscmax1p;





	disk =e0c*(e0c*pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


            b*fc*pow(h, 


                2)*(8*h*(-1 + k)*epscmax1 - 


                  3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscmax1 + 


                        4*(-1 + k)*epsn)), 2) + 


      16*b*fc*pow(h, 


          3)*(-1 + 


            k)*(b*e0c*fc*


              h*(-4*pow(h, 2)*(-1 + k)*pow(epscmax1, 2) - 


                  6*pow(d, 


                      2)*(epscmax1 + epsn)*((2 - 3*k)*epsc1 + 


                        2*(-1 + k)*epscmax1 + 2*(-1 + k)*epsn) + 


                  3*d*h*epscmax1*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscmax1 + 


                        4*(-1 + k)*epsn)) + 


            6*d*k*pow(epsc1, 


                2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                  as2*(-(ch*e0c*e0cn*epscmax1) + 


                        d*(e0cn*fy + e0c*(-fy + e0cn*(epscmax1 + epsn)))))));





  if (disk < 0.0){





    epscmax1p=1/(4.*b*sqrt(e0c)*fc*pow(h, 2)*(-1 + k))*(-2*epsc1*


          sqrt(pow(b, 2)*e0c*pow(fc, 2)*pow(h, 4)*pow(2 - 3*k, 2) + 


              4*e0c*(3*pow(as1*d*e0c + as2*ch*e0cn, 2) - 


                    3*(as1*e0c + as2*e0cn)*(as1*d*e0c + as2*ch*e0cn)*h + 


                    pow(as1*e0c + as2*e0cn, 2)*pow(h, 2))*pow(k, 2)*


                pow(epsc1, 2) + 


              2*b*fc*pow(h, 3)*


                k*(-4*(-1 + k)*(as2*(e0c - e0cn)*fy + e0c*n0) + 


                    e0c*(as1*e0c + as2*e0cn)*(-2 + 3*k)*epsc1)) + 


        sqrt(e0c)*(2*(-3*as1*d*e0c - 3*as2*ch*e0cn + 2*as1*e0c*h + 


                    2*as2*e0cn*h)*k*pow(epsc1, 2) + 


		   b*fc*pow(h, 2)*((-2 + 3*k)*epsc1 - 4*(-1 + k)*epsn))) + 1.e-6;





  }


  else{


    epscmax1p=epscmax1;


  }


  return epscmax1p;


}


  


//max. hodnota ohyboveho momentu, kdy uz tece vyztuz As2, netece As1 a dochazi k drceni betonu, x > h


double normmat::compute_mmax1a ()


{


	double mmax1a;	


	


	mmax1a =((-6*b*d*e0c*fc*pow(h, 2)*epsc1 + 9*b*d*e0c*fc*pow(h, 2)*k*epsc1 + 


            6*as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) + 


            6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


            12*b*d*e0c*fc*pow(h, 2)*epscmax1p - 


            12*b*d*e0c*fc*pow(h, 2)*k*epscmax1p + 


            12*b*d*e0c*fc*pow(h, 2)*epsn - 12*b*d*e0c*fc*pow(h, 2)*k*epsn - 


            sqrt(e0c*(e0c*


                        pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                            b*fc*pow(h, 


                                2)*(8*h*(-1 + k)*epscmax1p - 


                                  3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1p + 


                                        4*(-1 + k)*epsn)), 2) + 


                      16*b*fc*


                        pow(h, 


                          3)*(-1 + 


                            k)*(b*e0c*fc*


                              h*(-4*pow(h, 2)*(-1 + k)*pow(epscmax1p, 2) - 


                                  6*pow(d, 


                                      2)*(epscmax1p + 


                                        epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epscmax1p + 


                                        2*(-1 + k)*epsn) + 


                                  3*d*h*


                                    epscmax1p*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1p + 


                                        4*(-1 + k)*epsn)) + 


                            6*d*k*pow(epsc1, 


                                2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                  as2*(-(ch*e0c*e0cn*epscmax1p) + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscmax1p + 


                                        epsn)))))))))*(-2*b*d*e0c*fc*


              pow(h, 2)*epsc1 + 3*b*d*e0c*fc*pow(h, 2)*k*epsc1 - 


            6*as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) - 


            6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


            4*b*d*e0c*fc*pow(h, 2)*epscmax1p - 


            4*b*d*e0c*fc*pow(h, 2)*k*epscmax1p + 


            4*b*d*e0c*fc*pow(h, 2)*epsn - 4*b*d*e0c*fc*pow(h, 2)*k*epsn + 


            sqrt(e0c*(e0c*


                        pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                            b*fc*pow(h, 


                                2)*(8*h*(-1 + k)*epscmax1p - 


                                  3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1p + 


                                        4*(-1 + k)*epsn)), 2) + 


                      16*b*fc*


                        pow(h, 


                          3)*(-1 + 


                            k)*(b*e0c*fc*


                              h*(-4*pow(h, 2)*(-1 + k)*pow(epscmax1p, 2) - 


                                  6*pow(d, 


                                      2)*(epscmax1p + 


                                        epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epscmax1p + 


                                        2*(-1 + k)*epsn) + 


                                  3*d*h*


                                    epscmax1p*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1p + 


                                        4*(-1 + k)*epsn)) + 


                            6*d*k*pow(epsc1, 


                                2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                  as2*(-(ch*e0c*e0cn*epscmax1p) + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscmax1p + 


                                        epsn))))))))))/(384.*b*pow(d, 2)*


        pow(e0c, 2)*fc*pow(h, 2)*(-1 + k)*k*pow(epsc1, 2)) + (as1*


        e0c*(-2*cd + 


            h)*(epsn + (6*d*e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                  b*e0c*fc*


                    pow(h, 


                      2)*(8*h*(-1 + k)*epscmax1p - 


                        3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscmax1p + 


                              4*(-1 + k)*epsn)) - 


                  sqrt(e0c*(e0c*


                              pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                    pow(epsc1, 2) + 


                                  b*fc*pow(h, 


                                      2)*(8*h*(-1 + k)*epscmax1p - 


                                        3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1p + 


                                        4*(-1 + k)*epsn)), 2) + 


                            16*b*fc*


                              pow(h, 


                                3)*(-1 + 


                                  k)*(b*e0c*fc*


                                    h*(-4*pow(h, 2)*(-1 + k)*


                                        pow(epscmax1p, 2) - 


                                        6*pow(d, 


                                        2)*(epscmax1p + 


                                        epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epscmax1p + 


                                        2*(-1 + k)*epsn) + 


                                        3*d*h*


                                        epscmax1p*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1p + 


                                        4*(-1 + k)*epsn)) + 


                                  6*d*k*


                                    pow(epsc1, 


                                      2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                        as2*(-(ch*e0c*e0cn*epscmax1p) + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscmax1p + 


                                        epsn)))))))))/(8.*b*e0c*fc*


                  pow(h, 3)*(-1 + k))))/


    2. + (as2*(-2*ch + h)*(fy - 


            e0cn*(fy/e0c + epscmax1p - (ch*epscmax1p)/d + 


                  epsn + (ch*(6*d*e0c*(as1*d*e0c + as2*ch*e0cn)*k*


                              pow(epsc1, 2) + 


                            b*e0c*fc*


                              pow(h, 


                                2)*(8*h*(-1 + k)*epscmax1p - 


                                  3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1p + 


                                        4*(-1 + k)*epsn)) - 


                            sqrt(e0c*(e0c*


                                        pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                        pow(epsc1, 2) + 


                                        b*fc*pow(h, 


                                        2)*(8*h*(-1 + k)*epscmax1p - 


                                        3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1p + 


                                        4*(-1 + k)*epsn)), 2) + 


                                      16*b*fc*


                                        pow(h, 


                                        3)*(-1 + 


                                        k)*(b*e0c*fc*


                                        h*(-4*pow(h, 2)*(-1 + k)*


                                        pow(epscmax1p, 2) - 


                                        6*pow(d, 2)*(epscmax1p + 


                                        epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epscmax1p + 


                                        2*(-1 + k)*epsn) + 


                                        3*d*h*epscmax1p*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1p + 


                                        4*(-1 + k)*epsn)) + 


                                        6*d*k*


                                        pow(epsc1, 


                                        2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                        as2*(-(ch*e0c*e0cn*epscmax1p) + 


                                        d*(e0cn*fy + e0c*(-fy + 


                                        e0cn*(epscmax1p + epsn))))))))))/(8.*


                        b*d*e0c*fc*pow(h, 3)*(-1 + k)))))/2. + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mmax1a;


}


 


//hranicni ohybovy moment


double normmat::compute_mh1 ()


{


  double mh1;





  if ((mhr1-mhr4) > 0.0){





   mh1=mhr4;





  }


  else{


     mh1=mhr1;


  }


  return mh1;


 }


  


//hranicni pretvoreni betonu


double normmat::compute_epsch1 ()


{


  double epsch1;





  if ((mhr1-mhr4) > 0.0){





    epsch1=epschr4;





  }


  else{


      epsch1=epschr1;


  }


  return epsch1;


 }


 


//hodnota ohyboveho momentu pro pretvoreni na polovine danneho intervalu, x > h


double normmat::compute_mh1hrk1a ()


{


	double mh1hrk1a;	


	


	mh1hrk1a =(-24*as1*(2*cd - h)*(6*as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) + 


            6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


            b*e0c*fc*


              pow(h, 2)*(4*h*(-1 + k)*(epsch1 + epschrk1a + 2*epsn) + 


                  3*d*((-2 + 3*k)*epsc1 - 


                        2*(-1 + k)*(epsch1 + epschrk1a + 2*epsn))) - 


            sqrt(e0c*(e0c*


                        pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                            b*fc*pow(h, 


                                2)*(4*h*(-1 + k)*(epsch1 + epschrk1a) + 


                                  3*d*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*(epsch1 + epschrk1a + 


                                        2*epsn))), 2) + 


                      16*b*fc*


                        pow(h, 


                          3)*(-1 + 


                            k)*(b*e0c*fc*


                              h*(-(pow(h, 2)*(-1 + k)*


                                        pow(epsch1 + epschrk1a, 2)) - 


                                  3*pow(d, 


                                      2)*(epsch1 + epschrk1a + 


                                        2*epsn)*((2 - 3*k)*


                                        epsc1 + (-1 + k)*(epsch1 + 


                                        epschrk1a + 2*epsn)) + (3*d*


                                        h*(epsch1 + 


                                        epschrk1a)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*(epsch1 + epschrk1a + 


                                        2*epsn)))/2.) + 


                            6*d*k*pow(epsc1, 


                                2)*(d*


                                    e0c*(-n0 + 


                                        as1*e0c*


                                        epsn) - (as2*(ch*e0c*


                                        e0cn*(epsch1 + epschrk1a) + 


                                        d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch1 + 


                                        epschrk1a + 2*epsn)))))/


                                    2.))))) + (h*(6*as1*pow(d, 2)*pow(e0c, 2)*


                  k*pow(epsc1, 2) + 6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


                3*b*d*e0c*fc*


                  pow(h, 2)*((-2 + 3*k)*epsc1 - 


                      2*(-1 + k)*(epsch1 + epschrk1a + 2*epsn)) - 


                sqrt(e0c*(e0c*


                            pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                  pow(epsc1, 2) + 


                                b*fc*pow(h, 


                                    2)*(4*h*(-1 + k)*(epsch1 + epschrk1a) + 


                                      3*d*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*(epsch1 + epschrk1a + 


                                        2*epsn))), 2) + 


                          16*b*fc*


                            pow(h, 


                              3)*(-1 + 


                                k)*(b*e0c*fc*


                                  h*(-(pow(h, 2)*(-1 + k)*


                                        pow(epsch1 + epschrk1a, 2)) - 


                                      3*pow(d, 


                                        2)*(epsch1 + epschrk1a + 


                                        2*epsn)*((2 - 3*k)*


                                        epsc1 + (-1 + k)*(epsch1 + 


                                        epschrk1a + 2*epsn)) + (3*d*


                                        h*(epsch1 + 


                                        epschrk1a)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*(epsch1 + epschrk1a + 


                                        2*epsn)))/2.) + 


                                6*d*k*


                                  pow(epsc1, 


                                    2)*(d*


                                        e0c*(-n0 + 


                                        as1*e0c*


                                        epsn) - (as2*(ch*e0c*


                                        e0cn*(epsch1 + epschrk1a) + 


                                        d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch1 + 


                                        epschrk1a + 2*epsn)))))/2.)))))*(-6*


                  as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) - 


                6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


                b*d*e0c*fc*


                  pow(h, 2)*((-2 + 3*k)*epsc1 - 


                      2*(-1 + k)*(epsch1 + epschrk1a + 2*epsn)) + 


                sqrt(e0c*(e0c*


                            pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                  pow(epsc1, 2) + 


                                b*fc*pow(h, 


                                    2)*(4*h*(-1 + k)*(epsch1 + epschrk1a) + 


                                      3*d*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*(epsch1 + epschrk1a + 


                                        2*epsn))), 2) + 


                          16*b*fc*


                            pow(h, 


                              3)*(-1 + 


                                k)*(b*e0c*fc*


                                  h*(-(pow(h, 2)*(-1 + k)*


                                        pow(epsch1 + epschrk1a, 2)) - 


                                      3*pow(d, 


                                        2)*(epsch1 + epschrk1a + 


                                        2*epsn)*((2 - 3*k)*


                                        epsc1 + (-1 + k)*(epsch1 + 


                                        epschrk1a + 2*epsn)) + (3*d*


                                        h*(epsch1 + 


                                        epschrk1a)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*(epsch1 + epschrk1a + 


                                        2*epsn)))/2.) + 


                                6*d*k*


                                  pow(epsc1, 


                                    2)*(d*


                                        e0c*(-n0 + 


                                        as1*e0c*


                                        epsn) - (as2*(ch*e0c*


                                        e0cn*(epsch1 + epschrk1a) + 


                                        d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch1 + 


                                        epschrk1a + 2*epsn)))))/


                                        2.))))))/(pow(d, 2)*pow(e0c, 2)*k*


            pow(epsc1, 2)) + (24*


            as2*(2*ch - 


                h)*(b*d*fc*


                  pow(h, 2)*(8*e0cn*fy*h*(-1 + k) + 


                      e0c*(-8*fy*h*(-1 + k) + 


                            e0cn*(4*


                                    h*(-1 + k)*(epsch1 + epschrk1a + 


                                        2*epsn) + 


                                  3*ch*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*(epsch1 + epschrk1a + 


                                        2*epsn))))) + 


                ch*e0cn*(6*as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) + 


                      6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) - 


                      sqrt(e0c*(e0c*


                                  pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                        pow(epsc1, 2) + 


                                      b*fc*pow(h, 


                                        2)*(4*


                                        h*(-1 + k)*(epsch1 + epschrk1a) + 


                                        3*d*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*(epsch1 + epschrk1a + 


                                        2*epsn))), 2) + 


                                16*b*fc*


                                  pow(h, 


                                    3)*(-1 + 


                                      k)*(b*e0c*fc*


                                        h*(-(pow(h, 2)*(-1 + k)*


                                        pow(epsch1 + epschrk1a, 2)) - 


                                        3*pow(d, 


                                        2)*(epsch1 + epschrk1a + 


                                        2*epsn)*((2 - 3*k)*


                                        epsc1 + (-1 + k)*(epsch1 + 


                                        epschrk1a + 2*epsn)) + (3*d*


                                        h*(epsch1 + epschrk1a)*((2 - 3*k)*


                                        epsc1 + 2*(-1 + k)*(epsch1 + 


                                        epschrk1a + 2*epsn)))/2.) + 


                                      6*d*k*


                                        pow(epsc1, 


                                        2)*(d*


                                        e0c*(-n0 + 


                                        as1*e0c*epsn) - (as2*(ch*e0c*


                                        e0cn*(epsch1 + epschrk1a) + 


                                        d*(-2*e0cn*fy + e0c*(2*fy - 


                                        e0cn*(epsch1 + epschrk1a + 


                                        2*epsn)))))/2.)))))))/(d*e0c))/(384.*


      b*fc*pow(h, 3)*(-1 + k)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mh1hrk1a;


}


 


//pomocna hodnota ohyboveho momentu


double normmat::compute_mhrk1a ()


{


  double mhrk1a;


  


  if ((epscmax1-epschr4b) < 0.0){


    


    mhrk1a=mhr4b;


    


  }


  else{


    mhrk1a=mmax1a;


  }


  return mhrk1a;


}





  
//hranicni ohybovy moment


double normmat::compute_mh3 ()


{


  double mh3;


  


  if ((mhr4b-mhr1) < 0.0){


    


    mh3=mhr4b;


    


  }


  else{


    mh3=mhr3;


  }


  return mh3;


} 





  
//hranicni pretvoreni betonu


double normmat::compute_epsch3 ()


{


  double epsch3;





  if ((mhr4b-mhr1) < 0.0){





     epsch3=epschr4b;





  }


  else{


     epsch3=epschr3;


  }


  return epsch3;


 } 


 


//hranicni ohybovy moment


double normmat::compute_mh2 ()


{


  double mh2;





  if ((mhr2-mh3) > 0.0){





     mh2=mh3;





  }


  else{


     mh2=mhr2;


  }


  return mh2;


 } 


   


//hranicni pretvoreni betonu


double normmat::compute_epsch2 ()


{


  double epsch2;





  if ((mhr2-mh3) > 0.0){





    epsch2=epsch3;


  }


  else{


     epsch2=epschr2;


  }


  return epsch2;


 } 


  


//pomocne pretvoreni betonu


double normmat::compute_epscder2 ()


{


	double epscder2;





	epscder2 =-(-(mh1*epsch1) + 4*mh1hrk1a*epsch1 - 3*mhrk1a*epsch1 - 3*mh1*epschrk1a + 


        4*mh1hrk1a*epschrk1a - 


        mhrk1a*epschrk1a)/(4.*(mh1 - 2*mh1hrk1a + mhrk1a));





	return epscder2;


}


 


//hodnota maximalniho ohyboveho momentu, kdy uz tece vyztuz As2, netece As1 a dochazi k drceni betonu, x > h


double normmat::compute_mmax1 ()


{


	double mmax1;	


	


	mmax1 =((-6*b*d*e0c*fc*pow(h, 2)*epsc1 + 9*b*d*e0c*fc*pow(h, 2)*k*epsc1 + 


            6*as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) + 


            6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


            12*b*d*e0c*fc*pow(h, 2)*epscder2 - 


            12*b*d*e0c*fc*pow(h, 2)*k*epscder2 + 


            12*b*d*e0c*fc*pow(h, 2)*epsn - 12*b*d*e0c*fc*pow(h, 2)*k*epsn - 


            sqrt(e0c*(e0c*


                        pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                            b*fc*pow(h, 


                                2)*(8*h*(-1 + k)*epscder2 - 


                                  3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscder2 + 


                                        4*(-1 + k)*epsn)), 2) + 


                      16*b*fc*


                        pow(h, 


                          3)*(-1 + 


                            k)*(b*e0c*fc*


                              h*(-4*pow(h, 2)*(-1 + k)*pow(epscder2, 2) - 


                                  6*pow(d, 


                                      2)*(epscder2 + epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epscder2 + 


                                        2*(-1 + k)*epsn) + 


                                  3*d*h*


                                    epscder2*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscder2 + 


                                        4*(-1 + k)*epsn)) + 


                            6*d*k*pow(epsc1, 


                                2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                  as2*(-(ch*e0c*e0cn*epscder2) + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscder2 + 


                                        epsn)))))))))*(-2*b*d*e0c*fc*


              pow(h, 2)*epsc1 + 3*b*d*e0c*fc*pow(h, 2)*k*epsc1 - 


            6*as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) - 


            6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


            4*b*d*e0c*fc*pow(h, 2)*epscder2 - 


            4*b*d*e0c*fc*pow(h, 2)*k*epscder2 + 4*b*d*e0c*fc*pow(h, 2)*epsn - 


            4*b*d*e0c*fc*pow(h, 2)*k*epsn + 


            sqrt(e0c*(e0c*


                        pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                            b*fc*pow(h, 


                                2)*(8*h*(-1 + k)*epscder2 - 


                                  3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscder2 + 


                                        4*(-1 + k)*epsn)), 2) + 


                      16*b*fc*


                        pow(h, 


                          3)*(-1 + 


                            k)*(b*e0c*fc*


                              h*(-4*pow(h, 2)*(-1 + k)*pow(epscder2, 2) - 


                                  6*pow(d, 


                                      2)*(epscder2 + epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epscder2 + 


                                        2*(-1 + k)*epsn) + 


                                  3*d*h*


                                    epscder2*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscder2 + 


                                        4*(-1 + k)*epsn)) + 


                            6*d*k*pow(epsc1, 


                                2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                  as2*(-(ch*e0c*e0cn*epscder2) + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscder2 + 


                                        epsn))))))))))/(384.*b*pow(d, 2)*


        pow(e0c, 2)*fc*pow(h, 2)*(-1 + k)*k*pow(epsc1, 2)) + (as1*


        e0c*(-2*cd + 


            h)*(epsn + (6*d*e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                  b*e0c*fc*


                    pow(h, 2)*(8*h*(-1 + k)*epscder2 - 


                        3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscder2 + 


                              4*(-1 + k)*epsn)) - 


                  sqrt(e0c*(e0c*


                              pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                    pow(epsc1, 2) + 


                                  b*fc*pow(h, 


                                      2)*(8*h*(-1 + k)*epscder2 - 


                                        3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscder2 + 


                                        4*(-1 + k)*epsn)), 2) + 


                            16*b*fc*


                              pow(h, 


                                3)*(-1 + 


                                  k)*(b*e0c*fc*


                                    h*(-4*pow(h, 2)*(-1 + k)*


                                        pow(epscder2, 2) - 


                                        6*pow(d, 


                                        2)*(epscder2 + 


                                        epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epscder2 + 


                                        2*(-1 + k)*epsn) + 


                                        3*d*h*


                                        epscder2*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscder2 + 


                                        4*(-1 + k)*epsn)) + 


                                  6*d*k*


                                    pow(epsc1, 


                                      2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                        as2*(-(ch*e0c*e0cn*epscder2) + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscder2 + 


                                        epsn)))))))))/(8.*b*e0c*fc*


                  pow(h, 3)*(-1 + k))))/


    2. + (as2*(-2*ch + h)*(fy - 


            e0cn*(fy/e0c + epscder2 - (ch*epscder2)/d + 


                  epsn + (ch*(6*d*e0c*(as1*d*e0c + as2*ch*e0cn)*k*


                              pow(epsc1, 2) + 


                            b*e0c*fc*


                              pow(h, 


                                2)*(8*h*(-1 + k)*epscder2 - 


                                  3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscder2 + 


                                        4*(-1 + k)*epsn)) - 


                            sqrt(e0c*(e0c*


                                        pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                        pow(epsc1, 2) + 


                                        b*fc*pow(h, 


                                        2)*(8*h*(-1 + k)*epscder2 - 


                                        3*d*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscder2 + 


                                        4*(-1 + k)*epsn)), 2) + 


                                      16*b*fc*


                                        pow(h, 


                                        3)*(-1 + 


                                        k)*(b*e0c*fc*


                                        h*(-4*pow(h, 2)*(-1 + k)*


                                        pow(epscder2, 2) - 


                                        6*pow(d, 2)*(epscder2 + 


                                        epsn)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*epscder2 + 


                                        2*(-1 + k)*epsn) + 


                                        3*d*h*epscder2*((2 - 3*k)*epsc1 + 


                                        4*(-1 + k)*epscder2 + 


                                        4*(-1 + k)*epsn)) + 


                                        6*d*k*


                                        pow(epsc1, 


                                        2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                        as2*(-(ch*e0c*e0cn*epscder2) + 


                                        d*(e0cn*fy + e0c*(-fy + 


                                        e0cn*(epscder2 + epsn))))))))))/(8.*b*


                        d*e0c*fc*pow(h, 3)*(-1 + k)))))/2. + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mmax1;


}


 


//pomocna hodnota ohyboveho momentu


double normmat::compute_mhrk1 ()


{


	double mhrk1;





	if ((epscder2-epschr4 < 0.0) && (epscder2-epscmax1 > 0.0) && (epscder2-epschr4b > 0.0)){





    mhrk1=mmax1;


  }


  else{


    mhrk1=mhrk1a;


  }


  return mhrk1;


}


 


//pomocne pretvoreni betonu


double normmat::compute_epschrk1 ()


{


	double epschrk1;





	if ((epscder2-epschr4 < 0.0) && (epscder2-epscmax1 > 0.0) && (epscder2-epschr4b > 0.0)){





     epschrk1=epscder2;


  }


  else{


    epschrk1=epschrk1a;


  }


  return epschrk1;


}


  


//hodnota ohyboveho momentu pro pretvoreni na polovine danneho intervalu, x > h 


double normmat::compute_mh1hrk1 ()


{


	double mh1hrk1;	


	


	mh1hrk1 =(-24*as1*(2*cd - h)*(6*as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) + 


            6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


            b*e0c*fc*


              pow(h, 2)*(4*h*(-1 + k)*(epsch1 + epschrk1 + 2*epsn) + 


                  3*d*((-2 + 3*k)*epsc1 - 


                        2*(-1 + k)*(epsch1 + epschrk1 + 2*epsn))) - 


            sqrt(e0c*(e0c*


                        pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                            b*fc*pow(h, 


                                2)*(4*h*(-1 + k)*(epsch1 + epschrk1) + 


                                  3*d*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn))), 2) + 


                      16*b*fc*


                        pow(h, 


                          3)*(-1 + 


                            k)*(b*e0c*fc*


                              h*(-(pow(h, 2)*(-1 + k)*


                                        pow(epsch1 + epschrk1, 2)) - 


                                  3*pow(d, 


                                      2)*(epsch1 + epschrk1 + 


                                        2*epsn)*((2 - 3*k)*


                                        epsc1 + (-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn)) + (3*d*


                                        h*(epsch1 + 


                                        epschrk1)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn)))/2.) + 


                            6*d*k*pow(epsc1, 


                                2)*(d*


                                    e0c*(-n0 + 


                                        as1*e0c*


                                        epsn) - (as2*(ch*e0c*


                                        e0cn*(epsch1 + epschrk1) + 


                                        d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch1 + epschrk1 + 


                                        2*epsn)))))/2.))))) + (h*(6*as1*


                  pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) + 


                6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


                3*b*d*e0c*fc*


                  pow(h, 2)*((-2 + 3*k)*epsc1 - 


                      2*(-1 + k)*(epsch1 + epschrk1 + 2*epsn)) - 


                sqrt(e0c*(e0c*


                            pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                  pow(epsc1, 2) + 


                                b*fc*pow(h, 


                                    2)*(4*h*(-1 + k)*(epsch1 + epschrk1) + 


                                      3*d*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn))), 2) + 


                          16*b*fc*


                            pow(h, 


                              3)*(-1 + 


                                k)*(b*e0c*fc*


                                  h*(-(pow(h, 2)*(-1 + k)*


                                        pow(epsch1 + epschrk1, 2)) - 


                                      3*pow(d, 


                                        2)*(epsch1 + epschrk1 + 


                                        2*epsn)*((2 - 3*k)*


                                        epsc1 + (-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn)) + (3*d*


                                        h*(epsch1 + 


                                        epschrk1)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn)))/2.) + 


                                6*d*k*


                                  pow(epsc1, 


                                    2)*(d*


                                        e0c*(-n0 + 


                                        as1*e0c*


                                        epsn) - (as2*(ch*e0c*


                                        e0cn*(epsch1 + epschrk1) + 


                                        d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch1 + epschrk1 + 


                                        2*epsn)))))/2.)))))*(-6*as1*pow(d, 2)*


                  pow(e0c, 2)*k*pow(epsc1, 2) - 


                6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) + 


                b*d*e0c*fc*


                  pow(h, 2)*((-2 + 3*k)*epsc1 - 


                      2*(-1 + k)*(epsch1 + epschrk1 + 2*epsn)) + 


                sqrt(e0c*(e0c*


                            pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                  pow(epsc1, 2) + 


                                b*fc*pow(h, 


                                    2)*(4*h*(-1 + k)*(epsch1 + epschrk1) + 


                                      3*d*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn))), 2) + 


                          16*b*fc*


                            pow(h, 


                              3)*(-1 + 


                                k)*(b*e0c*fc*


                                  h*(-(pow(h, 2)*(-1 + k)*


                                        pow(epsch1 + epschrk1, 2)) - 


                                      3*pow(d, 


                                        2)*(epsch1 + epschrk1 + 


                                        2*epsn)*((2 - 3*k)*


                                        epsc1 + (-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn)) + (3*d*


                                        h*(epsch1 + 


                                        epschrk1)*((2 - 3*k)*epsc1 + 


                                        2*(-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn)))/2.) + 


                                6*d*k*


                                  pow(epsc1, 


                                    2)*(d*


                                        e0c*(-n0 + 


                                        as1*e0c*


                                        epsn) - (as2*(ch*e0c*


                                        e0cn*(epsch1 + epschrk1) + 


                                        d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch1 + epschrk1 + 


                                        2*epsn)))))/2.))))))/(pow(d, 2)*


            pow(e0c, 2)*k*pow(epsc1, 2)) + (24*


            as2*(2*ch - 


                h)*(b*d*fc*


                  pow(h, 2)*(8*e0cn*fy*h*(-1 + k) + 


                      e0c*(-8*fy*h*(-1 + k) + 


                            e0cn*(4*h*(-1 + k)*(epsch1 + epschrk1 + 2*epsn) + 


                                  3*ch*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn))))) + 


                ch*e0cn*(6*as1*pow(d, 2)*pow(e0c, 2)*k*pow(epsc1, 2) + 


                      6*as2*ch*d*e0c*e0cn*k*pow(epsc1, 2) - 


                      sqrt(e0c*(e0c*


                                  pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                                        pow(epsc1, 2) + 


                                      b*fc*pow(h, 


                                        2)*(4*


                                        h*(-1 + k)*(epsch1 + epschrk1) + 


                                        3*d*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn))), 2) + 


                                16*b*fc*


                                  pow(h, 


                                    3)*(-1 + 


                                      k)*(b*e0c*fc*


                                        h*(-(pow(h, 2)*(-1 + k)*


                                        pow(epsch1 + epschrk1, 2)) - 


                                        3*pow(d, 


                                        2)*(epsch1 + epschrk1 + 


                                        2*epsn)*((2 - 3*k)*


                                        epsc1 + (-1 + k)*(epsch1 + epschrk1 + 


                                        2*epsn)) + (3*d*


                                        h*(epsch1 + epschrk1)*((2 - 3*k)*


                                        epsc1 + 2*(-1 + k)*(epsch1 + 


                                        epschrk1 + 2*epsn)))/2.) + 


                                      6*d*k*


                                        pow(epsc1, 


                                        2)*(d*


                                        e0c*(-n0 + 


                                        as1*e0c*epsn) - (as2*(ch*e0c*


                                        e0cn*(epsch1 + epschrk1) + 


                                        d*(-2*e0cn*fy + e0c*(2*fy - 


                                        e0cn*(epsch1 + epschrk1 + 2*epsn)))))/


                                        2.)))))))/(d*e0c))/(384.*b*fc*


      pow(h, 3)*(-1 + k)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mh1hrk1;


}


 


//TLACENA VYZTUZ + NORMALOVA SILA + TECENI V As1 + TECENI V As2 + x < h


 


//PRVNI TEKLO As1





//pretvoreni betonu, kdy dochazi k teceni vyztuze As2, uz teklo As1 a nedochazi k drceni betonu, x < h


double normmat::compute_epschr5 ()


{


	double ac1,ac2,ac3,epschr5;	




	ac1 =((sqrt(3.)*sqrt(k*pow(epsc1, 


                  2)*(3*k*pow(epsc1, 2)*


                      pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                          d*(-(as1*e0cn*fy) + 


                                e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                      as1*(fy + e0cn*(-epsc1 + epsn)))), 2) - 


                    2*e0c*(as2*ch*e0c + 


                          as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                pow(epsc1 + epsn, 


                                  2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn)) + 


                          6*k*pow(epsc1, 


                              3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                e0c*(as2*ch*e0c*epsc1 + 


                                      d*(n0 - 


                                        as2*e0c*(epsc1 + epsn)))))))*((3*


                      pow(e0c, 


                        2)*(pow(as2*(2*ch - d)*e0c + as1*d*e0cn, 2)*k*


                            pow(epsc1, 2) - 


                          2*(as2*ch*e0c + 


                                as1*d*e0cn)*(2*as2*(ch - d)*e0c*k*


                                  pow(epsc1, 2) + 


                                b*pow(d, 2)*


                                  fc*((-2 + k)*epsc1 + 4*(-1 + k)*epsn))))/(3*


                        k*pow(epsc1, 2)*


                        pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                            d*(-(as1*e0cn*fy) + 


                                  e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                        as1*(fy + e0cn*(-epsc1 + epsn)))), 


                          2) - 2*


                        e0c*(as2*ch*e0c + 


                            as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                  pow(epsc1 + epsn, 


                                    2)*((-2 + 5*k)*epsc1 - 


                                      4*(-1 + k)*epsn)) + 


                            6*k*pow(epsc1, 


                                3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                  e0c*(as2*ch*e0c*epsc1 + 


                                        d*(n0 - as2*e0c*(epsc1 + epsn)))))) - 


                pow(6*e0c*(as2*(2*ch - d)*e0c + as1*d*e0cn)*k*


                          pow(epsc1, 


                            2)*(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                              d*(-(as1*e0cn*fy) + 


                                    e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                        as1*(fy + e0cn*(-epsc1 + epsn))))) + 


                        2*e0c*(as2*ch*e0c + 


                              as1*d*e0cn)*(-6*b*pow(d, 2)*e0c*


                                fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 


                                    2*epsn) - 


                              6*k*pow(epsc1, 


                                  2)*(as1*


                                      d*(-(e0cn*fy) + e0c*(fy + e0cn*epsn)) + 


                                    e0c*(-2*as2*ch*e0c*epsc1 + 


                                        d*(-n0 + as2*e0c*(2*epsc1 + epsn))))),


                       2)/(4.*


                        pow(3*k*pow(epsc1, 2)*


                              pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                                  d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                        as1*(fy + e0cn*(-epsc1 + epsn)))), 


                                2) - 2*


                              e0c*(as2*ch*e0c + 


                                  as1*d*


                                    e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epsc1 + epsn, 


                                        2)*((-2 + 5*k)*epsc1 - 


                                        4*(-1 + k)*epsn)) + 


                                  6*k*pow(epsc1, 


                                      3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epsc1 + 


                                        d*(n0 - as2*e0c*(epsc1 + epsn))))), 


                          2))))/((as2*ch*e0c + as1*d*e0cn)*


            k) + (2*(-3*as1*d*k*


                  pow(epsc1, 


                    2)*(-2*d*e0cn*(fy + e0c*(epsc1 + epsn)) + 


                      ch*(-(e0cn*fy) + e0c*(fy + e0cn*(epsc1 + epsn)))) + 


                ch*(3*d*e0c*k*n0*pow(epsc1, 2) + 


                      3*as2*d*e0c*k*


                        pow(epsc1, 2)*(2*fy + e0c*(epsc1 + epsn)) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                                      d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                        as1*(fy + e0cn*(-epsc1 + epsn)))), 


                                    2) - 2*


                                  e0c*(as2*ch*e0c + 


                                      as1*d*


                                        e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epsc1 + epsn, 


                                        2)*((-2 + 5*k)*epsc1 - 


                                        4*(-1 + k)*epsn)) + 


                                      6*k*pow(epsc1, 


                                        3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epsc1 + 


                                        d*(n0 - as2*e0c*(epsc1 + 


                                        epsn))))))))))/(ch*(as2*ch*e0c + 


                as1*d*e0cn)*k*pow(epsc1, 2)) - 


      2*epsc1*((6*(-ch + d)*e0c)/


              ch + (3*e0c*(2*as2*ch*e0c - as2*d*e0c + 


                      as1*d*e0cn + (sqrt(3.)*


                              pow(d, 


                                2)*(pow(as2, 2)*pow(e0c, 3)*k*


                                    pow(epsc1, 2)*(epsc1 + epsn) + 


                                  as1*e0cn*(2*b*d*e0c*


                                        fc*(epsc1 + 


                                        epsn)*(k*(epsc1 - 2*epsn) + 2*epsn) + 


                                        k*pow(epsc1, 


                                        2)*(-(e0c*n0) + 


                                        as1*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*(epsc1 + epsn))))) + 


                                  as2*e0c*(2*b*ch*e0c*


                                        fc*(epsc1 + 


                                        epsn)*(k*(epsc1 - 2*epsn) + 2*epsn) + 


                                        k*pow(epsc1, 


                                        2)*(-(e0c*n0) + 


                                        as1*(-(e0cn*fy) + 


                                        e0c*(fy + 2*e0cn*(epsc1 + epsn)))))))/


                          sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                                      d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                        as1*(fy + e0cn*(-epsc1 + epsn)))), 


                                    2) - 2*


                                  e0c*(as2*ch*e0c + 


                                      as1*d*


                                        e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epsc1 + epsn, 


                                        2)*((-2 + 5*k)*epsc1 - 


                                        4*(-1 + k)*epsn)) + 


                                      6*k*pow(epsc1, 


                                        3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epsc1 + 


                                        d*(n0 - as2*e0c*(epsc1 + 


                                        epsn)))))))))/(as2*ch*e0c + 


                  as1*d*e0cn)))/(12.*e0c);

										ac2 =((6*(-ch + d)*e0c)/


        ch + (3*e0c*(2*as2*ch*e0c - as2*d*e0c + 


                as1*d*e0cn + (sqrt(3.)*


                        pow(d, 


                          2)*(pow(as2, 2)*pow(e0c, 3)*k*


                              pow(epsc1, 2)*(epsc1 + epsn) + 


                            as1*e0cn*(2*b*d*e0c*


                                    fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 


                                        2*epsn) + 


                                  k*pow(epsc1, 


                                      2)*(-(e0c*n0) + 


                                        as1*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*(epsc1 + epsn))))) + 


                            as2*e0c*(2*b*ch*e0c*


                                    fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 


                                        2*epsn) + 


                                  k*pow(epsc1, 


                                      2)*(-(e0c*n0) + 


                                        as1*(-(e0cn*fy) + 


                                        e0c*(fy + 2*e0cn*(epsc1 + epsn)))))))/


                    sqrt(k*pow(epsc1, 


                        2)*(3*k*pow(epsc1, 2)*


                            pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                                d*(-(as1*e0cn*fy) + 


                                      e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                        as1*(fy + e0cn*(-epsc1 + epsn)))), 


                              2) - 2*


                            e0c*(as2*ch*e0c + 


                                as1*d*


                                  e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                      pow(epsc1 + epsn, 


                                        2)*((-2 + 5*k)*epsc1 - 


                                        4*(-1 + k)*epsn)) + 


                                6*k*pow(epsc1, 


                                    3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                      e0c*(as2*ch*e0c*epsc1 + 


                                        d*(n0 - as2*


                                        e0c*(epsc1 + epsn)))))))))/(as2*ch*


              e0c + as1*d*e0cn) - (sqrt(3.)*


            sqrt(k*pow(epsc1, 


                  2)*(3*k*pow(epsc1, 2)*


                      pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                          d*(-(as1*e0cn*fy) + 


                                e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                      as1*(fy + e0cn*(-epsc1 + epsn)))), 2) - 


                    2*e0c*(as2*ch*e0c + 


                          as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                pow(epsc1 + epsn, 


                                  2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn)) + 


                          6*k*pow(epsc1, 


                              3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                e0c*(as2*ch*e0c*epsc1 + 


                                      d*(n0 - 


                                        as2*e0c*(epsc1 + epsn)))))))*((3*


                      pow(e0c, 


                        2)*(pow(as2*(2*ch - d)*e0c + as1*d*e0cn, 2)*k*


                            pow(epsc1, 2) - 


                          2*(as2*ch*e0c + 


                                as1*d*e0cn)*(2*as2*(ch - d)*e0c*k*


                                  pow(epsc1, 2) + 


                                b*pow(d, 2)*


                                  fc*((-2 + k)*epsc1 + 4*(-1 + k)*epsn))))/(3*


                        k*pow(epsc1, 2)*


                        pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                            d*(-(as1*e0cn*fy) + 


                                  e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                        as1*(fy + e0cn*(-epsc1 + epsn)))), 


                          2) - 2*


                        e0c*(as2*ch*e0c + 


                            as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                  pow(epsc1 + epsn, 


                                    2)*((-2 + 5*k)*epsc1 - 


                                      4*(-1 + k)*epsn)) + 


                            6*k*pow(epsc1, 


                                3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                  e0c*(as2*ch*e0c*epsc1 + 


                                        d*(n0 - as2*e0c*(epsc1 + epsn)))))) - 


                pow(6*e0c*(as2*(2*ch - d)*e0c + as1*d*e0cn)*k*


                          pow(epsc1, 


                            2)*(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                              d*(-(as1*e0cn*fy) + 


                                    e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                        as1*(fy + e0cn*(-epsc1 + epsn))))) + 


                        2*e0c*(as2*ch*e0c + 


                              as1*d*e0cn)*(-6*b*pow(d, 2)*e0c*


                                fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 


                                    2*epsn) - 


                              6*k*pow(epsc1, 


                                  2)*(as1*


                                      d*(-(e0cn*fy) + e0c*(fy + e0cn*epsn)) + 


                                    e0c*(-2*as2*ch*e0c*epsc1 + 


                                        d*(-n0 + as2*e0c*(2*epsc1 + epsn))))),


                       2)/(4.*


                        pow(3*k*pow(epsc1, 2)*


                              pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                                  d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                        as1*(fy + e0cn*(-epsc1 + epsn)))), 


                                2) - 2*


                              e0c*(as2*ch*e0c + 


                                  as1*d*


                                    e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epsc1 + epsn, 


                                        2)*((-2 + 5*k)*epsc1 - 


                                        4*(-1 + k)*epsn)) + 


                                  6*k*pow(epsc1, 


                                      3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epsc1 + 


                                        d*(n0 - as2*e0c*(epsc1 + epsn))))), 


										2))))/((as2*ch*e0c + as1*d*e0cn)*k*epsc1))/(6.*e0c);

						  ac3 =(sqrt(k*pow(epsc1, 


            2)*(3*k*pow(epsc1, 2)*


                pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                    d*(-(as1*e0cn*fy) + 


                          e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                as1*(fy + e0cn*(-epsc1 + epsn)))), 2) - 


              2*e0c*(as2*ch*e0c + 


                    as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                          pow(epsc1 + epsn, 


                            2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn)) + 


                    6*k*pow(epsc1, 


                        3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                          e0c*(as2*ch*e0c*epsc1 + 


                                d*(n0 - as2*e0c*(epsc1 + epsn)))))))*((3*


                pow(e0c, 


                  2)*(pow(as2*(2*ch - d)*e0c + as1*d*e0cn, 2)*k*


                      pow(epsc1, 2) - 


                    2*(as2*ch*e0c + 


                          as1*d*e0cn)*(2*as2*(ch - d)*e0c*k*pow(epsc1, 2) + 


                          b*pow(d, 2)*


                            fc*((-2 + k)*epsc1 + 4*(-1 + k)*epsn))))/(3*k*


                  pow(epsc1, 2)*


                  pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                      d*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                  as1*(fy + e0cn*(-epsc1 + epsn)))), 2) - 


                2*e0c*(as2*ch*e0c + 


                      as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                            pow(epsc1 + epsn, 


                              2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn)) + 


                      6*k*pow(epsc1, 


                          3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                            e0c*(as2*ch*e0c*epsc1 + 


                                  d*(n0 - as2*e0c*(epsc1 + epsn)))))) - 


          pow(6*e0c*(as2*(2*ch - d)*e0c + as1*d*e0cn)*k*


                    pow(epsc1, 


                      2)*(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                        d*(-(as1*e0cn*fy) + 


                              e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                    as1*(fy + e0cn*(-epsc1 + epsn))))) + 


                  2*e0c*(as2*ch*e0c + 


                        as1*d*e0cn)*(-6*b*pow(d, 2)*e0c*


                          fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 2*epsn) - 


                        6*k*pow(epsc1, 


                            2)*(as1*d*(-(e0cn*fy) + e0c*(fy + e0cn*epsn)) + 


                              e0c*(-2*as2*ch*e0c*epsc1 + 


                                    d*(-n0 + as2*e0c*(2*epsc1 + epsn))))), 


                2)/(4.*pow(3*k*pow(epsc1, 2)*


                        pow(-2*as2*ch*pow(e0c, 2)*epsc1 + 


                            d*(-(as1*e0cn*fy) + 


                                  e0c*(-n0 + as2*e0c*(epsc1 + epsn) + 


                                        as1*(fy + e0cn*(-epsc1 + epsn)))), 


                          2) - 2*


                        e0c*(as2*ch*e0c + 


                            as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                  pow(epsc1 + epsn, 


                                    2)*((-2 + 5*k)*epsc1 - 


                                      4*(-1 + k)*epsn)) + 


                            6*k*pow(epsc1, 


                                3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                  e0c*(as2*ch*e0c*epsc1 + 


                                        d*(n0 - as2*e0c*(epsc1 + epsn))))), 


                    2))))/(4.*sqrt(3.)*e0c*(as2*ch*e0c + as1*d*e0cn)*k*


      pow(epsc1, 2));

	
										
		

			if (pow(ac2, 2) - 4*ac1*ac3 < 0.){
				epschr5 = -1.;}
			else {epschr5 =(-ac2 + sqrt(pow(ac2, 2) - 4*ac1*ac3))/(2.*ac3);}





	return epschr5;


}


 


//pretvoreni betonu po dosazeni mezniho pretvoreni oceli As1, kdy jeste nedoslo k teceni vyztuze As2 a nedochazi k drceni betonu, x < h 


double normmat::compute_epscs11 ()


{


	double ac1,ac2,ac3,epscs11;	


	


	ac1 =(25*sqrt(3.)*


        sqrt(k*pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                      d*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                  as1*(fy + e0cn*((-5*epsc1)/4. + epsn)))), 


                    2) - 2*e0c*(as2*ch*e0c + 


                      as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                              pow(5*epsc1 + 4*epsn, 


                                2)*((-1 + 4*k)*epsc1 - 4*(-1 + k)*epsn))/


                        16. + (15*k*


                            pow(epsc1, 


                              3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                      d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.)))*(-pow(2*


                      e0c*(as2*ch*e0c + 


                          as1*d*e0cn)*((-3*b*pow(d, 2)*e0c*


                                fc*(5*epsc1 + 4*epsn)*(epsc1 + k*epsc1 + 


                                    4*epsn - 4*k*epsn))/4. - 


                          3*k*pow(epsc1, 


                              2)*(e0c*(-2*d*n0 - 5*as2*ch*e0c*epsc1 + 


                                      5*as2*d*e0c*epsc1 + 2*as2*d*e0c*epsn) + 


                                2*as1*


                                  d*(e0c*fy - e0cn*fy + e0c*e0cn*epsn))) + 


                    6*e0c*(as2*(2*ch - d)*e0c + as1*d*e0cn)*k*


                      pow(epsc1, 


                        2)*((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                          d*(-(as1*e0cn*fy) + 


                                e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                      as1*(fy + 


                                        e0cn*((-5*epsc1)/4. + epsn))))), 


                  2)/(4.*pow(3*k*pow(epsc1, 2)*


                          pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                              d*(-(as1*e0cn*fy) + 


                                    e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) +


                                         as1*(fy + 


                                        e0cn*((-5*epsc1)/4. + epsn)))), 2) - 


                        2*e0c*(as2*ch*e0c + 


                              as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                      pow(5*epsc1 + 4*epsn, 


                                        2)*((-1 + 4*k)*epsc1 - 


                                        4*(-1 + k)*epsn))/


                                16. + (15*k*


                                    pow(epsc1, 


                                      3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                        d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.), 2)) + (3*


                  pow(e0c, 


                    2)*(pow(as2*(2*ch - d)*e0c + as1*d*e0cn, 2)*k*


                        pow(epsc1, 2) - 


                      2*(as2*ch*e0c + 


                            as1*d*e0cn)*(2*as2*(ch - d)*e0c*k*pow(epsc1, 2) + 


                            b*pow(d, 2)*


                              fc*((-3 + 2*k)*epsc1 + 4*(-1 + k)*epsn))))/(3*k*


                    pow(epsc1, 2)*


                    pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                        d*(-(as1*e0cn*fy) + 


                              e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                    as1*(fy + e0cn*((-5*epsc1)/4. + epsn)))), 


                      2) - 2*e0c*(as2*ch*e0c + 


                        as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                pow(5*epsc1 + 4*epsn, 


                                  2)*((-1 + 4*k)*epsc1 - 4*(-1 + k)*epsn))/


                          16. + (15*k*


                              pow(epsc1, 


                                3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                  e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                        d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.))) - 


      30*e0c*k*epsc1*(8*as2*ch*e0c - 4*as2*d*e0c + 


            4*as1*d*e0cn + (sqrt(3.)*


                    pow(d, 2)*(pow(as2, 2)*pow(e0c, 3)*k*


                          pow(epsc1, 2)*(5*epsc1 + 4*epsn) + 


                        as1*e0cn*(b*d*e0c*


                                fc*(5*epsc1 + 4*epsn)*(epsc1 + k*epsc1 + 


                                    4*epsn - 4*k*epsn) + 


                              k*pow(epsc1, 


                                  2)*(-4*e0c*n0 + 


                                    as1*(4*e0c*fy - 4*e0cn*fy + 


                                        5*e0c*e0cn*epsc1 + 


                                        4*e0c*e0cn*epsn))) + 


                        as2*e0c*(b*ch*e0c*


                                fc*(5*epsc1 + 4*epsn)*(epsc1 + k*epsc1 + 


                                    4*epsn - 4*k*epsn) + 


                              2*k*pow(epsc1, 


                                  2)*(-2*e0c*n0 + 


                                    as1*(2*e0c*fy - 2*e0cn*fy + 


                                        5*e0c*e0cn*epsc1 + 


                                        4*e0c*e0cn*epsn)))))/


                sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                            d*(-(as1*e0cn*fy) + 


                                  e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                        as1*(fy + 


                                        e0cn*((-5*epsc1)/4. + epsn)))), 2) - 


                      2*e0c*(as2*ch*e0c + 


                            as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                    pow(5*epsc1 + 4*epsn, 


                                      2)*((-1 + 4*k)*epsc1 - 


                                        4*(-1 + k)*epsn))/


                              16. + (15*k*


                                  pow(epsc1, 


                                    3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                      e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                        d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.)))) + (32*((15*as2*ch*


                        pow(e0c, 2)*k*pow(epsc1, 3))/2. - 


                  3*d*k*pow(epsc1, 


                      2)*(-(as1*e0cn*fy) + 


                        e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                              as1*(fy + e0cn*((-5*epsc1)/4. + epsn)))) + 


                  sqrt(3.)*


                    sqrt(k*pow(epsc1, 


                          2)*(3*k*pow(epsc1, 2)*


                              pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                                  d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + 


                                        as2*e0c*((5*epsc1)/4. + epsn) + 


                                        as1*(fy + e0cn*((-5*epsc1)/4. + 


                                        epsn)))), 2) - 


                            2*e0c*(as2*ch*e0c + 


                                  as1*d*


                                    e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(5*epsc1 + 4*epsn, 


                                        2)*((-1 + 4*k)*epsc1 - 


                                        4*(-1 + k)*epsn))/


                                    16. + (15*k*


                                        pow(epsc1, 


                                        3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                        d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.)))))/pow(epsc1, 2))/(192.*


      e0c*(as2*ch*e0c + as1*d*e0cn)*k);





	ac2 =(-5*sqrt(3.)*


        sqrt(k*pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                      d*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                  as1*(fy + e0cn*((-5*epsc1)/4. + epsn)))), 


                    2) - 2*e0c*(as2*ch*e0c + 


                      as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                              pow(5*epsc1 + 4*epsn, 


                                2)*((-1 + 4*k)*epsc1 - 4*(-1 + k)*epsn))/


                        16. + (15*k*


                            pow(epsc1, 


                              3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                      d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.)))*(-pow(2*


                      e0c*(as2*ch*e0c + 


                          as1*d*e0cn)*((-3*b*pow(d, 2)*e0c*


                                fc*(5*epsc1 + 4*epsn)*(epsc1 + k*epsc1 + 


                                    4*epsn - 4*k*epsn))/4. - 


                          3*k*pow(epsc1, 


                              2)*(e0c*(-2*d*n0 - 5*as2*ch*e0c*epsc1 + 


                                      5*as2*d*e0c*epsc1 + 2*as2*d*e0c*epsn) + 


                                2*as1*


                                  d*(e0c*fy - e0cn*fy + e0c*e0cn*epsn))) + 


                    6*e0c*(as2*(2*ch - d)*e0c + as1*d*e0cn)*k*


                      pow(epsc1, 


                        2)*((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                          d*(-(as1*e0cn*fy) + 


                                e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                      as1*(fy + 


                                        e0cn*((-5*epsc1)/4. + epsn))))), 


                  2)/(4.*pow(3*k*pow(epsc1, 2)*


                          pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                              d*(-(as1*e0cn*fy) + 


                                    e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) +


                                         as1*(fy + 


                                        e0cn*((-5*epsc1)/4. + epsn)))), 2) - 


                        2*e0c*(as2*ch*e0c + 


                              as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                      pow(5*epsc1 + 4*epsn, 


                                        2)*((-1 + 4*k)*epsc1 - 


                                        4*(-1 + k)*epsn))/


                                16. + (15*k*


                                    pow(epsc1, 


                                      3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                        d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.), 2)) + (3*


                  pow(e0c, 


                    2)*(pow(as2*(2*ch - d)*e0c + as1*d*e0cn, 2)*k*


                        pow(epsc1, 2) - 


                      2*(as2*ch*e0c + 


                            as1*d*e0cn)*(2*as2*(ch - d)*e0c*k*pow(epsc1, 2) + 


                            b*pow(d, 2)*


                              fc*((-3 + 2*k)*epsc1 + 4*(-1 + k)*epsn))))/(3*k*


                    pow(epsc1, 2)*


                    pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                        d*(-(as1*e0cn*fy) + 


                              e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                    as1*(fy + e0cn*((-5*epsc1)/4. + epsn)))), 


                      2) - 2*e0c*(as2*ch*e0c + 


                        as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                pow(5*epsc1 + 4*epsn, 


                                  2)*((-1 + 4*k)*epsc1 - 4*(-1 + k)*epsn))/


                          16. + (15*k*


                              pow(epsc1, 


                                3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                  e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                        d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.))) + 


      3*e0c*k*epsc1*(8*as2*ch*e0c - 4*as2*d*e0c + 


            4*as1*d*e0cn + (sqrt(3.)*


                    pow(d, 2)*(pow(as2, 2)*pow(e0c, 3)*k*


                          pow(epsc1, 2)*(5*epsc1 + 4*epsn) + 


                        as1*e0cn*(b*d*e0c*


                                fc*(5*epsc1 + 4*epsn)*(epsc1 + k*epsc1 + 


                                    4*epsn - 4*k*epsn) + 


                              k*pow(epsc1, 


                                  2)*(-4*e0c*n0 + 


                                    as1*(4*e0c*fy - 4*e0cn*fy + 


                                        5*e0c*e0cn*epsc1 + 


                                        4*e0c*e0cn*epsn))) + 


                        as2*e0c*(b*ch*e0c*


                                fc*(5*epsc1 + 4*epsn)*(epsc1 + k*epsc1 + 


                                    4*epsn - 4*k*epsn) + 


                              2*k*pow(epsc1, 


                                  2)*(-2*e0c*n0 + 


                                    as1*(2*e0c*fy - 2*e0cn*fy + 


                                        5*e0c*e0cn*epsc1 + 


                                        4*e0c*e0cn*epsn)))))/


                sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                            d*(-(as1*e0cn*fy) + 


                                  e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                        as1*(fy + 


                                        e0cn*((-5*epsc1)/4. + epsn)))), 2) - 


                      2*e0c*(as2*ch*e0c + 


                            as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                    pow(5*epsc1 + 4*epsn, 


                                      2)*((-1 + 4*k)*epsc1 - 


                                        4*(-1 + k)*epsn))/


                              16. + (15*k*


                                  pow(epsc1, 


                                    3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                      e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                        d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.)))))/(24.*


      e0c*(as2*ch*e0c + as1*d*e0cn)*k*epsc1);





	ac3 =(sqrt(k*pow(epsc1, 


            2)*(3*k*pow(epsc1, 2)*


                pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                    d*(-(as1*e0cn*fy) + 


                          e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                as1*(fy + e0cn*((-5*epsc1)/4. + epsn)))), 


                  2) - 2*e0c*(as2*ch*e0c + 


                    as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                            pow(5*epsc1 + 4*epsn, 


                              2)*((-1 + 4*k)*epsc1 - 4*(-1 + k)*epsn))/


                      16. + (15*k*


                          pow(epsc1, 


                            3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                              e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                    d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.)))*(-pow(2*


                    e0c*(as2*ch*e0c + 


                        as1*d*e0cn)*((-3*b*pow(d, 2)*e0c*


                              fc*(5*epsc1 + 4*epsn)*(epsc1 + k*epsc1 + 


                                  4*epsn - 4*k*epsn))/4. - 


                        3*k*pow(epsc1, 


                            2)*(e0c*(-2*d*n0 - 5*as2*ch*e0c*epsc1 + 


                                    5*as2*d*e0c*epsc1 + 2*as2*d*e0c*epsn) + 


                              2*as1*d*(e0c*fy - e0cn*fy + e0c*e0cn*epsn))) + 


                  6*e0c*(as2*(2*ch - d)*e0c + as1*d*e0cn)*k*


                    pow(epsc1, 


                      2)*((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                        d*(-(as1*e0cn*fy) + 


                              e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                    as1*(fy + e0cn*((-5*epsc1)/4. + epsn))))),


                 2)/(4.*


                  pow(3*k*pow(epsc1, 2)*


                        pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                            d*(-(as1*e0cn*fy) + 


                                  e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                        as1*(fy + 


                                        e0cn*((-5*epsc1)/4. + epsn)))), 2) - 


                      2*e0c*(as2*ch*e0c + 


                            as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                    pow(5*epsc1 + 4*epsn, 


                                      2)*((-1 + 4*k)*epsc1 - 


                                        4*(-1 + k)*epsn))/


                              16. + (15*k*


                                  pow(epsc1, 


                                    3)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                      e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                        d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.), 2)) + (3*


                pow(e0c, 


                  2)*(pow(as2*(2*ch - d)*e0c + as1*d*e0cn, 2)*k*


                      pow(epsc1, 2) - 


                    2*(as2*ch*e0c + 


                          as1*d*e0cn)*(2*as2*(ch - d)*e0c*k*pow(epsc1, 2) + 


                          b*pow(d, 2)*


                            fc*((-3 + 2*k)*epsc1 + 4*(-1 + k)*epsn))))/(3*k*


                  pow(epsc1, 2)*


                  pow((-5*as2*ch*pow(e0c, 2)*epsc1)/2. + 


                      d*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*((5*epsc1)/4. + epsn) + 


                                  as1*(fy + e0cn*((-5*epsc1)/4. + epsn)))), 


                    2) - 2*e0c*(as2*ch*e0c + 


                      as1*d*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                              pow(5*epsc1 + 4*epsn, 


                                2)*((-1 + 4*k)*epsc1 - 4*(-1 + k)*epsn))/


                        16. + (15*k*


                            pow(epsc1, 


                              3)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                e0c*((5*as2*ch*e0c*epsc1)/4. + 


                                      d*(n0 - (as2*e0c*(5*epsc1 + 4*epsn))/


                                        4.))))/2.))))/(4.*sqrt(3.)*


      e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2));





  if (pow(ac2, 2) - 4*ac1*ac3 + 4*ac3*epss1lim < 0.0){





    epscs11=-1.0;


  }


  else{





    epscs11=-((ac2 + sqrt(pow(ac2, 2) - 4*ac1*ac3 + 4*ac3*epss1lim))/(2.*ac3));


  }


  return epscs11;


}


 


//hodnota ohyboveho momentu, kdy dochazi k teceni vyztuze As2, uz teklo As1 a nedochazi k drceni betonu, x < h


double normmat::compute_mhr5 ()


{


	double mhr5;	


	
	if(epschr5 == -1.){mhr5 = 1000000000.;}

	else { mhr5 =(-6*as2*e0c*(-2*ch + h)*(epschr5 - (ch*epschr5)/d + 


            epsn + (ch*(6*as2*ch*pow(e0c, 2)*k*epschr5*pow(epsc1, 2) - 


                      3*d*k*pow(epsc1, 


                          2)*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*(epschr5 + epsn) + 


                                  as1*(fy + e0cn*(-epschr5 + epsn)))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*pow(e0c, 2)*epschr5 + 


                                      d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epschr5 + epsn) + 


                                        as1*(fy + e0cn*(-epschr5 + epsn)))), 


                                    2) - 2*


                                  e0c*(as2*ch*e0c + 


                                      as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epschr5 + epsn, 


                                        2)*(4*(-1 + k)*epschr5 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                      6*k*epschr5*


                                        pow(epsc1, 


                                        2)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epschr5 + 


                                        d*(n0 - as2*e0c*(epschr5 + 


                                        epsn)))))))))/(6.*d*


                  e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2))) - (b*d*fc*


            pow(epschr5 + epsn, 


              2)*(2*d*(epschr5 + 


                      epsn)*((-1 + k)*epschr5 + (2 - 3*k)*epsc1 + (-1 + k)*


                        epsn) - 


                h*(4*(-1 + k)*epschr5 + (6 - 9*k)*epsc1 + 


                      4*(-1 + k)*


                        epsn)*(epschr5 - (6*as2*ch*pow(e0c, 2)*k*epschr5*


                              pow(epsc1, 2) - 


                            3*d*k*pow(epsc1, 


                                2)*(-(as1*e0cn*fy) + 


                                  e0c*(-n0 + as2*e0c*(epschr5 + epsn) + 


                                        as1*(fy + e0cn*(-epschr5 + epsn)))) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(-2*as2*ch*pow(e0c, 2)*epschr5 + 


                                        d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epschr5 + epsn) + 


                                        as1*(fy + e0cn*(-epschr5 + epsn)))), 


                                        2) - 


                                      2*e0c*(as2*ch*e0c + 


                                        as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epschr5 + epsn, 


                                        2)*(4*(-1 + k)*epschr5 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                        6*k*epschr5*


                                        pow(epsc1, 


                                        2)*(as1*d*(e0cn*fy - 


                                        e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epschr5 + 


                                        d*(n0 - as2*e0c*(epschr5 + 


                                        epsn))))))))/(6.*


                            e0c*(as2*ch*e0c + as1*d*e0cn)*k*


                            pow(epsc1, 2)))))/(k*pow(epsc1, 2)*


            pow(epschr5 - (6*as2*ch*pow(e0c, 2)*k*epschr5*pow(epsc1, 2) - 


                      3*d*k*pow(epsc1, 


                          2)*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*(epschr5 + epsn) + 


                                  as1*(fy + e0cn*(-epschr5 + epsn)))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*pow(e0c, 2)*epschr5 + 


                                      d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epschr5 + epsn) + 


                                        as1*(fy + e0cn*(-epschr5 + epsn)))), 


                                    2) - 2*


                                  e0c*(as2*ch*e0c + 


                                      as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epschr5 + epsn, 


                                        2)*(4*(-1 + k)*epschr5 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                      6*k*epschr5*


                                        pow(epsc1, 


                                        2)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epschr5 + 


                                        d*(n0 - as2*e0c*(epschr5 + 


                                        epsn))))))))/(6.*


                      e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2)), 2)) + 


      6*as1*(-2*cd + h)*(fy + 


            e0cn*(-(fy/e0c) + 


                  epsn + (6*as2*ch*pow(e0c, 2)*k*epschr5*pow(epsc1, 2) - 


                        3*d*k*pow(epsc1, 


                            2)*(-(as1*e0cn*fy) + 


                              e0c*(-n0 + as2*e0c*(epschr5 + epsn) + 


                                    as1*(fy + e0cn*(-epschr5 + epsn)))) + 


                        sqrt(3.)*


                          sqrt(k*


                              pow(epsc1, 


                                2)*(3*k*pow(epsc1, 2)*


                                    pow(-2*as2*ch*pow(e0c, 2)*epschr5 + 


                                        d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epschr5 + epsn) + 


                                        as1*(fy + e0cn*(-epschr5 + epsn)))), 


                                      2) - 2*


                                    e0c*(as2*ch*e0c + 


                                        as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epschr5 + epsn, 


                                        2)*(4*(-1 + k)*epschr5 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                        6*k*epschr5*


                                        pow(epsc1, 


                                        2)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epschr5 + 


                                        d*(n0 - as2*e0c*(epschr5 + 


                                        epsn))))))))/(6.*


										e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2)))))/12. + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;}





	return mhr5;


}


 


//hodnota ohyboveho momentu po dosazeni mezniho pretvoreni betonu v tlaku, tece As1 a jeste nedoslo k teceni vyztuze As2


double normmat::compute_mmax2 ()


{


	double mmax2;	


	


	mmax2 =((-36*b*d*pow(e0c, 2)*pow(as2*ch*e0c + as1*d*e0cn, 3)*fc*pow(k, 2)*


              pow(epsc1, 4)*


              pow(epscmax1 + epsn, 


                2)*(2*d*(epscmax1 + 


                        epsn)*((2 - 3*k)*


                          epsc1 + (-1 + k)*(epscmax1 + 


                              epsn)) + (h*(3*(-2 + 3*k)*epsc1 - 


                            4*(-1 + k)*(epscmax1 + epsn))*(3*d*e0c*k*


                              pow(epsc1, 


                                2)*(-n0 + as2*e0c*(epscmax1 + epsn)) + 


                            3*as1*d*k*


                              pow(epsc1, 


                                2)*(-(e0cn*fy) + 


                                  e0c*(fy + e0cn*(epscmax1 + epsn))) - 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(-2*as2*ch*pow(e0c, 2)*epscmax1 + 


                                        d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epscmax1 + epsn) +


                                         as1*(fy + e0cn*(-epscmax1 + epsn)))),


                                         2) - 


                                      2*e0c*(as2*ch*e0c + 


                                        as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscmax1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*(epscmax1 + epsn)) + 


                                        6*k*pow(epsc1, 2)*


                                        epscmax1*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscmax1 + 


                                        d*(n0 - as2*e0c*(epscmax1 + 


                                        epsn)))))))))/(6.*


                        e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2))))/


          pow(3*d*e0c*k*pow(epsc1, 2)*(-n0 + as2*e0c*(epscmax1 + epsn)) + 


            3*as1*d*k*


              pow(epsc1, 2)*(-(e0cn*fy) + e0c*(fy + e0cn*(epscmax1 + epsn))) -


             sqrt(3.)*


              sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow(-2*as2*ch*pow(e0c, 2)*epscmax1 + 


                            d*(-(as1*e0cn*fy) + 


                                  e0c*(-n0 + as2*e0c*(epscmax1 + epsn) + 


                                        as1*(fy + e0cn*(-epscmax1 + epsn)))), 


                          2) - 2*


                        e0c*(as2*ch*e0c + 


                            as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                              pow(epscmax1 + epsn, 


                                2)*((6 - 9*k)*epsc1 + 


                                  4*(-1 + k)*(epscmax1 + epsn)) + 


                            6*k*pow(epsc1, 2)*


                              epscmax1*(as1*


                                    d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                  e0c*(as2*ch*e0c*epscmax1 + 


                                        d*(n0 - 


                                        as2*e0c*(epscmax1 + epsn))))))), 


          2) + (as2*(2*ch - 


                h)*(-3*as1*d*k*


                  pow(epsc1, 


                    2)*(-2*d*e0c*e0cn*(epscmax1 + epsn) + 


                      ch*(-(e0cn*fy) + e0c*(fy + e0cn*(epscmax1 + epsn)))) + 


                ch*(3*d*e0c*k*pow(epsc1, 2)*(n0 + as2*e0c*(epscmax1 + epsn)) +


                       sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*pow(e0c, 2)*epscmax1 + 


                                      d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epscmax1 + epsn) +


                                         as1*(fy + e0cn*(-epscmax1 + epsn)))),


                                     2) - 


                                2*e0c*(as2*ch*e0c + 


                                      as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscmax1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*(epscmax1 + epsn)) + 


                                      6*k*pow(epsc1, 2)*


                                        epscmax1*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscmax1 + 


                                        d*(n0 - as2*e0c*(epscmax1 + 


                                        epsn))))))))))/


        d - (as1*(2*cd - 


                h)*(3*as2*e0c*k*


                  pow(epsc1, 


                    2)*(-(d*e0c*e0cn*(epscmax1 + epsn)) + 


                      2*ch*(-(e0cn*fy) + e0c*(fy + e0cn*(epscmax1 + epsn)))) +


                 e0cn*(3*d*e0c*k*n0*pow(epsc1, 2) + 


                      3*as1*d*k*


                        pow(epsc1, 


                          2)*(-(e0cn*fy) + 


                            e0c*(fy + e0cn*(epscmax1 + epsn))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*pow(e0c, 2)*epscmax1 + 


                                      d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epscmax1 + epsn) +


                                         as1*(fy + e0cn*(-epscmax1 + epsn)))),


                                     2) - 


                                2*e0c*(as2*ch*e0c + 


                                      as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscmax1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*(epscmax1 + epsn)) + 


                                      6*k*pow(epsc1, 2)*


                                        epscmax1*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscmax1 + 


                                        d*(n0 - as2*e0c*(epscmax1 + 


                                        epsn))))))))))/


        e0c)/(12.*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mmax2;


}


  


//hodnota ohyboveho momentu po dosazeni mezniho pretvoreni oceli As1 pri jejim tazeni, //kdy jeste nedoslo k teceni vyztuze As2 a nedochazi k drceni betonu, x < h


double normmat::compute_ms11 ()





{


 	double ms11;	


	


	if (epscs11 == -1.0){





    ms11=1000000000.0;





  }





  else{





    ms11=0.08333333333333333*(-6*as2*


        e0c*(-2*ch + h)*(epscs11 - (ch*epscs11)/d + 


            epsn + (ch*(6*as2*ch*pow(e0c, 2)*k*pow(epsc1, 2)*epscs11 - 


                      3*d*k*pow(epsc1, 


                          2)*(-as1*e0cn*fy + 


                            e0c*(-n0 + as2*e0c*(epscs11 + epsn) + 


                                  as1*(fy + e0cn*(-epscs11 + epsn)))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*pow(e0c, 2)*epscs11 + 


                                      d*(-as1*e0cn*fy + 


                                        e0c*(-n0 + as2*e0c*(epscs11 + epsn) + 


                                        as1*(fy + e0cn*(-epscs11 + epsn)))), 


                                    2) - 2*


                                  e0c*(as2*ch*e0c + 


                                      as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscs11 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscs11 + 


                                        4*(-1 + k)*epsn) + 


                                      6*k*pow(epsc1, 2)*


                                        epscs11*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscs11 + 


                                        d*(n0 - as2*e0c*(epscs11 + 


                                        epsn)))))))))/(6.*d*


                  e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2))) - (b*d*fc*


            pow(epscs11 + epsn, 


              2)*(2*d*(epscs11 + 


                      epsn)*((2 - 3*k)*epsc1 + (-1 + k)*epscs11 + (-1 + k)*


                        epsn) - 


                h*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscs11 + 


                      4*(-1 + k)*


                        epsn)*(epscs11 - (6*as2*ch*pow(e0c, 2)*k*


                              pow(epsc1, 2)*epscs11 - 


                            3*d*k*pow(epsc1, 


                                2)*(-as1*e0cn*fy + 


                                  e0c*(-n0 + as2*e0c*(epscs11 + epsn) + 


                                        as1*(fy + e0cn*(-epscs11 + epsn)))) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(-2*as2*ch*pow(e0c, 2)*epscs11 + 


                                        d*(-as1*e0cn*fy + 


                                        e0c*(-n0 + as2*e0c*(epscs11 + epsn) + 


                                        as1*(fy + e0cn*(-epscs11 + epsn)))), 


                                        2) - 


                                      2*e0c*(as2*ch*e0c + 


                                        as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscs11 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscs11 + 


                                        4*(-1 + k)*epsn) + 


                                        6*k*pow(epsc1, 2)*


                                        epscs11*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscs11 + 


                                        d*(n0 - as2*e0c*(epscs11 + 


                                        epsn))))))))/(6.*


                            e0c*(as2*ch*e0c + as1*d*e0cn)*k*


                            pow(epsc1, 2)))))/(k*pow(epsc1, 2)*


            pow(epscs11 - (6*as2*ch*pow(e0c, 2)*k*pow(epsc1, 2)*epscs11 - 


                      3*d*k*pow(epsc1, 


                          2)*(-as1*e0cn*fy + 


                            e0c*(-n0 + as2*e0c*(epscs11 + epsn) + 


                                  as1*(fy + e0cn*(-epscs11 + epsn)))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*pow(e0c, 2)*epscs11 + 


                                      d*(-as1*e0cn*fy + 


                                        e0c*(-n0 + as2*e0c*(epscs11 + epsn) + 


                                        as1*(fy + e0cn*(-epscs11 + epsn)))), 


                                    2) - 2*


                                  e0c*(as2*ch*e0c + 


                                      as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscs11 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscs11 + 


                                        4*(-1 + k)*epsn) + 


                                      6*k*pow(epsc1, 2)*


                                        epscs11*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscs11 + 


                                        d*(n0 - as2*e0c*(epscs11 + 


                                        epsn))))))))/(6.*


                      e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2)), 2)) + 


      6*as1*(-2*cd + h)*(fy + 


            e0cn*(-(fy/e0c) + 


                  epsn + (6*as2*ch*pow(e0c, 2)*k*pow(epsc1, 2)*epscs11 - 


                        3*d*k*pow(epsc1, 


                            2)*(-as1*e0cn*fy + 


                              e0c*(-n0 + as2*e0c*(epscs11 + epsn) + 


                                    as1*(fy + e0cn*(-epscs11 + epsn)))) + 


                        sqrt(3.)*


                          sqrt(k*


                              pow(epsc1, 


                                2)*(3*k*pow(epsc1, 2)*


                                    pow(-2*as2*ch*pow(e0c, 2)*epscs11 + 


                                        d*(-as1*e0cn*fy + 


                                        e0c*(-n0 + as2*e0c*(epscs11 + epsn) + 


                                        as1*(fy + e0cn*(-epscs11 + epsn)))), 


                                      2) - 2*


                                    e0c*(as2*ch*e0c + 


                                        as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscs11 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscs11 + 


                                        4*(-1 + k)*epsn) + 


                                        6*k*pow(epsc1, 2)*


                                        epscs11*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscs11 + 


                                        d*(n0 - as2*e0c*(epscs11 + 


                                        epsn))))))))/(6.*


                        e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2))))) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





  }


  return ms11;


}


 


//pomocna hodnota ohyboveho momentu


double normmat::compute_mh5a ()


{


 	double mh5a;	


	


	if (mhr5-mmax2 > 0.0){





    mh5a=mmax2;


  }


  else{


    mh5a=mhr5;


  }


  return mh5a;


}


 


//pomocne pretvoreni betonu


double normmat::compute_epsch5a ()


{


 	double epsch5a;	


	


	if (mhr5-mmax2 > 0.0){





    epsch5a=epscmax1;


  }


  else{


    epsch5a=epschr5;


  }


  return epsch5a;


}


 


//pomocny hranicni ohybovy moment


double normmat::compute_mh5p ()


{


 	double mh5p;	


	


	if (mh5a-fabs(ms11) > 0.0){





     mh5p=ms11;


  }


  else{


    mh5p=mh5a;


  }


  return mh5p;


}


 


//pomocne hranicni pretvoreni betonu


double normmat::compute_epsch5p ()


{


 	double epsch5p;	


	


	if (mh5a-fabs(ms11) > 0.0){





    epsch5p=epscs11;


  }


  else{


    epsch5p=epsch5a;


  }


  return epsch5p;


}


 


//hodnota ohyboveho momentu pro pretvoreni na polovine danneho intervalu, x < h


double normmat::compute_mh25a ()


{


	double mh25a;	


	    mh25a =((-6*b*d*pow(e0c, 2)*pow(as2*ch*e0c + as1*d*e0cn, 3)*fc*pow(k, 2)*


              pow(epsc1, 4)*


              pow(epsch2 + epsch5p + 2*epsn, 


                2)*(6*d*(epsch2 + epsch5p + 


                        2*epsn)*((4 - 6*k)*


                          epsc1 + (-1 + k)*(epsch2 + epsch5p + 


                              2*epsn)) + (h*(3*(-2 + 3*k)*epsc1 - 


                            2*(-1 + k)*(epsch2 + epsch5p + 2*epsn))*(3*d*e0c*


                              k*pow(epsc1, 


                                2)*(-2*n0 + 


                                  as2*e0c*(epsch2 + epsch5p + 2*epsn)) + 


                            3*as1*d*k*


                              pow(epsc1, 


                                2)*(-2*e0cn*fy + 


                                  e0c*(2*fy + 


                                        e0cn*(epsch2 + epsch5p + 2*epsn))) - 


                            2*sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(as2*ch*


                                        pow(e0c, 2)*(epsch2 + epsch5p) - 


                                        d*(-(as1*e0cn*fy) + (e0c*(-2*n0 + 


                                        as1*(2*fy - e0cn*(epsch2 + epsch5p - 


                                        2*epsn)) + as2*e0c*(epsch2 + 


                                        epsch5p + 2*epsn)))/2.), 2) - 


                                      2*e0c*(as2*ch*e0c + 


                                        as1*d*


                                        e0cn)*((b*pow(d, 2)*e0c*fc*


                                        pow(epsch2 + epsch5p + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch2 + epsch5p + 


                                        2*epsn)))/4. + 


                                        3*k*pow(epsc1, 


                                        2)*(epsch2 + 


                                        epsch5p)*(as1*


                                        d*(e0cn*fy - e0c*(fy + 


                                        e0cn*epsn)) + (e0c*(as2*ch*


                                        e0c*(epsch2 + epsch5p) + 


                                        d*(2*n0 - as2*e0c*(epsch2 + epsch5p + 


                                        2*epsn))))/2.))))))/(e0c*(as2*ch*e0c +


                             as1*d*e0cn)*k*pow(epsc1, 2))))/


          pow(3*d*e0c*k*


              pow(epsc1, 2)*(-2*n0 + as2*e0c*(epsch2 + epsch5p + 2*epsn)) + 


            3*as1*d*k*


              pow(epsc1, 


                2)*(-2*e0cn*fy + 


                  e0c*(2*fy + e0cn*(epsch2 + epsch5p + 2*epsn))) - 


            2*sqrt(3.)*


              sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow(as2*ch*pow(e0c, 2)*(epsch2 + epsch5p) - 


                            d*(-(as1*e0cn*


                                        fy) + (e0c*(-2*n0 + 


                                        as1*(2*fy - 


                                        e0cn*(epsch2 + epsch5p - 2*epsn)) + 


                                        as2*e0c*(epsch2 + epsch5p + 2*epsn)))/


                                    2.), 2) - 


                      2*e0c*(as2*ch*e0c + 


                            as1*d*e0cn)*((b*pow(d, 2)*e0c*fc*


                                  pow(epsch2 + epsch5p + 2*epsn, 


                                    2)*((6 - 9*k)*epsc1 + 


                                      2*(-1 + k)*(epsch2 + epsch5p + 


                                        2*epsn)))/4. + 


                            3*k*pow(epsc1, 


                                2)*(epsch2 + 


                                  epsch5p)*(as1*


                                    d*(e0cn*fy - 


                                        e0c*(fy + e0cn*epsn)) + (e0c*(as2*ch*


                                        e0c*(epsch2 + epsch5p) + 


                                        d*(2*n0 - 


                                        as2*e0c*(epsch2 + epsch5p + 


                                        2*epsn))))/2.)))), 


          2) + (as2*(2*ch - 


                h)*(-3*as1*d*k*


                  pow(epsc1, 


                    2)*(-2*d*e0c*e0cn*(epsch2 + epsch5p + 2*epsn) + 


                      ch*(-2*e0cn*fy + 


                            e0c*(2*fy + e0cn*(epsch2 + epsch5p + 2*epsn)))) + 


                ch*(3*d*e0c*k*


                        pow(epsc1, 


                          2)*(2*n0 + as2*e0c*(epsch2 + epsch5p + 2*epsn)) + 


                      2*sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                pow(as2*ch*pow(e0c, 2)*(epsch2 + epsch5p) - 


                                      d*(-(as1*e0cn*


                                        fy) + (e0c*(-2*n0 + 


                                        as1*(2*fy - e0cn*(epsch2 + epsch5p - 


                                        2*epsn)) + as2*e0c*(epsch2 + 


                                        epsch5p + 2*epsn)))/2.), 2)


-2*e0c*(as2*ch*e0c + 


                                    as1*d*


                                      e0cn)*((b*pow(d, 2)*e0c*fc*


                                        pow(epsch2 + epsch5p + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch2 + epsch5p + 


                                        2*epsn)))/4. + 


                                    3*k*pow(epsc1, 


                                        2)*(epsch2 + 


                                        epsch5p)*(as1*


                                        d*(e0cn*fy - 


                                        e0c*(fy + e0cn*epsn)) + (e0c*(as2*ch*


                                        e0c*(epsch2 + epsch5p) + 


                                        d*(2*n0 - as2*e0c*(epsch2 + epsch5p + 


                                        2*epsn))))/2.)))))))/


        d - (as1*(2*cd - 


                h)*(3*as2*e0c*k*


                  pow(epsc1, 


                    2)*(-(d*e0c*e0cn*(epsch2 + epsch5p + 2*epsn)) + 


                      2*ch*(-2*e0cn*fy + 


                            e0c*(2*fy + e0cn*(epsch2 + epsch5p + 2*epsn)))) + 


                e0cn*(6*d*e0c*k*n0*pow(epsc1, 2) + 


                      3*as1*d*k*


                        pow(epsc1, 


                          2)*(-2*e0cn*fy + 


                            e0c*(2*fy + e0cn*(epsch2 + epsch5p + 2*epsn))) + 


                      2*sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                pow(as2*ch*pow(e0c, 2)*(epsch2 + epsch5p) - 


                                      d*(-(as1*e0cn*


                                        fy) + (e0c*(-2*n0 + 


                                        as1*(2*fy - e0cn*(epsch2 + epsch5p - 


                                        2*epsn)) + as2*e0c*(epsch2 + 


                                        epsch5p + 2*epsn)))/2.), 2)


-2*e0c*(as2*ch*e0c + 


                                    as1*d*


                                      e0cn)*((b*pow(d, 2)*e0c*fc*


                                        pow(epsch2 + epsch5p + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch2 + epsch5p + 


                                        2*epsn)))/4. + 


                                    3*k*pow(epsc1, 


                                        2)*(epsch2 + 


                                        epsch5p)*(as1*


                                        d*(e0cn*fy - 


                                        e0c*(fy + e0cn*epsn)) + (e0c*(as2*ch*


                                        e0c*(epsch2 + epsch5p) + 


                                        d*(2*n0 - as2*e0c*(epsch2 + epsch5p + 


                                        2*epsn))))/2.)))))))/


        e0c)/(24.*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mh25a;


}


 


//mezni pretvoren betonu v tlaku po dosazeni mezni nosnosti pruezu, kter se bliz meznmu pretvoreni oceli As1 pri jejim tazeni,// kdy jeste nedoslo k teceni vyztuze As2 a nedochazi k drceni betonu, x < h


double normmat::compute_epscder4 ()


{


	double epscder4;	


	


	epscder4 =-(-(mh2*epsch2) + 4*mh25a*epsch2 - 3*mh5p*epsch2 - 3*mh2*epsch5p + 


        4*mh25a*epsch5p - mh5p*epsch5p)/(4.*(mh2 - 2*mh25a + mh5p));





	return epscder4;


}





   
//hodnota ohyboveho momentu po dosazeni mezni nosnosti pruezu, kter se bliz meznmu pretvoreni oceli As1 pri jejim


//tazeni, kdy jeste nedoslo k teceni vyztuze As2 a nedochazi k drceni betonu, x < h


double normmat::compute_mmax5 ()


{


  double mmax5;	


  


  mmax5 =(-6*as2*e0c*(-2*ch + h)*(epscder4 - (ch*epscder4)/d + 


            epsn + (ch*(6*as2*ch*pow(e0c, 2)*k*pow(epsc1, 2)*epscder4 - 


                      3*d*k*pow(epsc1, 


                          2)*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*(epscder4 + epsn) + 


                                  as1*(fy + e0cn*(-epscder4 + epsn)))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*pow(e0c, 2)*epscder4 + 


                                      d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epscder4 + epsn) +


                                         as1*(fy + e0cn*(-epscder4 + epsn)))),


                                     2) - 


                                2*e0c*(as2*ch*e0c + 


                                      as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscder4 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscder4 + 


                                        4*(-1 + k)*epsn) + 


                                      6*k*pow(epsc1, 2)*


                                        epscder4*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscder4 + 


                                        d*(n0 - as2*e0c*(epscder4 + 


                                        epsn)))))))))/(6.*d*


                  e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2))) - (b*d*fc*


            pow(epscder4 + epsn, 


              2)*(2*d*(epscder4 + 


                      epsn)*((2 - 3*k)*epsc1 + (-1 + k)*epscder4 + (-1 + k)*


                        epsn) - 


                h*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscder4 + 


                      4*(-1 + k)*


                        epsn)*(epscder4 - (6*as2*ch*pow(e0c, 2)*k*


                              pow(epsc1, 2)*epscder4 - 


                            3*d*k*pow(epsc1, 


                                2)*(-(as1*e0cn*fy) + 


                                  e0c*(-n0 + as2*e0c*(epscder4 + epsn) + 


                                        as1*(fy + e0cn*(-epscder4 + epsn)))) +


                             sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(-2*as2*ch*pow(e0c, 2)*epscder4 + 


                                        d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epscder4 + epsn) +


                                         as1*(fy + e0cn*(-epscder4 + epsn)))),


                                         2) - 


                                      2*e0c*(as2*ch*e0c + 


                                        as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscder4 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscder4 + 


                                        4*(-1 + k)*epsn) + 


                                        6*k*pow(epsc1, 2)*


                                        epscder4*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscder4 + 


                                        d*(n0 - as2*e0c*(epscder4 + 


                                        epsn))))))))/(6.*


                            e0c*(as2*ch*e0c + as1*d*e0cn)*k*


                            pow(epsc1, 2)))))/(k*pow(epsc1, 2)*


            pow(epscder4 - (6*as2*ch*pow(e0c, 2)*k*pow(epsc1, 2)*epscder4 - 


                      3*d*k*pow(epsc1, 


                          2)*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*(epscder4 + epsn) + 


                                  as1*(fy + e0cn*(-epscder4 + epsn)))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-2*as2*ch*pow(e0c, 2)*epscder4 + 


                                      d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epscder4 + epsn) +


                                         as1*(fy + e0cn*(-epscder4 + epsn)))),


                                     2) - 


                                2*e0c*(as2*ch*e0c + 


                                      as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscder4 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscder4 + 


                                        4*(-1 + k)*epsn) + 


                                      6*k*pow(epsc1, 2)*


                                        epscder4*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscder4 + 


                                        d*(n0 - as2*e0c*(epscder4 + 


                                        epsn))))))))/(6.*


                      e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2)), 2)) + 


      6*as1*(-2*cd + h)*(fy + 


            e0cn*(-(fy/e0c) + 


                  epsn + (6*as2*ch*pow(e0c, 2)*k*pow(epsc1, 2)*epscder4 - 


                        3*d*k*pow(epsc1, 


                            2)*(-(as1*e0cn*fy) + 


                              e0c*(-n0 + as2*e0c*(epscder4 + epsn) + 


                                    as1*(fy + e0cn*(-epscder4 + epsn)))) + 


                        sqrt(3.)*


                          sqrt(k*


                              pow(epsc1, 


                                2)*(3*k*pow(epsc1, 2)*


                                    pow(-2*as2*ch*pow(e0c, 2)*epscder4 + 


                                        d*(-(as1*e0cn*fy) + 


                                        e0c*(-n0 + as2*e0c*(epscder4 + epsn) +


                                         as1*(fy + e0cn*(-epscder4 + epsn)))),


                                       2) - 


                                  2*e0c*(as2*ch*e0c + 


                                        as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                                        pow(epscder4 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscder4 + 


                                        4*(-1 + k)*epsn) + 


                                        6*k*pow(epsc1, 2)*


                                        epscder4*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        e0c*(as2*ch*e0c*epscder4 + 


                                        d*(n0 - as2*e0c*(epscder4 + 


                                        epsn))))))))/(6.*


                        e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2)))))/12. + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mmax5;


}


  


//hranicni ohybovy moment


double normmat::compute_mh5 ()


{


	double mh5;	


	


	if ((epscder4-epsch2) < 0.0 && (epscder4-epsch5p) > 0.0){





    mh5=mmax5;


  }


  else{


   mh5=mh5p;


  }


  return mh5;


}


 


//hranicni pretvoreni betonu


double normmat::compute_epsch5 ()


{


	double epsch5;	


	


	if ((epscder4-epsch2) < 0.0 && (epscder4-epsch5p) > 0.0){





    epsch5=epscder4;


  }


  else{


   epsch5=epsch5p;


  }


  return epsch5;


}


 


//PRVNI TEKLO As2


 


//pomocne pretvoreni betonu


double normmat::compute_epscp ()


{


	double ac1,ac2,ac3,epscp;	





	ac1 =-(fy/e0c) + epsn + (sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epsc1 - 


                            d*(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                    2) + 2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                        pow(epsc1 + epsn, 


                          2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 


                          3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn)))))))*(-pow(2*


                      e0c*(as1*d*e0c + 


                          as2*ch*e0cn)*(6*b*pow(d, 2)*e0c*


                            fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 2*epsn) + 


                          6*k*pow(epsc1, 


                              2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                as2*(-2*ch*e0c*e0cn*epsc1 + 


                                      d*(-(e0c*fy) + e0cn*fy + 


                                        2*e0c*e0cn*epsc1 + 


                                        e0c*e0cn*epsn)))) + 


                    6*e0c*(as1*d*e0c + as2*(2*ch - d)*e0cn)*k*


                      pow(epsc1, 


                        2)*(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                          as2*(2*ch*e0c*e0cn*epsc1 - 


                                d*(e0cn*fy + 


                                      e0c*(-fy + e0cn*(epsc1 + epsn))))), 


                  2)/(4.*pow(3*k*pow(epsc1, 2)*


                          pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                              as2*(2*ch*e0c*e0cn*epsc1 - 


                                    d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                            2) + 2*


                          e0c*(as1*d*e0c + 


                              as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                                pow(epsc1 + epsn, 


                                  2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                              6*k*pow(epsc1, 


                                  3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                                    d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn))))), 2)) + (3*


                  pow(e0c, 


                    2)*(pow(as1*d*e0c + as2*(2*ch - d)*e0cn, 2)*k*


                        pow(epsc1, 2) - 


                      2*(as1*d*e0c + 


                            as2*ch*e0cn)*(2*as2*(ch - d)*e0cn*k*


                              pow(epsc1, 2) + 


                            b*pow(d, 2)*


                              fc*((-2 + k)*epsc1 + 4*(-1 + k)*epsn))))/(3*k*


                    pow(epsc1, 2)*


                    pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                        as2*(2*ch*e0c*e0cn*epsc1 - 


                              d*(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                      2) + 2*e0c*(as1*d*e0c + 


                        as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                          pow(epsc1 + epsn, 


                            2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                        6*k*pow(epsc1, 


                            3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                              d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                    e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn))))))))/(4.*


        sqrt(3.)*e0c*(as1*d*e0c + as2*ch*e0cn)*


        k) + (3*d*e0c*k*pow(epsc1, 2)*(n0 + as1*e0c*(epsc1 - epsn)) - 


        3*as2*k*pow(epsc1, 


            2)*(-2*ch*e0c*e0cn*epsc1 + 


              d*(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn)))) + 


        sqrt(3.)*sqrt(k*


              pow(epsc1, 


                2)*(3*k*pow(epsc1, 2)*


                    pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                        as2*(2*ch*e0c*e0cn*epsc1 - 


                              d*(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                      2) + 2*e0c*(as1*d*e0c + 


                        as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                          pow(epsc1 + epsn, 


                            2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                        6*k*pow(epsc1, 


                            3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                              d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                    e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn))))))))/(6.*


        e0c*(as1*d*e0c + as2*ch*e0cn)*k*


        pow(epsc1, 2)) - (as1*d*e0c*k*pow(epsc1, 2) + 


        as2*(2*ch - d)*e0cn*k*


          pow(epsc1, 


            2) + (sqrt(3.)*(pow(as1, 2)*pow(e0c, 3)*k*


                    pow(epsc1, 2)*(epsc1 + epsn) + 


                  as2*e0cn*(2*b*ch*e0c*


                          fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 2*epsn) + 


                        k*pow(epsc1, 


                            2)*(-(e0c*n0) + 


                              as2*(e0cn*fy + 


                                    e0c*(-fy + e0cn*(epsc1 + epsn))))) + 


                  as1*e0c*(2*b*d*e0c*


                          fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 2*epsn) + 


                        k*pow(epsc1, 


                            2)*(-(e0c*n0) + 


                              as2*(e0cn*fy + 


                                    e0c*(-fy + 2*e0cn*(epsc1 + epsn))))))*


              sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                            as2*(2*ch*e0c*e0cn*epsc1 - 


                                  d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                          2) + 2*


                        e0c*(as1*d*e0c + 


                            as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                              pow(epsc1 + epsn, 


                                2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                            6*k*pow(epsc1, 


                                3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                                  d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn))))))))/(3*


                pow(as2, 2)*k*pow(epsc1, 2)*


                pow(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn)), 2) + 


              pow(e0c, 


                  2)*(-4*as1*b*d*e0c*fc*(epsc1 - 2*epsn)*


                      pow(epsc1 + epsn, 2) + 


                    k*(3*pow(n0, 2)*pow(epsc1, 2) - 


                          6*as1*e0c*n0*pow(epsc1, 2)*(epsc1 + epsn) + 


                          as1*e0c*(3*as1*e0c*pow(epsc1, 2) + 


                                2*b*d*fc*(5*epsc1 - 4*epsn))*


                            pow(epsc1 + epsn, 2))) - 


              2*as2*e0c*(3*e0cn*fy*k*n0*pow(epsc1, 2) - 


                    3*as1*pow(e0c, 2)*k*


                      pow(epsc1, 


                        2)*(epsc1 + epsn)*(-fy + e0cn*(epsc1 + epsn)) - 


                    e0c*(3*fy*k*pow(epsc1, 2)*(n0 + as1*e0cn*(epsc1 + epsn)) +


                           e0cn*(epsc1 + epsn)*(-3*k*n0*pow(epsc1, 2) + 


                                b*ch*fc*(epsc1 + epsn)*((-2 + 5*k)*epsc1 - 


                                      4*(-1 + k)*epsn))))))/(2.*(as1*d*e0c + 


            as2*ch*e0cn)*k*epsc1);





	ac2 =(3*as1*d*pow(e0c, 2)*k*pow(epsc1, 2) + 


      3*as2*(2*ch - d)*e0c*e0cn*k*


        pow(epsc1, 


          2) + (3*sqrt(3.)*


            e0c*(pow(as1, 2)*pow(e0c, 3)*k*pow(epsc1, 2)*(epsc1 + epsn) + 


                as2*e0cn*(2*b*ch*e0c*


                        fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 2*epsn) + 


                      k*pow(epsc1, 


                          2)*(-(e0c*n0) + 


                            as2*(e0cn*fy + 


                                  e0c*(-fy + e0cn*(epsc1 + epsn))))) + 


                as1*e0c*(2*b*d*e0c*


                        fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 2*epsn) + 


                      k*pow(epsc1, 


                          2)*(-(e0c*n0) + 


                            as2*(e0cn*fy + 


                                  e0c*(-fy + 2*e0cn*(epsc1 + epsn))))))*


            sqrt(k*pow(epsc1, 


                  2)*(3*k*pow(epsc1, 2)*


                      pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                          as2*(2*ch*e0c*e0cn*epsc1 - 


                                d*(e0cn*fy + 


                                      e0c*(-fy + e0cn*(epsc1 + epsn)))), 2) + 


                    2*e0c*(as1*d*e0c + 


                          as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                            pow(epsc1 + epsn, 


                              2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                          6*k*pow(epsc1, 


                              3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                                d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                      e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn))))))))/(3*


              pow(as2, 2)*k*pow(epsc1, 2)*


              pow(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn)), 2) + 


            pow(e0c, 


                2)*(-4*as1*b*d*e0c*fc*(epsc1 - 2*epsn)*pow(epsc1 + epsn, 2) + 


                  k*(3*pow(n0, 2)*pow(epsc1, 2) - 


                        6*as1*e0c*n0*pow(epsc1, 2)*(epsc1 + epsn) + 


                        as1*e0c*(3*as1*e0c*pow(epsc1, 2) + 


                              2*b*d*fc*(5*epsc1 - 4*epsn))*


                          pow(epsc1 + epsn, 2))) - 


            2*as2*e0c*(3*e0cn*fy*k*n0*pow(epsc1, 2) - 


                  3*as1*pow(e0c, 2)*k*


                    pow(epsc1, 2)*(epsc1 + epsn)*(-fy + e0cn*(epsc1 + epsn)) -


                   e0c*(3*fy*k*pow(epsc1, 2)*(n0 + as1*e0cn*(epsc1 + epsn)) + 


                        e0cn*(epsc1 + epsn)*(-3*k*n0*pow(epsc1, 2) + 


                              b*ch*fc*(epsc1 + epsn)*((-2 + 5*k)*epsc1 - 


                                    4*(-1 + k)*epsn))))) - 


      sqrt(3.)*epsc1*


        sqrt(k*pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epsc1 - 


                            d*(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                    2) + 2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                        pow(epsc1 + epsn, 


                          2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 


                          3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn)))))))*(-pow(2*


              


                e0c*(as1*d*e0c + 


                          as2*ch*e0cn)*(6*b*pow(d, 2)*e0c*


                            fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 2*epsn) + 


                          6*k*pow(epsc1, 


                              2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                as2*(-2*ch*e0c*e0cn*epsc1 + 


                                      d*(-(e0c*fy) + e0cn*fy + 


                                        2*e0c*e0cn*epsc1 + 


                                        e0c*e0cn*epsn)))) + 


                    6*e0c*(as1*d*e0c + as2*(2*ch - d)*e0cn)*k*


                      pow(epsc1, 


                        2)*(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                          as2*(2*ch*e0c*e0cn*epsc1 - 


                                d*(e0cn*fy + 


                                      e0c*(-fy + e0cn*(epsc1 + epsn))))), 


                  2)/(4.*pow(3*k*pow(epsc1, 2)*


                          pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                              as2*(2*ch*e0c*e0cn*epsc1 - 


                                    d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                            2) + 2*


                          e0c*(as1*d*e0c + 


                              as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                                pow(epsc1 + epsn, 


                                  2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                              6*k*pow(epsc1, 


                                  3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                                    d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn))))), 2)) + (3*


                  pow(e0c, 


                    2)*(pow(as1*d*e0c + as2*(2*ch - d)*e0cn, 2)*k*


                        pow(epsc1, 2) - 


                      2*(as1*d*e0c + 


                            as2*ch*e0cn)*(2*as2*(ch - d)*e0cn*k*


                              pow(epsc1, 2) + 


                            b*pow(d, 2)*


                              fc*((-2 + k)*epsc1 + 4*(-1 + k)*epsn))))/(3*k*


                    pow(epsc1, 2)*


                    pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                        as2*(2*ch*e0c*e0cn*epsc1 - 


                              d*(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                      2) + 2*e0c*(as1*d*e0c + 


                        as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                          pow(epsc1 + epsn, 


                            2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                        6*k*pow(epsc1, 


                            3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                              d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                    e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn))))))))/(6.*


      e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));


	ac3 =(sqrt(k*pow(epsc1, 


            2)*(3*k*pow(epsc1, 2)*


                pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                    as2*(2*ch*e0c*e0cn*epsc1 - 


                          d*(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                  2) + 2*e0c*(as1*d*e0c + 


                    as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                      pow(epsc1 + epsn, 


                        2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                    6*k*pow(epsc1, 


                        3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                          d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                e0c*(-(as2*fy) - n0 + 


                                      as2*e0cn*(epsc1 + epsn)))))))*(-pow(2*


                    e0c*(as1*d*e0c + 


                        as2*ch*e0cn)*(6*b*pow(d, 2)*e0c*


                          fc*(epsc1 + epsn)*(k*(epsc1 - 2*epsn) + 2*epsn) + 


                        6*k*pow(epsc1, 


                            2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                              as2*(-2*ch*e0c*e0cn*epsc1 + 


                                    d*(-(e0c*fy) + e0cn*fy + 


                                        2*e0c*e0cn*epsc1 + 


                                        e0c*e0cn*epsn)))) + 


                  6*e0c*(as1*d*e0c + as2*(2*ch - d)*e0cn)*k*


                    pow(epsc1, 


                      2)*(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                        as2*(2*ch*e0c*e0cn*epsc1 - 


                              d*(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn))))),


                 2)/(4.*


                  pow(3*k*pow(epsc1, 2)*


                        pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                            as2*(2*ch*e0c*e0cn*epsc1 - 


                                  d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                          2) + 2*


                        e0c*(as1*d*e0c + 


                            as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                              pow(epsc1 + epsn, 


                                2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                            6*k*pow(epsc1, 


                                3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                                  d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn))))), 2)) + (3*


                pow(e0c, 


                  2)*(pow(as1*d*e0c + as2*(2*ch - d)*e0cn, 2)*k*


                      pow(epsc1, 2) - 


                    2*(as1*d*e0c + 


                          as2*ch*e0cn)*(2*as2*(ch - d)*e0cn*k*pow(epsc1, 2) + 


                          b*pow(d, 2)*


                            fc*((-2 + k)*epsc1 + 4*(-1 + k)*epsn))))/(3*k*


                  pow(epsc1, 2)*


                  pow(d*e0c*(n0 + as1*e0c*(epsc1 - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epsc1 - 


                            d*(e0cn*fy + e0c*(-fy + e0cn*(epsc1 + epsn)))), 


                    2) + 2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(b*pow(d, 2)*e0c*fc*


                        pow(epsc1 + epsn, 


                          2)*((-2 + 5*k)*epsc1 - 4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 


                          3)*(-(as2*ch*e0c*e0cn*epsc1) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epsc1 + epsn))))))))/(4.*


      sqrt(3.)*e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));








  if (pow(ac2, 2) - 4*ac1*ac3 < 0.0){





    epscp=-1.0;





  }





  else{





    epscp=(-ac2 - sqrt(pow(ac2, 2) - 4*ac1*ac3))/(2.*ac3);





  }


  return epscp;


}


  


//pretvoreni betonu v tlaku, kdy dochazi k teceni vyztuze As1, uz teklo As2 a nedochazi k drceni betonu, x < h


double normmat::compute_epschr6 ()


{


	double ac1,ac2,ac3,epschr6;	





	ac1 =-(fy/e0c) + epsn + (3*d*e0c*k*pow(epsc1, 2)*(n0 + as1*e0c*(epscp - epsn)) + 


        3*as2*k*pow(epsc1, 


            2)*(2*ch*e0c*e0cn*epscp + 


              d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscp + epsn)))) + 


        sqrt(3.)*sqrt(k*


              pow(epsc1, 


                2)*(3*k*pow(epsc1, 2)*


                    pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                        as2*(2*ch*e0c*e0cn*epscp - 


                              d*(e0cn*fy + e0c*(-fy + e0cn*(epscp + epsn)))), 


                      2) + 2*e0c*(as1*d*e0c + 


                        as2*ch*


                          e0cn)*(-(b*pow(d, 2)*e0c*fc*


                              pow(epscp + epsn, 


                                2)*((6 - 9*k)*epsc1 + 


                                  4*(-1 + k)*(epscp + epsn))) + 


                        6*k*pow(epsc1, 2)*


                          epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                              d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                    e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + epsn))))))))/(6.*


        e0c*(as1*d*e0c + as2*ch*e0cn)*k*


        pow(epsc1, 


          2)) - (epscp*(6*as1*d*pow(e0c, 2) + 


            6*as2*(2*ch - d)*e0c*


              e0cn + (sqrt(3.)*(6*e0c*(as1*d*e0c + as2*(2*ch - d)*e0cn)*k*


                          pow(epsc1, 


                            2)*(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                              as2*(2*ch*e0c*e0cn*epscp - 


                                    d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscp + epsn))))) + 


                        2*e0c*(as1*d*e0c + 


                              as2*ch*e0cn)*(-6*b*pow(d, 2)*e0c*


                                fc*(epscp + epsn)*((2 - 3*k)*epsc1 + 


                                    2*(-1 + k)*(epscp + epsn)) - 


                              6*k*pow(epsc1, 


                                  2)*(d*e0c*(n0 - as1*e0c*epsn) + 


                                    as2*(2*ch*e0c*e0cn*epscp + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(2*epscp + 


                                        epsn))))))))/


                sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                            as2*(2*ch*e0c*e0cn*epscp - 


                                  d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscp + epsn)))), 


                          2) + 2*


                        e0c*(as1*d*e0c + 


                            as2*ch*


                              e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                  pow(epscp + epsn, 


                                    2)*((6 - 9*k)*epsc1 + 


                                      4*(-1 + k)*(epscp + epsn))) + 


                            6*k*pow(epsc1, 2)*


                              epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                                  d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + epsn)))))))))/(12.*


        e0c*(as1*d*e0c + as2*ch*e0cn)) + (pow(epscp, 2)*


        sqrt(k*pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epscp - 


                            d*(e0cn*fy + e0c*(-fy + e0cn*(epscp + epsn)))), 


                    2) + 2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                            pow(epscp + epsn, 


                              2)*((6 - 9*k)*epsc1 + 


                                4*(-1 + k)*(epscp + epsn))) + 


                      6*k*pow(epsc1, 2)*


                        epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + 


                                        epsn)))))))*((e0c*(3*e0c*


                        pow(as1*d*e0c + as2*(2*ch - d)*e0cn, 2)*k*


                        pow(epsc1, 2) + 


                      2*(as1*d*e0c + 


                            as2*ch*e0cn)*(6*as2*(-ch + d)*e0c*e0cn*k*


                              pow(epsc1, 2) + 


                            3*b*pow(d, 2)*e0c*


                              fc*((-2 + 3*k)*epsc1 - 


                                  4*(-1 + k)*(epscp + epsn)))))/(3*k*


                    pow(epsc1, 2)*


                    pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                        as2*(2*ch*e0c*e0cn*epscp - 


                              d*(e0cn*fy + e0c*(-fy + e0cn*(epscp + epsn)))), 


                      2) + 2*e0c*(as1*d*e0c + 


                        as2*ch*


                          e0cn)*(-(b*pow(d, 2)*e0c*fc*


                              pow(epscp + epsn, 


                                2)*((6 - 9*k)*epsc1 + 


                                  4*(-1 + k)*(epscp + epsn))) + 


                        6*k*pow(epsc1, 2)*


                          epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                              d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                    e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + epsn)))))) - 


            pow(6*e0c*(as1*d*e0c + as2*(2*ch - d)*e0cn)*k*


                      pow(epsc1, 


                        2)*(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                          as2*(2*ch*e0c*e0cn*epscp - 


                                d*(e0cn*fy + 


                                      e0c*(-fy + e0cn*(epscp + epsn))))) + 


                    2*e0c*(as1*d*e0c + 


                          as2*ch*e0cn)*(-6*b*pow(d, 2)*e0c*


                            fc*(epscp + epsn)*((2 - 3*k)*epsc1 + 


                                2*(-1 + k)*(epscp + epsn)) - 


                          6*k*pow(epsc1, 


                              2)*(d*e0c*(n0 - as1*e0c*epsn) + 


                                as2*(2*ch*e0c*e0cn*epscp + 


                                      d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(2*epscp + epsn)))))), 


                  2)/(4.*pow(3*k*pow(epsc1, 2)*


                          pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                              as2*(2*ch*e0c*e0cn*epscp - 


                                    d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscp + epsn)))), 


                            2) + 2*


                          e0c*(as1*d*e0c + 


                              as2*ch*


                                e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                    pow(epscp + epsn, 


                                      2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*(epscp + epsn))) + 


                              6*k*pow(epsc1, 2)*


                                epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                                    d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + epsn))))), 


                      2))))/(4.*sqrt(3.)*e0c*(as1*d*e0c + as2*ch*e0cn)*k*


        pow(epsc1, 2));





	ac2 =(3*as1*d*pow(e0c, 2)*k*pow(epsc1, 2) + 


      3*as2*(2*ch - d)*e0c*e0cn*k*


        pow(epsc1, 


          2) + (sqrt(3.)*k*


            pow(epsc1, 


              2)*(6*e0c*(as1*d*e0c + as2*(2*ch - d)*e0cn)*k*


                  pow(epsc1, 


                    2)*(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epscp - 


                            d*(e0cn*fy + e0c*(-fy + e0cn*(epscp + epsn))))) + 


                2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(-6*b*pow(d, 2)*e0c*


                        fc*(epscp + epsn)*((2 - 3*k)*epsc1 + 


                            2*(-1 + k)*(epscp + epsn)) - 


                      6*k*pow(epsc1, 


                          2)*(d*e0c*(n0 - as1*e0c*epsn) + 


                            as2*(2*ch*e0c*e0cn*epscp + 


                                  d*(-(e0cn*fy) + 


                                        e0c*(fy - 


                                        e0cn*(2*epscp + epsn))))))))/(2.*


            sqrt(k*pow(epsc1, 


                  2)*(3*k*pow(epsc1, 2)*


                      pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                          as2*(2*ch*e0c*e0cn*epscp - 


                                d*(e0cn*fy + 


                                      e0c*(-fy + e0cn*(epscp + epsn)))), 2) + 


                    2*e0c*(as1*d*e0c + 


                          as2*ch*


                            e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                pow(epscp + epsn, 


                                  2)*((6 - 9*k)*epsc1 + 


                                    4*(-1 + k)*(epscp + epsn))) + 


                          6*k*pow(epsc1, 2)*


                            epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                                d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                      e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + epsn)))))))) - 


      sqrt(3.)*epscp*


        sqrt(k*pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epscp - 


                            d*(e0cn*fy + e0c*(-fy + e0cn*(epscp + epsn)))), 


                    2) + 2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                            pow(epscp + epsn, 


                              2)*((6 - 9*k)*epsc1 + 


                                4*(-1 + k)*(epscp + epsn))) + 


                      6*k*pow(epsc1, 2)*


                        epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + 


                                        epsn)))))))*((e0c*(3*e0c*


                        pow(as1*d*e0c + as2*(2*ch - d)*e0cn, 2)*k*


                        pow(epsc1, 2) + 


                      2*(as1*d*e0c + 


                            as2*ch*e0cn)*(6*as2*(-ch + d)*e0c*e0cn*k*


                              pow(epsc1, 2) + 


                            3*b*pow(d, 2)*e0c*


                              fc*((-2 + 3*k)*epsc1 - 


                                  4*(-1 + k)*(epscp + epsn)))))/(3*k*


                    pow(epsc1, 2)*


                    pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                        as2*(2*ch*e0c*e0cn*epscp - 


                              d*(e0cn*fy + e0c*(-fy + e0cn*(epscp + epsn)))), 


                      2) + 2*e0c*(as1*d*e0c + 


                        as2*ch*


                          e0cn)*(-(b*pow(d, 2)*e0c*fc*


                              pow(epscp + epsn, 


                                2)*((6 - 9*k)*epsc1 + 


                                  4*(-1 + k)*(epscp + epsn))) + 


                        6*k*pow(epsc1, 2)*


                          epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                              d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                    e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + epsn)))))) - 


            pow(6*e0c*(as1*d*e0c + as2*(2*ch - d)*e0cn)*k*


                      pow(epsc1, 


                        2)*(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                          as2*(2*ch*e0c*e0cn*epscp - 


                                d*(e0cn*fy + 


                                      e0c*(-fy + e0cn*(epscp + epsn))))) + 


                    2*e0c*(as1*d*e0c + 


                          as2*ch*e0cn)*(-6*b*pow(d, 2)*e0c*


                            fc*(epscp + epsn)*((2 - 3*k)*epsc1 + 


                                2*(-1 + k)*(epscp + epsn)) - 


                          6*k*pow(epsc1, 


                              2)*(d*e0c*(n0 - as1*e0c*epsn) + 


                                as2*(2*ch*e0c*e0cn*epscp + 


                                      d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(2*epscp + epsn)))))), 


                  2)/(4.*pow(3*k*pow(epsc1, 2)*


                          pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                              as2*(2*ch*e0c*e0cn*epscp - 


                                    d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscp + epsn)))), 


                            2) + 2*


                          e0c*(as1*d*e0c + 


                              as2*ch*


                                e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                    pow(epscp + epsn, 


                                      2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*(epscp + epsn))) + 


                              6*k*pow(epsc1, 2)*


                                epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                                    d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + epsn))))), 


                      2))))/(6.*e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));





	ac3 =(sqrt(k*pow(epsc1, 


            2)*(3*k*pow(epsc1, 2)*


                pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                    as2*(2*ch*e0c*e0cn*epscp - 


                          d*(e0cn*fy + e0c*(-fy + e0cn*(epscp + epsn)))), 


                  2) + 2*e0c*(as1*d*e0c + 


                    as2*ch*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                          pow(epscp + epsn, 


                            2)*((6 - 9*k)*epsc1 + 


                              4*(-1 + k)*(epscp + epsn))) + 


                    6*k*pow(epsc1, 2)*


                      epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                          d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                e0c*(-(as2*fy) - n0 + 


                                      as2*e0cn*(epscp + epsn)))))))*((e0c*(3*


                      e0c*pow(as1*d*e0c + as2*(2*ch - d)*e0cn, 2)*k*


                      pow(epsc1, 2) + 


                    2*(as1*d*e0c + 


                          as2*ch*e0cn)*(6*as2*(-ch + d)*e0c*e0cn*k*


                            pow(epsc1, 2) + 


                          3*b*pow(d, 2)*e0c*


                            fc*((-2 + 3*k)*epsc1 - 


                                4*(-1 + k)*(epscp + epsn)))))/(3*k*


                  pow(epsc1, 2)*


                  pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epscp - 


                            d*(e0cn*fy + e0c*(-fy + e0cn*(epscp + epsn)))), 


                    2) + 2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                            pow(epscp + epsn, 


                              2)*((6 - 9*k)*epsc1 + 


                                4*(-1 + k)*(epscp + epsn))) + 


                      6*k*pow(epsc1, 2)*


                        epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + epsn)))))) - 


          pow(6*e0c*(as1*d*e0c + as2*(2*ch - d)*e0cn)*k*


                    pow(epsc1, 


                      2)*(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                        as2*(2*ch*e0c*e0cn*epscp - 


                              d*(e0cn*fy + 


                                    e0c*(-fy + e0cn*(epscp + epsn))))) + 


                  2*e0c*(as1*d*e0c + 


                        as2*ch*e0cn)*(-6*b*pow(d, 2)*e0c*


                          fc*(epscp + epsn)*((2 - 3*k)*epsc1 + 


                              2*(-1 + k)*(epscp + epsn)) - 


                        6*k*pow(epsc1, 


                            2)*(d*e0c*(n0 - as1*e0c*epsn) + 


                              as2*(2*ch*e0c*e0cn*epscp + 


                                    d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(2*epscp + epsn)))))), 


                2)/(4.*pow(3*k*pow(epsc1, 2)*


                        pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                            as2*(2*ch*e0c*e0cn*epscp - 


                                  d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscp + epsn)))), 


                          2) + 2*


                        e0c*(as1*d*e0c + 


                            as2*ch*


                              e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                  pow(epscp + epsn, 


                                    2)*((6 - 9*k)*epsc1 + 


                                      4*(-1 + k)*(epscp + epsn))) + 


                            6*k*pow(epsc1, 2)*


                              epscp*(-(as2*ch*e0c*e0cn*epscp) + 


                                  d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscp + epsn))))), 


                    2))))/(4.*sqrt(3.)*e0c*(as1*d*e0c + as2*ch*e0cn)*k*


      pow(epsc1, 2));








  if ((sqrt(k*pow(epsc1, 


        2)*(3*k*pow(epsc1, 2)*


            pow(d*e0c*(n0 + as1*e0c*(epscp - epsn)) + 


                as2*(2*ch*e0c*e0cn*epscp - 


                      d*(e0cn*fy + e0c*(-fy + e0cn*(epscp + epsn)))), 2) + 


          2*e0c*(as1*d*e0c + 


                as2*ch*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                      pow(epscp + epsn, 


                        2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*(epscp + epsn))) + 


                6*k*pow(epsc1, 2)*


                  epscp*(-(as2*ch*e0c*e0cn*epscp) + 


			 d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


			 e0c*(-(as2*fy) - n0 + 


			      as2*e0cn*(epscp + epsn)))))))) < 0.0 || epscp == -1.0 || (pow(ac2, 2) - 4*ac1*ac3) < 0.0){





    epschr6=-1.0;





  }


  else{


    epschr6=(-ac2 - sqrt(pow(ac2, 2) - 4*ac1*ac3))/(2.*ac3);


  }


  return epschr6;


}


 


//hodnota ohyboveho momentu, kdy dochazi k teceni vyztuze As1, uz teklo As2 a nedochazi k drceni betonu, x < h


double normmat::compute_mhr6 ()


{


	double mhr6;	


	


	if (epschr6 < 0 && epschr6 != -1){





    mhr6=0.08333333333333333*(6*as1*


        e0c*(-2*cd + 


            h)*(epsn + (3*d*e0c*k*


                    pow(epsc1, 2)*(n0 + as1*e0c*(epschr6 - epsn)) + 


                  3*as2*k*


                    pow(epsc1, 


                      2)*(2*ch*e0c*e0cn*epschr6 + 


                        d*(-e0cn*fy + e0c*(fy - e0cn*(epschr6 + epsn)))) + 


                  sqrt(3.)*


                    sqrt(k*pow(epsc1, 


                          2)*(3*k*pow(epsc1, 2)*


                              pow(d*e0c*(n0 + as1*e0c*(epschr6 - epsn)) + 


                                  as2*(2*ch*e0c*e0cn*epschr6 + 


                                        d*(-e0cn*fy + 


                                        e0c*(fy - e0cn*(epschr6 + epsn)))), 


                                2) + 2*


                              e0c*(as1*d*e0c + 


                                  as2*ch*e0cn)*(-b*pow(d, 2)*e0c*fc*


                                    pow(epschr6 + epsn, 


                                      2)*(4*(-1 + k)*epschr6 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                  6*k*epschr6*


                                    pow(epsc1, 


                                      2)*(-as2*ch*e0c*e0cn*epschr6 + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-as2*fy - n0 + 


                                        as2*e0cn*(epschr6 + epsn))))))))/(6.*


                  e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2))) - (b*d*fc*


            pow(epschr6 + epsn, 


              2)*(2*d*(epschr6 + 


                      epsn)*((-1 + k)*epschr6 + (2 - 3*k)*epsc1 + (-1 + k)*


                        epsn) - 


                h*(4*(-1 + k)*epschr6 + (6 - 9*k)*epsc1 + 


                      4*(-1 + k)*


                        epsn)*(epschr6 - (3*d*e0c*k*


                              pow(epsc1, 2)*(n0 + as1*e0c*(epschr6 - epsn)) + 


                            3*as2*k*


                              pow(epsc1, 


                                2)*(2*ch*e0c*e0cn*epschr6 + 


                                  d*(-e0cn*fy + 


                                        e0c*(fy - e0cn*(epschr6 + epsn)))) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(d*


                                        e0c*(n0 + as1*e0c*(epschr6 - epsn)) + 


                                        as2*(2*ch*e0c*e0cn*epschr6 + 


                                        d*(-e0cn*fy + e0c*(fy - 


                                        e0cn*(epschr6 + epsn)))), 2) + 


                                      2*e0c*(as1*d*e0c + 


                                        as2*ch*e0cn)*(-b*pow(d, 2)*e0c*fc*


                                        pow(epschr6 + epsn, 


                                        2)*(4*(-1 + k)*epschr6 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                        6*k*epschr6*


                                        pow(epsc1, 


                                        2)*(-as2*ch*e0c*e0cn*epschr6 + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-as2*fy - n0 + as2*


                                        e0cn*(epschr6 + epsn))))))))/(6.*


                            e0c*(as1*d*e0c + as2*ch*e0cn)*k*


                            pow(epsc1, 2)))))/(k*pow(epsc1, 2)*


            pow(epschr6 - (3*d*e0c*k*


                        pow(epsc1, 2)*(n0 + as1*e0c*(epschr6 - epsn)) + 


                      3*as2*k*


                        pow(epsc1, 


                          2)*(2*ch*e0c*e0cn*epschr6 + 


                            d*(-e0cn*fy + e0c*(fy - e0cn*(epschr6 + epsn)))) +


                       sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(d*e0c*(n0 + as1*e0c*(epschr6 - epsn)) + 


                                      as2*(2*ch*e0c*e0cn*epschr6 + 


                                        d*(-e0cn*fy + 


                                        e0c*(fy - e0cn*(epschr6 + epsn)))), 


                                    2) + 2*


                                  e0c*(as1*d*e0c + 


                                      as2*ch*e0cn)*(-b*pow(d, 2)*e0c*fc*


                                        pow(epschr6 + epsn, 


                                        2)*(4*(-1 + k)*epschr6 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                      6*k*epschr6*


                                        pow(epsc1, 


                                        2)*(-as2*ch*e0c*e0cn*epschr6 + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-as2*fy - n0 + 


                                        as2*e0cn*(epschr6 + epsn))))))))/(6.*


                      e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2)), 2)) + 


      6*as2*(-2*ch + h)*(fy - 


            e0cn*(fy/e0c + epschr6 - (ch*epschr6)/d + 


                  epsn + (ch*(3*d*e0c*k*


                              pow(epsc1, 2)*(n0 + as1*e0c*(epschr6 - epsn)) + 


                            3*as2*k*


                              pow(epsc1, 


                                2)*(2*ch*e0c*e0cn*epschr6 + 


                                  d*(-e0cn*fy + 


                                        e0c*(fy - e0cn*(epschr6 + epsn)))) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(d*


                                        e0c*(n0 + as1*e0c*(epschr6 - epsn)) + 


                                        as2*(2*ch*e0c*e0cn*epschr6 + 


                                        d*(-e0cn*fy + e0c*(fy - 


                                        e0cn*(epschr6 + epsn)))), 2) + 


                                      2*e0c*(as1*d*e0c + 


                                        as2*ch*e0cn)*(-b*pow(d, 2)*e0c*fc*


                                        pow(epschr6 + epsn, 


                                        2)*(4*(-1 + k)*epschr6 + (6 - 9*k)*


                                        epsc1 + 4*(-1 + k)*epsn) + 


                                        6*k*epschr6*


                                        pow(epsc1, 


                                        2)*(-as2*ch*e0c*e0cn*epschr6 + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-as2*fy - n0 + as2*


                                        e0cn*(epschr6 + epsn)))))))))/(6.*d*


                        e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2))))) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





  }


  else{


    mhr6=1000000000.0;


  }


  return mhr6;


}


   


//hodnota ohyboveho momentu po dosazeni mezniho pretvoreni betonu v tlaku, tece As2 a jeste nedoslo k teceni vyztuze As1, x < h


double normmat::compute_mmax3 ()


{


	double mmax3;	


	


	mmax3 =(6*as1*e0c*(-2*cd + 


            h)*(epsn + (3*d*e0c*k*


                    pow(epsc1, 2)*(n0 + as1*e0c*(epscmax1 - epsn)) + 


                  3*as2*k*


                    pow(epsc1, 


                      2)*(2*ch*e0c*e0cn*epscmax1 + 


                        d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscmax1 + epsn)))) + 


                  sqrt(3.)*


                    sqrt(k*pow(epsc1, 


                          2)*(3*k*pow(epsc1, 2)*


                              pow(d*e0c*(n0 + as1*e0c*(epscmax1 - epsn)) + 


                                  as2*(2*ch*e0c*e0cn*epscmax1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscmax1 + epsn)))), 


                                2) + 2*


                              e0c*(as1*d*e0c + 


                                  as2*ch*


                                    e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epscmax1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1 + 


                                        4*(-1 + k)*epsn)) + 


                                  6*k*pow(epsc1, 2)*


                                    epscmax1*(-(as2*ch*e0c*e0cn*epscmax1) + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscmax1 + epsn))))))))/(6.*


                  e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2))) - (b*d*fc*


            pow(epscmax1 + epsn, 


              2)*(2*d*(epscmax1 + 


                      epsn)*((2 - 3*k)*epsc1 + (-1 + k)*epscmax1 + (-1 + k)*


                        epsn) - 


                h*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscmax1 + 


                      4*(-1 + k)*


                        epsn)*(epscmax1 - (3*d*e0c*k*


                              pow(epsc1, 


                                2)*(n0 + as1*e0c*(epscmax1 - epsn)) + 


                            3*as2*k*


                              pow(epsc1, 


                                2)*(2*ch*e0c*e0cn*epscmax1 + 


                                  d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscmax1 + epsn)))) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(d*


                                        e0c*(n0 + as1*e0c*(epscmax1 - epsn)) +


                                         as2*(2*ch*e0c*e0cn*epscmax1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscmax1 + epsn)))), 


                                        2) + 


                                      2*e0c*(as1*d*e0c + 


                                        as2*ch*


                                        e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epscmax1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1 + 


                                        4*(-1 + k)*epsn)) + 


                                        6*k*pow(epsc1, 2)*


                                        epscmax1*(-(as2*ch*e0c*e0cn*


                                        epscmax1) + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscmax1 + epsn))))))))/(6.*


                            e0c*(as1*d*e0c + as2*ch*e0cn)*k*


                            pow(epsc1, 2)))))/(k*pow(epsc1, 2)*


            pow(epscmax1 - (3*d*e0c*k*


                        pow(epsc1, 2)*(n0 + as1*e0c*(epscmax1 - epsn)) + 


                      3*as2*k*


                        pow(epsc1, 


                          2)*(2*ch*e0c*e0cn*epscmax1 + 


                            d*(-(e0cn*fy) + 


                                  e0c*(fy - e0cn*(epscmax1 + epsn)))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(d*e0c*(n0 + as1*e0c*(epscmax1 - epsn)) +


                                       as2*(2*ch*e0c*e0cn*epscmax1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscmax1 + epsn)))), 


                                    2) + 2*


                                  e0c*(as1*d*e0c + 


                                      as2*ch*


                                        e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epscmax1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1 + 


                                        4*(-1 + k)*epsn)) + 


                                      6*k*pow(epsc1, 2)*


                                        epscmax1*(-(as2*ch*e0c*e0cn*


                                        epscmax1) + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscmax1 + epsn))))))))/(6.*


                      e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2)), 2)) + 


      6*as2*(-2*ch + h)*(fy - 


            e0cn*(fy/e0c + epscmax1 - (ch*epscmax1)/d + 


                  epsn + (ch*(3*d*e0c*k*


                              pow(epsc1, 


                                2)*(n0 + as1*e0c*(epscmax1 - epsn)) + 


                            3*as2*k*


                              pow(epsc1, 


                                2)*(2*ch*e0c*e0cn*epscmax1 + 


                                  d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscmax1 + epsn)))) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(d*


                                        e0c*(n0 + as1*e0c*(epscmax1 - epsn)) +


                                         as2*(2*ch*e0c*e0cn*epscmax1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscmax1 + epsn)))), 


                                        2) + 


                                      2*e0c*(as1*d*e0c + 


                                        as2*ch*


                                        e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epscmax1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1 + 


                                        4*(-1 + k)*epsn)) + 


                                        6*k*pow(epsc1, 2)*


                                        epscmax1*(-(as2*ch*e0c*e0cn*


                                        epscmax1) + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscmax1 + 


                                        epsn)))))))))/(6.*d*


                        e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2)))))/12. + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mmax3;


}


 


//pomocna hodnota ohyboveho momentu


double normmat::compute_mh6a () 


{


	double mh6a;	


	


	if ((mmax3-mhr6) > 0.0 && (mhr6-mh3) > 0.0){





    mh6a=mhr6;


  }


  else{


   mh6a=mmax3;


  }


  return mh6a;


}


   


//pomocna hodnota pretvoreni betonu v tlaku


double normmat::compute_epsch6a () 


{


	double epsch6a;	


	


	if ((mmax3-mhr6) > 0.0 && (mhr6-mh3) > 0.0){





    epsch6a=epschr6;


  }


  else{


   epsch6a=epscmax1;


  }


  return epsch6a;


}


   


//hranicni ohybovy moment


double normmat::compute_mh7 ()  


{


	double mh7;	


	


	if (mh2-mhr2 == 0.0){





    mh7=mh5;


  }


  else{


   mh7=mh6;


  }


  return mh7;


}


 


//hranicni pretvoreni betonu v tlaku


double normmat::compute_epsch7 ()  


{


	double epsch7;	


	


	if (mh2-mhr2  == 0.0){





    epsch7=epsch5;


  }


  else{


   epsch7=epsch6;


  }


  return epsch7;


}


  


//pretvoreni betonu v tlaku na polovine danneho intervalu


double normmat::compute_epsch12 ()


{


	double epsch12;	


	


	epsch12 =epsch1 + (-epsch1 + epsch2)/2.;





	return epsch12;


}


  


//pretvoren vyztuze As1, po dosazeni pretvoren betonu v tlaku epsch1


double normmat::compute_epss1h1 ()


{


	double epss1h1;	


	


	epss1h1 =(6*as2*ch*e0c*k*pow(epsc1, 2)*epsch1 + 


      3*d*k*pow(epsc1, 


          2)*(n0 + as1*e0c*(epsch1 - epsn) - as2*e0c*(epsch1 + epsn)) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(-2*as2*ch*e0c*epsch1 + 


                      d*(-n0 - as1*e0c*epsch1 + 


                            as2*e0c*epsch1 + (as1 + as2)*e0c*epsn), 2) - 


                2*(as2*ch + as1*d)*


                  e0c*(b*pow(d, 2)*fc*


                        pow(epsch1 + epsn, 


                          2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epsch1 + 


                            4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 2)*


                        epsch1*(as2*ch*e0c*epsch1 + 


                            d*(n0 - 


                                  e0c*(as2*epsch1 + (as1 + as2)*


                                        epsn)))))))/(6.*(as2*ch + as1*d)*e0c*


      k*pow(epsc1, 2));





	return epss1h1;


}


  


//pretvoren vyztuze As1, po dosazeni pretvoren betonu v tlaku epsch2


double normmat::compute_epss1h2 ()


{


	double epss1h2;	


	


	epss1h2 =(6*as2*ch*e0c*k*pow(epsc1, 2)*epsch2 + 


      3*d*k*pow(epsc1, 


          2)*(n0 + as1*e0c*(epsch2 - epsn) - as2*e0c*(epsch2 + epsn)) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(-2*as2*ch*e0c*epsch2 + 


                      d*(-n0 - as1*e0c*epsch2 + 


                            as2*e0c*epsch2 + (as1 + as2)*e0c*epsn), 2) - 


                2*(as2*ch + as1*d)*


                  e0c*(b*pow(d, 2)*fc*


                        pow(epsch2 + epsn, 


                          2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epsch2 + 


                            4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 2)*


                        epsch2*(as2*ch*e0c*epsch2 + 


                            d*(n0 - 


                                  e0c*(as2*epsch2 + (as1 + as2)*


                                        epsn)))))))/(6.*(as2*ch + as1*d)*e0c*


      k*pow(epsc1, 2));





	return epss1h2;


}


   


//hodnota ohyboveho momentu pro pretvoreni na polovine danneho intervalu


double normmat::compute_mh01 ()


{


	double mh01;	


	


	if ((pow(d, 2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*pow(epsc1, 4) - 


      pow(b, 2)*pow(fc, 2)*


        pow(h, 4)*((6 - 9*k)*epsc1 + 2*(-1 + k)*epsch1 + 


            4*(-1 + k)*epsn)*((-2 + 3*k)*epsc1 + 2*(-1 + k)*epsch1 + 


            4*(-1 + k)*epsn) + 


      4*b*fc*pow(h, 2)*k*


        pow(epsc1, 


          2)*(3*(as2*ch + as1*d)*


              e0c*((-2 + 3*k)*epsc1 - 2*(-1 + k)*epsch1 - 4*(-1 + k)*epsn) + 


            8*h*(-1 + k)*(-n0 + (as1 + as2)*e0c*(epsch1/2. + epsn))))) >= 0.0){





    mh01=1/(384.*b*pow(d, 2)*fc*pow(h, 2)*(-1 + k)*k*


          pow(epsc1, 2))*((-6*b*d*fc*pow(h, 2)*epsc1 + 


            9*b*d*fc*pow(h, 2)*k*epsc1 + 6*as2*ch*d*e0c*k*pow(epsc1, 2) + 


            6*as1*pow(d, 2)*e0c*k*pow(epsc1, 2) + 6*b*d*fc*pow(h, 2)*epsch1 - 


            6*b*d*fc*pow(h, 2)*k*epsch1 + 12*b*d*fc*pow(h, 2)*epsn - 


            12*b*d*fc*pow(h, 2)*k*epsn - 


            sqrt(3.)*sqrt(pow(d, 


                    2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                        pow(epsc1, 4) - 


                      pow(b, 2)*pow(fc, 2)*


                        pow(h, 


                          4)*((6 - 9*k)*epsc1 + 2*(-1 + k)*epsch1 + 


                            4*(-1 + k)*epsn)*((-2 + 3*k)*epsc1 + 


                            2*(-1 + k)*epsch1 + 4*(-1 + k)*epsn) + 


                      4*b*fc*pow(h, 2)*k*


                        pow(epsc1, 


                          2)*(3*(as2*ch + as1*d)*


                              e0c*((-2 + 3*k)*epsc1 - 2*(-1 + k)*epsch1 - 


                                  4*(-1 + k)*epsn) + 


                            8*h*(-1 + 


                                  k)*(-n0 + (as1 + as2)*


                                    e0c*(epsch1/2. + epsn))))))*(-2*b*d*fc*


              pow(h, 2)*epsc1 + 3*b*d*fc*pow(h, 2)*k*epsc1 - 


            6*as2*ch*d*e0c*k*pow(epsc1, 2) - 


            6*as1*pow(d, 2)*e0c*k*pow(epsc1, 2) + 2*b*d*fc*pow(h, 2)*epsch1 - 


            2*b*d*fc*pow(h, 2)*k*epsch1 + 4*b*d*fc*pow(h, 2)*epsn - 


            4*b*d*fc*pow(h, 2)*k*epsn + 


            sqrt(3.)*sqrt(pow(d, 


                    2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                        pow(epsc1, 4) - 


                      pow(b, 2)*pow(fc, 2)*


                        pow(h, 


                          4)*((6 - 9*k)*epsc1 + 2*(-1 + k)*epsch1 + 


                            4*(-1 + k)*epsn)*((-2 + 3*k)*epsc1 + 


                            2*(-1 + k)*epsch1 + 4*(-1 + k)*epsn) + 


                      4*b*fc*pow(h, 2)*k*


                        pow(epsc1, 


                          2)*(3*(as2*ch + as1*d)*


                              e0c*((-2 + 3*k)*epsc1 - 2*(-1 + k)*epsch1 - 


                                  4*(-1 + k)*epsn) + 


                            8*h*(-1 + 


                                  k)*(-n0 + (as1 + as2)*


                                    e0c*(epsch1/2. + epsn))))))) + 


  0.5*as1*e0c*(-2*cd + h)*(epsn + 


        1/(8.*b*fc*pow(h, 3)*(-1 + k))*(6*d*(as2*ch + as1*d)*e0c*k*


                pow(epsc1, 2) + 


              b*fc*pow(h, 


                  2)*(4*h*(-1 + k)*epsch1 - 


                    3*d*((2 - 3*k)*epsc1 + 2*(-1 + k)*epsch1 + 


                          4*(-1 + k)*epsn)) - 


              sqrt(3.)*sqrt(pow(d, 


                      2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                          pow(epsc1, 4) - 


                        pow(b, 2)*pow(fc, 2)*


                          pow(h, 


                            4)*((6 - 9*k)*epsc1 + 2*(-1 + k)*epsch1 + 


                              4*(-1 + k)*epsn)*((-2 + 3*k)*epsc1 + 


                              2*(-1 + k)*epsch1 + 4*(-1 + k)*epsn) + 


                        4*b*fc*pow(h, 2)*k*


                          pow(epsc1, 


                            2)*(3*(as2*ch + as1*d)*


                                e0c*((-2 + 3*k)*epsc1 - 2*(-1 + k)*epsch1 - 


                                    4*(-1 + k)*epsn) + 


                              8*h*(-1 + 


                                    k)*(-n0 + (as1 + as2)*


                                      e0c*(epsch1/2. + epsn))))))) - 


  0.5*as2*e0c*(-2*ch + h)*(epsch1/2. - (ch*epsch1)/(2.*d) + epsn + 


        1/(8.*b*d*fc*


                pow(h, 3)*(-1 + k))*(ch*(6*d*(as2*ch + as1*d)*e0c*k*


                    pow(epsc1, 2) + 


                  b*fc*pow(h, 


                      2)*(4*h*(-1 + k)*epsch1 - 


                        3*d*((2 - 3*k)*epsc1 + 2*(-1 + k)*epsch1 + 


                              4*(-1 + k)*epsn)) - 


                  sqrt(3.)*


                    sqrt(pow(d, 


                          2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                              pow(epsc1, 4) - 


                            pow(b, 2)*pow(fc, 2)*


                              pow(h, 


                                4)*((6 - 9*k)*epsc1 + 2*(-1 + k)*epsch1 + 


                                  4*(-1 + k)*epsn)*((-2 + 3*k)*epsc1 + 


                                  2*(-1 + k)*epsch1 + 4*(-1 + k)*epsn) + 


                            4*b*fc*pow(h, 2)*k*


                              pow(epsc1, 


                                2)*(3*(as2*ch + as1*d)*


                                    e0c*((-2 + 3*k)*epsc1 - 


                                        2*(-1 + k)*epsch1 - 


                                        4*(-1 + k)*epsn) + 


                                  8*h*(-1 + 


                                        k)*(-n0 + (as1 + as2)*


                                        e0c*(epsch1/2. + epsn)))))))) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





  }


  else{


    mh01=1000000000.0;


  }


  return mh01;


}


     


//hodnota ohyboveho momentu pro pretvoreni na polovine danneho intervalu


double normmat::compute_mh12 ()


{


  double mh12;	


  


  if ((k*pow(epsc1, 


        2)*((3*k*pow(epsc1, 2)*


              pow(2*as2*ch*e0c*(epsch2 + epschr1) + 


                  d*(2*n0 + 


                        e0c*(as1*(epsch2 + epschr1 - 2*epsn) - 


                              as2*(epsch2 + epschr1 + 2*epsn))), 2))/


          4. - ((as2*ch + as1*d)*


              e0c*(b*pow(d, 2)*fc*


                    pow(epsch2 + epschr1 + 2*epsn, 


                      2)*((6 - 9*k)*epsc1 + 


                        2*(-1 + k)*(epsch2 + epschr1 + 2*epsn)) - 


                  6*k*pow(epsc1, 


                      2)*(epsch2 + 


                        epschr1)*(-(as2*ch*e0c*(epsch2 + epschr1)) + 


                        d*(-2*n0 + 


                              e0c*(2*as1*epsn + 


				   as2*(epsch2 + epschr1 + 2*epsn))))))/2.)) >= 0.0){


	


	mh12=1.0/(24.0*(as2*ch + as1*d)*k*pow(epsc1,2))*(0.0-(6*b*d*pow(as2*ch + as1*d,3)*pow(e0c, 2)*fc*pow(k, 2)*


		 pow(epsc1, 4)*pow(epschr1 + epsch2 + 2*epsn,2)*(6*d*(epschr1 + epsch2 + 


                          2*epsn)*((4 - 6*k)*


                            epsc1 + (-1 + k)*(epschr1 + epsch2 + 2*epsn)) + 


                    1/((as2*ch + as1*d)*e0c*k*


                            pow(epsc1, 2))*(h*(3*(-2 + 3*k)*epsc1 - 


                              2*(-1 + k)*(epschr1 + epsch2 + 2*epsn))*(3*d*k*


                                pow(epsc1, 


                                  2)*(-2*n0 + (as1 + as2)*


                                      e0c*(epschr1 + epsch2 + 2*epsn)) - 


                              2*sqrt(3.)*


                                sqrt(k*


                                    pow(epsc1, 


                                      2)*(0.75*k*pow(epsc1, 2)*


                                        pow(2*as2*ch*e0c*(epschr1 + epsch2) + 


                                        d*(2*n0 + e0c*(as1*(epschr1 + 


                                        epsch2 - 2*epsn) - 


                                        as2*(epschr1 + epsch2 + 2*epsn))), 


                                        2)


-0.5*(as2*ch + as1*d)*


                                        e0c*(b*pow(d, 2)*fc*


                                        pow(epschr1 + epsch2 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epschr1 + epsch2 + 


                                        2*epsn)) - 


                                        6*k*pow(epsc1, 


                                        2)*(epschr1 + 


                                        epsch2)*(-as2*ch*


                                        e0c*(epschr1 + epsch2) + 


                                        d*(-2*n0 + e0c*(2*as1*epsn + 


                                        as2*(epschr1 + epsch2 + 


                                        2*epsn)))))))))))/


          pow(3*d*k*


              pow(epsc1, 


                2)*(-2*n0 + (as1 + as2)*e0c*(epschr1 + epsch2 + 2*epsn)) - 


            2*sqrt(3.)*


              sqrt(k*pow(epsc1, 


                    2)*(0.75*k*pow(epsc1, 2)*


                        pow(2*as2*ch*e0c*(epschr1 + epsch2) + 


                            d*(2*n0 + 


                                  e0c*(as1*(epschr1 + epsch2 - 2*epsn) - 


                                        as2*(epschr1 + epsch2 + 2*epsn))), 


                          2) - 0.5*(as2*ch + as1*d)*


                        e0c*(b*pow(d, 2)*fc*


                              pow(epschr1 + epsch2 + 2*epsn, 


                                2)*((6 - 9*k)*epsc1 + 


                                  2*(-1 + k)*(epschr1 + epsch2 + 2*epsn)) - 


                            6*k*pow(epsc1, 


                                2)*(epschr1 + 


                                  epsch2)*(-as2*ch*e0c*(epschr1 + epsch2) + 


                                  d*(-2*n0 + 


                                        e0c*(2*as1*epsn + 


                                        as2*(epschr1 + epsch2 + 2*epsn))))))),


           2) - as1*(2*cd - 


            h)*(3*d*k*


              pow(epsc1, 


                2)*(2*n0 + (as1 - as2)*e0c*(epschr1 + epsch2 + 2*epsn)) + 


            2*(3*as2*ch*e0c*k*pow(epsc1, 2)*(epschr1 + epsch2 + 2*epsn) + 


                  sqrt(3.)*


                    sqrt(k*pow(epsc1, 


                          2)*(0.75*k*pow(epsc1, 2)*


                              pow(2*as2*ch*e0c*(epschr1 + epsch2) + 


                                  d*(2*n0 + 


                                        e0c*(as1*(epschr1 + epsch2 - 2*epsn) -


                                         as2*(epschr1 + epsch2 + 2*epsn))), 


                                2) - 0.5*(as2*ch + as1*d)*


                              e0c*(b*pow(d, 2)*fc*


                                    pow(epschr1 + epsch2 + 2*epsn, 


                                      2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epschr1 + epsch2 + 


                                        2*epsn)) - 


                                  6*k*


                                    pow(epsc1, 


                                      2)*(epschr1 + 


                                        epsch2)*(-as2*ch*


                                        e0c*(epschr1 + epsch2) + 


                                        d*(-2*n0 + 


                                        e0c*(2*as1*epsn + 


                                        as2*(epschr1 + epsch2 + 


                                        2*epsn))))))))) + 


      1/d*(as2*(2*ch - 


                h)*(6*as1*pow(d, 2)*e0c*k*


                  pow(epsc1, 2)*(epschr1 + epsch2 + 2*epsn) + 


                ch*(3*d*k*


                        pow(epsc1, 


                          2)*(2*n0 - (as1 - as2)*


                              e0c*(epschr1 + epsch2 + 2*epsn)) + 


                      2*sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(0.75*k*pow(epsc1, 2)*


                                  pow(2*as2*ch*e0c*(epschr1 + epsch2) + 


                                      d*(2*n0 + 


                                        e0c*(as1*(epschr1 + epsch2 - 2*epsn) -


                                         as2*(epschr1 + epsch2 + 2*epsn))), 


                                    2) - 0.5*(as2*ch + as1*d)*


                                  e0c*(b*pow(d, 2)*fc*


                                        pow(epschr1 + epsch2 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epschr1 + epsch2 + 


                                        2*epsn)) - 


                                      6*k*pow(epsc1, 


                                        2)*(epschr1 + 


                                        epsch2)*(-as2*ch*


                                        e0c*(epschr1 + epsch2) + 


                                        d*(-2*n0 + 


                                        e0c*(2*as1*epsn + 


                                        as2*(epschr1 + epsch2 + 


                                        2*epsn))))))))))) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





      }


  else{


    mh12=1000000000.0;


  }





  return mh12;


}


 


//hodnota ohyboveho momentu pro pretvoreni na polovine danneho intervalu


double normmat::compute_mh25 ()


{


	double mh25;	


	


	if ((k*pow(epsc1, 


    2)*(3*k*pow(epsc1, 2)*


        pow(as2*ch*pow(e0c, 2)*(epsch2 + epsch5) - 


            d*(-(as1*e0cn*


                        fy) + (e0c*(-2*n0 + 


                            as1*(2*fy - e0cn*(epsch2 + epsch5 - 2*epsn)) + 


                            as2*e0c*(epsch2 + epsch5 + 2*epsn)))/2.), 2) - 


      2*e0c*(as2*ch*e0c + 


            as1*d*e0cn)*((b*pow(d, 2)*e0c*fc*


                  pow(epsch2 + epsch5 + 2*epsn, 


                    2)*((6 - 9*k)*epsc1 + 


                      2*(-1 + k)*(epsch2 + epsch5 + 2*epsn)))/4. + 


            3*k*pow(epsc1, 


                2)*(epsch2 + 


                  epsch5)*(as1*


                    d*(e0cn*fy - 


                        e0c*(fy + e0cn*epsn)) + (e0c*(as2*ch*


                              e0c*(epsch2 + epsch5) + 


                            d*(2*n0 - as2*e0c*(epsch2 + epsch5 + 2*epsn))))/


                    2.)))) >= 0.0){





    mh25=(-((6*b*d*pow(e0c, 2)*pow(as2*ch*e0c + as1*d*e0cn, 3)*fc*pow(k, 2)*


                  pow(epsc1, 4)*


                  pow(epsch2 + epsch5 + 2*epsn, 


                    2)*(6*d*(epsch2 + epsch5 + 


                            2*epsn)*((4 - 6*k)*


                              epsc1 + (-1 + k)*(epsch2 + epsch5 + 


                                  2*epsn)) + (h*(3*(-2 + 3*k)*epsc1 - 


                                2*(-1 + k)*(epsch2 + epsch5 + 2*epsn))*(3*d*


                                  e0c*k*


                                  pow(epsc1, 


                                    2)*(-2*n0 + 


                                      as2*e0c*(epsch2 + epsch5 + 2*epsn)) + 


                                3*as1*d*k*


                                  pow(epsc1, 


                                    2)*(-2*e0cn*fy + 


                                      e0c*(2*fy + 


                                        e0cn*(epsch2 + epsch5 + 2*epsn))) - 


                                2*sqrt(3.)*


                                  sqrt(k*


                                      pow(epsc1, 


                                        2)*(3*k*pow(epsc1, 2)*


                                        pow(as2*ch*


                                        pow(e0c, 2)*(epsch2 + epsch5) - 


                                        d*(-as1*e0cn*fy + 


                                        0.5*e0c*(-2*n0 + as1*(2*fy - 


                                        e0cn*(epsch2 + epsch5 - 2*epsn)) + 


                                        as2*e0c*(epsch2 + epsch5 + 2*epsn))), 


                                        2) - 


                                        2*e0c*(as2*ch*e0c + 


                                        as1*d*e0cn)*(0.25*b*pow(d, 2)*e0c*fc*


                                        pow(epsch2 + epsch5 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch2 + epsch5 + 


                                        2*epsn)) + 


                                        3*k*pow(epsc1, 


                                        2)*(epsch2 + epsch5)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        0.5*e0c*(as2*ch*e0c*(epsch2 + 


                                        epsch5) + d*(2*n0 - as2*e0c*(epsch2 + 


                                        epsch5 + 2*epsn)))))))))/(e0c*(as2*ch*


                                  e0c + as1*d*e0cn)*k*pow(epsc1, 2))))/


              pow(3*d*e0c*k*


                  pow(epsc1, 


                    2)*(-2*n0 + as2*e0c*(epsch2 + epsch5 + 2*epsn)) + 


                3*as1*d*k*


                  pow(epsc1, 


                    2)*(-2*e0cn*fy + 


                      e0c*(2*fy + e0cn*(epsch2 + epsch5 + 2*epsn))) - 


                2*sqrt(3.)*


                  sqrt(k*pow(epsc1, 


                        2)*(3*k*pow(epsc1, 2)*


                            pow(as2*ch*pow(e0c, 2)*(epsch2 + epsch5) - 


                                d*(-as1*e0cn*fy + 


                                      0.5*e0c*(-2*n0 + 


                                        as1*(2*fy - 


                                        e0cn*(epsch2 + epsch5 - 2*epsn)) + 


                                        as2*e0c*(epsch2 + epsch5 + 2*epsn))), 


                              2) - 2*


                            e0c*(as2*ch*e0c + 


                                as1*d*e0cn)*(0.25*b*pow(d, 2)*e0c*fc*


                                  pow(epsch2 + epsch5 + 2*epsn, 


                                    2)*((6 - 9*k)*epsc1 + 


                                      2*(-1 + k)*(epsch2 + epsch5 + 


                                        2*epsn)) + 


                                3*k*pow(epsc1, 


                                    2)*(epsch2 + 


                                      epsch5)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                      0.5*e0c*(as2*ch*e0c*(epsch2 + epsch5) + 


                                        d*(2*n0 - 


                                        as2*e0c*(epsch2 + epsch5 + 


                                        2*epsn))))))), 2)) + 


      1/d*(as2*(2*ch - 


                h)*(-3*as1*d*k*


                  pow(epsc1, 


                    2)*(-2*d*e0c*e0cn*(epsch2 + epsch5 + 2*epsn) + 


                      ch*(-2*e0cn*fy + 


                            e0c*(2*fy + e0cn*(epsch2 + epsch5 + 2*epsn)))) + 


                ch*(3*d*e0c*k*


                        pow(epsc1, 


                          2)*(2*n0 + as2*e0c*(epsch2 + epsch5 + 2*epsn)) + 


                      2*sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                pow(as2*ch*pow(e0c, 2)*(epsch2 + epsch5) - 


                                      d*(-as1*e0cn*fy + 


                                        0.5*e0c*(-2*n0 + 


                                        as1*(2*fy - e0cn*(epsch2 + epsch5 - 


                                        2*epsn)) + 


                                        as2*e0c*(epsch2 + epsch5 + 2*epsn))), 


                                    2)


-2*e0c*(as2*ch*e0c + 


                                    as1*d*e0cn)*(0.25*b*pow(d, 2)*e0c*fc*


                                      pow(epsch2 + epsch5 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch2 + epsch5 + 


                                        2*epsn)) + 


                                    3*k*pow(epsc1, 


                                        2)*(epsch2 + 


                                        epsch5)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        0.5*e0c*(as2*ch*


                                        e0c*(epsch2 + epsch5) + 


                                        d*(2*n0 - as2*e0c*(epsch2 + epsch5 + 


                                        2*epsn)))))))))) - 


      1/e0c*(as1*(2*cd - 


                h)*(3*as2*e0c*k*


                  pow(epsc1, 


                    2)*(-d*e0c*e0cn*(epsch2 + epsch5 + 2*epsn) + 


                      2*ch*(-2*e0cn*fy + 


                            e0c*(2*fy + e0cn*(epsch2 + epsch5 + 2*epsn)))) + 


                e0cn*(6*d*e0c*k*n0*pow(epsc1, 2) + 


                      3*as1*d*k*


                        pow(epsc1, 


                          2)*(-2*e0cn*fy + 


                            e0c*(2*fy + e0cn*(epsch2 + epsch5 + 2*epsn))) + 


                      2*sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                pow(as2*ch*pow(e0c, 2)*(epsch2 + epsch5) - 


                                      d*(-as1*e0cn*fy + 


                                        0.5*e0c*(-2*n0 + 


                                        as1*(2*fy - e0cn*(epsch2 + epsch5 - 


                                        2*epsn)) + 


                                        as2*e0c*(epsch2 + epsch5 + 2*epsn))), 


                                    2)


-2*e0c*(as2*ch*e0c + 


                                    as1*d*e0cn)*(0.25*b*pow(d, 2)*e0c*fc*


                                      pow(epsch2 + epsch5 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch2 + epsch5 + 


                                        2*epsn)) + 


                                    3*k*pow(epsc1, 


                                        2)*(epsch2 + 


                                        epsch5)*(as1*


                                        d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                        0.5*e0c*(as2*ch*


                                        e0c*(epsch2 + epsch5) + 


                                        d*(2*n0 - as2*e0c*(epsch2 + epsch5 + 


                                        2*epsn)))))))))))/(24.*(as2*ch*e0c + 


          as1*d*e0cn)*k*pow(epsc1, 2)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





  }


  else{


    mh25=1000000000.0;


  }


  return mh25;


}


  


//hodnota ohyboveho momentu pro pretvoreni na polovine danneho intervalu


double normmat::compute_mh36a ()


{


	double mh36a;	


	


	if (((k*pow(epsc1, 


      2)*(3*k*pow(epsc1, 2)*


          pow((d*e0c*(2*n0 + as1*e0c*(epsch3 + epsch6a - 2*epsn)))/2. + 


              as2*(ch*e0c*


                      e0cn*(epsch3 + 


                          epsch6a) + (d*(-2*e0cn*fy + 


                              e0c*(2*fy - e0cn*(epsch3 + epsch6a + 2*epsn))))/


                      2.), 2) + 


        2*e0c*(as1*d*e0c + 


              as2*ch*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                      pow(epsch3 + epsch6a + 2*epsn, 


                        2)*((6 - 9*k)*epsc1 + 


                          2*(-1 + k)*(epsch3 + epsch6a + 2*epsn)))/


                4. + (3*k*


                    pow(epsc1, 


                      2)*(epsch3 + epsch6a)*(2*d*e0c*(-n0 + as1*e0c*epsn) + 


                        as2*(-(ch*e0c*e0cn*(epsch3 + epsch6a)) + 


                              d*(2*e0cn*fy + 


                                    e0c*(-2*fy + 


                                        e0cn*(epsch3 + epsch6a + 2*epsn))))))/


			    2.))) >= 0.0)){





    mh36a=(-as1*(2*cd - 


            h)*(3*d*e0c*k*


              pow(epsc1, 2)*(2*n0 + as1*e0c*(epsch3 + epsch6a + 2*epsn)) + 


            3*as2*k*pow(epsc1, 


                2)*(2*ch*e0c*e0cn*(epsch3 + epsch6a + 2*epsn) + 


                  d*(-2*e0cn*fy + 


                        e0c*(2*fy - e0cn*(epsch3 + epsch6a + 2*epsn)))) + 


            2*sqrt(3.)*


              sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow(0.5*d*


                              e0c*(2*n0 + 


                                  as1*e0c*(epsch3 + epsch6a - 2*epsn)) + 


                            as2*(ch*e0c*e0cn*(epsch3 + epsch6a) + 


                                  0.5*d*(-2*e0cn*fy + 


                                        e0c*(2*fy - 


                                        e0cn*(epsch3 + epsch6a + 2*epsn)))), 


                          2) + 2*


                        e0c*(as1*d*e0c + 


                            as2*ch*e0cn)*(-0.25*b*pow(d, 2)*e0c*fc*


                              pow(epsch3 + epsch6a + 2*epsn, 


                                2)*((6 - 9*k)*epsc1 + 


                                  2*(-1 + k)*(epsch3 + epsch6a + 2*epsn)) + 


                            1.5*k*pow(epsc1, 


                                2)*(epsch3 + 


                                  epsch6a)*(2*d*e0c*(-n0 + as1*e0c*epsn) + 


                                  as2*(-ch*e0c*e0cn*(epsch3 + epsch6a) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + 


                                        e0cn*(epsch3 + epsch6a + 


                                        2*epsn))))))))) - (6*b*d*pow(e0c, 2)*


              pow(as1*d*e0c + as2*ch*e0cn, 3)*fc*pow(k, 2)*pow(epsc1, 4)*


              pow(epsch3 + epsch6a + 2*epsn, 


                2)*(6*d*(epsch3 + epsch6a + 


                        2*epsn)*((4 - 6*k)*


                          epsc1 + (-1 + k)*(epsch3 + epsch6a + 


                              2*epsn)) + (h*(3*(-2 + 3*k)*epsc1 - 


                            2*(-1 + k)*(epsch3 + epsch6a + 2*epsn))*(3*d*e0c*


                              k*pow(epsc1, 


                                2)*(-2*n0 + 


                                  as1*e0c*(epsch3 + epsch6a + 2*epsn)) + 


                            3*as2*d*k*


                              pow(epsc1, 


                                2)*(2*e0cn*fy + 


                                  e0c*(-2*fy + 


                                        e0cn*(epsch3 + epsch6a + 2*epsn))) - 


                            2*sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(0.5*d*


                                        e0c*(2*n0 + 


                                        as1*e0c*(epsch3 + epsch6a - 2*epsn)) +


                                         as2*(ch*e0c*


                                        e0cn*(epsch3 + epsch6a) + 


                                        0.5*d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch3 + epsch6a + 


                                        2*epsn)))), 2) + 


                                      2*e0c*(as1*d*e0c + 


                                        as2*ch*e0cn)*(-0.25*b*pow(d, 2)*e0c*


                                        fc*pow(epsch3 + epsch6a + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch3 + epsch6a + 


                                        2*epsn)) + 


                                        1.5*k*


                                        pow(epsc1, 


                                        2)*(epsch3 + 


                                        epsch6a)*(2*d*


                                        e0c*(-n0 + as1*e0c*epsn) + 


                                        as2*(-ch*e0c*e0cn*(epsch3 + epsch6a) +


                                         d*(2*e0cn*fy + e0c*(-2*fy + 


                                        e0cn*(epsch3 + epsch6a + 


                                        2*epsn))))))))))/(e0c*(as1*d*e0c + 


                            as2*ch*e0cn)*k*pow(epsc1, 2))))/


          pow(3*d*e0c*k*


              pow(epsc1, 2)*(-2*n0 + as1*e0c*(epsch3 + epsch6a + 2*epsn)) + 


            3*as2*d*k*


              pow(epsc1, 


                2)*(2*e0cn*fy + 


                  e0c*(-2*fy + e0cn*(epsch3 + epsch6a + 2*epsn))) - 


            2*sqrt(3.)*


              sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow(0.5*d*


                              e0c*(2*n0 + 


                                  as1*e0c*(epsch3 + epsch6a - 2*epsn)) + 


                            as2*(ch*e0c*e0cn*(epsch3 + epsch6a) + 


                                  0.5*d*(-2*e0cn*fy + 


                                        e0c*(2*fy - 


                                        e0cn*(epsch3 + epsch6a + 2*epsn)))), 


                          2) + 2*


                        e0c*(as1*d*e0c + 


                            as2*ch*e0cn)*(-0.25*b*pow(d, 2)*e0c*fc*


                              pow(epsch3 + epsch6a + 2*epsn, 


                                2)*((6 - 9*k)*epsc1 + 


                                  2*(-1 + k)*(epsch3 + epsch6a + 2*epsn)) + 


                            1.5*k*pow(epsc1, 


                                2)*(epsch3 + 


                                  epsch6a)*(2*d*e0c*(-n0 + as1*e0c*epsn) + 


                                  as2*(-ch*e0c*e0cn*(epsch3 + epsch6a) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + 


                                        e0cn*(epsch3 + epsch6a + 


                                        2*epsn)))))))), 2) + 


      1/(d*e0c)*(as2*(2*ch - 


                h)*(-3*as1*d*e0c*k*


                  pow(epsc1, 


                    2)*(ch*e0c*e0cn*(epsch3 + epsch6a + 2*epsn) - 


                      2*d*(2*e0cn*fy + 


                            e0c*(-2*fy + e0cn*(epsch3 + epsch6a + 2*epsn)))) +


                 ch*e0cn*(6*d*e0c*k*n0*pow(epsc1, 2) + 


                      3*as2*d*k*


                        pow(epsc1, 


                          2)*(2*e0cn*fy + 


                            e0c*(-2*fy + e0cn*(epsch3 + epsch6a + 2*epsn))) + 


                      2*sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(0.5*d*


                                        e0c*(2*n0 + 


                                        as1*e0c*(epsch3 + epsch6a - 2*epsn)) +


                                       as2*(ch*e0c*e0cn*(epsch3 + epsch6a) + 


                                        0.5*d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch3 + epsch6a + 


                                        2*epsn)))), 2) + 


                                2*e0c*(as1*d*e0c + 


                                      as2*ch*e0cn)*(-0.25*b*pow(d, 2)*e0c*fc*


                                        pow(epsch3 + epsch6a + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch3 + epsch6a + 


                                        2*epsn)) + 


                                      1.5*k*


                                        pow(epsc1, 


                                        2)*(epsch3 + 


                                        epsch6a)*(2*d*


                                        e0c*(-n0 + as1*e0c*epsn) + 


                                        as2*(-ch*e0c*e0cn*(epsch3 + epsch6a) +


                                         d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch3 + epsch6a + 


                                        2*epsn))))))))))))/(24.*(as1*d*e0c + 


          as2*ch*e0cn)*k*pow(epsc1, 2)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





  }


  else{


    mh36a=1000000000.0;


  }


  return mh36a;


}


  


//pomocne pretvoreni betonu


double normmat::compute_epscder1 ()


{


	double epscder1;	


	


	epscder1 =(mh3*epsch3 - 4*mh36a*epsch3 + 3*mh6a*epsch3 + 3*mh3*epsch6a - 


      4*mh36a*epsch6a + mh6a*epsch6a)/(4.*(mh3 - 2*mh36a + mh6a));





	return epscder1;


}



 

//maximalni ohybovy moment, tece As2 a jeste nedoslo k teceni vyztuze As1 a k dosazeni mezniho pretvoreni betonu, x < h


double normmat::compute_mmax4 ()


{


	double mmax4;	


	


	mmax4 =(6*as1*e0c*(-2*cd + 


            h)*(epsn + (3*d*e0c*k*


                    pow(epsc1, 2)*(n0 + as1*e0c*(epscder1 - epsn)) + 


                  3*as2*k*


                    pow(epsc1, 


                      2)*(2*ch*e0c*e0cn*epscder1 + 


                        d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscder1 + epsn)))) + 


                  sqrt(3.)*


                    sqrt(k*pow(epsc1, 


                          2)*(3*k*pow(epsc1, 2)*


                              pow(d*e0c*(n0 + as1*e0c*(epscder1 - epsn)) + 


                                  as2*(2*ch*e0c*e0cn*epscder1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscder1 + epsn)))), 


                                2) + 2*


                              e0c*(as1*d*e0c + 


                                  as2*ch*


                                    e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epscder1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscder1 + 


                                        4*(-1 + k)*epsn)) + 


                                  6*k*pow(epsc1, 2)*


                                    epscder1*(-(as2*ch*e0c*e0cn*epscder1) + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscder1 + epsn))))))))/(6.*


                  e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2))) - (b*d*fc*


            pow(epscder1 + epsn, 


              2)*(2*d*(epscder1 + 


                      epsn)*((2 - 3*k)*epsc1 + (-1 + k)*epscder1 + (-1 + k)*


                        epsn) - 


                h*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscder1 + 


                      4*(-1 + k)*


                        epsn)*(epscder1 - (3*d*e0c*k*


                              pow(epsc1, 


                                2)*(n0 + as1*e0c*(epscder1 - epsn)) + 


                            3*as2*k*


                              pow(epsc1, 


                                2)*(2*ch*e0c*e0cn*epscder1 + 


                                  d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscder1 + epsn)))) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(d*


                                        e0c*(n0 + as1*e0c*(epscder1 - epsn)) +


                                         as2*(2*ch*e0c*e0cn*epscder1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscder1 + epsn)))), 


                                        2) + 


                                      2*e0c*(as1*d*e0c + 


                                        as2*ch*


                                        e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epscder1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscder1 + 


                                        4*(-1 + k)*epsn)) + 


                                        6*k*pow(epsc1, 2)*


                                        epscder1*(-(as2*ch*e0c*e0cn*


                                        epscder1) + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscder1 + epsn))))))))/(6.*


                            e0c*(as1*d*e0c + as2*ch*e0cn)*k*


                            pow(epsc1, 2)))))/(k*pow(epsc1, 2)*


            pow(epscder1 - (3*d*e0c*k*


                        pow(epsc1, 2)*(n0 + as1*e0c*(epscder1 - epsn)) + 


                      3*as2*k*


                        pow(epsc1, 


                          2)*(2*ch*e0c*e0cn*epscder1 + 


                            d*(-(e0cn*fy) + 


                                  e0c*(fy - e0cn*(epscder1 + epsn)))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(d*e0c*(n0 + as1*e0c*(epscder1 - epsn)) +


                                       as2*(2*ch*e0c*e0cn*epscder1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscder1 + epsn)))), 


                                    2) + 2*


                                  e0c*(as1*d*e0c + 


                                      as2*ch*


                                        e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epscder1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscder1 + 


                                        4*(-1 + k)*epsn)) + 


                                      6*k*pow(epsc1, 2)*


                                        epscder1*(-(as2*ch*e0c*e0cn*


                                        epscder1) + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscder1 + epsn))))))))/(6.*


                      e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2)), 2)) + 


      6*as2*(-2*ch + h)*(fy - 


            e0cn*(fy/e0c + epscder1 - (ch*epscder1)/d + 


                  epsn + (ch*(3*d*e0c*k*


                              pow(epsc1, 


                                2)*(n0 + as1*e0c*(epscder1 - epsn)) + 


                            3*as2*k*


                              pow(epsc1, 


                                2)*(2*ch*e0c*e0cn*epscder1 + 


                                  d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscder1 + epsn)))) + 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(d*


                                        e0c*(n0 + as1*e0c*(epscder1 - epsn)) +


                                         as2*(2*ch*e0c*e0cn*epscder1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscder1 + epsn)))), 


                                        2) + 


                                      2*e0c*(as1*d*e0c + 


                                        as2*ch*


                                        e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epscder1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscder1 + 


                                        4*(-1 + k)*epsn)) + 


                                        6*k*pow(epsc1, 2)*


                                        epscder1*(-(as2*ch*e0c*e0cn*


                                        epscder1) + 


                                        d*(as2*e0cn*fy + 


                                        as1*pow(e0c, 2)*epsn + 


                                        e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscder1 + 


                                        epsn)))))))))/(6.*d*


                        e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2)))))/12. + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mmax4;


}


   

//hranicni ohybovy moment

double normmat::compute_mh6 () 


{


	double mh6;	


	


	if ((epscder1-epsch3) < 0.0 && (epscder1-epsch6a) > 0.0){





    mh6 = mmax4;


  }


  else{


   mh6=mh6a;


  }


  return mh6;


}
 

//hranicni pretvoreni betonu v tlaku


double normmat::compute_epsch6 () 


{


	double epsch6;	


	


	if ((epscder1-epsch3) < 0.0 && (epscder1-epsch6a) > 0.0){





    epsch6=epscder1;


  }


  else{


   epsch6=epsch6a;


  }


  return epsch6;


}


   


//hodnota ohyboveho momentu pro pretvoreni na polovine danneho intervalu


double normmat::compute_mh36 ()


{


	double mh36;	


	


	mh36 =(-(as1*(2*cd - h)*(3*d*e0c*k*


                  pow(epsc1, 2)*(2*n0 + as1*e0c*(epsch3 + epsch6 + 2*epsn)) + 


                3*as2*k*


                  pow(epsc1, 


                    2)*(2*ch*e0c*e0cn*(epsch3 + epsch6 + 2*epsn) + 


                      d*(-2*e0cn*fy + 


                            e0c*(2*fy - e0cn*(epsch3 + epsch6 + 2*epsn)))) + 


                2*sqrt(3.)*


                  sqrt(k*pow(epsc1, 


                        2)*(3*k*pow(epsc1, 2)*


                            pow((d*e0c*(2*n0 + 


                                        as1*e0c*(epsch3 + epsch6 - 2*epsn)))/


                                  2. + as2*(ch*e0c*


                                        e0cn*(epsch3 + 


                                        epsch6) + (d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch3 + epsch6 + 


                                        2*epsn))))/2.), 2) + 


                          2*e0c*(as1*d*e0c + 


                                as2*ch*


                                  e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epsch3 + epsch6 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch3 + epsch6 + 


                                        2*epsn)))/


                                  4. + (3*k*


                                      pow(epsc1, 


                                        2)*(epsch3 + 


                                        epsch6)*(2*d*


                                        e0c*(-n0 + as1*e0c*epsn) + 


                                        as2*(-(ch*e0c*


                                        e0cn*(epsch3 + epsch6)) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch3 + epsch6 + 


                                        2*epsn))))))/2.))))) - (6*b*d*


              pow(e0c, 2)*pow(as1*d*e0c + as2*ch*e0cn, 3)*fc*pow(k, 2)*


              pow(epsc1, 4)*


              pow(epsch3 + epsch6 + 2*epsn, 


                2)*(6*d*(epsch3 + epsch6 + 


                        2*epsn)*((4 - 6*k)*


                          epsc1 + (-1 + k)*(epsch3 + epsch6 + 


                              2*epsn)) + (h*(3*(-2 + 3*k)*epsc1 - 


                            2*(-1 + k)*(epsch3 + epsch6 + 2*epsn))*(3*d*e0c*k*


                              pow(epsc1, 


                                2)*(-2*n0 + 


                                  as1*e0c*(epsch3 + epsch6 + 2*epsn)) + 


                            3*as2*d*k*


                              pow(epsc1, 


                                2)*(2*e0cn*fy + 


                                  e0c*(-2*fy + 


                                        e0cn*(epsch3 + epsch6 + 2*epsn))) - 


                            2*sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow((d*e0c*(2*n0 + 


                                        as1*e0c*(epsch3 + epsch6 - 2*epsn)))/


                                        2. + 


                                        as2*(ch*e0c*


                                        e0cn*(epsch3 + epsch6) + (d*(-2*e0cn*


                                        fy + e0c*(2*fy - e0cn*(epsch3 + 


                                        epsch6 + 2*epsn))))/2.), 2) + 


                                      2*e0c*(as1*d*e0c + 


                                        as2*ch*


                                        e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epsch3 + epsch6 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch3 + epsch6 + 


                                        2*epsn)))/


                                        4. + (3*k*


                                        pow(epsc1, 2)*(epsch3 + 


                                        epsch6)*(2*d*e0c*(-n0 + 


                                        as1*e0c*epsn) + 


                                        as2*(-(ch*e0c*e0cn*(epsch3 + 


                                        epsch6)) + d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch3 + epsch6 + 


                                        2*epsn))))))/2.)))))/(e0c*(as1*d*e0c +


                             as2*ch*e0cn)*k*pow(epsc1, 2))))/


          pow(3*d*e0c*k*


              pow(epsc1, 2)*(-2*n0 + as1*e0c*(epsch3 + epsch6 + 2*epsn)) + 


            3*as2*d*k*


              pow(epsc1, 


                2)*(2*e0cn*fy + 


                  e0c*(-2*fy + e0cn*(epsch3 + epsch6 + 2*epsn))) - 


            2*sqrt(3.)*


              sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow((d*e0c*(2*n0 + 


                                      as1*e0c*(epsch3 + epsch6 - 2*epsn)))/


                              2. + as2*(ch*e0c*


                                    e0cn*(epsch3 + 


                                        epsch6) + (d*(-2*e0cn*fy + 


                                        e0c*(2*fy - 


                                        e0cn*(epsch3 + epsch6 + 2*epsn))))/


                                    2.), 2) + 


                      2*e0c*(as1*d*e0c + 


                            as2*ch*


                              e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                    pow(epsch3 + epsch6 + 2*epsn, 


                                      2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch3 + epsch6 + 


                                        2*epsn)))/


                              4. + (3*k*


                                  pow(epsc1, 


                                    2)*(epsch3 + 


                                      epsch6)*(2*d*e0c*(-n0 + as1*e0c*epsn) + 


                                      as2*(-(ch*e0c*e0cn*(epsch3 + epsch6)) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch3 + epsch6 + 


                                        2*epsn))))))/2.))), 


          2) + (as2*(2*ch - 


                h)*(-3*as1*d*e0c*k*


                  pow(epsc1, 


                    2)*(ch*e0c*e0cn*(epsch3 + epsch6 + 2*epsn) - 


                      2*d*(2*e0cn*fy + 


                            e0c*(-2*fy + e0cn*(epsch3 + epsch6 + 2*epsn)))) + 


                ch*e0cn*(6*d*e0c*k*n0*pow(epsc1, 2) + 


                      3*as2*d*k*


                        pow(epsc1, 


                          2)*(2*e0cn*fy + 


                            e0c*(-2*fy + e0cn*(epsch3 + epsch6 + 2*epsn))) + 


                      2*sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow((d*e0c*(2*n0 + 


                                        as1*e0c*(epsch3 + epsch6 - 2*epsn)))/


                                        2. + 


                                      as2*(ch*e0c*


                                        e0cn*(epsch3 + 


                                        epsch6) + (d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch3 + epsch6 + 


                                        2*epsn))))/2.), 2) + 


                                2*e0c*(as1*d*e0c + 


                                      as2*ch*


                                        e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                        pow(epsch3 + epsch6 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch3 + epsch6 + 


                                        2*epsn)))/


                                        4. + (3*k*


                                        pow(epsc1, 


                                        2)*(epsch3 + 


                                        epsch6)*(2*d*


                                        e0c*(-n0 + as1*e0c*epsn) + 


                                        as2*(-(ch*e0c*e0cn*(epsch3 + 


                                        epsch6)) + d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch3 + epsch6 + 


                                        2*epsn))))))/2.))))))/(d*


            e0c))/(24.*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mh36;


}


   


//hodnota ohyboveho momentu pro pretvoreni na polovine danneho intervalu


double normmat::compute_mh7maxa ()


{


	double mh7maxa;	


	


	mh7maxa =-(as1*(2*cd - h)*(3*d*e0c*k*n0*pow(epsc1, 2) + 


              3*as1*d*k*


                pow(epsc1, 


                  2)*(-(e0cn*


                          fy) + (e0c*(2*fy + 


                              e0cn*(epsch7 + epscmax1 + 2*epsn)))/2.) + 


              3*as2*k*pow(epsc1, 


                  2)*(-(d*(2*e0cn*fy + 


                                e0c*(-2*fy + 


                                      e0cn*(epsch7 + epscmax1 + 2*epsn))))/


                      2. + ch*(-2*e0cn*fy + 


                          e0c*(2*fy + e0cn*(epsch7 + epscmax1 + 2*epsn)))) + 


              sqrt(3.)*sqrt(k*


                    pow(epsc1, 


                      2)*((3*k*pow(epsc1, 2)*


                              pow(-2*d*e0c*n0 + 


                                  as1*d*(-2*e0cn*fy + 


                                        e0c*(2*fy - 


                                        e0cn*(epsch7 + epscmax1 - 2*epsn))) + 


                                  as2*(-2*ch*e0c*e0cn*(epsch7 + epscmax1) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + 


                                        e0cn*(epsch7 + epscmax1 + 2*epsn)))), 


                                2))/4. - ((as2*ch + as1*d)*e0c*


                              e0cn*(b*pow(d, 2)*e0c*fc*


                                    pow(epsch7 + epscmax1 + 2*epsn, 


                                      2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch7 + epscmax1 + 


                                        2*epsn)) - 


                                  6*k*pow(epsc1, 


                                      2)*(epsch7 + epscmax1)*(-2*d*e0c*n0 + 


                                        2*as1*


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*epsn)) + 


                                        as2*(-(ch*e0c*


                                        e0cn*(epsch7 + epscmax1)) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch7 + 


                                        epscmax1 + 2*epsn)))))))/


                          2.))) - (as2*(2*ch - 


                  h)*(-3*as1*d*k*


                    pow(epsc1, 


                      2)*(-2*d*(2*e0cn*fy + 


                              e0c*(-2*fy + 


                                    e0cn*(epsch7 + epscmax1 + 2*epsn))) + 


                        ch*(-2*e0cn*fy + 


                              e0c*(2*fy + 


                                    e0cn*(epsch7 + epscmax1 + 2*epsn)))) + 


                  ch*(6*d*e0c*k*n0*pow(epsc1, 2) + 


                        3*as2*d*k*


                          pow(epsc1, 


                            2)*(2*e0cn*fy + 


                              e0c*(-2*fy + 


                                    e0cn*(epsch7 + epscmax1 + 2*epsn))) + 


                        2*sqrt(3.)*


                          sqrt(k*


                              pow(epsc1, 


                                2)*((3*k*pow(epsc1, 2)*


                                        pow(-2*d*e0c*n0 + 


                                        as1*d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch7 + epscmax1 - 


                                        2*epsn))) + 


                                        as2*(-2*ch*e0c*


                                        e0cn*(epsch7 + epscmax1) + 


                                        d*(2*e0cn*fy + e0c*(-2*fy + 


                                        e0cn*(epsch7 + epscmax1 + 2*epsn)))), 


                                        2))/4. - ((as2*ch + as1*d)*e0c*


                                        e0cn*(b*pow(d, 2)*e0c*fc*


                                        pow(epsch7 + epscmax1 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch7 + epscmax1 + 


                                        2*epsn)) - 


                                        6*k*pow(epsc1, 


                                        2)*(epsch7 + epscmax1)*(-2*d*e0c*n0 + 


                                        2*as1*d*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*epsn)) + 


                                        as2*(-(ch*e0c*e0cn*(epsch7 + 


                                        epscmax1)) + d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch7 + 


                                        epscmax1 + 2*epsn)))))))/2.)))))/(2.*


              d) + (3*b*d*pow(as2*ch + as1*d, 3)*pow(e0c, 3)*pow(e0cn, 2)*fc*


                pow(k, 2)*pow(epsc1, 4)*


                pow(epsch7 + epscmax1 + 2*epsn, 


                  2)*(6*d*(epsch7 + epscmax1 + 


                          2*epsn)*((4 - 6*k)*


                            epsc1 + (-1 + k)*(epsch7 + epscmax1 + 


                                2*epsn)) + (h*(3*(-2 + 3*k)*epsc1 - 


                              2*(-1 + k)*(epsch7 + epscmax1 + 2*epsn))*(3*as2*


                                d*k*pow(epsc1, 


                                  2)*(2*e0cn*fy + 


                                    e0c*(-2*fy + 


                                        e0cn*(epsch7 + epscmax1 + 2*epsn))) + 


                              3*as1*d*k*


                                pow(epsc1, 


                                  2)*(-2*e0cn*fy + 


                                    e0c*(2*fy + 


                                        e0cn*(epsch7 + epscmax1 + 2*epsn))) - 


                              2*(3*d*e0c*k*n0*pow(epsc1, 2) + 


                                    sqrt(3.)*


                                      sqrt(k*


                                        pow(epsc1, 


                                        2)*((3*k*pow(epsc1, 2)*


                                        pow(-2*d*e0c*n0 + 


                                        as1*d*(-2*e0cn*fy + e0c*(2*fy - 


                                        e0cn*(epsch7 + epscmax1 - 2*epsn))) + 


                                        as2*(-2*ch*e0c*e0cn*(epsch7 + 


                                        epscmax1) + d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch7 + 


                                        epscmax1 + 2*epsn)))), 2))/4.


-((as2*ch + as1*d)*e0c*


                                        e0cn*(b*pow(d, 2)*e0c*fc*


                                        pow(epsch7 + epscmax1 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 2*(-1 + 


                                        k)*(epsch7 + epscmax1 + 2*epsn)) - 


                                        6*k*pow(epsc1, 2)*(epsch7 + 


                                        epscmax1)*(-2*d*e0c*n0 + 2*as1*


                                        d*(e0c*fy - e0cn*fy + e0c*e0cn*epsn) +


                                         as2*(-(ch*e0c*e0cn*(epsch7 + 


                                        epscmax1)) + d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch7 + 


                                        epscmax1 + 2*epsn)))))))/


                                        2.)))))/((as2*ch + as1*d)*e0c*e0cn*k*


                          pow(epsc1, 2))))/


            pow(6*d*e0c*k*n0*pow(epsc1, 2) - 


              3*as2*d*k*


                pow(epsc1, 


                  2)*(2*e0cn*fy + 


                    e0c*(-2*fy + e0cn*(epsch7 + epscmax1 + 2*epsn))) - 


              3*as1*d*k*


                pow(epsc1, 


                  2)*(-2*e0cn*fy + 


                    e0c*(2*fy + e0cn*(epsch7 + epscmax1 + 2*epsn))) + 


              2*sqrt(3.)*


                sqrt(k*pow(epsc1, 


                      2)*((3*k*pow(epsc1, 2)*


                              pow(-2*d*e0c*n0 + 


                                  as1*d*(-2*e0cn*fy + 


                                        e0c*(2*fy - 


                                        e0cn*(epsch7 + epscmax1 - 2*epsn))) + 


                                  as2*(-2*ch*e0c*e0cn*(epsch7 + epscmax1) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + 


                                        e0cn*(epsch7 + epscmax1 + 2*epsn)))), 


                                2))/4. - ((as2*ch + as1*d)*e0c*


                              e0cn*(b*pow(d, 2)*e0c*fc*


                                    pow(epsch7 + epscmax1 + 2*epsn, 


                                      2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch7 + epscmax1 + 


                                        2*epsn)) - 


                                  6*k*pow(epsc1, 


                                      2)*(epsch7 + epscmax1)*(-2*d*e0c*n0 + 


                                        2*as1*


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*epsn)) + 


                                        as2*(-(ch*e0c*


                                        e0cn*(epsch7 + epscmax1)) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch7 + 


                                        epscmax1 + 2*epsn)))))))/2.)), 


            2))/(12.*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mh7maxa;


}


 


//maximaln mozny ohybovy moment dosazeny na dannem elementu pri danne normalove sile, bez zohlednen epscder3


double normmat::compute_mhmaxa ()


{


	double mhmaxa;	


	


	mhmaxa =(-(as1*(2*cd - h)*(3*d*e0c*k*n0*pow(epsc1, 2) + 


                3*as1*d*k*


                  pow(epsc1, 


                    2)*(-(e0cn*fy) + e0c*(fy + e0cn*(epscmax1 + epsn))) + 


                3*as2*k*


                  pow(epsc1, 


                    2)*(d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscmax1 + epsn))) + 


                      2*ch*(-(e0cn*fy) + e0c*(fy + e0cn*(epscmax1 + epsn)))) +


                 sqrt(3.)*


                  sqrt(k*pow(epsc1, 


                        2)*(3*k*pow(epsc1, 2)*


                            pow(-(d*e0c*n0) + 


                                as1*d*(-(e0cn*fy) + 


                                      e0c*(fy + e0cn*(-epscmax1 + epsn))) + 


                                as2*(-2*ch*e0c*e0cn*epscmax1 + 


                                      d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscmax1 + epsn)))), 


                              2) - 2*(as2*ch + as1*d)*e0c*


                            e0cn*(b*pow(d, 2)*e0c*fc*


                                  pow(epscmax1 + epsn, 


                                    2)*((6 - 9*k)*epsc1 + 


                                      4*(-1 + k)*epscmax1 + 


                                      4*(-1 + k)*epsn) + 


                                6*k*pow(epsc1, 2)*


                                  epscmax1*(d*e0c*n0 + 


                                      as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) +


                                       as2*(ch*e0c*e0cn*epscmax1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscmax1 + 


                                        epsn)))))))))) - (36*b*d*


              pow(as2*ch + as1*d, 3)*pow(e0c, 3)*pow(e0cn, 2)*fc*pow(k, 2)*


              pow(epsc1, 4)*


              pow(epscmax1 + epsn, 


                2)*(2*d*(epscmax1 + 


                        epsn)*((2 - 3*k)*epsc1 + (-1 + k)*epscmax1 + (-1 + k)*


                          epsn) - (h*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscmax1 + 


                            4*(-1 + k)*epsn)*(-3*d*e0c*k*n0*pow(epsc1, 2) + 


                            3*as2*d*k*


                              pow(epsc1, 


                                2)*(e0cn*fy + 


                                  e0c*(-fy + e0cn*(epscmax1 + epsn))) + 


                            3*as1*d*k*


                              pow(epsc1, 


                                2)*(-(e0cn*fy) + 


                                  e0c*(fy + e0cn*(epscmax1 + epsn))) - 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(-(d*e0c*n0) + 


                                        as1*d*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*(-epscmax1 + epsn))) + 


                                        as2*(-2*ch*e0c*e0cn*epscmax1 + 


                                        d*(e0cn*fy + e0c*(-fy + 


                                        e0cn*(epscmax1 + epsn)))), 2) - 


                                      2*(as2*ch + as1*d)*e0c*


                                        e0cn*(b*pow(d, 2)*e0c*fc*


                                        pow(epscmax1 + epsn,2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1 + 


                                        4*(-1 + k)*epsn) + 


                                        6*k*pow(epsc1, 2)*


                                        epscmax1*(d*e0c*n0 + 


                                        as1*d*(e0cn*fy - 


                                        e0c*(fy + e0cn*epsn)) + 


                                        as2*(ch*e0c*e0cn*epscmax1 + 


                                        d*(-(e0cn*fy) + e0c*(fy - 


                                        e0cn*(epscmax1 + 


                                        epsn))))))))))/(6.*(as2*ch + as1*d)*


                        e0c*e0cn*k*pow(epsc1, 2))))/


          pow(3*d*e0c*k*n0*pow(epsc1, 2) + 


            3*as2*d*k*


              pow(epsc1, 


                2)*(-(e0cn*fy) + e0c*(fy - e0cn*(epscmax1 + epsn))) - 


            3*as1*d*k*


              pow(epsc1, 2)*(-(e0cn*fy) + e0c*(fy + e0cn*(epscmax1 + epsn))) +


             sqrt(3.)*


              sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow(-(d*e0c*n0) + 


                            as1*d*(-(e0cn*fy) + 


                                  e0c*(fy + e0cn*(-epscmax1 + epsn))) + 


                            as2*(-2*ch*e0c*e0cn*epscmax1 + 


                                  d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscmax1 + epsn)))), 


                          2) - 2*(as2*ch + as1*d)*e0c*


                        e0cn*(b*pow(d, 2)*e0c*fc*


                              pow(epscmax1 + epsn, 


                                2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscmax1 + 


                                  4*(-1 + k)*epsn) + 


                            6*k*pow(epsc1, 2)*


                              epscmax1*(d*e0c*n0 + 


                                  as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                  as2*(ch*e0c*e0cn*epscmax1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscmax1 + 


                                        epsn)))))))), 


          2) + (as2*(2*ch - 


                h)*(-3*as1*d*k*


                  pow(epsc1, 


                    2)*(-2*d*(e0cn*fy + e0c*(-fy + e0cn*(epscmax1 + epsn))) + 


                      ch*(-(e0cn*fy) + e0c*(fy + e0cn*(epscmax1 + epsn)))) + 


                ch*(3*d*e0c*k*n0*pow(epsc1, 2) + 


                      3*as2*d*k*


                        pow(epsc1, 


                          2)*(e0cn*fy + e0c*(-fy + e0cn*(epscmax1 + epsn))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-(d*e0c*n0) + 


                                      as1*d*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*(-epscmax1 + epsn))) + 


                                      as2*(-2*ch*e0c*e0cn*epscmax1 + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscmax1 + epsn)))), 


                                    2) - 2*(as2*ch + as1*d)*e0c*


                                  e0cn*(b*pow(d, 2)*e0c*fc*


                                        pow(epscmax1 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscmax1 + 


                                        4*(-1 + k)*epsn) + 


                                      6*k*pow(epsc1, 2)*


                                        epscmax1*(d*e0c*n0 + 


                                        as1*d*(e0cn*fy - 


                                        e0c*(fy + e0cn*epsn)) + 


                                        as2*(ch*e0c*e0cn*epscmax1 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscmax1 + 


                                        epsn)))))))))))/


        d)/(12.*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mhmaxa;


}


 


//pomocna hodnota pretvoreni betonu v tlaku


double normmat::compute_epscder3 ()


{


	double epscder3;	


	


	epscder3 =-(-(mh7*epsch7) + 4*mh7maxa*epsch7 - 3*mhmaxa*epsch7 - 3*mh7*epscmax1 + 


        4*mh7maxa*epscmax1 - mhmaxa*epscmax1)/(4.*(mh7 - 2*mh7maxa + mhmaxa));





	return epscder3;


}


 


//maximaln mozny ohybovy moment dosazeny na dannem elementu pri danne normalove sile, pokud epscder3 lez v dannm definicnm oboru


double normmat::compute_mhmax ()


{


	double mhmax;	


	


	mhmax =(-(as1*(2*cd - h)*(3*d*e0c*k*n0*pow(epsc1, 2) + 


                3*as1*d*k*


                  pow(epsc1, 


                    2)*(-(e0cn*fy) + e0c*(fy + e0cn*(epscder3 + epsn))) + 


                3*as2*k*


                  pow(epsc1, 


                    2)*(d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscder3 + epsn))) + 


                      2*ch*(-(e0cn*fy) + e0c*(fy + e0cn*(epscder3 + epsn)))) +


                 sqrt(3.)*


                  sqrt(k*pow(epsc1, 


                        2)*(3*k*pow(epsc1, 2)*


                            pow(-(d*e0c*n0) + 


                                as1*d*(-(e0cn*fy) + 


                                      e0c*(fy + e0cn*(-epscder3 + epsn))) + 


                                as2*(-2*ch*e0c*e0cn*epscder3 + 


                                      d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscder3 + epsn)))), 


                              2) - 2*(as2*ch + as1*d)*e0c*


                            e0cn*(b*pow(d, 2)*e0c*fc*


                                  pow(epscder3 + epsn, 


                                    2)*((6 - 9*k)*epsc1 + 


                                      4*(-1 + k)*epscder3 + 


                                      4*(-1 + k)*epsn) + 


                                6*k*pow(epsc1, 2)*


                                  epscder3*(d*e0c*n0 + 


                                      as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) +


                                       as2*(ch*e0c*e0cn*epscder3 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscder3 + 


                                        epsn)))))))))) - (36*b*d*


              pow(as2*ch + as1*d, 3)*pow(e0c, 3)*pow(e0cn, 2)*fc*pow(k, 2)*


              pow(epsc1, 4)*


              pow(epscder3 + epsn, 


                2)*(2*d*(epscder3 + 


                        epsn)*((2 - 3*k)*epsc1 + (-1 + k)*epscder3 + (-1 + k)*


                          epsn) - (h*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscder3 + 


                            4*(-1 + k)*epsn)*(-3*d*e0c*k*n0*pow(epsc1, 2) + 


                            3*as2*d*k*


                              pow(epsc1, 


                                2)*(e0cn*fy + 


                                  e0c*(-fy + e0cn*(epscder3 + epsn))) + 


                            3*as1*d*k*


                              pow(epsc1, 


                                2)*(-(e0cn*fy) + 


                                  e0c*(fy + e0cn*(epscder3 + epsn))) - 


                            sqrt(3.)*


                              sqrt(k*


                                  pow(epsc1, 


                                    2)*(3*k*pow(epsc1, 2)*


                                        pow(-(d*e0c*n0) + 


                                        as1*d*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*(-epscder3 + epsn))) + 


                                        as2*(-2*ch*e0c*e0cn*epscder3 + 


                                        d*(e0cn*fy + e0c*(-fy + 


                                        e0cn*(epscder3 + epsn)))), 2) - 


                                      2*(as2*ch + as1*d)*e0c*


                                        e0cn*(b*pow(d, 2)*e0c*fc*


                                        pow(epscder3 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscder3 + 


                                        4*(-1 + k)*epsn) + 


                                        6*k*pow(epsc1, 2)*


                                        epscder3*(d*e0c*n0 + 


                                        as1*d*(e0cn*fy - 


                                        e0c*(fy + e0cn*epsn)) + 


                                        as2*(ch*e0c*e0cn*epscder3 + 


                                        d*(-(e0cn*fy) + e0c*(fy - 


                                        e0cn*(epscder3 + 


                                        epsn))))))))))/(6.*(as2*ch + as1*d)*


                        e0c*e0cn*k*pow(epsc1, 2))))/


          pow(3*d*e0c*k*n0*pow(epsc1, 2) + 


            3*as2*d*k*


              pow(epsc1, 


                2)*(-(e0cn*fy) + e0c*(fy - e0cn*(epscder3 + epsn))) - 


            3*as1*d*k*


              pow(epsc1, 2)*(-(e0cn*fy) + e0c*(fy + e0cn*(epscder3 + epsn))) +


             sqrt(3.)*


              sqrt(k*pow(epsc1, 


                    2)*(3*k*pow(epsc1, 2)*


                        pow(-(d*e0c*n0) + 


                            as1*d*(-(e0cn*fy) + 


                                  e0c*(fy + e0cn*(-epscder3 + epsn))) + 


                            as2*(-2*ch*e0c*e0cn*epscder3 + 


                                  d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscder3 + epsn)))), 


                          2) - 2*(as2*ch + as1*d)*e0c*


                        e0cn*(b*pow(d, 2)*e0c*fc*


                              pow(epscder3 + epsn, 


                                2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscder3 + 


                                  4*(-1 + k)*epsn) + 


                            6*k*pow(epsc1, 2)*


                              epscder3*(d*e0c*n0 + 


                                  as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                  as2*(ch*e0c*e0cn*epscder3 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscder3 + 


                                        epsn)))))))), 


          2) + (as2*(2*ch - 


                h)*(-3*as1*d*k*


                  pow(epsc1, 


                    2)*(-2*d*(e0cn*fy + e0c*(-fy + e0cn*(epscder3 + epsn))) + 


                      ch*(-(e0cn*fy) + e0c*(fy + e0cn*(epscder3 + epsn)))) + 


                ch*(3*d*e0c*k*n0*pow(epsc1, 2) + 


                      3*as2*d*k*


                        pow(epsc1, 


                          2)*(e0cn*fy + e0c*(-fy + e0cn*(epscder3 + epsn))) + 


                      sqrt(3.)*


                        sqrt(k*


                            pow(epsc1, 


                              2)*(3*k*pow(epsc1, 2)*


                                  pow(-(d*e0c*n0) + 


                                      as1*d*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*(-epscder3 + epsn))) + 


                                      as2*(-2*ch*e0c*e0cn*epscder3 + 


                                        d*(e0cn*fy + 


                                        e0c*(-fy + e0cn*(epscder3 + epsn)))), 


                                    2) - 2*(as2*ch + as1*d)*e0c*


                                  e0cn*(b*pow(d, 2)*e0c*fc*


                                        pow(epscder3 + epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        4*(-1 + k)*epscder3 + 


                                        4*(-1 + k)*epsn) + 


                                      6*k*pow(epsc1, 2)*


                                        epscder3*(d*e0c*n0 + 


                                        as1*d*(e0cn*fy - 


                                        e0c*(fy + e0cn*epsn)) + 


                                        as2*(ch*e0c*e0cn*epscder3 + 


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy - e0cn*(epscder3 + 


                                        epsn)))))))))))/


        d)/(12.*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mhmax;


}


 


//pomocna hodnota ohyboveho momentu


double normmat::compute_mh8p () 


{


	double mh8p;	


	


	if ((epscder3-epsch7) < 0.0 && (epscder3-epscmax1) > 0.0){





    mh8p=mhmax;


  }


  else{


   mh8p=mhmaxa;


  }


  return mh8p;


}


   


//pomocna hodnota pretvoreni betonu v tlaku


double normmat::compute_epsch8p () 


{


	double epsch8p;	


	


	if ((epscder3-epsch7) < 0.0 && (epscder3-epscmax1) > 0.0){





    epsch8p=epscder3;


  }


  else{


   epsch8p=epscmax1;


  }


  return epsch8p;


}


  


//pomocna hodnota ohyboveho momentu


double normmat::compute_mh8 () 


{


	double mh8;	


	


	if ((epscder3-epsch7) > 0.0 || (epscder3-epscmax1) < 0.0 && (mh8p-mh7) < 0.0){





    mh8=mh7;


  }


  else{


   mh8=mh8p;


  }


  return mh8;


}


   


//pomocna hodnota pretvoreni betonu v tlaku


double normmat::compute_epsch8 () 


{


	double epsch8;	


	


	if ((epscder3-epsch7) > 0.0 || (epscder3-epscmax1) < 0.0 && (mh8p-mh7) < 0.0){





     epsch8=epsch7;


  }


  else{


    epsch8=epsch8p;


  }


  return epsch8;


}


 


//hodnota ohyboveho momentu pro pretvoreni na polovine danneho intervalu


double normmat::compute_mh78 ()


{


	double mh78;	


	


	mh78 =-(as1*(2*cd - h)*(3*d*e0c*k*n0*pow(epsc1, 2) + 


              3*as1*d*k*


                pow(epsc1, 


                  2)*(-(e0cn*


                          fy) + (e0c*(2*fy + 


                              e0cn*(epsch7 + epsch8 + 2*epsn)))/2.) + 


              3*as2*k*pow(epsc1, 


                  2)*(-(d*(2*e0cn*fy + 


                                e0c*(-2*fy + 


                                      e0cn*(epsch7 + epsch8 + 2*epsn))))/2. + 


                    ch*(-2*e0cn*fy + 


                          e0c*(2*fy + e0cn*(epsch7 + epsch8 + 2*epsn)))) + 


              sqrt(3.)*sqrt(k*


                    pow(epsc1, 


                      2)*((3*k*pow(epsc1, 2)*


                              pow(-2*d*e0c*n0 + 


                                  as1*d*(-2*e0cn*fy + 


                                        e0c*(2*fy - 


                                        e0cn*(epsch7 + epsch8 - 2*epsn))) + 


                                  as2*(-2*ch*e0c*e0cn*(epsch7 + epsch8) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + 


                                        e0cn*(epsch7 + epsch8 + 2*epsn)))), 


                                2))/4. - ((as2*ch + as1*d)*e0c*


                              e0cn*(b*pow(d, 2)*e0c*fc*


                                    pow(epsch7 + epsch8 + 2*epsn, 


                                      2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch7 + epsch8 + 


                                        2*epsn)) - 


                                  6*k*pow(epsc1, 


                                      2)*(epsch7 + epsch8)*(-2*d*e0c*n0 + 


                                        2*as1*


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*epsn)) + 


                                        as2*(-(ch*e0c*


                                        e0cn*(epsch7 + epsch8)) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch7 + epsch8 + 


                                        2*epsn)))))))/2.))) - (as2*(2*ch - 


                  h)*(-3*as1*d*k*


                    pow(epsc1, 


                      2)*(-2*d*(2*e0cn*fy + 


                              e0c*(-2*fy + e0cn*(epsch7 + epsch8 + 2*epsn))) +


                         ch*(-2*e0cn*fy + 


                              e0c*(2*fy + e0cn*(epsch7 + epsch8 + 2*epsn)))) +


                   ch*(6*d*e0c*k*n0*pow(epsc1, 2) + 


                        3*as2*d*k*


                          pow(epsc1, 


                            2)*(2*e0cn*fy + 


                              e0c*(-2*fy + 


                                    e0cn*(epsch7 + epsch8 + 2*epsn))) + 


                        2*sqrt(3.)*


                          sqrt(k*


                              pow(epsc1, 


                                2)*((3*k*pow(epsc1, 2)*


                                        pow(-2*d*e0c*n0 + 


                                        as1*d*(-2*e0cn*fy + 


                                        e0c*(2*fy - e0cn*(epsch7 + epsch8 - 


                                        2*epsn))) + 


                                        as2*(-2*ch*e0c*


                                        e0cn*(epsch7 + epsch8) + 


                                        d*(2*e0cn*fy + e0c*(-2*fy + 


                                        e0cn*(epsch7 + epsch8 + 2*epsn)))), 


                                        2))/4. - ((as2*ch + as1*d)*e0c*


                                        e0cn*(b*pow(d, 2)*e0c*fc*


                                        pow(epsch7 + epsch8 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch7 + epsch8 + 


                                        2*epsn)) - 


                                        6*k*pow(epsc1, 


                                        2)*(epsch7 + epsch8)*(-2*d*e0c*n0 + 


                                        2*as1*d*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*epsn)) + 


                                        as2*(-(ch*e0c*e0cn*(epsch7 + 


                                        epsch8)) + d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch7 + epsch8 + 


                                        2*epsn)))))))/2.)))))/(2.*


              d) + (3*b*d*pow(as2*ch + as1*d, 3)*pow(e0c, 3)*pow(e0cn, 2)*fc*


                pow(k, 2)*pow(epsc1, 4)*


                pow(epsch7 + epsch8 + 2*epsn, 


                  2)*(6*d*(epsch7 + epsch8 + 


                          2*epsn)*((4 - 6*k)*


                            epsc1 + (-1 + k)*(epsch7 + epsch8 + 


                                2*epsn)) + (h*(3*(-2 + 3*k)*epsc1 - 


                              2*(-1 + k)*(epsch7 + epsch8 + 2*epsn))*(3*as2*d*


                                k*pow(epsc1, 


                                  2)*(2*e0cn*fy + 


                                    e0c*(-2*fy + 


                                        e0cn*(epsch7 + epsch8 + 2*epsn))) + 


                              3*as1*d*k*


                                pow(epsc1, 


                                  2)*(-2*e0cn*fy + 


                                    e0c*(2*fy + 


                                        e0cn*(epsch7 + epsch8 + 2*epsn))) - 


                              2*(3*d*e0c*k*n0*pow(epsc1, 2) + 


                                    sqrt(3.)*


                                      sqrt(k*


                                        pow(epsc1, 


                                        2)*((3*k*pow(epsc1, 2)*


                                        pow(-2*d*e0c*n0 + 


                                        as1*d*(-2*e0cn*fy + e0c*(2*fy - 


                                        e0cn*(epsch7 + epsch8 - 2*epsn))) + 


                                        as2*(-2*ch*e0c*e0cn*(epsch7 + 


                                        epsch8) + d*(2*e0cn*fy + e0c*(-2*fy + 


                                        e0cn*(epsch7 + epsch8 + 2*epsn)))), 


                                        2))/4. - ((as2*ch + as1*d)*e0c*


                                        e0cn*(b*pow(d, 2)*e0c*fc*


                                        pow(epsch7 + epsch8 + 2*epsn, 


                                        2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch7 + epsch8 + 


                                        2*epsn)) - 6*k*pow(epsc1, 


                                        2)*(epsch7 + epsch8)*(-2*d*e0c*n0 + 


                                        2*as1*d*(e0c*fy - e0cn*fy + 


                                        e0c*e0cn*epsn) + 


                                        as2*(-(ch*e0c*e0cn*(epsch7 + 


                                        epsch8)) + d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch7 + epsch8 + 


                                        2*epsn)))))))/2.)))))/((as2*ch + 


                              as1*d)*e0c*e0cn*k*pow(epsc1, 2))))/


            pow(6*d*e0c*k*n0*pow(epsc1, 2) - 


              3*as2*d*k*


                pow(epsc1, 


                  2)*(2*e0cn*fy + 


                    e0c*(-2*fy + e0cn*(epsch7 + epsch8 + 2*epsn))) - 


              3*as1*d*k*


                pow(epsc1, 


                  2)*(-2*e0cn*fy + 


                    e0c*(2*fy + e0cn*(epsch7 + epsch8 + 2*epsn))) + 


              2*sqrt(3.)*


                sqrt(k*pow(epsc1, 


                      2)*((3*k*pow(epsc1, 2)*


                              pow(-2*d*e0c*n0 + 


                                  as1*d*(-2*e0cn*fy + 


                                        e0c*(2*fy - 


                                        e0cn*(epsch7 + epsch8 - 2*epsn))) + 


                                  as2*(-2*ch*e0c*e0cn*(epsch7 + epsch8) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + 


                                        e0cn*(epsch7 + epsch8 + 2*epsn)))), 


                                2))/4. - ((as2*ch + as1*d)*e0c*


                              e0cn*(b*pow(d, 2)*e0c*fc*


                                    pow(epsch7 + epsch8 + 2*epsn, 


                                      2)*((6 - 9*k)*epsc1 + 


                                        2*(-1 + k)*(epsch7 + epsch8 + 


                                        2*epsn)) - 


                                  6*k*pow(epsc1, 


                                      2)*(epsch7 + epsch8)*(-2*d*e0c*n0 + 


                                        2*as1*


                                        d*(-(e0cn*fy) + 


                                        e0c*(fy + e0cn*epsn)) + 


                                        as2*(-(ch*e0c*


                                        e0cn*(epsch7 + epsch8)) + 


                                        d*(2*e0cn*fy + 


                                        e0c*(-2*fy + e0cn*(epsch7 + epsch8 + 


                                        2*epsn)))))))/2.)), 2))/(12.*(as2*ch +


           as1*d)*e0c*k*pow(epsc1, 2)) + e0c*(-(as1*(-cd + h/2.)) + as2*(-ch + h/2.))*epsn;





	return mh78;


}


 


//ohybovy moment pri kterem uz nespolupusobi beton a dochazi k teceni vyztuze As2, netece As1


double normmat::compute_mhoc1 ()


{


	double mhoc1;	


	


	mhoc1 = -(as2*(ch - d)*(fy + e0c*epsn));





	return mhoc1;


}


 


//ohybovy moment pri kterem uz nespolupusobi beton a dochazi k meznimu teceni vyztuze As2, netece As1


double normmat::compute_mmaxoc1 ()


{


	double mmaxoc1;	


	


	mmaxoc1 = -((as2*(ch - d)*(-(e0cn*fy) + pow(e0c, 2)*epsn + 


                e0c*(fy + e0cn*epss1lim)))/e0c);





	return mmaxoc1;


}


 


//pretvoreni oceli As1 pri kterem uz nespolupusobi beton a dochazi k meznimu teceni vyztuze As2, netece As1


double normmat::compute_epss1oc1 ()


{


	double epss1oc1;	


	


	epss1oc1 = mhoc1/(-(as1*ch*e0c) + as1*d*e0c);





	return epss1oc1;


}


 


//ohybovy moment pri kterem uz nespolupusobi beton a dochazi k teceni vyztuze As1 a uz teklo As2


double normmat::compute_mhoc2 ()


{


	double mhoc2;	


	


	mhoc2 = as1*(ch - d)*(-fy + e0c*epsn);





	return mhoc2;


}


 


//pretvoreni oceli As1 pri kterem uz nespolupusobi beton a dochazi k teceni vyztuze As1 a uz teklo As2


double normmat::compute_epss1oc2 ()


{


	double epss1oc2;	


	


	epss1oc2 = -((mhoc2 - (as1*(ch - d)*(-(e0c*fy) + e0cn*fy + 


                      pow(e0c, 2)*epsn))/e0c)/(as1*(ch - d)*e0cn));





	return epss1oc2;


}


 


//ohybovy moment pri kterem uz nespolupusobi beton a dochazi k meznimu teceni vyztuze As1 a prekroceni mezniho pretvoreni As2


double normmat::compute_mmaxoc2 ()


{


	double mmaxoc2;	


	


	mmaxoc2 = (as1*(ch - d)*(e0cn*fy + pow(e0c, 2)*epsn - 


            e0c*(fy + e0cn*epss1lim)))/e0c;





	return mmaxoc2;


}


 


//hodnota ohyboveho momentu pro prvni bod zlomu na pracovnim diagramu prurezu


double normmat::compute_mht1 () 


{


	double mht1;	


		


  if (mh1 == mhr4){





    mht1 = mhr4;


  }


  else{


   mht1 = mhr1;


  }


  return mht1;


}


 


//hodnota ohyboveho momentu pro druhy bod zlomu na pracovnim diagramu prurezu


double normmat::compute_mht2 () 


{


	double mht2;	


	


  if ((mh1 == mhr4) && (mhrk1 == mmax1)){





    mht2 = mmax1;


  }


  else if ((mh1 == mhr4) && (mhrk1 == mhr4b)){





    mht2 = mhr4b;


  }


  else if ((mh1 == mhr1) && (mh2 == mhr2)){





    mht2 = mhr2;


  }


  else if ((mh1 == mhr1) && (mh2 == mhr3)){





    mht2 = mhr3;


  }


  return mht2;


}


 


//hodnota ohyboveho momentu pro treti bod zlomu na pracovnim diagramu prurezu


double normmat::compute_mht3 () 


{


	double mht3;	


	


  if ((mh1 == mhr4) && (mhrk1 == mmax1)){





    mht3 = mmax1;


  }


  else if ((mht2 == mhr4b) && (mh6 == mmax4)){





    mht3 = mmax4;


  }


  else if ((mht2 == mhr4b) && (mh6 == mmax3)){





    mht3 = mmax3;


  }


  else if ((mht2 == mhr4b) && (mh6 == mhr6)){





    mht3 = mhr6;


  }


  else if ((mht2 == mhr2) && (mh5 == mhr5)){





    mht3 = mhr5;


  }


  else if ((mht2 == mhr2) && (mh5 == mmax2)){





    mht3 = mmax2;


  }


  else if ((mht2 == mhr2) && (mh5 == ms11)){





    mht3 = ms11;


  }


  else if ((mht2 == mhr2) && (mh5 == mmax5)){





    mht3 = mmax5;


  }


  else if ((mht2 == mhr3) && (mh6 == mhr6)){





    mht3 = mhr6;


  }


  else if ((mht2 == mhr3) && (mh6 == mmax3)){





    mht3 = mmax3;


  }


  else if ((mht2 == mhr3) && (mh6 == mmax4)){





    mht3 = mmax4;


  }


  return mht3;


}


 


//hodnota ohyboveho momentu pro ctvrty bod zlomu na pracovnim diagramu prurezu


double normmat::compute_mht4 () 


{


	double mht4;	


	


  if ((mht3 == mhr5) || (mht3 == mhr6)){





    mht4 = mh8;


  }


  else if (mht2 == mmax1){





    mht4 = mh2;


  }


  else{


    mht4 = mht3;


  }


  return mht4;


}


 


//maximalni hodnota ohyboveho momentu na pracovnim diagramu prurezu


double normmat::compute_mmax () 


{


	double mmax;	


	


  if ((mht3 == mhr5) || (mht3 == mhr6)){





    mmax = mht4;


  }


  else if (mht2 == mmax1){





    mmax = mht2;


  }


  else{


    mmax = mht3;


  }


  return mmax;


}


 


//hodnota pretvoreni betonu v tlaku pro prvni bod zlomu na pracovnim diagramu prurezu


double normmat::compute_epscht1 () 


{


	double epscht1;	


	


  if (mh1 == mhr4){





    epscht1 = epschr4;


  }


  else{


   epscht1 = epschr1;


  }


  return epscht1;


}


 


//hodnota pretvoreni betonu v tlaku pro druhy bod zlomu na pracovnim diagramu prurezu


double normmat::compute_epscht2 () 


{


	double epscht2;	


	


  if ((mh1 == mhr4) && (mhrk1 == mmax1)){





    epscht2 = epscder2;


  }


  else if ((mh1 == mhr4) && (mhrk1 == mhr4b)){





    epscht2 = epschr4b;


  }


  else if ((mh1 == mhr1) && (mh2 == mhr2)){





    epscht2 = epschr2;


  }


  else if ((mh1 == mhr1) && (mh2 == mhr3)){





    epscht2 = epschr3;


  }


  return epscht2;


}


 


//hodnota pretvoreni betonu v tlaku pro treti bod zlomu na pracovnim diagramu prurezu


double normmat::compute_epscht3 () 


{


	double epscht3;


	


  if ((mh1 == mhr4) && (mhrk1 == mmax1)){





    epscht3 = epscder2;


  }


  else if ((mht2 == mhr4b) && (mh6 == mmax4)){





    epscht3 = epscder1;


  }


  else if ((mht2 == mhr4b) && (mh6 == mmax3)){





    epscht3 = epscmax1;


  }


  else if ((mht2 == mhr4b) && (mh6 == mhr6)){





    epscht3 = epschr6;


  }


  else if ((mht2 == mhr2) && (mh5 == mhr5)){





    epscht3 = epschr5;


  }


  else if ((mht2 == mhr2) && (mh5 == mmax2)){





    epscht3 = epscmax1;


  }


  else if ((mht2 == mhr2) && (mh5 == ms11)){





    epscht3 = epscs11;


  }


  else if ((mht2 == mhr2) && (mh5 == mmax5)){





    epscht3 = epscder4;


  }


  else if ((mht2 == mhr3) && (mh6 == mhr6)){





    epscht3 = epschr6;


  }


  else if ((mht2 == mhr3) && (mh6 == mmax3)){





    epscht3 = epscmax1;


  }


  else if ((mht2 == mhr3) && (mh6 == mmax4)){





    epscht3 = epscder1;


  }


  return epscht3;


}


 


//hodnota pretvoreni betonu v tlaku pro ctvrty bod zlomu na pracovnim diagramu prurezu


double normmat::compute_epscht4 () 


{


	double epscht4;	


	


  if ((mht3 == mhr5) || (mht3 == mhr6)){





    epscht4 = epsch8;


  }


  else if (epscht2 == epscmax1){





    epscht4 = epsch2;


  }


  else{


    epscht4 = epscht3;


  }


  return epscht4;


}


 


//maximalni hodnota pretvoreni betonu v tlaku na pracovnim diagramu prurezu


double normmat::compute_epscmax () 


{


	double epscmax;	


	


  if ((mht3 == mhr5) || (mht3 == mhr6)){





    epscmax = epscht4;


  }


  else if (epscht2 == epscmax1){





    epscmax = epscht2;


  }


  else{


    epscmax = epscht3;


  }


  return epscmax;


}


 


//absolutni uvazovana hodnota ohyboveho momentu na dannem elementu v polovine intervalu


void normmat::compute_mp ()
{

  long i;

  for (i=0;i<4;i++){	  


    if ((mpp[i] > mmax) && (iter <= 2)){


      


      mp[i] = mmax;


    }


    else {


      


      mp[i] = mpp[i];


    }


  }   


}





  
//funkce ktera rusi vliv betonove casti prurezu


void normmat::compute_tcn ()


{	


  long i;


  for (i=0;i<4;i++){


    


    if ((mp[i] > mmax) || (tcv[i] == 1.)){


      


      tcn[i] = 1.;


    }


    else {


      


      tcn[i] = 0.;


    }


  }


  }


 


//hodnota pretvoreni betonu v tlaku odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_epscsp ()


{


  long i;




  		


  for (i=0;i<4;i++){


    if ((mp[i] <= mht1) && (tcn[i] == 0)){


      


      epscsp[i] = (4*mh01*epsch1 - mh1*epsch1 - 


		   epsch1*sqrt(16*pow(mh01, 2) - 8*mh01*mh1 + pow(mh1, 2) - 


			       16*mh01*mp[i] + 8*mh1*mp[i]))/(2.*(4*mh01 - 2*mh1));


    }


    else if ((mp[i] > mht1) && (mht1 == mhr4) && (mp[i] <= mht2) && (tcn[i] == 0)){


      


      epscsp[i] = (3*mhrk1*epsch1 + mhrk1*epschrk1 - 4*mh1hrk1*(epsch1 + epschrk1) + 


		   mh1*(epsch1 + 3*epschrk1) + (-epsch1 + epschrk1)*


		   sqrt(pow(mh1, 2) + pow(-4*mh1hrk1 + mhrk1, 2) - 


			2*mh1*(4*mh1hrk1 + mhrk1 - 4*mp[i]) + 


			8*(-2*mh1hrk1 + mhrk1)*mp[i]))/(4.*(mh1 - 2*mh1hrk1 + mhrk1));


    }


    else if ((mp[i] > mht2) && (mht2 == mhr4b) && (mp[i] <= mht3) && (tcn[i] == 0)){


      


      epscsp[i] = (3*mh6*epsch3 + mh6*epsch6 - 4*mh36*(epsch3 + epsch6) + 


		   mh3*(epsch3 + 3*epsch6) + (-epsch3 + epsch6)*


		   sqrt(pow(mh3, 2) + pow(-4*mh36 + mh6, 2) - 


			2*mh3*(4*mh36 + mh6 - 4*mp[i]) + 


			8*(-2*mh36 + mh6)*mp[i]))/(4.*(mh3 - 2*mh36 + mh6));


    }


    else if ((mp[i] > mht1) && (mht1 == mhr1) && (mp[i] <= mht2) && (tcn[i] == 0)){


      


      epscsp[i] = ((-mh2 - 3*mhr1)*epsch2 - (3*mh2 + mhr1)*epschr1 + 


		   4*mh12*(epsch2 + epschr1) + (-epsch2 + epschr1)*


		   sqrt(16*pow(mh12, 2) + pow(mh2 - mhr1, 2) + 8*(mh2 + mhr1)*mp[i] - 


			8*mh12*(mh2 + mhr1 + 2*mp[i])))/(8*mh12 - 4*(mh2 + mhr1));


    }


    else if ((mp[i] > mht2) && (mht2 == mhr2) && (mp[i] <= mht3) && (tcn[i] == 0)){


      


      epscsp[i] = (3*mh5*epsch2 + mh5*epsch5 - 4*mh25*(epsch2 + epsch5) + 


		   mh2*(epsch2 + 3*epsch5) + (-epsch2 + epsch5)*


		   sqrt(pow(mh2, 2) + pow(-4*mh25 + mh5, 2) - 


			2*mh2*(4*mh25 + mh5 - 4*mp[i]) + 


			8*(-2*mh25 + mh5)*mp[i]))/(4.*(mh2 - 2*mh25 + mh5));


    }


    else if ((mp[i] > mht2) && (mht2 == mhr3) && (mp[i] <= mht3) && (tcn[i] == 0)){


      


      epscsp[i] = (3*mh6*epsch3 + mh6*epsch6 - 4*mh36*(epsch3 + epsch6) + 


		   mh3*(epsch3 + 3*epsch6) + (-epsch3 + epsch6)*


		   sqrt(pow(mh3, 2) + pow(-4*mh36 + mh6, 2) - 


			2*mh3*(4*mh36 + mh6 - 4*mp[i]) + 


			8*(-2*mh36 + mh6)*mp[i]))/(4.*(mh3 - 2*mh36 + mh6));


    }


    else if ((mp[i] > mht3) && ((mht3 == mhr6) || (mht3 == mhr5)) && (mp[i] <= mht4) && (tcn[i] == 0)){


      


      epscsp[i] = (3*mh8*epsch7 + mh8*epsch8 - 4*mh78*(epsch7 + epsch8) + 


		   mh7*(epsch7 + 3*epsch8) + (-epsch7 + epsch8)*


		   sqrt(pow(mh7, 2) + pow(-4*mh78 + mh8, 2) - 


			2*mh7*(4*mh78 + mh8 - 4*mp[i]) + 


			8*(-2*mh78 + mh8)*mp[i]))/(4.*(mh7 - 2*mh78 + mh8));


    }


    else {


      


      epscsp[i] = 1;


    }


  } 


  


}





  

//hodnota pretvoreni oceli As1 v tahu, od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_epss1sp ()


{


	long i;





	


			


  for (i=0;i<4;i++){


    if ((mp[i] <= mht1) && (tcn[i] == 0.)){





    epss1sp[i] = (6*d*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2) + 


      b*fc*pow(h, 


          2)*(8*h*(-1 + k)*epscsp[i] - 


            3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn)) - 


      sqrt(3.)*sqrt(pow(d, 


              2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                  pow(epsc1, 4) - 


                pow(b, 2)*pow(fc, 2)*


                  pow(h, 4)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                      4*(-1 + k)*epsn)*((-2 + 3*k)*epsc1 + 


                      4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn) + 


                4*b*fc*pow(h, 2)*k*


                  pow(epsc1, 


                    2)*(3*(as2*ch + as1*d)*


                        e0c*(-2*epsc1 + 3*k*epsc1 - 4*(-1 + k)*epscsp[i] + 


                            4*epsn - 4*k*epsn) + 


                      8*h*(-1 + 


                            k)*(-n0 + (as1 + as2)*


                              e0c*(epscsp[i] + epsn))))))/(8.*b*fc*


      pow(h, 3)*(-1 + k));


  }	
	
	else if ((mp[i] > mht1) && (mht1 == mhr4) && (mp[i] <= mht2) && (tcn[i] == 0.)){





    epss1sp[i] = (6*d*e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


      b*e0c*fc*pow(h, 


          2)*(8*h*(-1 + k)*epscsp[i] - 


            3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn)) - 


      sqrt(e0c*(e0c*


                  pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                      b*fc*pow(h, 


                          2)*(8*h*(-1 + k)*epscsp[i] - 


                            3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                  4*(-1 + k)*epsn)), 2) + 


                16*b*fc*


                  pow(h, 3)*(-1 + 


                      k)*(b*e0c*fc*


                        h*(-4*pow(h, 2)*(-1 + k)*pow(epscsp[i], 2) - 


                            6*pow(d, 


                                2)*(epscsp[i] + epsn)*((2 - 3*k)*epsc1 + 


                                  2*(-1 + k)*epscsp[i] + 2*(-1 + k)*epsn) + 


                            3*d*h*epscsp[i]*((2 - 3*k)*epsc1 + 


                                  4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn)) + 


                      6*d*k*pow(epsc1, 


                          2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                            as2*(-(ch*e0c*e0cn*epscsp[i]) + 


                                  d*(e0cn*fy + 


                                        e0c*(-fy + 


                                        e0cn*(epscsp[i] + epsn)))))))))/(8.*b*


      e0c*fc*pow(h, 3)*(-1 + k));


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr4b) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    epss1sp[i] = (3*d*e0c*k*pow(epsc1, 2)*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


      3*as2*k*pow(epsc1, 


          2)*(2*ch*e0c*e0cn*epscsp[i] + 


            d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscsp[i] + epsn)))) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(d*e0c*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epscsp[i] + 


                            d*(-(e0cn*fy) + 


                                  e0c*(fy - e0cn*(epscsp[i] + epsn)))), 2) + 


                2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                            pow(epscsp[i] + epsn, 


                              2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                4*(-1 + k)*epsn)) + 


                      6*k*pow(epsc1, 2)*


                        epscsp[i]*(-(as2*ch*e0c*e0cn*epscsp[i]) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscsp[i] + epsn))))))))/(6.*


      e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));


  }	 
	
	else if ((mp[i] > mht1) && (mht1 == mhr1) && (mp[i] <= mht2) && (tcn[i] == 0.)){





    epss1sp[i] = (6*as2*ch*e0c*k*pow(epsc1, 2)*epscsp[i] + 


      3*d*k*pow(epsc1, 


          2)*(n0 + as1*e0c*(epscsp[i] - epsn) - as2*e0c*(epscsp[i] + epsn)) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(-2*as2*ch*e0c*epscsp[i] + 


                      d*(-n0 - as1*e0c*epscsp[i] + 


                            as2*e0c*epscsp[i] + (as1 + as2)*e0c*epsn), 2) - 


                2*(as2*ch + as1*d)*


                  e0c*(b*pow(d, 2)*fc*


                        pow(epscsp[i] + epsn, 


                          2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                            4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 2)*


                        epscsp[i]*(as2*ch*e0c*epscsp[i] + 


                            d*(n0 - 


                                  e0c*(as2*epscsp[i] + (as1 + as2)*


                                        epsn)))))))/(6.*(as2*ch + as1*d)*e0c*


      k*pow(epsc1, 2));


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr2) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    epss1sp[i] = (6*as2*ch*pow(e0c, 2)*k*pow(epsc1, 2)*epscsp[i] - 


      3*d*k*pow(epsc1, 


          2)*(-(as1*e0cn*fy) + 


            e0c*(-n0 + as2*e0c*(epscsp[i] + epsn) + 


                  as1*(fy + e0cn*(-epscsp[i] + epsn)))) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(-2*as2*ch*pow(e0c, 2)*epscsp[i] + 


                      d*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*(epscsp[i] + epsn) + 


                                  as1*(fy + e0cn*(-epscsp[i] + epsn)))), 2) - 


                2*e0c*(as2*ch*e0c + 


                      as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                        pow(epscsp[i] + epsn, 


                          2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                            4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 2)*


                        epscsp[i]*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                            e0c*(as2*ch*e0c*epscsp[i] + 


                                  d*(n0 - 


                                        as2*e0c*(epscsp[i] + epsn))))))))/(6.*


      e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2));


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr3) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    epss1sp[i] = (3*d*e0c*k*pow(epsc1, 2)*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


      3*as2*k*pow(epsc1, 


          2)*(2*ch*e0c*e0cn*epscsp[i] + 


            d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscsp[i] + epsn)))) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(d*e0c*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epscsp[i] + 


                            d*(-(e0cn*fy) + 


                                  e0c*(fy - e0cn*(epscsp[i] + epsn)))), 2) + 


                2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                            pow(epscsp[i] + epsn, 


                              2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                4*(-1 + k)*epsn)) + 


                      6*k*pow(epsc1, 2)*


                        epscsp[i]*(-(as2*ch*e0c*e0cn*epscsp[i]) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscsp[i] + epsn))))))))/(6.*


      e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));


  }	
	
	else if ((mp[i] > mht3) && ((mht3 == mhr6) || (mht3 == mhr5)) && (mp[i] <= mht4) && (tcn[i] == 0.)){





    epss1sp[i] = (3*as1*d*k*pow(epsc1, 2)*(e0cn*fy - e0c*(fy + e0cn*(-epscsp[i] + epsn))) + 


      3*k*pow(epsc1, 


          2)*(d*e0c*n0 + 


            as2*(2*ch*e0c*e0cn*epscsp[i] + 


                  d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscsp[i] + epsn))))) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(-(d*e0c*n0) + 


                      as1*d*(-(e0cn*fy) + 


                            e0c*(fy - e0cn*epscsp[i] + e0cn*epsn)) + 


                      as2*(-2*ch*e0c*e0cn*epscsp[i] + 


                            d*(e0cn*fy + e0c*(-fy + e0cn*(epscsp[i] + epsn)))),


                     2) - 2*(as2*ch + as1*d)*e0c*


                  e0cn*(b*pow(d, 2)*e0c*fc*


                        pow(epscsp[i] + epsn, 


                          2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                            4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 2)*


                        epscsp[i]*(d*e0c*n0 + 


                            as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                            as2*(ch*e0c*e0cn*epscsp[i] + 


                                  d*(-(e0cn*fy) + 


                                        e0c*(fy - 


                                        e0cn*(epscsp[i] + 


                                        epsn)))))))))/(6.*(as2*ch + as1*d)*


      e0c*e0cn*k*pow(epsc1, 2));


  }	
	
	else if ((tcn[i] != 0.) && (mp[i] <= mhoc1)){





    epss1sp[i] = mp[i]/(-(as1*ch*e0c) + as1*d*e0c);


  }



	
	else if ((tcn[i] != 0.) && (mp[i] > mhoc1) && (mp[i] <= mhoc2)){





    epss1sp[i] = mp[i]/(-(as1*ch*e0c) + as1*d*e0c);


  }	
	
	else {





    epss1sp[i] = -((-((as1*(ch - d)*(-(e0c*fy) + e0cn*fy + pow(e0c, 2)*epsn))/e0c) + 


          mp[i])/(as1*(ch - d)*e0cn));


  } } 


  


 }


  


//hodnota prvni konstanty pro vypocet ohyboveho momntu v zavislosti na pretvoreni betonu v tlaku, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_a1sp ()


{


  long i;





  


  for (i=0;i<4;i++){


    if ((mp[i] <= mht1) && (tcn[i] == 0)){





    a1sp[i] = (4*mh01*(epsch1 - 2*epscsp[i]) + mh1*(-epsch1 + 4*epscsp[i]))/pow(epsch1, 2);


  }	
	
	else if ((mp[i] > mht1) && (mht1 == mhr4) && (mp[i] <= mht2) && (tcn[i] == 0)){





    a1sp[i] = (4*mh1hrk1*(epsch1 + epschrk1 - 2*epscsp[i]) + 


        mh1*(-epsch1 - 3*epschrk1 + 4*epscsp[i]) + 


        mhrk1*(-3*epsch1 - epschrk1 + 4*epscsp[i]))/pow(epsch1 - epschrk1, 2);


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr4b) && (mp[i] <= mht3) && (tcn[i] == 0)){





    a1sp[i] = (4*mh36*(epsch3 + epsch6 - 2*epscsp[i]) + 


	       mh3*(-epsch3 - 3*epsch6 + 4*epscsp[i]) + 


        mh6*(-3*epsch3 - epsch6 + 4*epscsp[i]))/pow(epsch3 - epsch6, 2);


  }	
	
	else if ((mp[i] > mht1) && (mht1 == mhr1) && (mp[i] <= mht2) && (tcn[i] == 0)){





    a1sp[i] = (-(mh2*epsch2) - 3*mhr1*epsch2 - (3*mh2 + mhr1)*epschr1 + 


        4*mh12*(epsch2 + epschr1 - 2*epscsp[i]) + 4*mh2*epscsp[i] + 


        4*mhr1*epscsp[i])/pow(epsch2 - epschr1, 2);


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr2) && (mp[i] <= mht3) && (tcn[i] == 0)){





    a1sp[i] = (4*mh25*(epsch2 + epsch5 - 2*epscsp[i]) + 


        mh2*(-epsch2 - 3*epsch5 + 4*epscsp[i]) + 


        mh5*(-3*epsch2 - epsch5 + 4*epscsp[i]))/pow(epsch2 - epsch5, 2);


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr3) && (mp[i] <= mht3) && (tcn[i] == 0)){





    a1sp[i] = (4*mh36*(epsch3 + epsch6 - 2*epscsp[i]) + 


        mh3*(-epsch3 - 3*epsch6 + 4*epscsp[i]) + 


        mh6*(-3*epsch3 - epsch6 + 4*epscsp[i]))/pow(epsch3 - epsch6, 2);


  }	
	
	else if ((mp[i] > mht3) && ((mht3 == mhr6) || (mht3 == mhr5)) && (mp[i] <= mht4) && (tcn[i] == 0)){





    a1sp[i] = (4*mh78*(epsch7 + epsch8 - 2*epscsp[i]) + 


        mh7*(-epsch7 - 3*epsch8 + 4*epscsp[i]) + 


        mh8*(-3*epsch7 - epsch8 + 4*epscsp[i]))/pow(epsch7 - epsch8, 2);


  }	
	
	else if ((tcn[i] != 0) && (mp[i] <= mhoc1)){





    a1sp[i] = 1;


  }


	else if ((tcn[i] != 0) && (mp[i] > mhoc1) && (mp[i] <= mhoc2)){





    a1sp[i] = 1;


  }	
	
	else {





    a1sp[i] = 1;


  } } 


  


}


 


//hodnota druhe pomocne konstanty pro vypocet ohyboveho momntu v zavislosti na pretvoreni betonu v tlaku, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_a2spp ()


{


  long i;



  


  for (i=0;i<4;i++){


	if ((mp[i] <= mmax) && (tcn[i] == 0)){





    a2spp[i] = -(a1sp[i]*epscsp[i]) + mp[i];


  }		
	
	else if ((tcn[i] != 0) && (mp[i] <= mhoc1)){





    a2spp[i] = 0;


  }


	else if ((tcn[i] != 0) && (mp[i] > mhoc1) && (mp[i] <= mhoc2)){





    a2spp[i] = 0;


  }	
	
	else {





    a2spp[i] = 0;


  } }   


  


 }


  


//hodnota druhe konstanty pro vypocet ohyboveho momntu v zavislosti na pretvoreni betonu v tlaku, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_a2sp ()


{


  long i;


   


  for (i=0;i<4;i++){


    if (m[i] > 0){


      


      a2sp[i] = -a2spp[i];


    }	


    else {


      


      a2sp[i] = a2spp[i];


    }


  }   





}





   
//hodnota prvni konstanty pro vypocet pretvoreni oceli As1 v tahu, od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_b1sp ()


{


  long i;


  

  	


  for (i=0;i<4;i++){


    if ((mp[i] <= mht1) && (tcn[i] == 0.)){





    b1sp[i] = (b*fc*pow(h, 


          2)*(-12*d*(-1 + k) + 8*h*(-1 + k)) - (sqrt(3.)*


            pow(d, 2)*(4*b*fc*


                  pow(h, 2)*(-12*(as2*ch + as1*d)*e0c*(-1 + k) + 


                      8*(as1 + as2)*e0c*h*(-1 + k))*k*pow(epsc1, 2) - 


                4*pow(b, 2)*pow(fc, 2)*


                  pow(h, 4)*(-1 + k)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                      4*(-1 + k)*epsn) - 


                4*pow(b, 2)*pow(fc, 2)*


                  pow(h, 4)*(-1 + k)*((-2 + 3*k)*epsc1 + 


                      4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn)))/(2.*


            sqrt(pow(d, 


                  2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                      pow(epsc1, 4) - 


                    pow(b, 2)*pow(fc, 2)*


                      pow(h, 4)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                          4*(-1 + k)*epsn)*((-2 + 3*k)*epsc1 + 


                          4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn) + 


                    4*b*fc*pow(h, 2)*k*


                      pow(epsc1, 


                        2)*(3*(as2*ch + as1*d)*


                            e0c*(-2*epsc1 + 3*k*epsc1 - 4*(-1 + k)*epscsp[i] + 


                                4*epsn - 4*k*epsn) + 


                          8*h*(-1 + 


                                k)*(-n0 + (as1 + as2)*


                                  e0c*(epscsp[i] + epsn)))))))/(8.*b*fc*


      pow(h, 3)*(-1 + k));


  }	
	
	else if ((mp[i] > mht1) && (mht1 == mhr4) && (mp[i] <= mht2) && (tcn[i] == 0)){





    b1sp[i] = (b*e0c*fc*


        pow(h, 2)*(-12*d*(-1 + k) + 


            8*h*(-1 + k)) - (e0c*(2*b*e0c*fc*


                  pow(h, 2)*(-12*d*(-1 + k) + 


                      8*h*(-1 + k))*(6*d*(as1*d*e0c + as2*ch*e0cn)*k*


                        pow(epsc1, 2) + 


                      b*fc*pow(h, 


                          2)*(8*h*(-1 + k)*epscsp[i] - 


                            3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                  4*(-1 + k)*epsn))) + 


                16*b*fc*


                  pow(h, 3)*(-1 + 


                      k)*(6*as2*d*(-(ch*e0c*e0cn) + d*e0c*e0cn)*k*


                        pow(epsc1, 2) + 


                      b*e0c*fc*


                        h*(12*d*h*(-1 + k)*epscsp[i] - 


                            8*pow(h, 2)*(-1 + k)*epscsp[i] - 


                            12*pow(d, 2)*(-1 + k)*(epscsp[i] + epsn) - 


                            6*pow(d, 


                                2)*((2 - 3*k)*epsc1 + 2*(-1 + k)*epscsp[i] + 


                                  2*(-1 + k)*epsn) + 


                            3*d*h*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                  4*(-1 + k)*epsn)))))/(2.*


            sqrt(e0c*(e0c*


                      pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                          b*fc*pow(h, 


                              2)*(8*h*(-1 + k)*epscsp[i] - 


                                3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                      4*(-1 + k)*epsn)), 2) + 


                    16*b*fc*


                      pow(h, 3)*(-1 + 


                          k)*(b*e0c*fc*


                            h*(-4*pow(h, 2)*(-1 + k)*pow(epscsp[i], 2) - 


                                6*pow(d, 


                                    2)*(epscsp[i] + epsn)*((2 - 3*k)*epsc1 + 


                                      2*(-1 + k)*epscsp[i] + 


                                      2*(-1 + k)*epsn) + 


                                3*d*h*


                                  epscsp[i]*((2 - 3*k)*epsc1 + 


                                      4*(-1 + k)*epscsp[i] + 


                                      4*(-1 + k)*epsn)) + 


                          6*d*k*pow(epsc1, 


                              2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                                as2*(-(ch*e0c*e0cn*epscsp[i]) + 


                                      d*(e0cn*fy + 


                                        e0c*(-fy + 


                                        e0cn*(epscsp[i] + epsn))))))))))/(8.*b*


      e0c*fc*pow(h, 3)*(-1 + k));


  }	
  
  else if ((mp[i] > mht2) && (mht2 == mhr4b) && (mp[i] <= mht3) && (tcn[i] == 0)){





    b1sp[i] = (3*as1*d*pow(e0c, 2)*k*pow(epsc1, 2) + 


      3*as2*(2*ch*e0c*e0cn - d*e0c*e0cn)*k*


        pow(epsc1, 


          2) + (sqrt(3.)*k*


            pow(epsc1, 


              2)*(6*(as1*d*pow(e0c, 2) + as2*(2*ch*e0c*e0cn - d*e0c*e0cn))*k*


                  pow(epsc1, 


                    2)*(d*e0c*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epscsp[i] + 


                            d*(-(e0cn*fy) + 


                                  e0c*(fy - e0cn*(epscsp[i] + epsn))))) + 


                2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(6*(-(as2*ch*e0c*e0cn) + as2*d*e0c*e0cn)*k*


                        pow(epsc1, 2)*epscsp[i] - 


                      4*b*pow(d, 2)*e0c*fc*(-1 + k)*pow(epscsp[i] + epsn, 2) - 


                      2*b*pow(d, 2)*e0c*


                        fc*(epscsp[i] + epsn)*((6 - 9*k)*epsc1 + 


                            4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 


                          2)*(-(as2*ch*e0c*e0cn*epscsp[i]) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscsp[i] + epsn)))))))/(2.*


            sqrt(k*pow(epsc1, 


                  2)*(3*k*pow(epsc1, 2)*


                      pow(d*e0c*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


                          as2*(2*ch*e0c*e0cn*epscsp[i] + 


                                d*(-(e0cn*fy) + 


                                      e0c*(fy - e0cn*(epscsp[i] + epsn)))), 


                        2) + 2*


                      e0c*(as1*d*e0c + 


                          as2*ch*


                            e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                pow(epscsp[i] + epsn, 


                                  2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                    4*(-1 + k)*epsn)) + 


                          6*k*pow(epsc1, 2)*


                            epscsp[i]*(-(as2*ch*e0c*e0cn*epscsp[i]) + 


                                d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                      e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscsp[i] + 


                                        epsn)))))))))/(6.*


      e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));


  }	
  
  else if ((mp[i] > mht1) && (mht1 == mhr1) && (mp[i] <= mht2) && (tcn[i] == 0)){





    b1sp[i] = (2*as2*ch + (as1 - as2)*


        d + (sqrt(3.)*


              pow(d, 2)*(pow(as2, 2)*e0c*k*pow(epsc1, 2)*(epscsp[i] + epsn) + 


                  as1*(-2*b*d*


                          fc*(epscsp[i] + epsn)*((2 - 3*k)*epsc1 + 


                              2*(-1 + k)*epscsp[i] + 2*(-1 + k)*epsn) + 


                        k*pow(epsc1, 2)*(-n0 + as1*e0c*(epscsp[i] + epsn))) + 


                  as2*(-2*b*ch*


                          fc*(epscsp[i] + epsn)*((2 - 3*k)*epsc1 + 


                              2*(-1 + k)*epscsp[i] + 2*(-1 + k)*epsn) + 


                        k*pow(epsc1, 


                            2)*(-n0 + 2*as1*e0c*(epscsp[i] + epsn)))))/


          sqrt(k*pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(-2*as2*ch*e0c*epscsp[i] + 


                      d*(-n0 - as1*e0c*epscsp[i] + 


                            as2*e0c*epscsp[i] + (as1 + as2)*e0c*epsn), 2) - 


                2*(as2*ch + as1*d)*


                  e0c*(b*pow(d, 2)*fc*


                        pow(epscsp[i] + epsn, 


                          2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                            4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 2)*


                        epscsp[i]*(as2*ch*e0c*epscsp[i] + 


                            d*(n0 - 


                                  e0c*(as2*epscsp[i] + (as1 + as2)*


                                        epsn)))))))/(2.*(as2*ch + as1*d));


  }	
  
  else if ((mp[i] > mht2) && (mht2 == mhr2) && (mp[i] <= mht3) && (tcn[i] == 0)){





    b1sp[i] = (6*as2*ch*pow(e0c, 2)*k*pow(epsc1, 2) - 


      3*d*e0c*(as2*e0c - as1*e0cn)*k*


        pow(epsc1, 


          2) + (sqrt(3.)*k*


            pow(epsc1, 


              2)*(6*(-2*as2*ch*pow(e0c, 2) + d*e0c*(as2*e0c - as1*e0cn))*k*


                pow(epsc1, 


                  2)*(-2*as2*ch*pow(e0c, 2)*epscsp[i] + 


                      d*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*(epscsp[i] + epsn) + 


                                  as1*(fy + e0cn*(-epscsp[i] + epsn)))))


-2*e0c*(as2*ch*e0c + 


                    as1*d*e0cn)*(6*e0c*(as2*ch*e0c - as2*d*e0c)*k*


                      pow(epsc1, 2)*epscsp[i] + 


                    4*b*pow(d, 2)*e0c*fc*(-1 + k)*pow(epscsp[i] + epsn, 2) + 


                    2*b*pow(d, 2)*e0c*


                      fc*(epscsp[i] + epsn)*((6 - 9*k)*epsc1 + 


                          4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn) + 


                    6*k*pow(epsc1, 


                        2)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                          e0c*(as2*ch*e0c*epscsp[i] + 


                                d*(n0 - as2*e0c*(epscsp[i] + epsn)))))))/(2.*


            sqrt(k*pow(epsc1, 


                  2)*(3*k*pow(epsc1, 2)*


                      pow(-2*as2*ch*pow(e0c, 2)*epscsp[i] + 


                          d*(-(as1*e0cn*fy) + 


                                e0c*(-n0 + as2*e0c*(epscsp[i] + epsn) + 


                                      as1*(fy + e0cn*(-epscsp[i] + epsn)))), 


                        2) - 2*


                      e0c*(as2*ch*e0c + 


                          as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                            pow(epscsp[i] + epsn, 


                              2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                4*(-1 + k)*epsn) + 


                          6*k*pow(epsc1, 2)*


                            epscsp[i]*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) +


                                 e0c*(as2*ch*e0c*epscsp[i] + 


                                      d*(n0 - 


                                        as2*e0c*(epscsp[i] + epsn)))))))))/(6.*


      e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2));


  }	
  
  else if ((mp[i] > mht2) && (mht2 == mhr3) && (mp[i] <= mht3) && (tcn[i] == 0)){





    b1sp[i] = (3*as1*d*pow(e0c, 2)*k*pow(epsc1, 2) + 


      3*as2*(2*ch*e0c*e0cn - d*e0c*e0cn)*k*


        pow(epsc1, 


          2) + (sqrt(3.)*k*


            pow(epsc1, 


              2)*(6*(as1*d*pow(e0c, 2) + as2*(2*ch*e0c*e0cn - d*e0c*e0cn))*k*


                  pow(epsc1, 


                    2)*(d*e0c*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epscsp[i] + 


                            d*(-(e0cn*fy) + 


                                  e0c*(fy - e0cn*(epscsp[i] + epsn))))) + 


                2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(6*(-(as2*ch*e0c*e0cn) + as2*d*e0c*e0cn)*k*


                        pow(epsc1, 2)*epscsp[i] - 


                      4*b*pow(d, 2)*e0c*fc*(-1 + k)*pow(epscsp[i] + epsn, 2) - 


                      2*b*pow(d, 2)*e0c*


                        fc*(epscsp[i] + epsn)*((6 - 9*k)*epsc1 + 


                            4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 


                          2)*(-(as2*ch*e0c*e0cn*epscsp[i]) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscsp[i] + epsn)))))))/(2.*


            sqrt(k*pow(epsc1, 


                  2)*(3*k*pow(epsc1, 2)*


                      pow(d*e0c*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


                          as2*(2*ch*e0c*e0cn*epscsp[i] + 


                                d*(-(e0cn*fy) + 


                                      e0c*(fy - e0cn*(epscsp[i] + epsn)))), 


                        2) + 2*


                      e0c*(as1*d*e0c + 


                          as2*ch*


                            e0cn)*(-(b*pow(d, 2)*e0c*fc*


                                pow(epscsp[i] + epsn, 


                                  2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                    4*(-1 + k)*epsn)) + 


                          6*k*pow(epsc1, 2)*


                            epscsp[i]*(-(as2*ch*e0c*e0cn*epscsp[i]) + 


                                d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                      e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscsp[i] + 


                                        epsn)))))))))/(6.*


      e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));


  }	
  
  else if ((mp[i] > mht3) && ((mht3 == mhr6) || (mht3 == mhr5)) && (mp[i] <= mht4) && (tcn[i] == 0)){





    b1sp[i] = (3*as1*d*e0c*e0cn*k*pow(epsc1, 2) + 


      3*as2*(2*ch*e0c*e0cn - d*e0c*e0cn)*k*


        pow(epsc1, 


          2) + (sqrt(3.)*k*


            pow(epsc1, 


              2)*(6*(-(as1*d*e0c*e0cn) + as2*(-2*ch*e0c*e0cn + d*e0c*e0cn))*k*


                  pow(epsc1, 


                    2)*(-(d*e0c*n0) + 


                      as1*d*(-(e0cn*fy) + 


                            e0c*(fy - e0cn*epscsp[i] + e0cn*epsn)) + 


                      as2*(-2*ch*e0c*e0cn*epscsp[i] + 


                            d*(e0cn*fy + 


                                  e0c*(-fy + e0cn*(epscsp[i] + epsn))))) - 


                2*(as2*ch + as1*d)*e0c*


                  e0cn*(6*as2*(ch*e0c*e0cn - d*e0c*e0cn)*k*pow(epsc1, 2)*


                        epscsp[i] + 


                      4*b*pow(d, 2)*e0c*fc*(-1 + k)*pow(epscsp[i] + epsn, 2) + 


                      2*b*pow(d, 2)*e0c*


                        fc*(epscsp[i] + epsn)*((6 - 9*k)*epsc1 + 


                            4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn) + 


                      6*k*pow(epsc1, 


                          2)*(d*e0c*n0 + 


                            as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                            as2*(ch*e0c*e0cn*epscsp[i] + 


                                  d*(-(e0cn*fy) + 


                                        e0c*(fy - 


                                        e0cn*(epscsp[i] + epsn))))))))/(2.*


            sqrt(k*pow(epsc1, 


                  2)*(3*k*pow(epsc1, 2)*


                      pow(-(d*e0c*n0) + 


                          as1*d*(-(e0cn*fy) + 


                                e0c*(fy - e0cn*epscsp[i] + e0cn*epsn)) + 


                          as2*(-2*ch*e0c*e0cn*epscsp[i] + 


                                d*(e0cn*fy + 


                                      e0c*(-fy + e0cn*(epscsp[i] + epsn)))), 


                        2) - 2*(as2*ch + as1*d)*e0c*


                      e0cn*(b*pow(d, 2)*e0c*fc*


                            pow(epscsp[i] + epsn, 


                              2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                4*(-1 + k)*epsn) + 


                          6*k*pow(epsc1, 2)*


                            epscsp[i]*(d*e0c*n0 + 


                                as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                                as2*(ch*e0c*e0cn*epscsp[i] + 


                                      d*(-(e0cn*fy) + 


                                        e0c*(fy - 


                                        e0cn*(epscsp[i] + 


                                        epsn))))))))))/(6.*(as2*ch + as1*d)*


      e0c*e0cn*k*pow(epsc1, 2));


  }	
  
  else if ((tcn[i] != 0) && (mp[i] <= mhoc1)){





    b1sp[i] = 1/(-(as1*ch*e0c) + as1*d*e0c);


  }


	else if ((tcn[i] != 0) && (mp[i] > mhoc1) && (mp[i] <= mhoc2)){





    b1sp[i] = 1/(-(as1*ch*e0c) + as1*d*e0c);


  }	
	
	else {





    b1sp[i] = 1/(-(as1*ch*e0c) + as1*d*e0c);


  } }    


  }


  


  //hodnota druhe pomocne konstanty pro vypocet pretvoreni oceli As1 v tahu, od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_b2spp ()


{


  long i;


  


  


	


	for (i=0;i<4;i++){


	  if ((mp[i] <= mht1) && (tcn[i] == 0.)){





    b2spp[i] = -(b1sp[i]*epscsp[i]) + (6*d*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2) + 


        b*fc*pow(h, 


            2)*(8*h*(-1 + k)*epscsp[i] - 


              3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn)) -


         sqrt(3.)*


          sqrt(pow(d, 


                2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                    pow(epsc1, 4) - 


                  pow(b, 2)*pow(fc, 2)*


                    pow(h, 4)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                        4*(-1 + k)*epsn)*((-2 + 3*k)*epsc1 + 


                        4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn) + 


                  4*b*fc*pow(h, 2)*k*


                    pow(epsc1, 


                      2)*(3*(as2*ch + as1*d)*


                          e0c*(-2*epsc1 + 3*k*epsc1 - 4*(-1 + k)*epscsp[i] + 


                              4*epsn - 4*k*epsn) + 


                        8*h*(-1 + 


                              k)*(-n0 + (as1 + as2)*


                                e0c*(epscsp[i] + epsn))))))/(8.*b*fc*


        pow(h, 3)*(-1 + k));


  }	
	  
	  else if ((mp[i] > mht1) && (mht1 == mhr4) && (mp[i] <= mht2) && (tcn[i] == 0.)){





    b2spp[i] = -(b1sp[i]*epscsp[i]) + (6*d*e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


        b*e0c*fc*


          pow(h, 2)*(8*h*(-1 + k)*epscsp[i] - 


              3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn)) -


         sqrt(e0c*(e0c*


                    pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                        b*fc*pow(h, 


                            2)*(8*h*(-1 + k)*epscsp[i] - 


                              3*d*((2 - 3*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                    4*(-1 + k)*epsn)), 2) + 


                  16*b*fc*


                    pow(h, 3)*(-1 + 


                        k)*(b*e0c*fc*


                          h*(-4*pow(h, 2)*(-1 + k)*pow(epscsp[i], 2) - 


                              6*pow(d, 


                                  2)*(epscsp[i] + epsn)*((2 - 3*k)*epsc1 + 


                                    2*(-1 + k)*epscsp[i] + 2*(-1 + k)*epsn) + 


                              3*d*h*epscsp[i]*((2 - 3*k)*epsc1 + 


                                    4*(-1 + k)*epscsp[i] + 4*(-1 + k)*epsn)) + 


                        6*d*k*pow(epsc1, 


                            2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                              as2*(-(ch*e0c*e0cn*epscsp[i]) + 


                                    d*(e0cn*fy + 


                                        e0c*(-fy + 


                                        e0cn*(epscsp[i] + epsn)))))))))/(8.*b*


        e0c*fc*pow(h, 3)*(-1 + k));


  }	
	  
	  else if ((mp[i] > mht2) && (mht2 == mhr4b) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    b2spp[i] = -(b1sp[i]*epscsp[i]) + (3*d*e0c*k*pow(epsc1, 2)*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


        3*as2*k*pow(epsc1, 


            2)*(2*ch*e0c*e0cn*epscsp[i] + 


              d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscsp[i] + epsn)))) + 


        sqrt(3.)*sqrt(k*


              pow(epsc1, 


                2)*(3*k*pow(epsc1, 2)*


                    pow(d*e0c*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


                        as2*(2*ch*e0c*e0cn*epscsp[i] + 


                              d*(-(e0cn*fy) + 


                                    e0c*(fy - e0cn*(epscsp[i] + epsn)))), 2) + 


                  2*e0c*(as1*d*e0c + 


                        as2*ch*


                          e0cn)*(-(b*pow(d, 2)*e0c*fc*


                              pow(epscsp[i] + epsn, 


                                2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                  4*(-1 + k)*epsn)) + 


                        6*k*pow(epsc1, 2)*


                          epscsp[i]*(-(as2*ch*e0c*e0cn*epscsp[i]) + 


                              d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                    e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscsp[i] + epsn))))))))/(6.*


        e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));


  }	
	  
	  else if ((mp[i] > mht1) && (mht1 == mhr1) && (mp[i] <= mht2) && (tcn[i] == 0.)){





    b2spp[i] = -(b1sp[i]*epscsp[i]) + (6*as2*ch*e0c*k*pow(epsc1, 2)*epscsp[i] + 


        3*d*k*pow(epsc1, 


            2)*(n0 + as1*e0c*(epscsp[i] - epsn) - as2*e0c*(epscsp[i] + epsn)) + 


        sqrt(3.)*sqrt(k*


              pow(epsc1, 


                2)*(3*k*pow(epsc1, 2)*


                    pow(-2*as2*ch*e0c*epscsp[i] + 


                        d*(-n0 - as1*e0c*epscsp[i] + 


                              as2*e0c*epscsp[i] + (as1 + as2)*e0c*epsn), 2) - 


                  2*(as2*ch + as1*d)*


                    e0c*(b*pow(d, 2)*fc*


                          pow(epscsp[i] + epsn, 


                            2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                              4*(-1 + k)*epsn) + 


                        6*k*pow(epsc1, 2)*


                          epscsp[i]*(as2*ch*e0c*epscsp[i] + 


                              d*(n0 - 


                                    e0c*(as2*epscsp[i] + (as1 + as2)*


                                        epsn)))))))/(6.*(as2*ch + as1*d)*e0c*


        k*pow(epsc1, 2));


  }	
	  
	  else if ((mp[i] > mht2) && (mht2 == mhr2) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    b2spp[i] = -(b1sp[i]*epscsp[i]) + (6*as2*ch*pow(e0c, 2)*k*pow(epsc1, 2)*epscsp[i] - 


        3*d*k*pow(epsc1, 


            2)*(-(as1*e0cn*fy) + 


              e0c*(-n0 + as2*e0c*(epscsp[i] + epsn) + 


                    as1*(fy + e0cn*(-epscsp[i] + epsn)))) + 


        sqrt(3.)*sqrt(k*


              pow(epsc1, 


                2)*(3*k*pow(epsc1, 2)*


                    pow(-2*as2*ch*pow(e0c, 2)*epscsp[i] + 


                        d*(-(as1*e0cn*fy) + 


                              e0c*(-n0 + as2*e0c*(epscsp[i] + epsn) + 


                                    as1*(fy + e0cn*(-epscsp[i] + epsn)))), 


                      2) - 2*e0c*(as2*ch*e0c + 


                        as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                          pow(epscsp[i] + epsn, 


                            2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                              4*(-1 + k)*epsn) + 


                        6*k*pow(epsc1, 2)*


                          epscsp[i]*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                              e0c*(as2*ch*e0c*epscsp[i] + 


                                    d*(n0 - 


                                        as2*e0c*(epscsp[i] + epsn))))))))/(6.*


        e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2));


  }	
	  
	  else if ((mp[i] > mht2) && (mht2 == mhr3) && (mp[i] <= mht3) && (tcn[i] == 0.)){





     b2spp[i] = -(b1sp[i]*epscsp[i]) + (3*d*e0c*k*pow(epsc1, 2)*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


        3*as2*k*pow(epsc1, 


            2)*(2*ch*e0c*e0cn*epscsp[i] + 


              d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscsp[i] + epsn)))) + 


        sqrt(3.)*sqrt(k*


              pow(epsc1, 


                2)*(3*k*pow(epsc1, 2)*


                    pow(d*e0c*(n0 + as1*e0c*(epscsp[i] - epsn)) + 


                        as2*(2*ch*e0c*e0cn*epscsp[i] + 


                              d*(-(e0cn*fy) + 


                                    e0c*(fy - e0cn*(epscsp[i] + epsn)))), 2) + 


                  2*e0c*(as1*d*e0c + 


                        as2*ch*


                          e0cn)*(-(b*pow(d, 2)*e0c*fc*


                              pow(epscsp[i] + epsn, 


                                2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                                  4*(-1 + k)*epsn)) + 


                        6*k*pow(epsc1, 2)*


                          epscsp[i]*(-(as2*ch*e0c*e0cn*epscsp[i]) + 


                              d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                    e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscsp[i] + epsn))))))))/(6.*


        e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));


  }	
	  
	  else if ((mp[i] > mht3) && ((mht3 == mhr6) || (mht3 == mhr5)) && (mp[i] <= mht4) && (tcn[i] == 0.)){





    b2spp[i] = -(b1sp[i]*epscsp[i]) + (3*as1*d*k*


          pow(epsc1, 2)*(e0cn*fy - e0c*(fy + e0cn*(-epscsp[i] + epsn))) + 


        3*k*pow(epsc1, 


            2)*(d*e0c*n0 + 


              as2*(2*ch*e0c*e0cn*epscsp[i] + 


                    d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscsp[i] + epsn))))) + 


        sqrt(3.)*sqrt(k*


              pow(epsc1, 


                2)*(3*k*pow(epsc1, 2)*


                    pow(-(d*e0c*n0) + 


                        as1*d*(-(e0cn*fy) + 


                              e0c*(fy - e0cn*epscsp[i] + e0cn*epsn)) + 


                        as2*(-2*ch*e0c*e0cn*epscsp[i] + 


                              d*(e0cn*fy + 


                                    e0c*(-fy + e0cn*(epscsp[i] + epsn)))), 


                      2) - 2*(as2*ch + as1*d)*e0c*


                    e0cn*(b*pow(d, 2)*e0c*fc*


                          pow(epscsp[i] + epsn, 


                            2)*((6 - 9*k)*epsc1 + 4*(-1 + k)*epscsp[i] + 


                              4*(-1 + k)*epsn) + 


                        6*k*pow(epsc1, 2)*


                          epscsp[i]*(d*e0c*n0 + 


                              as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                              as2*(ch*e0c*e0cn*epscsp[i] + 


                                    d*(-(e0cn*fy) + 


                                        e0c*(fy - 


                                        e0cn*(epscsp[i] + 


                                        epsn)))))))))/(6.*(as2*ch + as1*d)*


        e0c*e0cn*k*pow(epsc1, 2));


  }	
	  
	  else if ((tcn[i] != 0.) && (mp[i] <= mhoc1)){





    b2spp[i] = 0;


  }


	
	  else if ((tcn[i] != 0.) && (mp[i] > mhoc1) && (mp[i] <= mhoc2)){





    b2spp[i] = 0;


  }	
	  
	  else {





    b2spp[i] = fy/e0c - fy/e0cn + (e0c*epsn)/e0cn;


  } }    


  


 }


  


 //hodnota druhe konstanty pro vypocet ohyboveho momntu v zavislosti na pretvoreni betonu v tlaku, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_b2sp ()


{


  long i;


  

  for (i=0;i<4;i++){


    if (m[i] > 0.){


      


      b2sp[i] = -b2spp[i];


    }	


    else {


      


      b2sp[i] = b2spp[i];


    } 


  } 


  


}





    
//hodnota ohyboveho momentu pro vypocet prvni hodnoty funkce prace vnitrnich sil,odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_mr ()


{


  long i;


  
  


  for (i=0;i<4;i++){


    if ((mp[i] <= mht1) && (tcn[i] == 0.)){





    mr[i] = 0.0;


  }	
	
	else if ((mp[i] > mht1) && (mht1 == mhr4) && (mp[i] <= mht2) && (tcn[i] == 0.)){





    mr[i] = mh1;


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr4b) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    mr[i] = mh3;


  }	
	
	else if ((mp[i] > mht1) && (mht1 == mhr1) && (mp[i] <= mht2) && (tcn[i] == 0.)){





    mr[i] = mhr1;


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr2) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    mr[i] = mh2;


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr3) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    mr[i] = mh3;


  }	
	
	else if ((mp[i] > mht3) && ((mht3 == mhr6) || (mht3 == mhr5)) && (mp[i] <= mht4) && (tcn[i] == 0.)){





    mr[i] = mh7;


  }	
	
	else if ((tcn[i] != 0.) && (mp[i] <= mhoc1)){





    mr[i] = 0.;


  }


	else if ((tcn[i] != 0.) && (mp[i] > mhoc1) && (mp[i] <= mhoc2)){





    mr[i] = mhoc1;


  }	
	
	else {





    mr[i] = mhoc2;


  } }   


  


 


  }


 


 //hodnota pretvoreni betonu v tlaku pro vypocet prvni hodnoty funkce prace vnitrnich sil, od ucinku ohyboveho momentu,


//odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_epscr ()


{


  long i;




  


		


  for (i=0;i<4;i++){


    if ((mp[i] <= mht1) && (tcn[i] == 0.)){





    epscr[i] = 0.0;


  }	
	
	else if ((mp[i] > mht1) && (mht1 == mhr4) && (mp[i] <= mht2) && (tcn[i] == 0.)){





    epscr[i] = epsch1;


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr4b) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    epscr[i] = epsch3;


  }	
	
	else if ((mp[i] > mht1) && (mht1 == mhr1) && (mp[i] <= mht2) && (tcn[i] == 0.)){





    epscr[i] = epschr1;


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr2) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    epscr[i] = epsch2;


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr3) && (mp[i] <= mht3) && (tcn[i] == 0.)){





     epscr[i] = epsch3;


  }	
	
	else if ((mp[i] > mht3) && ((mht3 == mhr6) || (mht3 == mhr5)) && (mp[i] <= mht4) && (tcn[i] == 0.)){





    epscr[i] = epsch7;


  }	
	
	else if ((tcn[i] != 0.) && (mp[i] <= mhoc1)){





    epscr[i] = 0;


  }


	else if ((tcn[i] != 0.) && (mp[i] > mhoc1) && (mp[i] <= mhoc2)){





    epscr[i] = 0;


  }	
	
	else {





    epscr[i] = 0;


  } }   


  


}


 


 //hodnota pretvoreni oceli As1 v tahu pro vypocet prvni hodnoty funkce prace vnitrnich sil, od ucinku ohyboveho momentu,// odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_epss1r ()


{


  long i;



  		


  for (i=0;i<4;i++){


    if ((mp[i] <= mht1) && (tcn[i] == 0.)){





    epss1r[i] = (6*d*(as2*ch + as1*d)*e0c*k*pow(epsc1, 2) + 


        b*fc*pow(h, 


            2)*(8*h*(-1 + k)*epscr[i] - 


              3*d*(4*(-1 + k)*epscr[i] + (2 - 3*k)*epsc1 + 4*(-1 + k)*epsn)) - 


        sqrt(3.)*sqrt(pow(d, 


                2)*(12*pow(as2*ch + as1*d, 2)*pow(e0c, 2)*pow(k, 2)*


                    pow(epsc1, 4) - 


                  pow(b, 2)*pow(fc, 2)*


                    pow(h, 4)*(4*(-1 + k)*epscr[i] + (6 - 9*k)*epsc1 + 


                        4*(-1 + k)*epsn)*(4*(-1 + k)*epscr[i] + (-2 + 3*k)*


                          epsc1 + 4*(-1 + k)*epsn) + 


                  4*b*fc*pow(h, 2)*k*


                    pow(epsc1, 


                      2)*(3*(as2*ch + as1*d)*


                          e0c*(-4*(-1 + k)*epscr[i] - 2*epsc1 + 3*k*epsc1 + 


                              4*epsn - 4*k*epsn) + 


                        8*h*(-1 + 


                              k)*(-n0 + (as1 + as2)*


                                e0c*(epscr[i] + epsn))))))/(8.*b*fc*


        pow(h, 3)*(-1 + k));


  }	
	
	else if ((mp[i] > mht1) && (mht1 == mhr4) && (mp[i] <= mht2) && (tcn[i] == 0.)){





    epss1r[i] = (6*d*e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


      b*e0c*fc*pow(h, 


          2)*(8*h*(-1 + k)*epscr[i] - 


            3*d*(4*(-1 + k)*epscr[i] + (2 - 3*k)*epsc1 + 4*(-1 + k)*epsn)) - 


      sqrt(e0c*(e0c*


                  pow(6*d*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2) + 


                      b*fc*pow(h, 


                          2)*(8*h*(-1 + k)*epscr[i] - 


                            3*d*(4*(-1 + k)*epscr[i] + (2 - 3*k)*epsc1 + 


                                  4*(-1 + k)*epsn)), 2) + 


                16*b*fc*


                  pow(h, 3)*(-1 + 


                      k)*(b*e0c*fc*


                        h*(-4*pow(h, 2)*(-1 + k)*pow(epscr[i], 2) - 


                            6*pow(d, 


                                2)*(epscr[i] + 


                                  epsn)*(2*(-1 + k)*epscr[i] + (2 - 3*k)*epsc1 + 


                                  2*(-1 + k)*epsn) + 


                            3*d*h*epscr[i]*(4*(-1 + k)*epscr[i] + (2 - 3*k)*epsc1 + 


                                  4*(-1 + k)*epsn)) + 


                      6*d*k*pow(epsc1, 


                          2)*(d*e0c*(-n0 + as1*e0c*epsn) + 


                            as2*(-(ch*e0c*e0cn*epscr[i]) + 


                                  d*(e0cn*fy + 


                                        e0c*(-fy + 


                                        e0cn*(epscr[i] + epsn)))))))))/(8.*b*e0c*


      fc*pow(h, 3)*(-1 + k));


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr4b) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    epss1r[i] = (3*d*e0c*k*pow(epsc1, 2)*(n0 + as1*e0c*(epscr[i] - epsn)) + 


      3*as2*k*pow(epsc1, 


          2)*(2*ch*e0c*e0cn*epscr[i] + 


            d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscr[i] + epsn)))) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(d*e0c*(n0 + as1*e0c*(epscr[i] - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epscr[i] + 


                            d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscr[i] + epsn)))), 


                    2) + 2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                            pow(epscr[i] + epsn, 


                              2)*(4*(-1 + k)*epscr[i] + (6 - 9*k)*epsc1 + 


                                4*(-1 + k)*epsn)) + 


                      6*k*epscr[i]*


                        pow(epsc1, 


                          2)*(-(as2*ch*e0c*e0cn*epscr[i]) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscr[i] + epsn))))))))/(6.*


      e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));


  }	
	
	else if ((mp[i] > mht1) && (mht1 == mhr1) && (mp[i] <= mht2) && (tcn[i] == 0.)){





    epss1r[i] = (6*as2*ch*e0c*k*epscr[i]*pow(epsc1, 2) + 


      3*d*k*pow(epsc1, 


          2)*(n0 + as1*e0c*(epscr[i] - epsn) - as2*e0c*(epscr[i] + epsn)) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(-2*as2*ch*e0c*epscr[i] + 


                      d*(-n0 - as1*e0c*epscr[i] + 


                            as2*e0c*epscr[i] + (as1 + as2)*e0c*epsn), 2) - 


                2*(as2*ch + as1*d)*


                  e0c*(b*pow(d, 2)*fc*


                        pow(epscr[i] + epsn, 


                          2)*(4*(-1 + k)*epscr[i] + (6 - 9*k)*epsc1 + 


                            4*(-1 + k)*epsn) + 


                      6*k*epscr[i]*


                        pow(epsc1, 


                          2)*(as2*ch*e0c*epscr[i] + 


                            d*(n0 - 


                                  e0c*(as2*epscr[i] + (as1 + as2)*


                                        epsn)))))))/(6.*(as2*ch + as1*d)*e0c*


      k*pow(epsc1, 2));


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr2) && (mp[i] <= mht3) && (tcn[i] == 0.)){





    epss1r[i] = (6*as2*ch*pow(e0c, 2)*k*epscr[i]*pow(epsc1, 2) - 


      3*d*k*pow(epsc1, 


          2)*(-(as1*e0cn*fy) + 


            e0c*(-n0 + as2*e0c*(epscr[i] + epsn) + 


                  as1*(fy + e0cn*(-epscr[i] + epsn)))) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(-2*as2*ch*pow(e0c, 2)*epscr[i] + 


                      d*(-(as1*e0cn*fy) + 


                            e0c*(-n0 + as2*e0c*(epscr[i] + epsn) + 


                                  as1*(fy + e0cn*(-epscr[i] + epsn)))), 2) - 


                2*e0c*(as2*ch*e0c + 


                      as1*d*e0cn)*(b*pow(d, 2)*e0c*fc*


                        pow(epscr[i] + epsn, 


                          2)*(4*(-1 + k)*epscr[i] + (6 - 9*k)*epsc1 + 


                            4*(-1 + k)*epsn) + 


                      6*k*epscr[i]*


                        pow(epsc1, 


                          2)*(as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                            e0c*(as2*ch*e0c*epscr[i] + 


                                  d*(n0 - as2*e0c*(epscr[i] + epsn))))))))/(6.*


      e0c*(as2*ch*e0c + as1*d*e0cn)*k*pow(epsc1, 2));


  }	
	
	else if ((mp[i] > mht2) && (mht2 == mhr3) && (mp[i] <= mht3) && (tcn[i] == 0.)){





     epss1r[i] = (3*d*e0c*k*pow(epsc1, 2)*(n0 + as1*e0c*(epscr[i] - epsn)) + 


      3*as2*k*pow(epsc1, 


          2)*(2*ch*e0c*e0cn*epscr[i] + 


            d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscr[i] + epsn)))) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(d*e0c*(n0 + as1*e0c*(epscr[i] - epsn)) + 


                      as2*(2*ch*e0c*e0cn*epscr[i] + 


                            d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscr[i] + epsn)))), 


                    2) + 2*e0c*(as1*d*e0c + 


                      as2*ch*e0cn)*(-(b*pow(d, 2)*e0c*fc*


                            pow(epscr[i] + epsn, 


                              2)*(4*(-1 + k)*epscr[i] + (6 - 9*k)*epsc1 + 


                                4*(-1 + k)*epsn)) + 


                      6*k*epscr[i]*


                        pow(epsc1, 


                          2)*(-(as2*ch*e0c*e0cn*epscr[i]) + 


                            d*(as2*e0cn*fy + as1*pow(e0c, 2)*epsn + 


                                  e0c*(-(as2*fy) - n0 + 


                                        as2*e0cn*(epscr[i] + epsn))))))))/(6.*


      e0c*(as1*d*e0c + as2*ch*e0cn)*k*pow(epsc1, 2));


  }	
	
	else if ((mp[i] > mht3) && ((mht3 == mhr6) || (mht3 == mhr5)) && (mp[i] <= mht4) && (tcn[i] == 0.)){





    epss1r[i] = (3*as1*d*k*pow(epsc1, 2)*(e0cn*fy - e0c*(fy + e0cn*(-epscr[i] + epsn))) + 


      3*k*pow(epsc1, 


          2)*(d*e0c*n0 + 


            as2*(2*ch*e0c*e0cn*epscr[i] + 


                  d*(-(e0cn*fy) + e0c*(fy - e0cn*(epscr[i] + epsn))))) + 


      sqrt(3.)*sqrt(k*


            pow(epsc1, 


              2)*(3*k*pow(epsc1, 2)*


                  pow(-(d*e0c*n0) + 


                      as1*d*(-(e0cn*fy) + e0c*(fy - e0cn*epscr[i] + e0cn*epsn)) + 


                      as2*(-2*ch*e0c*e0cn*epscr[i] + 


                            d*(e0cn*fy + e0c*(-fy + e0cn*(epscr[i] + epsn)))), 


                    2) - 2*(as2*ch + as1*d)*e0c*


                  e0cn*(b*pow(d, 2)*e0c*fc*


                        pow(epscr[i] + epsn, 


                          2)*(4*(-1 + k)*epscr[i] + (6 - 9*k)*epsc1 + 


                            4*(-1 + k)*epsn) + 


                      6*k*epscr[i]*


                        pow(epsc1, 


                          2)*(d*e0c*n0 + 


                            as1*d*(e0cn*fy - e0c*(fy + e0cn*epsn)) + 


                            as2*(ch*e0c*e0cn*epscr[i] + 


                                  d*(-(e0cn*fy) + 


                                        e0c*(fy - 


                                        e0cn*(epscr[i] + epsn)))))))))/(6.*(as2*


            ch + as1*d)*e0c*e0cn*k*pow(epsc1, 2));


  }	
	
	else if ((tcn[i] != 0.) && (mp[i] <= mhoc1)){





    epss1r[i] = 0;


  }


    
	else if ((tcn[i] != 0.) && (mp[i] > mhoc1) && (mp[i] <= mhoc2)){


      


      epss1r[i] = mhoc1/(-(as1*ch*e0c) + as1*d*e0c);


    }	
	
	else {


      


      epss1r[i] = -((mhoc2 - (as1*(ch - d)*(-(e0c*fy) + e0cn*fy + pow(e0c,2)*epsn))/e0c)/(as1*(ch - d)*e0cn));


    }


  } 


  


}





  
//hodnota pretvoreni oceli As1 v tahu pro vypocet prvni hodnoty funkce pomocne prace vnitrnich sil,  // od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_epss1spp ()


{


  long i;


  

  


 


  for (i=0;i<4;i++){


    epss1spp[i]=(a2spp[i]*b1sp[i])/a1sp[i] - b2spp[i] + epss1sp[i];


  }   


}





    
//velikost pomocne tlacene plochy prurezu


void normmat::compute_xr ()


{


  long i;



  


  


  for (i=0;i<4;i++){


    if ((epscr[i] < 0.) && (d*(-epsn - epscr[i]))/(-epscr[i] + epss1r[i]) <= h){


      xr[i] = -(epscr[i] + epsn)*d/(-epscr[i] + epss1r[i]);


    }	


    else {


      xr[i] = h;


    } 


  }   


}





 
//velikost tlacene plochy prurezu


void normmat::compute_xsp ()


{


  long i;


  

    


  for (i=0;i<4;i++){


    if ((epscsp[i] < 0.) && (d*(-epsn - epscsp[i]))/(-epscsp[i] + epss1sp[i]) <= h){


      


      xsp[i] = -(epscsp[i] + epsn)*d/(-epscsp[i] + epss1sp[i]);


    }	else {


      


      xsp[i] = h;


    } 


  }  


}





   
//prvni integracni hodnota udavajici pocatek funkce prace vnitrnich sil pripadajici betonu, od ucinku ohyboveho momentu,


//odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_ir1 ()


{


  long i;


  
 		


  for (i=0;i<4;i++){


    if ((epscr[i] < 0.) && (tcn[i] == 0.) && (xr[i] != h)){





    ir1[i] = (b*d*fc*(-3.*(-1. + k)*pow(epscr[i], 4) + 


          pow(epsn, 3)*((-4. + 6.*k)*epsc1 - 5.*(-1. + k)*epsn) + 


          2*pow(epscr[i], 3)*((-2. + 3.*k)*epsc1 - 4.*(-1. + k)*epsn)))/(6.*k*


      pow(epsc1, 2)*(epscr[i] - epss1r[i]));


  }	
	
	else if ((epscr[i] < 0.) && (tcn[i] == 0.) && (xr[i] == h)){





    ir1[i] = 1./(4.*pow(d, 3)*k*pow(epsc1, 2))*(b*


      fc*(4*pow(d, 3)*h*


            pow(epscr[i], 


              2)*(-2.*(-1. + k)*epscr[i] + (-2. + 3.*k)*epsc1 - 4.*(-1. + k)*epsn) + 


          4.*pow(d, 2)*pow(h, 2)*


            epscr[i]*(3.*(-1. + k)*epscr[i] + (2. - 3.*k)*epsc1 + 4.*(-1. + k)*epsn)*(epscr[i] -


                 epss1r[i]) - 


          4./3.*d*


            pow(h, 3)*(6.*(-1. + k)*epscr[i] + (2. - 3.*k)*epsc1 + 4.*(-1. + k)*epsn)*


            pow(epscr[i] - epss1r[i], 2) + 


          2.*pow(h, 4)*(-1. + k)*pow(epscr[i] - epss1r[i], 3)));


  }	
	
	else {





    ir1[i] = 0.0;


  } }        





}


 


//druha integracni hodnota funkce prace vnitrnich sil pripadajici betonu, od ucinku ohyboveho momentu,odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_ims1 ()


{


  long i;




    


  for (i=0;i<4;i++){


    if ((epscsp[i] < 0.) && (tcn[i] == 0.) && (xsp[i] != h)){


      


      ims1[i] = (b*d*fc*(-3.*(-1. + k)*pow(epscsp[i], 4) + 


			 pow(epsn, 3)*((-4. + 6.*k)*epsc1 - 5.*(-1. + k)*epsn) + 


			 2.*pow(epscsp[i], 3)*((-2. + 3.*k)*epsc1 - 4.*(-1. + k)*epsn)))/(6.*k*


										     pow(epsc1, 2)*(epscsp[i] - epss1sp[i]));


    }	
	
	else if ((epscsp[i] < 0.) && (tcn[i] == 0.) && (xsp[i] == h)){


      
      ims1[i] = 1./(4.*pow(d, 3)*k*pow(epsc1, 2))*(b*


						  fc*(4.*pow(d, 3)*h*


						      pow(epscsp[i], 


							  2)*(-2.*(-1. + k)*epscsp[i] + (-2. + 3.*k)*epsc1 - 4.*(-1. + k)*epsn) + 


						      4.*pow(d, 2)*pow(h, 2)*


						      epscsp[i]*(3.*(-1. + k)*epscsp[i] + (2. - 3.*k)*epsc1 + 4.*(-1. + k)*epsn)*(epscsp[i] -


															    epss1sp[i]) - 


						      4./3.*d*


						      pow(h, 3)*(6.*(-1. + k)*epscsp[i] + (2. - 3.*k)*epsc1 + 4.*(-1. + k)*epsn)*


						      pow(epscsp[i] - epss1sp[i], 2) + 


						      2.*pow(h, 4)*(-1. + k)*pow(epscsp[i] - epss1sp[i], 3)));


    }	
	
	else {


      


      ims1[i] = 0.0;


    }
	  


  }        





}





  
//druha integracni hodnota funkce prace vnitrnich sil pripadajici tazene oceli As1, od ucinku ohyboveho momentu,odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_ims2 ()


{


  long i;


  


  


  for (i=0;i<4;i++){


    if ((epss1sp[i]+epsn) <= fy/e0c){





    ims2[i] = as1*e0c*epss1sp[i]*epss1sp[i];


  }	
	
	else {





    ims2[i] = (e0cn*(epss1sp[i] - fy/e0c + epsn) + e0c*(fy/e0c - epsn))*epss1sp[i]*as1;


  } }   





  }


 





//prvni integracni hodnota udavajici pocatek funkce prace vnitrnich sil pripadajici tazene oceli As1, od ucinku ohyboveho momentu,


//odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_ir2 ()


{


  long i;


  
  


  for (i=0;i<4;i++){


    if ((epss1r[i]+epsn) <= fy/e0c){


      


      ir2[i] = as1*e0c*epss1r[i]*epss1r[i];


    }	else {


      


      ir2[i] = (e0cn*(epss1r[i] - fy/e0c + epsn) + e0c*(fy/e0c - epsn))*epss1r[i]*as1;


    } 


  }    


}














   
//prvni integracni hodnota udavajici pocatek funkce prace vnitrnich sil pripadajici tlacene oceli As2, od ucinku ohyboveho momentu,


//odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_ir3 ()


{


  long i;


  

  


  for (i=0;i<4;i++){


    if ((epsn + (-(ch*epscr[i]) + d*epscr[i] + ch*epss1r[i])/d) >= -(fy/e0c) && 


  (tcn[i] == 0)){





    ir3[i] = (as2*e0c*(d*epscr[i] + ch*(-epscr[i] + epss1r[i]))*(d*epscr[i] + ch*(-epscr[i] + epss1r[i])))/pow(d, 


      2);


  }	
  
  else if (((ch*epss1r[i] + ch*-epscr[i] - d*-epscr[i])/d + epsn) < -fy/e0c && (tcn[i] == 0)){





    ir3[i] = (e0c*(-fy/e0c - epsn) + 


      e0cn*((ch*epss1r[i] + ch*-epscr[i] - d*-epscr[i])/d + epsn + fy/e0c))*(ch*epss1r[i] + 


        ch*-epscr[i] - d*-epscr[i])/d*as2;


  }	
  
  else if ((-((as1*epss1r[i])/as2) + epsn) >= -fy/e0c && (tcn[i] == 1.) && (mhoc1 >= mp[i])){





    ir3[i] = -((as1*epss1r[i])/as2)*e0c*-((as1*epss1r[i])/as2)*as2;


  }	
  
  else if (((as2*(e0c - e0cn)*(fy + e0c*epsn) - as1*pow(e0c, 2)*epss1r[i])/(as2*e0c*


            e0cn) + epsn) < -fy/e0c && (tcn[i] == 1.) && (mhoc2 >= mp[i]) && 


  (mhoc1 < mp[i])){





    ir3[i] = -((as2*e0cn*epsn + as1*e0c*epss1r[i])/as2)*(as2*(e0c - e0cn)*(fy + e0c*epsn) - 


        as1*pow(e0c, 2)*epss1r[i])/(as2*e0c*e0cn)*as2;


  }	
  
  else {





    ir3[i] = (-as2*e0c*e0cn*epsn + 


        as1*(e0cn*fy + pow(e0c, 2)*epsn - 


              e0c*(fy + e0cn*(epsn + epss1r[i]))))/(as2*


        e0c)*((e0c - e0cn)*(-as1*fy + as2*fy + as1*e0c*epsn + as2*e0c*epsn) - 


        as1*e0c*e0cn*epss1r[i])/(as2*e0c*e0cn)*as2;


  } } 


  


}


 


//druha integracni hodnota prace vnitrnich sil pripadajici tlacene oceli As2, od ucinku ohyboveho momentu,odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_ims3 ()


{


  long i;


  

    


  for (i=0;i<4;i++){


    if ((epsn + (-(ch*epscsp[i]) + d*epscsp[i] + ch*epss1sp[i])/d) >= -(fy/e0c) && 


	(tcn[i] == 0.)){





    ims3[i] = (as2*e0c*(d*epscsp[i] + ch*(-epscsp[i] + epss1sp[i]))*(d*epscsp[i] + ch*(-epscsp[i] + epss1sp[i])))/pow(d, 


      2);


  }	
	
	else if (((ch*epss1sp[i] + ch*-epscsp[i] - d*-epscsp[i])/d + epsn) < -fy/e0c && (tcn[i] == 0.)){





    ims3[i] = (e0c*(-fy/e0c - epsn) + 


      e0cn*((ch*epss1sp[i] + ch*-epscsp[i] - d*-epscsp[i])/d + epsn + fy/e0c))*(ch*epss1sp[i] + ch*-epscsp[i] - d*-epscsp[i])/d*as2;


  }	
	
	else if ((-((as1*epss1sp[i])/as2) + epsn) >= -fy/e0c && (tcn[i] == 1.) && (mhoc1 >= mp[i])){





    ims3[i] = -((as1*epss1sp[i])/as2)*e0c*-((as1*epss1sp[i])/as2)*as2;


  }	
	
	else if (((as2*(e0c - e0cn)*(fy + e0c*epsn) - as1*pow(e0c, 2)*epss1sp[i])/(as2*e0c*


            e0cn) + epsn) < -fy/e0c && (tcn[i] == 1.) && (mhoc2 >= mp[i]) && 


  (mhoc1 < mp[i])){





    ims3[i] = -((as2*e0cn*epsn + as1*e0c*epss1sp[i])/as2)*(as2*(e0c - e0cn)*(fy + e0c*epsn) - 


        as1*pow(e0c, 2)*epss1sp[i])/(as2*e0c*e0cn)*as2;


  }	
	
	else {





    ims3[i] = (-as2*e0c*e0cn*epsn + 


        as1*(e0cn*fy + pow(e0c, 2)*epsn - 


              e0c*(fy + e0cn*(epsn + epss1sp[i]))))/(as2*


        e0c)*((e0c - e0cn)*(-as1*fy + as2*fy + as1*e0c*epsn + as2*e0c*epsn) - 


        as1*e0c*e0cn*epss1sp[i])/(as2*e0c*e0cn)*as2;


  } } 


  


  }


 


//prvni integracni hodnota udavajici pocatek funkce prace vnitrnich sil, od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_ic1 ()


{


  long i;


  


    


  for (i=0;i<4;i++){


    ic1[i] = ir1[i]+ir2[i]+ir3[i];


  }   





}





   

//druha integracni hodnota prace vnitrnich sil, od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_ic2 ()


{


  long i;


  

   


  for (i=0;i<4;i++){


    ic2[i] = ims1[i]+ims2[i]+ims3[i];


  }   


}





 //pomocna integracni hodnota prace vnitrnich sil, od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_icp ()


{


  long i;


  
  


  


  for (i=0;i<4;i++){


    icp[i] = as1*e0c*epss1sp[i]*epss1spp[i];


  }   


}





   
//prvni clen integracni funkce prace vnitrnich sil, od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_c1 ()


{


  long i;


  


  for (i=0;i<4;i++){


    c1[i] = -((-ic1[i] + ic2[i])/(-pow(mp[i], 2) + pow(mr[i], 2)));


  }   


}





  
//druhy clen integracni funkce prace vnitrnich sil, od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_c2 ()


{


  long i;


  


    


  for (i=0;i<4;i++){


    c2[i] = -((ic1[i]*pow(mp[i], 2) - ic2[i]*pow(mr[i], 2))/(-pow(mp[i], 2) + pow(mr[i], 2)));


  }   





}





  
//prvni clen pomocne integracni funkce prace vnitrnich sil, od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_c1p ()


{


  long i;


 


  


  for (i=0;i<4;i++){


    c1p[i] = -((-ic1[i] + icp[i])/(-pow(mp[i], 2) + pow(mr[i], 2)));


  }   





}





   
//druhy clen pomocne integracni funkce prace vnitrnich sil, od ucinku ohyboveho momentu, odpovidajici i-temu vnitrnimu uzlu


void normmat::compute_c2p ()


{


  long i;


  
    


  for (i=0;i<4;i++){


    c2p[i] = -((ic1[i]*pow(mp[i], 2) - icp[i]*pow(mr[i], 2))/(-pow(mp[i], 2) + pow(mr[i], 2)));


  }   


} 





   
//integral prace vnitrnich sil pres dany element


void normmat::compute_kih (double lp)


{	


  


    


  kih[0]=(lp*((3*pow(fp, 2)*pow(lp, 4) + 20.*fp*pow(lp, 2)*(3.*lp*z1 + 16.*z2) + 


	       320.*(pow(lp, 2)*pow(z1, 2) + 12.*lp*z1*z2 + 48.*pow(z2, 2)))*


	      c1[0] + 15360.*c2[0]))/61440.;


  kih[1]=(lp*(93.*pow(fp, 2)*pow(lp, 4) + 20.*fp*pow(lp, 2)*(45.*lp*z1 + 112.*z2) + 


	      320.*(7.*pow(lp, 2)*pow(z1, 2) + 36.*lp*z1*z2 + 48.*pow(z2, 2)))*


	  c1[1])/61440. + (lp*c2[1])/4.;


  kih[2]=(lp*(633.*pow(fp, 2)*pow(lp, 4) + 20.*fp*pow(lp, 2)*(195.*lp*z1 + 304.*z2) + 


	      320.*(19.*pow(lp, 2)*pow(z1, 2) + 60.*lp*z1*z2 + 48.*pow(z2, 2)))*


	  c1[2])/61440. + (lp*c2[2])/4.;


  kih[3]=(lp*(2343.*pow(fp, 2)*pow(lp, 4) + 20.*fp*pow(lp, 2)*(525.*lp*z1 + 592.*z2) + 


	      320.*(37.*pow(lp, 2)*pow(z1, 2) + 84.*lp*z1*z2 + 48.*pow(z2, 2)))*


	  c1[3])/61440. + (lp*c2[3])/4.;


  


}





  
//integral pomocne prace vnitrnich sil pres dany element


void normmat::compute_kid (double lp)


{


  


    


  kid[0]=(lp*((3.*pow(fp, 2)*pow(lp, 4) + 20.*fp*pow(lp, 2)*(3.*lp*z1 + 16.*z2) + 


	       320.*(pow(lp, 2)*pow(z1, 2) + 12.*lp*z1*z2 + 48.*pow(z2, 2)))*


	      c1p[0] + 15360.*c2p[0]))/61440.;


  kid[1]=(lp*(93.*pow(fp, 2)*pow(lp, 4) + 20.*fp*pow(lp, 2)*(45.*lp*z1 + 112.*z2) + 


	      320.*(7.*pow(lp, 2)*pow(z1, 2) + 36.*lp*z1*z2 + 48.*pow(z2, 2)))*


	  c1p[1])/61440. + (lp*c2p[1])/4.;


  kid[2]=(lp*(633.*pow(fp, 2)*pow(lp, 4) + 20.*fp*pow(lp, 2)*(195.*lp*z1 + 304.*z2) + 


	      320.*(19.*pow(lp, 2)*pow(z1, 2) + 60.*lp*z1*z2 + 48.*pow(z2, 2)))*


	  c1p[2])/61440. + (lp*c2p[2])/4.;


  kid[3]=(lp*(2343.*pow(fp, 2)*pow(lp, 4) + 20.*fp*pow(lp, 2)*(525.*lp*z1 + 592.*z2) + 


	      320.*(37.*pow(lp, 2)*pow(z1, 2) + 84.*lp*z1*z2 + 48.*pow(z2, 2)))*


	  c1p[3])/61440. + (lp*c2p[3])/4.;


  


}


 


//pomer prace vnitrnich sil a pomocne prace vnitrnich sil na dannem elementu


void normmat::compute_ki ()


{


  long i;




    


  for (i=0;i<4;i++){


    ki[i] = kih[i]/kid[i];


  }   





} 





  
//clen matice tuhosti


double normmat::compute_k11 (double lp)


{


  double k11;


    


  k11 = (768*(pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


	      pow(b1sp[0], 2)*ki[0] + 


	      pow(a1sp[0], 


              4)*(pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 3)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k11; 	} 


 


//clen matice tuhosti


double normmat::compute_k12 (double lp)


{


  double k12;


  


	 


    k12 = (-96*(pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(3*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(5*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      7*pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 2)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k12;  	}  


  
//clen matice tuhosti


double normmat::compute_k13 (double lp)


{


  double k13;


  	


	k13 = (-768*(pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 3)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k13;	} 


 


//clen matice tuhosti


double normmat::compute_k14 (double lp)


{


  double k14;


			


	k14 = (-96*(7*pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(5*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(3*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 2)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k14; 	} 


 


//zatizeni od ucinku rovnomerneho spojiteho zatizeni (prava strana)


double normmat::compute_f1 (double lp)


{


	double f1;


		


	f1 = (-3*fp*pow(lp, 2)*pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


        pow(b1sp[1], 4)*pow(ki[1], 2) + 


      384*pow(a1sp[0], 2)*pow(a1sp[1], 3)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


        b1sp[1]*b2sp[1]*


        ki[1]*(pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


            pow(a1sp[2], 


                2)*(-(pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0]) + 


                  2*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) - 


      2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


        pow(b1sp[1], 2)*


        ki[1]*(4*pow(a1sp[0], 2)*


              pow(a1sp[3], 2)*(7*fp*pow(lp, 2) + 48*a2sp[1] - 48*a2sp[2])*


              pow(b1sp[2], 2)*ki[2] + 


            192*pow(a1sp[0], 2)*a1sp[2]*pow(a1sp[3], 2)*b1sp[2]*b2sp[2]*


              ki[2] + pow(a1sp[2], 


                2)*(2*pow(a1sp[3], 2)*


                    b1sp[0]*((7*fp*pow(lp, 2) + 96*a2sp[0] - 96*a2sp[1])*


                          b1sp[0] - 96*a1sp[0]*b2sp[0])*ki[0] + 


                  pow(a1sp[0], 


                      2)*(125*fp*pow(lp, 2) + 384*a2sp[1] - 384*a2sp[3])*


                    pow(b1sp[3], 2)*ki[3] + 


                  384*pow(a1sp[0], 2)*a1sp[3]*b1sp[3]*b2sp[3]*ki[3])) - 


      pow(a1sp[1], 


          4)*(5*fp*pow(lp, 2)*pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


              pow(ki[2], 2) - 


            384*pow(a1sp[0], 2)*pow(a1sp[2], 3)*pow(a1sp[3], 2)*b1sp[2]*


              b2sp[2]*ki[


                3]*(-2*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                  pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


            6*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*


              ki[2]*(pow(a1sp[3], 2)*


                    b1sp[0]*((25*fp*pow(lp, 2) + 128*a2sp[0] - 128*a2sp[2])*


                          b1sp[0] - 128*a1sp[0]*b2sp[0])*ki[0] + 


                  2*pow(a1sp[0], 


                      2)*(7*fp*pow(lp, 2) + 32*a2sp[2] - 32*a2sp[3])*


                    pow(b1sp[3], 2)*ki[3] + 


                  64*pow(a1sp[0], 2)*a1sp[3]*b1sp[3]*b2sp[3]*ki[3]) + 


            pow(a1sp[2], 


                4)*(fp*pow(lp, 2)*pow(a1sp[3], 4)*pow(b1sp[0], 4)*


                    pow(ki[0], 2) + 


                  8*pow(a1sp[0], 2)*pow(a1sp[3], 2)*b1sp[0]*


                    pow(b1sp[3], 


                      2)*((55*fp*pow(lp, 2) + 144*a2sp[0] - 144*a2sp[3])*


                          b1sp[0] - 144*a1sp[0]*b2sp[0])*ki[0]*ki[3] + 


                  1152*pow(a1sp[0], 2)*pow(a1sp[3], 3)*pow(b1sp[0], 2)*


                    b1sp[3]*b2sp[3]*ki[0]*ki[3] + 


                  7*fp*pow(lp, 2)*pow(a1sp[0], 4)*pow(b1sp[3], 4)*


                    pow(ki[3], 2))))/(8.*


      lp*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*pow(b1sp[1], 4)*


            pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return f1;	} 


 


//clen matice tuhosti


double normmat::compute_k21 (double lp)


{


  double k21;


  	  


    k21 = (-96*(pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(3*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(5*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      7*pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 2)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k21;	} 


 


//clen matice tuhosti


double normmat::compute_k22 (double lp)


{


  double k22;


  	  


    k22 = (16*(pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(7*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(19*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      37*pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      lp*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*pow(b1sp[1], 4)*


            pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k22;	}  


  
//clen matice tuhosti


double normmat::compute_k23 (double lp)


{


  double k23;


  	  


    k23 = (96*(pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(3*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(5*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      7*pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 2)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k23;	} 


 


//clen matice tuhosti


double normmat::compute_k24 (double lp)


{


  double k24;


  	 


    k24 = (16*(5*pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(11*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(11*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      5*pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      lp*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*pow(b1sp[1], 4)*


            pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k24;	} 


 


//zatizeni od ucinku rovnomerneho spojiteho zatizeni (prava strana)


double normmat::compute_f2 (double lp)





{


	double f2;


		  


    f2 = (pow(a1sp[0], 4)*pow(a1sp[2], 4)*


        pow(a1sp[3], 4)*(13*fp*pow(lp, 2) + 192*a2sp[1])*pow(b1sp[1], 4)*


        pow(ki[1], 2) - 


      192*pow(a1sp[0], 4)*a1sp[1]*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


        pow(b1sp[1], 3)*b2sp[1]*pow(ki[1], 2) - 


      192*pow(a1sp[0], 2)*pow(a1sp[1], 3)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


        b1sp[1]*b2sp[1]*


        ki[1]*(31*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] - 


            5*pow(a1sp[2], 


                2)*(pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] - 


                  17*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


      2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


        pow(b1sp[1], 2)*


        ki[1]*(pow(a1sp[0], 2)*


              pow(a1sp[3], 


                2)*(151*fp*pow(lp, 2) + 2976*a2sp[1] - 1632*a2sp[2])*


              pow(b1sp[2], 2)*ki[2] + 


            1632*pow(a1sp[0], 2)*a1sp[2]*pow(a1sp[3], 2)*b1sp[2]*b2sp[2]*


              ki[2] + pow(a1sp[2], 


                2)*(pow(a1sp[3], 2)*


                    b1sp[0]*((25*fp*pow(lp, 2) + 1824*a2sp[0] - 480*a2sp[1])*


                          b1sp[0] - 1824*a1sp[0]*b2sp[0])*ki[0] + 


                  pow(a1sp[0], 


                      2)*(763*fp*pow(lp, 2) + 8160*a2sp[1] - 3360*a2sp[3])*


                    pow(b1sp[3], 2)*ki[3] + 


                  3360*pow(a1sp[0], 2)*a1sp[3]*b1sp[3]*b2sp[3]*ki[3])) + 


      pow(a1sp[1], 


          4)*(pow(a1sp[0], 4)*


              pow(a1sp[3], 4)*(37*fp*pow(lp, 2) + 192*a2sp[2])*


              pow(b1sp[2], 4)*pow(ki[2], 2) - 


            192*pow(a1sp[0], 4)*a1sp[2]*pow(a1sp[3], 4)*pow(b1sp[2], 3)*


              b2sp[2]*pow(ki[2], 2) - 


            192*pow(a1sp[0], 2)*pow(a1sp[2], 3)*pow(a1sp[3], 2)*b1sp[2]*


              b2sp[2]*ki[


                3]*(-11*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                  43*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


            2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*


              ki[2]*(pow(a1sp[3], 2)*


                    b1sp[0]*((163*fp*pow(lp, 2) + 5856*a2sp[0] - 


                              1056*a2sp[2])*b1sp[0] - 5856*a1sp[0]*b2sp[0])*


                    ki[0] + 


                  pow(a1sp[0], 


                      2)*(361*fp*pow(lp, 2) + 4128*a2sp[2] - 2784*a2sp[3])*


                    pow(b1sp[3], 2)*ki[3] + 


                  2784*pow(a1sp[0], 2)*a1sp[3]*b1sp[3]*b2sp[3]*ki[3]) + 


            pow(a1sp[2], 


                4)*(pow(a1sp[3], 4)*


                    pow(b1sp[0], 


                      3)*((fp*pow(lp, 2) + 192*a2sp[0])*b1sp[0] - 


                        192*a1sp[0]*b2sp[0])*pow(ki[0], 2) + 


                  2*pow(a1sp[0], 2)*pow(a1sp[3], 2)*b1sp[0]*


                    pow(b1sp[3], 


                      2)*((523*fp*pow(lp, 2) + 12192*a2sp[0] - 1632*a2sp[3])*


                          b1sp[0] - 12192*a1sp[0]*b2sp[0])*ki[0]*ki[3] + 


                  3264*pow(a1sp[0], 2)*pow(a1sp[3], 3)*pow(b1sp[0], 2)*


                    b1sp[3]*b2sp[3]*ki[0]*ki[3] + 


                  pow(a1sp[0], 4)*(73*fp*pow(lp, 2) + 192*a2sp[3])*


                    pow(b1sp[3], 4)*pow(ki[3], 2) - 


                  192*pow(a1sp[0], 4)*a1sp[3]*pow(b1sp[3], 3)*b2sp[3]*


                    pow(ki[3], 2))))/(192.*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*


            pow(a1sp[3], 4)*pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return f2;	 } 


 


//clen matice tuhosti


double normmat::compute_k31 (double lp)


{


  double k31;


  	  


    k31 = (-768*(pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 3)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k31;	} 


 


//clen matice tuhosti


double normmat::compute_k32 (double lp)


{


  double k32;


  	  


    k32 = (96*(pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(3*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(5*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      7*pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 2)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k32;	}  


  
//clen matice tuhosti


double normmat::compute_k33 (double lp)


{


  double k33;


  	  


    k33 = (768*(pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 3)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k33;	} 


 


//clen matice tuhosti


double normmat::compute_k34 (double lp)


{


  double k34;


  	  


    k34 = (96*(7*pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(5*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(3*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 2)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k34;	} 


 


//zatizeni od ucinku rovnomerneho spojiteho zatizeni (prava strana)


double normmat::compute_f3 (double lp)





{


	double f3;


		  


    f3 = (-5*fp*pow(lp, 2)*pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


        pow(b1sp[1], 4)*pow(ki[1], 2) - 


      384*pow(a1sp[0], 2)*pow(a1sp[1], 3)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


        b1sp[1]*b2sp[1]*


        ki[1]*(pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


            pow(a1sp[2], 


                2)*(-(pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0]) + 


                  2*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) - 


      2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


        pow(b1sp[1], 2)*


        ki[1]*(4*pow(a1sp[0], 2)*


              pow(a1sp[3], 2)*(7*fp*pow(lp, 2) - 48*a2sp[1] + 48*a2sp[2])*


              pow(b1sp[2], 2)*ki[2] - 


            192*pow(a1sp[0], 2)*a1sp[2]*pow(a1sp[3], 2)*b1sp[2]*b2sp[2]*


              ki[2] + 3*


              pow(a1sp[2], 


                2)*(2*pow(a1sp[3], 2)*


                    b1sp[0]*((7*fp*pow(lp, 2) - 32*a2sp[0] + 32*a2sp[1])*


                          b1sp[0] + 32*a1sp[0]*b2sp[0])*ki[0] + 


                  pow(a1sp[0], 


                      2)*(25*fp*pow(lp, 2) - 128*a2sp[1] + 128*a2sp[3])*


                    pow(b1sp[3], 2)*ki[3] - 


                  128*pow(a1sp[0], 2)*a1sp[3]*b1sp[3]*b2sp[3]*ki[3])) - 


      pow(a1sp[1], 


          4)*(3*fp*pow(lp, 2)*pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


              pow(ki[2], 2) + 


            384*pow(a1sp[0], 2)*pow(a1sp[2], 3)*pow(a1sp[3], 2)*b1sp[2]*


              b2sp[2]*ki[


                3]*(-2*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                  pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


            2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*


              ki[2]*(pow(a1sp[3], 2)*


                    b1sp[0]*((125*fp*pow(lp, 2) - 384*a2sp[0] + 384*a2sp[2])*


                          b1sp[0] + 384*a1sp[0]*b2sp[0])*ki[0] + 


                  2*pow(a1sp[0], 


                      2)*(7*fp*pow(lp, 2) - 96*a2sp[2] + 96*a2sp[3])*


                    pow(b1sp[3], 2)*ki[3] - 


                  192*pow(a1sp[0], 2)*a1sp[3]*b1sp[3]*b2sp[3]*ki[3]) + 


            pow(a1sp[2], 


                4)*(7*fp*pow(lp, 2)*pow(a1sp[3], 4)*pow(b1sp[0], 4)*


                    pow(ki[0], 2) + 


                  8*pow(a1sp[0], 2)*pow(a1sp[3], 2)*b1sp[0]*


                    pow(b1sp[3], 


                      2)*((55*fp*pow(lp, 2) - 144*a2sp[0] + 144*a2sp[3])*


                          b1sp[0] + 144*a1sp[0]*b2sp[0])*ki[0]*ki[3] - 


                  1152*pow(a1sp[0], 2)*pow(a1sp[3], 3)*pow(b1sp[0], 2)*


                    b1sp[3]*b2sp[3]*ki[0]*ki[3] + 


                  fp*pow(lp, 2)*pow(a1sp[0], 4)*pow(b1sp[3], 4)*


                    pow(ki[3], 2))))/(8.*


      lp*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*pow(b1sp[1], 4)*


            pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return f3;	 } 


 


//clen matice tuhosti


double normmat::compute_k41 (double lp)


{


  double k41;


  	  


    k41 = (-96*(7*pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(5*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(3*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 2)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k41;	} 


 


//clen matice tuhosti


double normmat::compute_k42 (double lp)


{


  double k42;


  	  


    k42 = (16*(5*pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(11*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(11*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      5*pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      lp*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*pow(b1sp[1], 4)*


            pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k42;	}  


   
//clen matice tuhosti


double normmat::compute_k43 (double lp)


{


  double k43;


  	  


    k43 = (96*(7*pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(5*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(3*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      pow(lp, 2)*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k43;	} 


 


//clen matice tuhosti


double normmat::compute_k44 (double lp)


{


  double k44;


    


    k44 = (16*(37*pow(a1sp[0], 2)*pow(a1sp[1], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


            pow(b1sp[0], 2)*ki[0] + 


          pow(a1sp[0], 


              4)*(19*pow(a1sp[1], 2)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


                  pow(b1sp[1], 2)*ki[1] + 


                pow(a1sp[1], 


                    4)*(7*pow(a1sp[2], 2)*pow(a1sp[3], 4)*pow(b1sp[2], 2)*


                        ki[2] + 


                      pow(a1sp[2], 4)*pow(a1sp[3], 2)*pow(b1sp[3], 2)*


                        ki[3]))))/(as1*e0c*


      lp*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*pow(a1sp[3], 4)*pow(b1sp[1], 4)*


            pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return k44;	} 


 


//zatizeni od ucinku rovnomerneho spojiteho zatizeni (prava strana)


double normmat::compute_f4 (double lp)





{


	double f4;


	  


    f4 = (-(pow(a1sp[0], 4)*pow(a1sp[2], 4)*


            pow(a1sp[3], 4)*(37*fp*pow(lp, 2) + 192*a2sp[1])*pow(b1sp[1], 4)*


            pow(ki[1], 2)) + 


      192*pow(a1sp[0], 4)*a1sp[1]*pow(a1sp[2], 4)*pow(a1sp[3], 4)*


        pow(b1sp[1], 3)*b2sp[1]*pow(ki[1], 2) - 


      192*pow(a1sp[0], 2)*pow(a1sp[1], 3)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


        b1sp[1]*b2sp[1]*


        ki[1]*(17*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


            pow(a1sp[2], 


                2)*(-43*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                  11*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) - 


      2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


        pow(b1sp[1], 2)*


        ki[1]*(pow(a1sp[0], 2)*


              pow(a1sp[3], 


                2)*(151*fp*pow(lp, 2) - 1632*a2sp[1] + 2976*a2sp[2])*


              pow(b1sp[2], 2)*ki[2] - 


            2976*pow(a1sp[0], 2)*a1sp[2]*pow(a1sp[3], 2)*b1sp[2]*b2sp[2]*


              ki[2] + pow(a1sp[2], 


                2)*(pow(a1sp[3], 2)*


                    b1sp[0]*((361*fp*pow(lp, 2) - 2784*a2sp[0] + 


                              4128*a2sp[1])*b1sp[0] + 2784*a1sp[0]*b2sp[0])*


                    ki[0] + 


                  pow(a1sp[0], 


                      2)*(163*fp*pow(lp, 2) - 1056*a2sp[1] + 5856*a2sp[3])*


                    pow(b1sp[3], 2)*ki[3] - 


                  5856*pow(a1sp[0], 2)*a1sp[3]*b1sp[3]*b2sp[3]*ki[3])) - 


      pow(a1sp[1], 


          4)*(pow(a1sp[0], 4)*


              pow(a1sp[3], 4)*(13*fp*pow(lp, 2) + 192*a2sp[2])*


              pow(b1sp[2], 4)*pow(ki[2], 2) - 


            192*pow(a1sp[0], 4)*a1sp[2]*pow(a1sp[3], 4)*pow(b1sp[2], 3)*


              b2sp[2]*pow(ki[2], 2) + 


            960*pow(a1sp[0], 2)*pow(a1sp[2], 3)*pow(a1sp[3], 2)*b1sp[2]*


              b2sp[2]*ki[


                3]*(-17*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                  pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


            2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*


              ki[2]*(pow(a1sp[3], 2)*


                    b1sp[0]*((763*fp*pow(lp, 2) - 3360*a2sp[0] + 


                              8160*a2sp[2])*b1sp[0] + 3360*a1sp[0]*b2sp[0])*


                    ki[0] + 


                  pow(a1sp[0], 


                      2)*(25*fp*pow(lp, 2) - 480*a2sp[2] + 1824*a2sp[3])*


                    pow(b1sp[3], 2)*ki[3] - 


                  1824*pow(a1sp[0], 2)*a1sp[3]*b1sp[3]*b2sp[3]*ki[3]) + 


            pow(a1sp[2], 


                4)*(pow(a1sp[3], 4)*


                    pow(b1sp[0], 


                      3)*((73*fp*pow(lp, 2) + 192*a2sp[0])*b1sp[0] - 


                        192*a1sp[0]*b2sp[0])*pow(ki[0], 2) + 


                  2*pow(a1sp[0], 2)*pow(a1sp[3], 2)*b1sp[0]*


                    pow(b1sp[3], 


                      2)*((523*fp*pow(lp, 2) - 1632*a2sp[0] + 12192*a2sp[3])*


                          b1sp[0] + 1632*a1sp[0]*b2sp[0])*ki[0]*ki[3] - 


                  24384*pow(a1sp[0], 2)*pow(a1sp[3], 3)*pow(b1sp[0], 2)*


                    b1sp[3]*b2sp[3]*ki[0]*ki[3] + 


                  pow(a1sp[0], 4)*(fp*pow(lp, 2) + 192*a2sp[3])*


                    pow(b1sp[3], 4)*pow(ki[3], 2) - 


                  192*pow(a1sp[0], 4)*a1sp[3]*pow(b1sp[3], 3)*b2sp[3]*


                    pow(ki[3], 2))))/(192.*(pow(a1sp[0], 4)*pow(a1sp[2], 4)*


            pow(a1sp[3], 4)*pow(b1sp[1], 4)*pow(ki[1], 2) + 


          2*pow(a1sp[0], 2)*pow(a1sp[1], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


            pow(b1sp[1], 2)*


            ki[1]*(7*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[2], 2)*ki[2] + 


                pow(a1sp[2], 


                    2)*(7*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      25*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3])) + 


          pow(a1sp[1], 


              4)*(pow(a1sp[0], 4)*pow(a1sp[3], 4)*pow(b1sp[2], 4)*


                  pow(ki[2], 2) + 


                2*pow(a1sp[0], 2)*pow(a1sp[2], 2)*pow(a1sp[3], 2)*


                  pow(b1sp[2], 2)*


                  ki[2]*(25*pow(a1sp[3], 2)*pow(b1sp[0], 2)*ki[0] + 


                      7*pow(a1sp[0], 2)*pow(b1sp[3], 2)*ki[3]) + 


                pow(a1sp[2], 


                    4)*(pow(a1sp[3], 4)*pow(b1sp[0], 4)*pow(ki[0], 2) + 


                      110*pow(a1sp[0], 2)*pow(a1sp[3], 2)*pow(b1sp[0], 2)*


                        pow(b1sp[3], 2)*ki[0]*ki[3] + 


                      pow(a1sp[0], 4)*pow(b1sp[3], 4)*pow(ki[3], 2)))));


  	return f4;	  


} 


 


//matice tuhosti pro stanoveni posouvajici sily a ohyboveho momentu na elementu delky lp


void normmat::compute_kp (double lp)


{
	
	if (fabs(z1)<zero && fabs(z2)<zero){

				
		
	  kp[0][0]=ecnom*b*(h*h*h)/12.*((12.)/pow(lp,3));


	  kp[0][1]=ecnom*b*(h*h*h)/12.*((-6.)/pow(lp,2));


	  kp[0][2]=ecnom*b*(h*h*h)/12.*((-12.)/pow(lp,3));


	  kp[0][3]=ecnom*b*(h*h*h)/12.*((-6.)/pow(lp,2));


	  kp[1][0]=ecnom*b*(h*h*h)/12.*((-6.)/pow(lp,2));


	  kp[1][1]=ecnom*b*(h*h*h)/12.*((4.)/lp);


	  kp[1][2]=ecnom*b*(h*h*h)/12.*((6.)/pow(lp,2));


	  kp[1][3]=ecnom*b*(h*h*h)/12.*((2.)/lp);


	  kp[2][0]=ecnom*b*(h*h*h)/12.*((-12.)/pow(lp,3));


	  kp[2][1]=ecnom*b*(h*h*h)/12.*((6.)/pow(lp,2));


	  kp[2][2]=ecnom*b*(h*h*h)/12.*((12.)/pow(lp,3));


	  kp[2][3]=ecnom*b*(h*h*h)/12.*((6.)/pow(lp,2));


	  kp[3][0]=ecnom*b*(h*h*h)/12.*((-6.)/pow(lp,2));


	  kp[3][1]=ecnom*b*(h*h*h)/12.*((2.)/lp);


	  kp[3][2]=ecnom*b*(h*h*h)/12.*((6.)/pow(lp,2));


	  kp[3][3]=ecnom*b*(h*h*h)/12.*((4.)/lp);

}
else{


  kp[0][0]=k11;


  kp[0][1]=k12;


  kp[0][2]=k13;


  kp[0][3]=k14;


  kp[1][0]=k21;


  kp[1][1]=k22;


  kp[1][2]=k23;


  kp[1][3]=k24;


  kp[2][0]=k31;


  kp[2][1]=k32;


  kp[2][2]=k33;


  kp[2][3]=k34;


  kp[3][0]=k41;


  kp[3][1]=k42;


  kp[3][2]=k43;


  kp[3][3]=k44;

  }


  


} 


 


//prava strana (+zatizeni od ucinku spojiteho zatizeni) pro stanoveni posouvajici sily a ohyboveho momentu na elementu delky lp


void normmat::compute_fkp (double lp)


{

	if (fabs(z1)<zero && fabs(z2)<zero){

		
		fkp[0]=(fp*lp)/2.;


		fkp[1]=-(fp*pow(lp,2))/12.;


		fkp[2]=(fp*lp)/2.;


		fkp[3]=(fp*pow(lp,2))/12.;

	}

	else {
		
		fkp[0]=-f1;


  fkp[1]=-f2;


  fkp[2]=-f3;


  fkp[3]=-f4;
	
	}


} 





 


//matice tuhosti pro stanoveni normalove sily na elementu delky lp


void normmat::compute_kn (double lp)


{
	if (fabs(z3p)<zero){

				
		kn[0][0] =   ecnom*a/lp;


		kn[0][1] = -ecnom*a/lp;


		kn[1][0] = -ecnom*a/lp;


		kn[1][1] =  ecnom*a/lp;

	}

	else {
		
		kn[0][0] =   pow(an1, 2)/(as1*e0c*kin*lp);


		kn[0][1] = -(pow(an1, 2)/(as1*e0c*kin*lp));


		kn[1][0] = -(pow(an1, 2)/(as1*e0c*kin*lp));


		kn[1][1] =  (pow(an1, 2)/(as1*e0c*kin*lp));
	
	}


  


  


} 





 
//prava strana (+zatizeni od ucinku spojiteho zatizeni) pro stanoveni normalove sily na elementu delky lp


void normmat::compute_fkn (double lp)


{
	if (fabs(z3p)<zero)
	
	{

		fkn[0]= - (fn*lp)/2.;


		fkn[1]= - (fn*lp)/2.;

	}


	else {
		
		fkn[0]=(an2 - (fn*lp)/2.);


		fkn[1]=(-an2 - (fn*lp)/2.);

	}


}





 
void normmat::compute_all (long ipp,double lp)
{

  compute_z1 (ipp,lp);
  compute_z2 (ipp,lp);
  compute_z3p (ipp,lp);
  compute_z3 ();
  as1 = compute_as1 (lp);
  as2 = compute_as2 (lp);
  compute_m (lp);

  compute_mpp (lp);

  n0 = compute_n0 (lp);

  iter = compute_iter ();

  compute_tcv ();

  epsn = compute_epsn ();

  nmax = compute_nmax ();

  an1 = compute_an1 ();

  an2 = compute_an2 ();

  in1 = compute_in1 (lp);

  in2 = compute_in2 (lp);

  kinh = compute_kinh ();

  kind = compute_kind (lp);

  kin = compute_kin ();

  epschr1 = compute_epschr1 ();

  mhr1 = compute_mhr1 ();

  epschr2 = compute_epschr2 ();

  mhr2 = compute_mhr2 ();

  epschr3 = compute_epschr3 ();

  mhr3 = compute_mhr3 ();

  epschr4 = compute_epschr4 ();

  epscmax1 = compute_epscmax1 ();

  epschr4b = compute_epschr4b ();

  epschrk1a = compute_epschrk1a ();

  mhr4 = compute_mhr4 ();

  mhr4b = compute_mhr4b ();

  epscmax1p = compute_epscmax1p ();

  mmax1a = compute_mmax1a ();

  mh1 = compute_mh1 ();

  epsch1 = compute_epsch1 ();

  mh1hrk1a = compute_mh1hrk1a ();

  mhrk1a = compute_mhrk1a ();

  mh3 = compute_mh3 ();

  epsch3 = compute_epsch3 ();

  mh2 = compute_mh2 ();

  epsch2 = compute_epsch2 ();

  epscder2 = compute_epscder2 ();

  mmax1 = compute_mmax1 ();

  mhrk1 = compute_mhrk1 ();

  epschrk1 = compute_epschrk1 ();

  mh1hrk1 = compute_mh1hrk1 ();

  epschr5 = compute_epschr5 ();

  epscs11 = compute_epscs11 ();

  mhr5 = compute_mhr5 ();

  mmax2 = compute_mmax2 ();

  ms11 = compute_ms11 ();

  mh5a = compute_mh5a ();

  epsch5a = compute_epsch5a ();

  mh5p = compute_mh5p ();

  epsch5p = compute_epsch5p ();

  mh25a = compute_mh25a ();

  epscder4 = compute_epscder4 ();

  mmax5 = compute_mmax5 ();

  mh5 = compute_mh5 ();

  epsch5 = compute_epsch5 ();

  epscp = compute_epscp ();

  epschr6 = compute_epschr6 ();

  mhr6 = compute_mhr6 ();

  mmax3 = compute_mmax3 ();

  mh6a = compute_mh6a (); 

  epsch6a = compute_epsch6a (); 

  mh7 = compute_mh7 ();  

  epsch7 = compute_epsch7 ();  

  epsch12 = compute_epsch12 ();

  epss1h1 = compute_epss1h1 ();

  epss1h2 = compute_epss1h2 ();

  mh01 = compute_mh01 ();

  mh12 = compute_mh12 ();

  mh25 = compute_mh25 ();

  mh36a = compute_mh36a ();

  epscder1 = compute_epscder1 ();

  mmax4 = compute_mmax4 ();

  mh6 = compute_mh6 (); 

  epsch6 = compute_epsch6 (); 

  mh36 = compute_mh36 ();
  
  mh7maxa = compute_mh7maxa ();

  mhmaxa = compute_mhmaxa ();

  epscder3 = compute_epscder3 ();

  mhmax = compute_mhmax ();

  mh8p = compute_mh8p (); 

  epsch8p = compute_epsch8p (); 

  mh8 = compute_mh8 (); 

  epsch8 = compute_epsch8 (); 

  mh78 = compute_mh78 ();

  mhoc1 = compute_mhoc1 ();

  mmaxoc1 = compute_mmaxoc1 ();

  epss1oc1 = compute_epss1oc1 ();

  mhoc2 = compute_mhoc2 ();

  epss1oc2 = compute_epss1oc2 ();

  mmaxoc2 = compute_mmaxoc2 ();

  mht1 = compute_mht1 (); 

  mht2 = compute_mht2 (); 

  mht3 = compute_mht3 ();

  mht4 = compute_mht4 ();

  mmax = compute_mmax ();

  epscht1 = compute_epscht1 ();

  epscht2 = compute_epscht2 ();

  epscht3 = compute_epscht3 ();

  epscht4 = compute_epscht4 ();

  epscmax = compute_epscmax ();

  compute_mp ();

  compute_tcn ();

  compute_epscsp ();

  compute_epss1sp ();

  compute_a1sp ();

  compute_a2spp ();

  compute_a2sp ();

  compute_b1sp ();

  compute_b2spp ();

  compute_b2sp ();

  compute_mr ();

  compute_epscr ();

  compute_epss1r ();

  compute_epss1spp ();

  compute_xr ();

  compute_xsp ();

  compute_ir1 ();

  compute_ims1 ();

  compute_ir2 ();

  compute_ims2 ();

  compute_ir3 ();

  compute_ims3 ();

  compute_ic1 ();

  compute_ic2 ();

  compute_icp ();

  compute_c1 ();

  compute_c2 ();

  compute_c1p ();

  compute_c2p ();

  compute_kih (lp);

  compute_kid (lp);

  compute_ki ();


  k11 = compute_k11 (lp);

  k12 = compute_k12 (lp);

  k13 = compute_k13 (lp);

  k14 = compute_k14 (lp);

  f1 = compute_f1 (lp);

  k21 = compute_k21 (lp);

  k22 = compute_k22 (lp);

  k23 = compute_k23 (lp);

  k24 = compute_k24 (lp);

  f2 = compute_f2 (lp);

  k31 = compute_k31 (lp);

  k32 = compute_k32 (lp);

  k33 = compute_k33 (lp);

  k34 = compute_k34 (lp);

  f3 = compute_f3 (lp);

  k41 = compute_k41 (lp);

  k42 = compute_k42 (lp);

  k43 = compute_k43 (lp);

  k44 = compute_k44 (lp);

  f4 = compute_f4 ( lp);

  compute_kp (lp);

  compute_fkp (lp);

  compute_kn (lp);

  compute_fkn (lp);

  //stiffness_matrix (sm);

  //internal_forces (ifor);

}








 /**


   function assembles stiffness %matrix


*/


void normmat::stiffness_matrix (matrix &sm,long ipp,double lp)
{
  
  compute_all (ipp,lp);


  sm[0][0]=kn[0][0];


  sm[0][1]=0.0;


  sm[0][2]=0.0;


  sm[0][3]=kn[0][1];


  sm[0][4]=0.0;


  sm[0][5]=0.0;





  sm[1][0]=0.0;


  sm[1][1]=kp[0][0];


  sm[1][2]=kp[0][1];


  sm[1][3]=0.0;


  sm[1][4]=kp[0][2];


  sm[1][5]=kp[0][3];





  sm[2][0]=0.0;


  sm[2][1]=kp[1][0];


  sm[2][2]=kp[1][1];


  sm[2][3]=0.0;


  sm[2][4]=kp[1][2];


  sm[2][5]=kp[1][3];





  sm[3][0]=kn[1][0];


  sm[3][1]=0.0;


  sm[3][2]=0.0;


  sm[3][3]=kn[1][1];


  sm[3][4]=0.0;


  sm[3][5]=0.0;





  sm[4][0]=0.0;


  sm[4][1]=kp[2][0];


  sm[4][2]=kp[2][1];


  sm[4][3]=0.0;


  sm[4][4]=kp[2][2];


  sm[4][5]=kp[2][3];





  sm[5][0]=0.0;


  sm[5][1]=kp[3][0];


  sm[5][2]=kp[3][1];


  sm[5][3]=0.0;


  sm[5][4]=kp[3][2];


  sm[5][5]=kp[3][3];


  


}





void normmat::internal_forces (vector &ifor,long ipp,double lp)


{
  vector kp(6);
  matrix sm(6,6);
  
  compute_all (ipp,lp);
  
  
  
  kp[0] = Mm->ip[ipp].strain[0];
  kp[1] = Mm->ip[ipp].strain[1];
  kp[2] = Mm->ip[ipp].strain[2];
  
  kp[3] = Mm->ip[ipp].strain[3];
  kp[4] = Mm->ip[ipp].strain[4];
  kp[5] = Mm->ip[ipp].strain[5];
  

  stiffness_matrix (sm,ipp,lp);
  
  mxv (sm,kp,ifor);
  
  ifor[0]+=fkn[0];
  ifor[1]+=fkp[0];
  ifor[2]+=fkp[1];
  ifor[3]+=fkn[1];
  ifor[4]+=fkp[2];
  ifor[5]+=fkp[3];

  
  //  zde dodat mimostycnikove zatizeni
  
  
  /*
  ifor[0]=fkn[0];


  ifor[1]=fkp[0];


  ifor[2]=fkp[1];


  ifor[3]=fkn[1];


  ifor[4]=fkp[2];


  ifor[5]=fkp[3];
  */


  Mm->ip[ipp].stress[0]=ifor[0];
  Mm->ip[ipp].stress[1]=ifor[1];
  Mm->ip[ipp].stress[2]=ifor[2];


  compute_all (ipp,lp);

  stiffness_matrix (sm,ipp,lp);
  
  mxv (sm,kp,ifor);

  ifor[0]+=fkn[0];
  ifor[1]+=fkp[0];
  ifor[2]+=fkp[1];
  ifor[3]+=fkn[1];
  ifor[4]+=fkp[2];
  ifor[5]+=fkp[3];

  Mm->ip[ipp].stress[0]=ifor[0];
  Mm->ip[ipp].stress[1]=ifor[1];
  Mm->ip[ipp].stress[2]=ifor[2];

}







